/*:
 *
 * @plugindesc 装备界面插件
 * @author 第四梦境
 * @help 
 * 因为重写装备界面太多函数，如果有些插件和该插件冲突，可以试着将其放在该插件下面试试。
 *
 * @param 装备格子尺寸
 * @type number
 * @default 48
 *
 * @param 装备格子图片
 * @type file
 * @dir img/system/
 * @require 1
 *
 * @param 光标动画速度
 * @type number
 * @default 16
 *
 * @param 快速穿戴清空按钮图片
 * @type file
 * @dir img/system/
 * @require 1
 *
 * @param 快速穿戴清空按钮图片宽
 * @type number
 * @default 172
 *
 * @param 快速穿戴清空按钮图片高
 * @type number
 * @default 48
 *
 * @param 快速穿戴按钮图片X坐标
 * @type number
 * @default 20
 *
 * @param 快速穿戴按钮图片Y坐标
 * @type number
 * @default 450
 *
 * @param 快速清空按钮图片X坐标
 * @type number
 * @default 216
 *
 * @param 快速清空按钮图片Y坐标
 * @type number
 * @default 450
 *
 * @param 文本参数
 * @desc 
 * @type struct<WBSY>
 * @default {"经验比值":"经验","暴击率":"暴击率","命中率":"命中率","回避率":"回避率","排序":"1"}
 *
 * @-param 格子界面设置
 * @-desc 
 * @-type struct<EuipEX>[]
 *
 *
 */
 
 /*~struct~EuipEX:
 *
 * @param 角色
 * @desc 
 * @type actor
 * @default 1
 *
 * @param 背景图片
 * @type file
 * @dir img/pictures/
 * @require 1
 *
 * @param 装备格子集
 * @type struct<EuipCell>[]
 *
 *
 */


 /*~struct~EuipCell:
 *
 * @param 装备格子
 * @type number
 * @default 1
 *
 * @param 装备类型
 * @type string
 *
 * @param X坐标
 * @type number
 * @default 1
 *
 * @param Y坐标
 * @type number
 * @default 1
 *
 */
 
  /*~struct~WBSY:
 *
 * @param 经验比值
 * @type string
 * @default 经验
 *
 * @param 暴击率
 * @type string
 * @default 暴击率
 *
 * @param 命中率
 * @type string
 * @default 命中率
 *
 * @param 回避率
 * @type string
 * @default 回避率
 *
 * @param 排序
 * @type number
 * @min 1
 * @max 6
 * @default 1
 *
 */

var $HYTTDQUTPEX = {};
$HYTTDQUTPEX.equipcell = [];
$HYTTDQUTPEX.actorbgis = [];
$HYTTDQUTPEX.actorfis = [];
$HYTTDQUTPEX.Parameters = PluginManager.parameters("DFMJ_HYTT_EQUIPEX");
$HYTTDQUTPEX.CellWH = $HYTTDQUTPEX.Parameters["装备格子尺寸"] * 1;
$HYTTDQUTPEX.CellImg = $HYTTDQUTPEX.Parameters["装备格子图片"];
$HYTTDQUTPEX.CSD = $HYTTDQUTPEX.Parameters["光标动画速度"] * 1;
$HYTTDQUTPEX.KSCD_IMG = $HYTTDQUTPEX.Parameters["快速穿戴清空按钮图片"];
$HYTTDQUTPEX.KSCD_IMGCX = $HYTTDQUTPEX.Parameters["快速穿戴按钮图片X坐标"] * 1;
$HYTTDQUTPEX.KSCD_IMGCY = $HYTTDQUTPEX.Parameters["快速穿戴按钮图片Y坐标"] * 1;
$HYTTDQUTPEX.KSCD_IMGQX = $HYTTDQUTPEX.Parameters["快速清空按钮图片X坐标"] * 1;
$HYTTDQUTPEX.KSCD_IMGQY = $HYTTDQUTPEX.Parameters["快速清空按钮图片Y坐标"] * 1;
$HYTTDQUTPEX.KSCD_IMGW = $HYTTDQUTPEX.Parameters["快速穿戴清空按钮图片宽"] * 1;
$HYTTDQUTPEX.KSCD_IMGH = $HYTTDQUTPEX.Parameters["快速穿戴清空按钮图片高"] * 1;
$HYTTDQUTPEX.texpam = JSON.parse($HYTTDQUTPEX.Parameters["文本参数"]);
$HYTTDQUTPEX.texpam["排序"] = $HYTTDQUTPEX["排序"] * 1;

//=============================================================================
// 自定义场景类
//=============================================================================

function Scene_Equip() {
    this.initialize.apply(this, arguments);
}
Scene_Equip.prototype = Object.create(Scene_MenuBase.prototype);
Scene_Equip.prototype.constructor = Scene_Equip;

//=============================================================================
// 自定义窗口类
//=============================================================================

function Window_HYTT_EquipSlot() {
    this.initialize.apply(this, arguments);
}
Window_HYTT_EquipSlot.prototype = Object.create(Window_Base.prototype);
Window_HYTT_EquipSlot.prototype.constructor = Window_HYTT_EquipSlot;

Window_HYTT_EquipSlot.prototype.initialize = function(x, y, width, height,anisz,anisd) {
    Window_Base.prototype.initialize.call(this, x, y, width, height);
	this._actor = null;
	this._anisz = anisz || [1,2,3,4,3,2];
	this._anisd = $HYTTDQUTPEX.CSD || 16;
	this._anindex = 0;
	this._index = 0;
	this._selectindex = 0;
	this._touching = false;
	this._handlers = {};
	this._cellbutton = [];
};

Window_HYTT_EquipSlot.prototype.update = function() {
    Window_Base.prototype.update.call(this);
	this.processTouch();
	this.updateCellButton();
	this.processCursorMove();
    this.processHandling();
	this.updateCcontent();
};

Window_HYTT_EquipSlot.prototype.updateCellButton = function() {
    for (var i = 0;i < this._cellbutton.length;i++) {
		this._cellbutton[i].update()
	}
};

Window_HYTT_EquipSlot.prototype.processTouch = function() {
    if (this.isOpenAndActive()) {
        if (TouchInput.isCancelled()) {
            if (this.isCancelEnabled()) {
                this.processCancel();
            }
        }
	}
};

Window_HYTT_EquipSlot.prototype.isOpenAndActive = function() {
    return this.isOpen() && this.active;
};

Window_HYTT_EquipSlot.prototype.activate = function() {
    Window_Base.prototype.activate.call(this);
};

Window_HYTT_EquipSlot.prototype.deactivate = function() {
    Window_Base.prototype.deactivate.call(this);
};

Window_HYTT_EquipSlot.prototype.updateInputData = function() {
    Input.update();
    TouchInput.update();
};

Window_HYTT_EquipSlot.prototype.isCurrentItemEnabled = function() {
    return this.isEnabled(0);
};

Window_HYTT_EquipSlot.prototype.isEnabled = function(index) {
    return this._actor ? this._actor.isEquipChangeOk(index) : false;
};

Window_HYTT_EquipSlot.prototype.isOkEnabled = function() {
    return this.isHandled('ok');
};

Window_HYTT_EquipSlot.prototype.isCancelEnabled = function() {
    return this.isHandled('cancel');
};

Window_HYTT_EquipSlot.prototype.isOkTriggered = function() {
	var buer = Input.isRepeated('ok') || this._touching;
	this._touching = false;
    return buer;
};

Window_HYTT_EquipSlot.prototype.isCancelTriggered = function() {
    return Input.isRepeated('cancel');
};

Window_HYTT_EquipSlot.prototype.processOk = function() {
    if (this.isCurrentItemEnabled()) {
        this.playOkSound();
        this.updateInputData();
        this.callOkHandler();
    } else {
        this.playBuzzerSound();
    }
};

Window_HYTT_EquipSlot.prototype.processCancel = function() {
    SoundManager.playCancel();
    this.updateInputData();
    this.deactivate();
    this.callCancelHandler();
};

Window_HYTT_EquipSlot.prototype.callCancelHandler = function() {
    this.callHandler('cancel');
};

Window_HYTT_EquipSlot.prototype.playOkSound = function() {
    SoundManager.playOk();
};

Window_HYTT_EquipSlot.prototype.playBuzzerSound = function() {
    SoundManager.playBuzzer();
};

Window_HYTT_EquipSlot.prototype.callOkHandler = function() {
    this.callHandler('ok');
};

Window_HYTT_EquipSlot.prototype.processHandling = function() {
    if (this.isOpenAndActive()) {
        if (this.isOkEnabled() && this.isOkTriggered()) {
            this.processOk();
        } else if (this.isCancelEnabled() && this.isCancelTriggered()) {
            this.processCancel();	    
        }
    }
};

Window_HYTT_EquipSlot.prototype.processCursorMove = function() {
	if (!this.isOpenAndActive()) return;
	var xy = 0;
	if (Input.isTriggered('up') || Input.isTriggered('left')) {
		xy--;
	}
	if (Input.isTriggered('down') || Input.isTriggered('right')) {
		xy++
	}
	if (xy != 0) {
		this._selectindex = (this._selectindex + this._cellbutton.length + xy) % this._cellbutton.length;
	}
};

Window_HYTT_EquipSlot.prototype.setHandler = function(symbol, method) {
    this._handlers[symbol] = method;
};

Window_HYTT_EquipSlot.prototype.isHandled = function(symbol) {
    return !!this._handlers[symbol];
};

Window_HYTT_EquipSlot.prototype.callHandler = function(symbol) {
    if (this.isHandled(symbol)) {
        this._handlers[symbol]();
    }
};

Window_HYTT_EquipSlot.prototype.standardPadding = function() {
    return 0;
};

Window_HYTT_EquipSlot.prototype.setActor = function(actor) {
    if (this._actor !== actor) {
        this._actor = actor;
        this.refresh();
    }
};

Window_HYTT_EquipSlot.prototype.setStatusWindow = function(statusWindow) {
    this._statusWindow = statusWindow;
    this.callUpdateHelp();
};

Window_HYTT_EquipSlot.prototype.setItemWindow = function(itemWindow) {
    this._itemWindow = itemWindow;
    this.update();
};

Window_HYTT_EquipSlot.prototype.setHelpWindow = function(helpWindow) {
    this._helpWindow = helpWindow;
    this.callUpdateHelp();
};

Window_HYTT_EquipSlot.prototype.callUpdateHelp = function() {
    if (this.active && this._helpWindow) {
        this.updateHelp();
    }
};

Window_HYTT_EquipSlot.prototype.updateHelp = function() {
    this._helpWindow.clear();
};

Window_HYTT_EquipSlot.prototype.updateCcontent = function() {
    this.contents.clear();
	if (!this._actor) return;
	let wh = $HYTTDQUTPEX.CellWH;
	let cqw = $HYTTDQUTPEX.KSCD_IMGW;
	let cqh = $HYTTDQUTPEX.KSCD_IMGH;
    var pw = 408;
    var ph = 504;
    var sx = 0;
    var sy = 0;
    this.contents.blt($HYTTDQUTPEX.actorbgis[this._actor.actorId() - 1], sx, sy, pw, ph, 0, 0);
	var scb = {};
	for (var i = 0;i < this._cellbutton.length;i++) {
		scb = this._cellbutton[i];
		scb.draw();
		if (scb.iconIndex) {
			this.drawIcon(scb.iconIndex, (wh-32)/2+scb.x,(wh-32)/2+scb.y);
		}
		
	}
	
	scb = this._cellbutton[this._selectindex];
	var anindex = this._anisz[Math.floor(this._anindex/this._anisd)];
	if (this._selectindex == 0) {
		this.contents.blt($HYTTDQUTPEX.KSCD_IMG,anindex*cqw, 0, cqw, cqh, scb.x, scb.y);
	} else if (this._selectindex == 1) {
		this.contents.blt($HYTTDQUTPEX.KSCD_IMG,anindex*cqw, cqh, cqw, cqh, scb.x, scb.y);
	} else if (this._selectindex >= 2 && this._selectindex < this._cellbutton.length) {
		this.contents.blt($HYTTDQUTPEX.CellImg,anindex*wh, 0, wh, wh, scb.x, scb.y);
	}
	this._anindex = (this._anindex+1)%(this._anisd*this._anisz.length);
};

Window_HYTT_EquipSlot.prototype.index = function() {
    return this._index;
};

Window_HYTT_EquipSlot.prototype.select = function(index) {
    this._index = index;
	this._anindex = 0;
    this.callUpdateHelp();
};

Window_HYTT_EquipSlot.prototype.deselect = function() {
    this.select(-1);
};

Window_HYTT_EquipSlot.prototype.reselect = function() {
    this.select(this._index);
};

Window_HYTT_EquipSlot.prototype.refresh = function() {
    
	
	//this._windowContentsSprite.removeChildren(0,this._windowContentsSprite.children.length);
	
	this._cellbutton = [];
	let scb = new CellButton(this,0,-1,$HYTTDQUTPEX.KSCD_IMG,$HYTTDQUTPEX.KSCD_IMGCX,$HYTTDQUTPEX.KSCD_IMGCY,0,0,$HYTTDQUTPEX.KSCD_IMGW,$HYTTDQUTPEX.KSCD_IMGH);
	this._cellbutton.push(scb);
	//scb.draw();
	scb.setClickHandler(scb.oncclick);
	scb = new CellButton(this,1,-1,$HYTTDQUTPEX.KSCD_IMG,$HYTTDQUTPEX.KSCD_IMGQX,$HYTTDQUTPEX.KSCD_IMGQY,0,$HYTTDQUTPEX.KSCD_IMGH,$HYTTDQUTPEX.KSCD_IMGW,$HYTTDQUTPEX.KSCD_IMGH);
	this._cellbutton.push(scb);
	//scb.draw();
	scb.setClickHandler(scb.oncclick);
	
	var cell = $HYTTDQUTPEX.equipcell[this._actor.actorId()-1];
	let ind = 2;
	for (let key=0;key < cell.length;key++) {
		let x = cell[key].imgzx;let y = cell[key].imgzy;let wh = $HYTTDQUTPEX.CellWH;let index = cell[key].imgindex;
		var item = this._actor._equips[cell[key].slotId];
		if (!item) continue; 
		item = item.object();
		if (item) {
			scb = new CellButton(this,ind,cell[key].slotId,$HYTTDQUTPEX.CellImg,x,y,0,0,wh,wh);
			this._cellbutton.push(scb);
			//scb.draw();
			scb.setClickHandler(scb.oncclick);
			scb.iconIndex = item.iconIndex;
			ind++;
		} else {
			scb = new CellButton(this,ind,cell[key].slotId,$HYTTDQUTPEX.CellImg,x,y,((index-1)%5)*wh,Math.floor(((index+4)/5))*wh,wh,wh);
		    this._cellbutton.push(scb);
			//scb.draw();
			scb.setClickHandler(scb.oncclick);
			ind++;
		}
		
	}
	
};

function Window_HYTT_EquipFace() {
    this.initialize.apply(this, arguments);
}
Window_HYTT_EquipFace.prototype = Object.create(Window_Base.prototype);
Window_HYTT_EquipFace.prototype.constructor = Window_HYTT_EquipFace;

Window_HYTT_EquipFace.prototype.initialize = function(x, y, width, height) {
    Window_Base.prototype.initialize.call(this, x, y, width, height);
};

Window_HYTT_EquipFace.prototype.standardPadding = function() {
    return 0;
};

Window_HYTT_EquipFace.prototype.drawFace = function(bitmap, faceIndex, x, y, width, height) {
    width = width || Window_Base._faceWidth;
    height = height || Window_Base._faceHeight;
    var pw = Window_Base._faceWidth;
    var ph = Window_Base._faceHeight;
    var sw = Math.min(width, pw);
    var sh = Math.min(height, ph);
    var dx = Math.floor(x + Math.max(width - pw, 0) / 2);
    var dy = Math.floor(y + Math.max(height - ph, 0) / 2);
    var sx = faceIndex % 4 * pw + (pw - sw) / 2;
    var sy = Math.floor(faceIndex / 4) * ph + (ph - sh) / 2;
    this.contents.blt(bitmap, sx, sy, sw, sh, dx, dy);
};

Window_HYTT_EquipFace.prototype.setActor = function(actor) {
    if (this._actor !== actor) {
        this._actor = actor;
        this.refresh();
    }
};

Window_HYTT_EquipFace.prototype.refresh = function() {
    this.contents.clear();
	this.drawFace($HYTTDQUTPEX.actorfis[this._actor.actorId()-1],this._actor.faceIndex(),84,36,144,144)
	this.drawActorHp(this._actor, 84, 176, 144);
	this.drawActorMp(this._actor, 84, 208, 144);
};

//=============================================================================
// 自定义精灵类
//=============================================================================

function CellButton() {
    this.initialize.apply(this, arguments);
}
CellButton.prototype.constructor = CellButton;

CellButton.prototype.initialize = function(parent,index,slotId,bitmap,zx,zy,cx,cy,cwidth,cheight,x,y,width,height) {
	this.bitmap = bitmap;
	this.parent = parent;
	this.slotId = slotId;
	this.x = zx;
    this.y = zy;
	this.iconIndex = null;
    this._touching = false;
    this.setColdFrame(cx,cy,cwidth,cheight);
	this.frame = this._coldFrame;
	hx = x || cx;hy = y || cy;hwidth = width || cwidth;hheight = height || cheight;
    this.setHotFrame(hx,hy,hwidth,hheight);
    this._clickHandler = null;
	this.visible = true;
	this.index = index;
};

CellButton.prototype.draw = function(ch) {
	this.parent.contents.blt(this.bitmap,this.frame.x, this.frame.y, this.frame.width, this.frame.height, this.x, this.y);
};

CellButton.prototype.update = function() {
    this.updateFrame();
    this.processTouch();
};


CellButton.prototype.oncclick = function() {
	if (!this.parent.isOpenAndActive()) return;
    if (this.parent._selectindex != this.index) {
		this.parent._selectindex = this.index;
	} else {
		this.parent._touching = true;
	}
};

CellButton.prototype.updateFrame = function() {
    var frame;
    if (this._touching) {
        frame = this._hotFrame;
    } else {
        frame = this._coldFrame;
    }
    if (frame) {
        this.frame = frame;
    }
};

CellButton.prototype.setColdFrame = function(x, y, width, height) {
    this._coldFrame = new Rectangle(x, y, width, height);
};

CellButton.prototype.setHotFrame = function(x, y, width, height) {
    this._hotFrame = new Rectangle(x, y, width, height);
};

CellButton.prototype.setClickHandler = function(method) {
    this._clickHandler = method;
};

CellButton.prototype.callClickHandler = function() {
    if (this._clickHandler) {
        this._clickHandler();
    }
};

CellButton.prototype.processTouch = function() {
    if (this.isActive()) {
        if (TouchInput.isTriggered() && this.isButtonTouched()) {
            this._touching = true;
        }
        if (this._touching) {
            if (TouchInput.isReleased() || !this.isButtonTouched()) {
                this._touching = false;
                if (TouchInput.isReleased()) {
                    this.callClickHandler();
                }
            }
        }
    } else {
        this._touching = false;
    }
};

CellButton.prototype.isActive = function() {
    var node = this;
    while (node) {
        if (!node.visible) {
            return false;
        }
        node = node.parent;
    }
    return true;
};

CellButton.prototype.isButtonTouched = function() {
    var x = this.canvasToLocalX(TouchInput.x);
    var y = this.canvasToLocalY(TouchInput.y);
    return x >= 0 && y >= 0 && x < this.frame.width && y < this.frame.height;
};

CellButton.prototype.canvasToLocalX = function(x) {
    var node = this;
    while (node) {
        x -= node.x;
        node = node.parent;
    }
    return x;
};

CellButton.prototype.canvasToLocalY = function(y) {
    var node = this;
    while (node) {
        y -= node.y;
        node = node.parent;
    }
    return y;
};


(function(){
	
var Game_Interpreter_DFMJ_HYTT_EQUIPEX_pluginCommand = Game_Interpreter.prototype.pluginCommand;
Game_Interpreter.prototype.pluginCommand = function(command, args) {
     Game_Interpreter_DFMJ_HYTT_EQUIPEX_pluginCommand.call(this, command, args);
	 switch (command) {
		 case "OpenEquipmentInterface":
		 SceneManager.push(Scene_Equip);
		 break;
	 }
};

Scene_Menu.prototype.onPersonalOk = function() {
    switch (this._commandWindow.currentSymbol()) {
    case 'skill':
        SceneManager.push(Scene_Skill);
        break;
    case 'equip':
        SceneManager.push(Scene_Equip);
        break;
    case 'status':
        SceneManager.push(Scene_Status);
        break;
    }
};

Scene_Equip.prototype.initialize = function() {
    Scene_MenuBase.prototype.initialize.call(this);
};

Scene_Equip.prototype.create = function() {
    Scene_MenuBase.prototype.create.call(this);
    this.createHelpWindow();
    this.createStatusWindow();
    this.createCommandWindow();
    this.createSlotWindow();
	this.createSlotEXWindow();
	this.createFaceWindow()
    this.createItemWindow();
    this.refreshActor();
	
	if (!GT) return;if (!GT.Param) return;if (!GT.Param.OIWSceneEquipSet) return;
	if (eval(GT.Param.OIWSceneEquipSet.ShowWindow)) {
		this.getObjInfoWindowSet();
		this.createObjInfoWindow();
		this._objInfoWindow.setActor(this.actor());
	}
};

Scene_Equip.prototype.createHelpWindow = function() {
    this._helpWindow = new Window_Help();
    this.addWindow(this._helpWindow);
};

Scene_Equip.prototype.createStatusWindow = function() {
    this._statusWindow = new Window_EquipStatus(0, this._helpWindow.height);
    this.addWindow(this._statusWindow);
};

Scene_Equip.prototype.createCommandWindow = function() {
    var wx = this._statusWindow.width;
    var wy = this._helpWindow.height;
    var ww = Graphics.boxWidth - this._statusWindow.width;
    this._commandWindow = new Window_EquipCommand(wx, wy, ww);
    this._commandWindow.setHelpWindow(this._helpWindow);
	this._commandWindow.hide();
};

Scene_Equip.prototype.createSlotEXWindow = function() {
    var wx = this._statusWindow.width;
    var wy = this._helpWindow.height;
    var ww = Graphics.boxWidth - this._statusWindow.width;
    var wh = this._statusWindow.height;
    this._slotEXWindow = new Window_HYTT_EquipSlot(wx, wy, ww, wh);
	this._slotEXWindow.setHelpWindow(this._helpWindow);
    this._slotEXWindow.setStatusWindow(this._statusWindow);
    this._slotEXWindow.setHandler('ok',       this.onSlotOk.bind(this));
    this._slotEXWindow.setHandler('cancel',   this.popScene.bind(this));
    this.addWindow(this._slotEXWindow);
};

Scene_Equip.prototype.createSlotWindow = function() {
    var wx = this._statusWindow.width;
    var wy = this._helpWindow.height;
    var ww = Graphics.boxWidth - this._statusWindow.width;
    var wh = 864 - wy;
    this._slotWindow = new Window_EquipSlot(wx, wy, ww, wh);
    this._slotWindow.setHelpWindow(this._helpWindow);
    this._slotWindow.setStatusWindow(this._statusWindow);
	this._slotWindow.hide();
};

Scene_Equip.prototype.createItemWindow = function() {
    var wx = this._statusWindow.width;
    var wy = this._statusWindow.y + this._statusWindow.height;
    var ww = Graphics.boxWidth - this._statusWindow.width;
    var wh = 864 - wy;
    this._itemWindow = new Window_EquipItem(wx, wy, ww, wh);
    this._itemWindow.setHelpWindow(this._helpWindow);
    this._itemWindow.setStatusWindow(this._statusWindow);
    this._itemWindow.setHandler('ok',     this.onItemOk.bind(this));
    this._itemWindow.setHandler('cancel', this.onItemCancel.bind(this));
    this._slotWindow.setItemWindow(this._itemWindow);
	var wd = new Window_Base(wx, wy, ww, wh);this.addWindow(wd);
    this.addWindow(this._itemWindow);
	this._itemWindow.hide();
};

Scene_Equip.prototype.createFaceWindow = function() {
    var wx = 0;
    var wy = this._statusWindow.y + this._statusWindow.height;
    var ww = this._statusWindow.width;
    var wh = 864 - wy;
    this._faceWindow = new Window_HYTT_EquipFace(wx, wy, ww, wh);
    this.addWindow(this._faceWindow);
};


Scene_Equip.prototype.refreshActor = function() {
    var actor = this.actor();
    this._statusWindow.setActor(actor);
    this._slotWindow.setActor(actor);
    this._itemWindow.setActor(actor);
	this._slotEXWindow.setActor(actor);
	this._faceWindow.setActor(actor);
};

Scene_Equip.prototype.commandOptimize = function() {
    SoundManager.playEquip();
    this.actor().optimizeEquipments();
    this._statusWindow.refresh();
	this._slotWindow.refresh();
	this._itemWindow.refresh();
    this._slotEXWindow.refresh();
};

Scene_Equip.prototype.commandClear = function() {
    SoundManager.playEquip();
    this.actor().clearEquipments();
	this._statusWindow.setTempActor(null);
    this._statusWindow.refresh();
	this._slotWindow.refresh();
	this._itemWindow.refresh();
    this._slotEXWindow.refresh();
};

Scene_Equip.prototype.onSlotOk = function() {
	if (this._slotEXWindow._selectindex > 1) {
		this._slotEXWindow.deactivate();
		this._slotEXWindow.select(this._slotEXWindow._cellbutton[this._slotEXWindow._selectindex].slotId);
		this._slotWindow.select(this._slotEXWindow.index());
		this._itemWindow.setSlotIdEX(this._slotEXWindow.index());
		this._itemWindow.select(0);
		this._itemWindow.activate();
		this._itemWindow.show();
	} else if (this._slotEXWindow._selectindex == 0) {
		this.commandOptimize();
	} else if (this._slotEXWindow._selectindex == 1) {
		this.commandClear();
	}
};

Window_EquipItem.prototype.setSlotIdEX = function(slotId) {
    if (this._slotId !== slotId) {
        this._slotId = slotId;
        this.refresh();
        this.resetScroll();
    }
};

Scene_Equip.prototype.onItemOk = function() {
    SoundManager.playEquip();
    this.actor().changeEquip(this._slotWindow.index(), this._itemWindow.item());
    this._itemWindow.deselect();
    this._itemWindow.refresh();
	this._slotEXWindow.refresh();
    this._statusWindow.refresh();
	this._statusWindow.setTempActor(null);
	this._slotEXWindow.activate();
	this._itemWindow.hide();
};

Scene_Equip.prototype.onItemCancel = function() {
	this._slotEXWindow.activate();
    this._itemWindow.deselect();
	this._statusWindow.setTempActor(null);
	this._statusWindow.refresh();
	this._itemWindow.hide();
};

Scene_Equip.prototype.onActorChange = function() {
    this.refreshActor();
    this._slotEXWindow.activate();
};

Window_EquipStatus.prototype.windowWidth = function() {
    return 312;
};

Window_EquipStatus.prototype.windowHeight = function() {
    return 504;
};

Window_EquipStatus.prototype.refresh = function() {
    this.contents.clear();
    if (this._actor) {
        this.drawActorName(this._actor, this.textPadding(), 0);
		this.drawStatusEX(this.textPadding(), this.lineHeight());
        for (var i = 0; i < 8; i++) {
            this.drawItem(0, this.lineHeight() * (2 + i), 0 + i);
        }
    }
};

Window_EquipStatus.prototype.drawItem = function(x, y, paramId) {
    this.drawParamName(x + this.textPadding(), y, paramId);
    if (this._actor) {
        this.drawCurrentParam(x + 140, y, paramId);
    }
    this.drawRightArrow(x + 188, y);
    if (this._tempActor) {
        this.drawNewParam(x + 222, y, paramId);
    }
};

Window_EquipStatus.prototype.drawStatusEX = function( x, y) {
	var ty = y;
    this.changeTextColor(this.systemColor());
    this.drawText($HYTTDQUTPEX.texpam["经验比值"], x, y, 160);
	this.resetTextColor();
	let texp = Math.round((this._actor.currentExp()/this._actor.nextLevelExp()) * 10000) / 100;
    this.drawText(texp.toFixed(2)+"%", x+140, y, 72, 'right');
	/**
	暴击率:22:2;命中率:22:0;回避率:22:1
	**/
	//return;
	var te = this._actor._equips;
	var hb = 0;var hm = 0;var hh = 0;
	for (var j = 0;j < te.length;j++) {
		if (!te[j].object()) continue;
		var traits = te[j].object().traits;
		for (var i = 0;i < traits.length;i++) {
			if (traits[i].code == 22) {
				if (traits[i].dataId == 0) {
					hm += traits[i].value;
				} else if (traits[i].dataId == 1) {
					hh += traits[i].value;
				} else if (traits[i].dataId == 2) {
					hb += traits[i].value;
				}
				
			}
		}
	}
	var tb = 0;var tm = 0;var th = 0;
	if (this._tempActor) {
		te = this._tempActor._equips;
		for (var j = 0;j < te.length;j++) {
			if (!te[j].object()) continue;
			var traits = te[j].object().traits;
			for (var i = 0;i < traits.length;i++) {
				if (traits[i].code == 22) {
					if (traits[i].dataId == 0) {
						tm += traits[i].value;
					} else if (traits[i].dataId == 1) {
						th += traits[i].value;
					} else if (traits[i].dataId == 2) {
						tb += traits[i].value;
					}
				}
			}
		}
    }
	
	var iy = 0;
	if (hb > 0 || tb > 0) {
		ty = y + (9 + iy) * this.lineHeight();
		this.drawBHM("暴击率",hb,tb,x,ty);
		iy++;
	}
	if (hh > 0 || th > 0) {
		ty = y + (9 + iy) * this.lineHeight();
		this.drawBHM("回避率",hh,th,x,ty);
		iy++;
	}
	if (hm > 0 || tm > 0) {
		ty = y + (9 + iy) * this.lineHeight();
		this.drawBHM("命中率",hm,tm,x,ty);
		iy++;
	}
};

Window_EquipStatus.prototype.drawBHM = function(tpm,ht,tt,x,y) {
	this.changeTextColor(this.systemColor());
    this.drawText($HYTTDQUTPEX.texpam[tpm], x, y, 120);
	this.resetTextColor();
    if (this._actor) {
		this.drawText(ht*100+"%", x + 140, y, 48, 'right');
    }
	this.drawRightArrow(x + 188, y);
    if (this._tempActor) {
		var diffvalue = tt - ht;
		this.changeTextColor(this.paramchangeTextColor(diffvalue));
		this.drawText(tt*100+"%", x + 222, y, 48, 'right');
    }
};

Window_EquipStatus.prototype.ishtrait = function(equip,code,dataId) {
	var traits = equip.traits;
	for (var i = 0;i < traits.length;i++) {
		if (traits[i].code == code && traits[i].dataId == dataId) {
			return traits[i].value;
		}
	}
    return 0;
};

//=============================================================================
// DataManager
//=============================================================================

var DataManager_DFMJ_HYTT_isDatabaseLoaded = DataManager.isDatabaseLoaded;
DataManager.isDatabaseLoaded = function() {
  if (!DataManager_DFMJ_HYTT_isDatabaseLoaded.call(this)) return false;
  $HYTTDQUTPEX.CellImg = ImageManager.loadSystem($HYTTDQUTPEX.CellImg);
  $HYTTDQUTPEX.KSCD_IMG = ImageManager.loadSystem($HYTTDQUTPEX.KSCD_IMG);
  DataManager.processEquipNotetag1($dataActors);
  return true;
};

DataManager.processEquipNotetag1 = function(group) {
  var note1 = /<(?:EQUIPCELL|equipcell)>/i;
  var note2 = /<\/(?:EQUIPCELL|equipcell)>/i;
  var note3 = /(.*):(.*)/i;
  var note4 = /(.*)-(.*)-(.*)-(.*)/i;
  for (var n = 1; n < group.length; n++) {
    var obj = group[n];
    var notedata = obj.note.split(/[\r\n]+/);

	var equipcell = [];
    var yd = false;

    for (var i = 0; i < notedata.length; i++) {
      var line = notedata[i];
      if (line.match(note1)) {
        yd = true;
      } else if (line.match(note2)) {
        yd = false;
      }/*else if (yd && line.replace(/\s+/g,"").match(note3)) {
		  var name = String(RegExp.$1);
		  var slotId = $dataSystem.equipTypes.indexOf(name);
		  if (slotId >= 0) {
			  var rs = RegExp.$2.split('-');
			  equipcell[name] = {};
			  equipcell[name].imgindex = rs[0] * 1;
			  equipcell[name].imgzx = rs[1] * 1;
			  equipcell[name].imgzy = rs[2] * 1;
			  equipcell[name].slotId = slotId - 1;
		  }
      }*/else if (yd && line.replace(/\s+/g,"").match(note4)) {
		  var slotId = RegExp.$1 * 1;
		  if (slotId > 0 && slotId < $dataSystem.equipTypes.length) {
			  var ecl = {};
			  ecl.imgindex = RegExp.$2 * 1;
			  ecl.imgzx = RegExp.$3 * 1;
			  ecl.imgzy = RegExp.$4 * 1;
			  ecl.slotId = slotId - 1;
			  equipcell.push(ecl);
		  }
      }
    }
	$HYTTDQUTPEX.equipcell.push(equipcell);
	if ($dataActors[n].meta["bgi"]) {
		$HYTTDQUTPEX.actorbgis.push(ImageManager.loadPicture($dataActors[n].meta["bgi"]));
	} else {
		$HYTTDQUTPEX.actorbgis.push($HYTTDQUTPEX.loadEmptyBitmap(408,504));
	}
	$HYTTDQUTPEX.actorfis.push(ImageManager.loadFace($dataActors[n].faceName));
  }
};

$HYTTDQUTPEX.loadEmptyBitmap = function(w,h) {
    var emptyex = ImageManager.cache.getItem('emptyex');
    if (!emptyex) {
        emptyex = new Bitmap(w || 408,h || 504);
        ImageManager.cache.setItem('emptyex', emptyex);
    }
    return emptyex;
};

})()


