/*:
 *
 * @plugindesc 回复插件
 * @author 第四梦境
 * @help 
 * <rehp:数字>格式设置hp回复方式，不写或数字为0为按百分比回复，数字为1为按点数回复;例:<rehp:0>或<rehp:1>
 * <remp:数字>格式设置mp回复方式，不写或数字为0为按百分比回复，数字为1为按点数回复;例:<remp:0>或<remp:1>
 *
 */
 var Game_Actor_DFMJ_HYTT_initMembers = Game_Actor.prototype.initMembers;
 Game_Actor.prototype.initMembers = function() {
	 Game_Actor_DFMJ_HYTT_initMembers.call(this);
    this.rehp_0 = 0;
	this.remp_0 = 0;
	this.rehp_1 = 0;
	this.remp_1 = 0;
};

Object.defineProperties( Game_Actor.prototype, {
	hrg: { get: function() { return this.xparam(7) - this.rehp_1; }, configurable: true },
    mrg: { get: function() { return this.xparam(8) - this.remp_1; }, configurable: true }
});

var Game_Actor_DFMJ_HYTT_changeEquip = Game_Actor.prototype.changeEquip;
Game_Actor.prototype.changeEquip = function(slotId, item) {
	Game_Actor_DFMJ_HYTT_changeEquip.call(this,slotId, item);
	/*
	hp:7;mp:8;tp:9
	*/
	var te = this._equips;
	var hh_0 = 0;var hm_0 = 0;
	var hh_1 = 0;var hm_1 = 0;
	for (var j = 0;j < te.length;j++) {
		var obj = te[j].object();
		if (!obj) continue;
		var traits = obj.traits;
		var rehp = obj.meta["rehp"] || '0';
		var remp = obj.meta["remp"] || '0';
		for (var i = 0;i < traits.length;i++) {
			if (traits[i].code == 22) {
				if (traits[i].dataId == 7) {
					if (rehp == '0') {
						hh_0 += traits[i].value;
					} else {
						hh_1 += traits[i].value;
					}
				} else if (traits[i].dataId == 8) {
					if (remp == '0') {
						hm_0 += traits[i].value;
					} else {
						hm_1 += traits[i].value;
					}
				}
			}
		}
	}
	this.rehp_0 = hh_0;
	this.remp_0 = hm_0;
	this.rehp_1 = hh_1;
	this.remp_1 = hm_1;
	//alert("hrg:"+this.hrg+"-mrg:"+this.mrg);
};

Game_Actor.prototype.regenerateHp = function() {
    var value = Math.floor(this.mhp * this.hrg + this.rehp_1 * 100);
    value = Math.max(value, -this.maxSlipDamage());
    if (value !== 0) {
        this.gainHp(value);
    }
};

Game_Actor.prototype.regenerateMp = function() {
    var value = Math.floor(this.mmp * this.mrg + this.remp_1 * 100);
    if (value !== 0) {
        this.gainMp(value);
    }
};
(function(){
	var Game_Actor_discardEquip = Game_Actor.prototype.discardEquip;
	Game_Actor.prototype.discardEquip = function(item) {
		Game_Actor_discardEquip.call(this,item);
		
		var te = this._equips;
	var hh_0 = 0;var hm_0 = 0;
	var hh_1 = 0;var hm_1 = 0;
	for (var j = 0;j < te.length;j++) {
		var obj = te[j].object();
		if (!obj) continue;
		var traits = obj.traits;
		var rehp = obj.meta["rehp"] || '0';
		var remp = obj.meta["remp"] || '0';
		for (var i = 0;i < traits.length;i++) {
			if (traits[i].code == 22) {
				if (traits[i].dataId == 7) {
					if (rehp == '0') {
						hh_0 += traits[i].value;
					} else {
						hh_1 += traits[i].value;
					}
				} else if (traits[i].dataId == 8) {
					if (remp == '0') {
						hm_0 += traits[i].value;
					} else {
						hm_1 += traits[i].value;
					}
				}
			}
		}
	}
	this.rehp_0 = hh_0;
	this.remp_0 = hm_0;
	this.rehp_1 = hh_1;
	this.remp_1 = hm_1;
	};
})()
