﻿//==============================
// JHMW_Joystick.js
//==============================

/*:
 * @plugindesc v1.6 虚拟摇杆
 * @author 江湖梦网 Fanzi
 * @version 1.6
 *
 * @param ---主项---
 * @default
 *
 * @param PC端摇杆
 * @parent ---主项---
 * @desc 游戏发布PC端是否开启摇杆效果
 * @type boolean
 * @on 开启
 * @off 关闭
 * @default false
 *
 * @param 战场摇杆
 * @parent ---主项---
 * @desc 战斗场景是否开启摇杆效果
 * @type boolean
 * @on 开启
 * @off 关闭
 * @default false
 *
 * @param 菜单摇杆
 * @parent ---主项---
 * @desc 菜单场景是否开启摇杆效果
 * @type boolean
 * @on 开启
 * @off 关闭
 * @default false
 *
 * @param 点击移动
 * @parent ---主项---
 * @desc 是否维持点击地图控制角色移动
 * @type boolean
 * @on 维持
 * @off 禁止
 * @default true
 *
 * @param 默认显示
 * @parent ---主项---
 * @desc 启动游戏是否显示虚拟按键？读档继承游戏设定
 * @type boolean
 * @on 显示
 * @off 隐藏
 * @default true
 *
 * @param 八方移动
 * @parent ---主项---
 * @desc 是否启用八方向移动？需要八方向插件支持
 * @type boolean
 * @on 八方向
 * @off 四方向
 * @default false
 *
 * @param 方向键盘
 * @parent ---主项---
 * @desc 左下角方向盘图片，system文件夹
 * @default DirPad
 * @require 1
 * @dir img/system/
 * @type file
 *
 * @param 方向X坐标
 * @parent ---主项---
 * @desc 方向盘左上角的X坐标
 * @type number
 * @min 0
 * @default 100
 *
 * @param 方向Y坐标
 * @parent ---主项---
 * @desc 方向盘左上角的X坐标
 * @type number
 * @min 0
 * @default 600
 *
 * @param 摇杆图片
 * @parent ---主项---
 * @desc 按方向盘时显示的摇杆，留空则不启用
 * @default Shadow
 * @require 1
 * @dir img/system/
 * @type file
 *
 * @param 按钮动态
 * @parent ---主项---
 * @desc 按下按钮是否显示并且等待响应，50毫秒
 * @type boolean
 * @on 动态延时
 * @off 静态即时
 * @default true
 *
 * @param 关闭触摸
 * @parent ---主项---
 * @desc 填写需要关闭触摸指令的菜单界面名称
 * @type text[]
 * @default ["Scene_Menu"]
 *
 * @param ---地图按钮---
 * @default
 *
 * @param 地图按钮-1
 * @parent ---地图按钮---
 * @type struct<Butten>
 * @desc 按钮内容的详细配置信息，第一个按钮无法隐藏
 * @default
 *
 * @param 地图按钮-2
 * @parent ---地图按钮---
 * @type struct<Butten>
 * @desc 按钮内容的详细配置信息
 * @default
 *
 * @param 地图按钮-3
 * @parent ---地图按钮---
 * @type struct<Butten>
 * @desc 按钮内容的详细配置信息
 * @default
 *
 * @param 地图按钮-4
 * @parent ---地图按钮---
 * @type struct<Butten>
 * @desc 按钮内容的详细配置信息
 * @default
 *
 * @param 地图按钮-5
 * @parent ---地图按钮---
 * @type struct<Butten>
 * @desc 按钮内容的详细配置信息
 * @default
 *
 * @param 地图按钮-6
 * @parent ---地图按钮---
 * @type struct<Butten>
 * @desc 按钮内容的详细配置信息
 * @default
 *
 * @param 地图按钮-7
 * @parent ---地图按钮---
 * @type struct<Butten>
 * @desc 按钮内容的详细配置信息
 * @default
 *
 * @param 地图按钮-8
 * @parent ---地图按钮---
 * @type struct<Butten>
 * @desc 按钮内容的详细配置信息
 * @default
 *
 * @param 地图按钮-9
 * @parent ---地图按钮---
 * @type struct<Butten>
 * @desc 按钮内容的详细配置信息
 * @default
 *
 * @param 地图按钮-10
 * @parent ---地图按钮---
 * @type struct<Butten>
 * @desc 按钮内容的详细配置信息
 * @default
 *
 * @param 地图按钮-11
 * @parent ---地图按钮---
 * @type struct<Butten>
 * @desc 按钮内容的详细配置信息
 * @default
 *
 * @param 地图按钮-12
 * @parent ---地图按钮---
 * @type struct<Butten>
 * @desc 按钮内容的详细配置信息
 * @default
 *
 * @param 地图按钮-13
 * @parent ---地图按钮---
 * @type struct<Butten>
 * @desc 按钮内容的详细配置信息
 * @default
 *
 * @param 地图按钮-14
 * @parent ---地图按钮---
 * @type struct<Butten>
 * @desc 按钮内容的详细配置信息
 * @default
 *
 * @param 地图按钮-15
 * @parent ---地图按钮---
 * @type struct<Butten>
 * @desc 按钮内容的详细配置信息
 * @default
 *
 * @param 地图按钮-16
 * @parent ---地图按钮---
 * @type struct<Butten>
 * @desc 按钮内容的详细配置信息
 * @default
 *
 * @param 地图按钮-17
 * @parent ---地图按钮---
 * @type struct<Butten>
 * @desc 按钮内容的详细配置信息
 * @default
 *
 * @param 地图按钮-18
 * @parent ---地图按钮---
 * @type struct<Butten>
 * @desc 按钮内容的详细配置信息
 * @default
 *
 * @param 地图按钮-19
 * @parent ---地图按钮---
 * @type struct<Butten>
 * @desc 按钮内容的详细配置信息
 * @default
 *
 * @param 地图按钮-20
 * @parent ---地图按钮---
 * @type struct<Butten>
 * @desc 按钮内容的详细配置信息
 * @default
 *
 * @param ---战场按钮---
 * @default
 *
 * @param 战场按钮-1
 * @parent ---战场按钮---
 * @type struct<Butten>
 * @desc 按钮内容的详细配置信息，第一个按钮无法隐藏
 * @default
 *
 * @param 战场按钮-2
 * @parent ---战场按钮---
 * @type struct<Butten>
 * @desc 按钮内容的详细配置信息
 * @default
 *
 * @param 战场按钮-3
 * @parent ---战场按钮---
 * @type struct<Butten>
 * @desc 按钮内容的详细配置信息
 * @default
 *
 * @param 战场按钮-4
 * @parent ---战场按钮---
 * @type struct<Butten>
 * @desc 按钮内容的详细配置信息
 * @default
 *
 * @param 战场按钮-5
 * @parent ---战场按钮---
 * @type struct<Butten>
 * @desc 按钮内容的详细配置信息
 * @default
 *
 * @param 战场按钮-6
 * @parent ---战场按钮---
 * @type struct<Butten>
 * @desc 按钮内容的详细配置信息
 * @default
 *
 * @param 战场按钮-7
 * @parent ---战场按钮---
 * @type struct<Butten>
 * @desc 按钮内容的详细配置信息
 * @default
 *
 * @param 战场按钮-8
 * @parent ---战场按钮---
 * @type struct<Butten>
 * @desc 按钮内容的详细配置信息
 * @default
 *
 * @param 战场按钮-9
 * @parent ---战场按钮---
 * @type struct<Butten>
 * @desc 按钮内容的详细配置信息
 * @default
 *
 * @param 战场按钮-10
 * @parent ---战场按钮---
 * @type struct<Butten>
 * @desc 按钮内容的详细配置信息
 * @default
 *
 * @param 战场按钮-11
 * @parent ---战场按钮---
 * @type struct<Butten>
 * @desc 按钮内容的详细配置信息
 * @default
 *
 * @param 战场按钮-12
 * @parent ---战场按钮---
 * @type struct<Butten>
 * @desc 按钮内容的详细配置信息
 * @default
 *
 * @param 战场按钮-13
 * @parent ---战场按钮---
 * @type struct<Butten>
 * @desc 按钮内容的详细配置信息
 * @default
 *
 * @param 战场按钮-14
 * @parent ---战场按钮---
 * @type struct<Butten>
 * @desc 按钮内容的详细配置信息
 * @default
 *
 * @param 战场按钮-15
 * @parent ---战场按钮---
 * @type struct<Butten>
 * @desc 按钮内容的详细配置信息
 * @default
 *
 * @param ---菜单按钮---
 * @default
 *
 * @param 菜单按钮-1
 * @parent ---菜单按钮---
 * @type struct<Butten>
 * @desc 按钮内容的详细配置信息，第一个按钮无法隐藏
 * @default
 *
 * @param 菜单按钮-2
 * @parent ---菜单按钮---
 * @type struct<Butten>
 * @desc 按钮内容的详细配置信息
 * @default
 *
 * @param 菜单按钮-3
 * @parent ---菜单按钮---
 * @type struct<Butten>
 * @desc 按钮内容的详细配置信息
 * @default
 *
 * @param 菜单按钮-4
 * @parent ---菜单按钮---
 * @type struct<Butten>
 * @desc 按钮内容的详细配置信息
 * @default
 *
 * @param 菜单按钮-5
 * @parent ---菜单按钮---
 * @type struct<Butten>
 * @desc 按钮内容的详细配置信息
 * @default
 *
 * @help
 * 本插件为 江湖梦网•Fanzi 原创力作，仅供江湖梦网入驻游戏免费使用，其它
 * 游戏如需使用请咨询 江湖梦网 或 Fanzi 获得授权，未经授权的使用将可能受
 * 到侵权追究。
 * 【江湖梦网】游戏自助服务平台 https://bbs.jhmeng.cn/  QQ：12868880
 *
 * 本插件可以在地图、战斗场景、各式菜单界面生成触摸方向盘与自定义功能的
 * 按钮，其中方向盘模拟摇杆样式，支持最多地图二十、战场十个、菜单五个按
 * 钮，方向盘及所有按钮全为圆形有效范围，按钮支持调用公共事件、键盘按键、
 * 自定义脚本，插件取消双指触屏返回功能，方向盘与按钮支持同时多点触发，
 * 使游戏得以模仿 ARPG 效果，如配合作者修改的 MOG_LMBS.js 插件使用，
 * 在战斗场景生成按钮，点击按钮可施放技能或使用物品，效果极佳。
 *
 * 插件指令：
 * 显示按钮生效点击：MBJopen
 * 隐藏按钮禁用点击：MBJclose
 * 脚本指令：
 * 显示按钮生效点击：$gameSystem.setJoystickShow(true);
 * 隐藏按钮禁用点击：$gameSystem.setJoystickShow(false);
 * 第一按钮用作摇杆开关时可调用如下脚本：
 *  $gameSystem._joystickShow = !$gameSystem._joystickShow;
 *
 * 插件使用到的素材需为圆形，置于 img/system/ 文件夹里，
 * 音效置于 audio/se/ 文件夹里。
 * 按钮调用键盘按键的按键列表如下：
 * 填写：     对应键：       填写：    对应键：
 * tab       ：tab             ok      ：enter、space、Z
 * shift     ：shift           escape  ：escape、insert、X、numpad 0
 * control   ：control、alt    left    ：left arrow、numpad 4
 * pageup    ：pageup、Q       right   ：right arrow、numpad 6
 * pagedown  ：pagedown、W     up      ：up arrow、numpad 8
 * debug     ：F9              down    ：down arrow、numpad 2
 *
 * 如遇有些插件生成菜单不显示方向盘与按钮，或者点击无响应，可作如下调整：
 * 1、本插件需优于其它菜单插件运行，请放在插件管理器底层。
 * 2、本插件关于菜单功能写在 Scene_MenuBase 类，有些插件可能会将菜单继
 * 承直接跳过 Scene_MenuBase 类，而直接继承在 Scene_Base 类上，遇到这种
 * 情况需修改对应的生成或修改菜单的插件(非摇杆插件)。
 * 搜索以下语句：
 * Scene_Base.prototype.create.call(this);
 * Scene_Base.prototype.update.call(this);
 * 分别替换为以下语句即可：
 * Scene_MenuBase.prototype.create.call(this);
 * Scene_MenuBase.prototype.update.call(this);
 */
/*~struct~Butten:
 * 
 * @param 启用按钮
 * @type boolean
 * @on 启用
 * @off 禁用
 * @desc true - 启用，false - 禁用
 * @default false
 * 
 * @param PCWeb有效
 * @type boolean
 * @on 启用
 * @off 禁用
 * @desc 非手机端是否启用按钮，true - 启用，false - 禁用
 * @default true
 * 
 * @param 按钮图片
 * @desc 选择按钮使用的图片素材
 * @default 
 * @require 1
 * @dir img/system/
 * @type file
 *
 * @param 按钮X坐标
 * @type number
 * @min 0
 * @desc 希望按钮出现位置的左上角X坐标
 * @default
 *
 * @param 按钮Y坐标
 * @type number
 * @min 0
 * @desc 希望按钮出现位置的左上角Y坐标
 * @default
 * 
 * @param 触发模式
 * @type boolean
 * @on 长按连发
 * @off 长按单发
 * @desc true - 长按连发，false - 长按单发
 * @default false
 *
 * @param 调用类型
 * @type select
 * @option 公共事件
 * @value 0
 * @option 键盘按键
 * @value 1
 * @option 运行脚本
 * @value 2
 * @desc 0 - 公共事件   1 - 键盘按键   2 - 运行脚本
 * @default
 * 
 * @param 公共事件id
 * @type common_event
 * @desc 按下按钮调用的公共事件id，非此类型不填
 * @default
 *
 * @param 键盘按键
 * @desc 按下按钮调用的键盘按键，非此类型不填
 * @default
 *
 * @param 运行脚本
 * @desc 按下按钮调用的脚本内容，非此类型不填
 * @default
 */
//==============================

var Imported = Imported || {};
Imported.JHMW_Joystick = 1.5;

var JHMW = JHMW || {};
JHMW.Joystick = JHMW.Joystick || {};
JHMW.JoystickParam = PluginManager.parameters('JHMW_Joystick');

JHMW.Joystick.PCJoystick = JHMW.JoystickParam['PC端摇杆'].toLowerCase() == 'true';
JHMW.Joystick.btlJoystick = JHMW.JoystickParam['战场摇杆'].toLowerCase() == 'true';
JHMW.Joystick.menuJoystick = JHMW.JoystickParam['菜单摇杆'].toLowerCase() == 'true';
JHMW.Joystick.TouchMove = JHMW.JoystickParam['点击移动'].toLowerCase() == 'true';
JHMW.Joystick.Respond = JHMW.JoystickParam['按钮动态'].toLowerCase() == 'true';
JHMW.Joystick.joyShow = JHMW.JoystickParam['默认显示'].toLowerCase() == 'true';
JHMW.Joystick.dir8Move = JHMW.JoystickParam['八方移动'].toLowerCase() == 'true';
JHMW.Joystick.DirPadimg = String(JHMW.JoystickParam['方向键盘']);
JHMW.Joystick.DirPadX = parseInt(JHMW.JoystickParam['方向X坐标']);
JHMW.Joystick.DirPadY = parseInt(JHMW.JoystickParam['方向Y坐标']);
JHMW.Joystick.Shadow = String(JHMW.JoystickParam['摇杆图片']);
JHMW.Joystick.Scenes = JHMW.JoystickParam['关闭触摸'];
JHMW.Joystick.mapBtn = [];
JHMW.Joystick.mapBtnPCActive = [];
JHMW.Joystick.mapBtnActive = [];
JHMW.Joystick.mapBtnName = [];
JHMW.Joystick.mapBtnX = [];
JHMW.Joystick.mapBtnY = [];
JHMW.Joystick.mapBtnMode = [];
JHMW.Joystick.mapBtnType = [];
JHMW.Joystick.mapBtnEvent = [];
JHMW.Joystick.mapBtnKey = [];
JHMW.Joystick.mapBtnScript = [];
JHMW.Joystick.btlBtn = [];
JHMW.Joystick.btlBtnPCActive = [];
JHMW.Joystick.btlBtnActive = [];
JHMW.Joystick.btlBtnName = [];
JHMW.Joystick.btlBtnX = [];
JHMW.Joystick.btlBtnY = [];
JHMW.Joystick.btlBtnMode = [];
JHMW.Joystick.btlBtnType = [];
JHMW.Joystick.btlBtnEvent = [];
JHMW.Joystick.btlBtnKey = [];
JHMW.Joystick.btlBtnScript = [];
JHMW.Joystick.menuBtn = [];
JHMW.Joystick.menuBtnPCActive = [];
JHMW.Joystick.menuBtnActive = [];
JHMW.Joystick.menuBtnName = [];
JHMW.Joystick.menuBtnX = [];
JHMW.Joystick.menuBtnY = [];
JHMW.Joystick.menuBtnMode = [];
JHMW.Joystick.menuBtnType = [];
JHMW.Joystick.menuBtnEvent = [];
JHMW.Joystick.menuBtnKey = [];
JHMW.Joystick.menuBtnScript = [];
for (var i = 0; i < 20; i++) {
    if (JHMW.JoystickParam['地图按钮-' + String(i + 1)] != '') {
        JHMW.Joystick.mapBtn[i] = JSON.parse(JHMW.JoystickParam['地图按钮-' + String(i + 1)]);
    } else {
        JHMW.Joystick.mapBtn[i] = {};
    }
    JHMW.Joystick.mapBtnPCActive[i] = String(JHMW.Joystick.mapBtn[i]['PCWeb有效']).toLowerCase() == 'true';
    JHMW.Joystick.mapBtnActive[i] = String(JHMW.Joystick.mapBtn[i]['启用按钮']).toLowerCase() == 'true';
    JHMW.Joystick.mapBtnName[i] = String(JHMW.Joystick.mapBtn[i]['按钮图片']);
    JHMW.Joystick.mapBtnX[i] = Number(JHMW.Joystick.mapBtn[i]['按钮X坐标']);
    JHMW.Joystick.mapBtnY[i] = Number(JHMW.Joystick.mapBtn[i]['按钮Y坐标']);
    JHMW.Joystick.mapBtnMode[i] = String(JHMW.Joystick.mapBtn[i]['触发模式']).toLowerCase() == 'true';
    JHMW.Joystick.mapBtnType[i] = Number(JHMW.Joystick.mapBtn[i]['调用类型']);
    JHMW.Joystick.mapBtnEvent[i] = Number(JHMW.Joystick.mapBtn[i]['公共事件id']);
    JHMW.Joystick.mapBtnKey[i] = String(JHMW.Joystick.mapBtn[i]['键盘按键']);
    JHMW.Joystick.mapBtnScript[i] = String(JHMW.Joystick.mapBtn[i]['运行脚本']);
}
for (var i = 0; i < 15; i++) {
    if (JHMW.JoystickParam['战场按钮-' + String(i + 1)] != '') {
        JHMW.Joystick.btlBtn[i] = JSON.parse(JHMW.JoystickParam['战场按钮-' + String(i + 1)]);
    } else {
        JHMW.Joystick.btlBtn[i] = {};
    }
    JHMW.Joystick.btlBtnPCActive[i] = String(JHMW.Joystick.btlBtn[i]['PCWeb有效']).toLowerCase() == 'true';
    JHMW.Joystick.btlBtnActive[i] = String(JHMW.Joystick.btlBtn[i]['启用按钮']).toLowerCase() == 'true';
    JHMW.Joystick.btlBtnName[i] = String(JHMW.Joystick.btlBtn[i]['按钮图片']);
    JHMW.Joystick.btlBtnX[i] = Number(JHMW.Joystick.btlBtn[i]['按钮X坐标']);
    JHMW.Joystick.btlBtnY[i] = Number(JHMW.Joystick.btlBtn[i]['按钮Y坐标']);
    JHMW.Joystick.btlBtnMode[i] = String(JHMW.Joystick.btlBtn[i]['触发模式']).toLowerCase() == 'true';
    JHMW.Joystick.btlBtnType[i] = Number(JHMW.Joystick.btlBtn[i]['调用类型']);
    JHMW.Joystick.btlBtnEvent[i] = Number(JHMW.Joystick.btlBtn[i]['公共事件id']);
    JHMW.Joystick.btlBtnKey[i] = String(JHMW.Joystick.btlBtn[i]['键盘按键']);
    JHMW.Joystick.btlBtnScript[i] = String(JHMW.Joystick.btlBtn[i]['运行脚本']);
}
for (var i = 0; i < 5; i++) {
    if (JHMW.JoystickParam['菜单按钮-' + String(i + 1)] != '') {
        JHMW.Joystick.menuBtn[i] = JSON.parse(JHMW.JoystickParam['菜单按钮-' + String(i + 1)]);
    } else {
        JHMW.Joystick.menuBtn[i] = {};
    }
    JHMW.Joystick.menuBtnPCActive[i] = String(JHMW.Joystick.menuBtn[i]['PCWeb有效']).toLowerCase() == 'true';
    JHMW.Joystick.menuBtnActive[i] = String(JHMW.Joystick.menuBtn[i]['启用按钮']).toLowerCase() == 'true';
    JHMW.Joystick.menuBtnName[i] = String(JHMW.Joystick.menuBtn[i]['按钮图片']);
    JHMW.Joystick.menuBtnX[i] = Number(JHMW.Joystick.menuBtn[i]['按钮X坐标']);
    JHMW.Joystick.menuBtnY[i] = Number(JHMW.Joystick.menuBtn[i]['按钮Y坐标']);
    JHMW.Joystick.menuBtnMode[i] = String(JHMW.Joystick.menuBtn[i]['触发模式']).toLowerCase() == 'true';
    JHMW.Joystick.menuBtnType[i] = Number(JHMW.Joystick.menuBtn[i]['调用类型']);
    JHMW.Joystick.menuBtnEvent[i] = Number(JHMW.Joystick.menuBtn[i]['公共事件id']);
    JHMW.Joystick.menuBtnKey[i] = String(JHMW.Joystick.menuBtn[i]['键盘按键']);
    JHMW.Joystick.menuBtnScript[i] = String(JHMW.Joystick.menuBtn[i]['运行脚本']);
}
JHMW.Joystick.Input = false;
JHMW.Joystick.Touch = false;
JHMW.Joystick.DirTouch = false;
JHMW.Joystick.Message = false;
JHMW.Joystick.TouchX = 0;
JHMW.Joystick.TouchY = 0;

JHMW.Joystick._onTouchStart = TouchInput._onTouchStart;
TouchInput._onTouchStart = function(event) {
    JHMW.Joystick.TouchX = Graphics.pageToCanvasX(event.touches[0].pageX);
    JHMW.Joystick.TouchY = Graphics.pageToCanvasY(event.touches[0].pageY);
    if (event.touches.length > 1) JHMW.Joystick.Touch = true;
    JHMW.Joystick._onTouchStart.apply(this, arguments);
};

JHMW.Joystick._onTouchMove = TouchInput._onTouchMove;
TouchInput._onTouchMove = function(event) {
    JHMW.Joystick.TouchX = Graphics.pageToCanvasX(event.touches[0].pageX);
    JHMW.Joystick.TouchY = Graphics.pageToCanvasY(event.touches[0].pageY);
    JHMW.Joystick._onTouchMove.apply(this, arguments);
};

TouchInput._onTouchEnd = function(event) {
    for (var i = 0; i < event.changedTouches.length; i++) {
        var touch = event.changedTouches[i];
        var x = Graphics.pageToCanvasX(touch.pageX);
        var y = Graphics.pageToCanvasY(touch.pageY);
        JHMW.Joystick.DirTouch = false;
        JHMW.Joystick.Touch = false;
        this._screenPressed = false;
        this._onRelease(x, y);
    }
    if (event.touches[0]) {
        JHMW.Joystick.Touch = true;
        JHMW.Joystick.DirTouch = true;
        JHMW.Joystick.TouchX = Graphics.pageToCanvasX(event.touches[0].pageX);
        JHMW.Joystick.TouchY = Graphics.pageToCanvasY(event.touches[0].pageY);
    }
};

TouchInput._onCancel = function(x, y) {
    if (!Utils.isMobileDevice() || !$gameSystem.isJoystickShow()) this._events.cancelled = true;
    this._x = x;
    this._y = y;
};

TouchInput.clearPressed = function() {
    Input._currentState['up'] = false;
    Input._currentState['down'] = false;
    Input._currentState['left'] = false;
    Input._currentState['right'] = false;
    JHMW.Joystick.Input = false;
};

TouchInput.onButton = function() {
    if ($gameSystem.isJoystickShow() && SceneManager._scene._dirPad) {
        var rr = SceneManager._scene._dirPad.width / 2
        var xx = this.x - JHMW.Joystick.DirPadX - rr;
        var yy = this.y - JHMW.Joystick.DirPadY - rr;
        if (Math.sqrt(Math.pow(xx, 2) + Math.pow(yy, 2)) <= rr)
            return true;
    }
    if (SceneManager._scene instanceof Scene_Map)
        var btns = SceneManager._scene._mapBtn;
    else if (SceneManager._scene instanceof Scene_Battle)
        var btns = SceneManager._scene._btlBtn;
    else if (SceneManager._scene instanceof Scene_MenuBase)
        var btns = SceneManager._scene._menuBtn;
    else btns = null;
    if (!btns) return false;
    var state = false;
    for (var i = 0; i < btns.length; i++) {
        var xx = btns[i] ? this.x - btns[i].x - btns[i].width / 2 : 0;
        var yy = btns[i] ? this.y - btns[i].y - btns[i].height / 2 : 0;
        if (btns[i] && Math.sqrt(Math.pow(xx, 2) + Math.pow(yy, 2)) <= btns[i].width / 2) {
            if (i == 0 || $gameSystem.isJoystickShow()) {
                state = true;
                break;
            }
        }
    }
    return state;
};

TouchInput.isButton = function() {
    if (SceneManager._scene instanceof Scene_Map)
        var btns = SceneManager._scene._mapBtn;
    else if (SceneManager._scene instanceof Scene_Battle)
        var btns = SceneManager._scene._btlBtn;
    else if (SceneManager._scene instanceof Scene_MenuBase)
        var btns = SceneManager._scene._menuBtn;
    else btns = null;
    if (!btns) return false;
    var state = false;
    for (var i = 0; i < btns.length; i++) {
        var xx = btns[i] ? JHMW.Joystick.TouchX - btns[i].x - btns[i].width / 2 : 0;
        var yy = btns[i] ? JHMW.Joystick.TouchY - btns[i].y - btns[i].height / 2 : 0;
        if (btns[i] && Math.sqrt(Math.pow(xx, 2) + Math.pow(yy, 2)) <= btns[i].width / 2) {
            state = true;
            break;
        }
    }
    return state;
};

JHMW.Joystick.Game_Temp_setDestination = Game_Temp.prototype.setDestination;
Game_Temp.prototype.setDestination = function(x, y) {
    if (TouchInput.onButton() || JHMW.Joystick.DirTouch) return;
    if (Utils.isMobileDevice() && !JHMW.Joystick.TouchMove && $gameSystem.isJoystickShow()) return;
    if (JHMW.Joystick.PCJoystick && !JHMW.Joystick.TouchMove && $gameSystem.isJoystickShow()) return;
    JHMW.Joystick.Game_Temp_setDestination.call(this, x, y);
};

JHMW.Joystick.Game_System_initialize = Game_System.prototype.initialize;
Game_System.prototype.initialize = function() {
    JHMW.Joystick.Game_System_initialize.call(this);
    this._joystickShow = JHMW.Joystick.joyShow;
};

Game_System.prototype.isJoystickShow = function() {
    return this._joystickShow;
};

Game_System.prototype.setJoystickShow = function(value) {
    this._joystickShow = value;
};

JHMW.Joystick.Game_Interpreter_pluginCommand = Game_Interpreter.prototype.pluginCommand;
Game_Interpreter.prototype.pluginCommand = function(command, args){
    JHMW.Joystick.Game_Interpreter_pluginCommand.call(this, command, args);
    if (command === 'MBJopen') $gameSystem.setJoystickShow(true);
    if (command === 'MBJclose') $gameSystem.setJoystickShow(false);
};

Scene_Base.prototype.createDirPad = function() {
    if (JHMW.Joystick.DirPadimg) {
        this._dirPad = new Sprite(ImageManager.loadSystem(JHMW.Joystick.DirPadimg));
        this.addChild(this._dirPad);
        this._dirPad.move(JHMW.Joystick.DirPadX, JHMW.Joystick.DirPadY);
        if ($gameSystem.isJoystickShow()) this._dirPad.opacity = 255;
        else this._dirPad.opacity = 0;
    }
};

Scene_Base.prototype.createTouchShadow = function() {
    if (JHMW.Joystick.Shadow) {
        this._touchShadow = new Sprite(ImageManager.loadSystem(JHMW.Joystick.Shadow));
        this.addChild(this._touchShadow);
        var x = this._dirPad.x + this._dirPad.width / 2 - this._touchShadow.width / 2;
        var y = this._dirPad.y + this._dirPad.height / 2 - this._touchShadow.height / 2;
        this._touchShadow.move(x, y);
        if ($gameSystem.isJoystickShow()) this._touchShadow.opacity = 255;
        else this._touchShadow.opacity = 0;
    }
};

Scene_Base.prototype.createMapButton = function() {
    this._mapBtn = [];
    for (var i = 0; i < JHMW.Joystick.mapBtn.length; i++) {
        if (JHMW.Joystick.mapBtnActive[i] && (Utils.isMobileDevice() || JHMW.Joystick.mapBtnPCActive[i])) {
            this._mapBtn[i] = new Sprite(ImageManager.loadSystem(JHMW.Joystick.mapBtnName[i]));
            this.addChild(this._mapBtn[i]);
            this._mapBtn[i].move(JHMW.Joystick.mapBtnX[i], JHMW.Joystick.mapBtnY[i]);
            if (i == 0 || $gameSystem.isJoystickShow()) this._mapBtn[i].opacity = 255;
            else this._mapBtn[i].opacity = 0;
        }
    }
};

Scene_Base.prototype.createBattleButton = function() {
    this._btlBtn = [];
    for (var i = 0; i < JHMW.Joystick.btlBtn.length; i++) {
        if (JHMW.Joystick.btlBtnActive[i] && (Utils.isMobileDevice() || JHMW.Joystick.btlBtnPCActive[i])) {
            this._btlBtn[i] = new Sprite(ImageManager.loadSystem(JHMW.Joystick.btlBtnName[i]));
            this.addChild(this._btlBtn[i]);
            this._btlBtn[i].move(JHMW.Joystick.btlBtnX[i], JHMW.Joystick.btlBtnY[i]);
            if (i == 0 || $gameSystem.isJoystickShow()) this._btlBtn[i].opacity = 255;
            else this._btlBtn[i].opacity = 0;
        }
    }
};

Scene_Base.prototype.createMenuButton = function() {
    this._menuBtn = [];
    for (var i = 0; i < JHMW.Joystick.menuBtn.length; i++) {
        if (JHMW.Joystick.menuBtnActive[i] && (Utils.isMobileDevice() || JHMW.Joystick.menuBtnPCActive[i])) {
            this._menuBtn[i] = new Sprite(ImageManager.loadSystem(JHMW.Joystick.menuBtnName[i]));
            this.addChild(this._menuBtn[i]);
            this._menuBtn[i].move(JHMW.Joystick.menuBtnX[i], JHMW.Joystick.menuBtnY[i]);
            if (i == 0 || $gameSystem.isJoystickShow()) this._menuBtn[i].opacity = 255;
            else this._menuBtn[i].opacity = 0;
        }
    }
};

Scene_Base.prototype.updateShadow = function() {
    if (!JHMW.Joystick.Shadow) return;
    if (Utils.isMobileDevice()) {
        var xx = JHMW.Joystick.TouchX - this._dirPad.x - this._dirPad.width / 2;
        var yy = JHMW.Joystick.TouchY - this._dirPad.y - this._dirPad.height / 2;
        var tx = JHMW.Joystick.TouchX - this._touchShadow.width / 2;
        var ty = JHMW.Joystick.TouchY - this._touchShadow.height / 2;
    } else {
        var xx = TouchInput.x - this._dirPad.x - this._dirPad.width / 2;
        var yy = TouchInput.y - this._dirPad.y - this._dirPad.height / 2;
        var tx = TouchInput.x - this._touchShadow.width / 2;
        var ty = TouchInput.y - this._touchShadow.height / 2;
    }
    var rr = Math.sqrt(Math.pow(xx, 2) + Math.pow(yy, 2));
    if (TouchInput.isPressed() && rr <= this._dirPad.width / 2)
        this._touchShadow.move(tx, ty);
    else if (JHMW.Joystick.Touch || JHMW.Joystick.DirTouch) {
        var sx = (rr <= this._dirPad.width / 2) ? xx : (xx / rr * this._dirPad.width / 2);
        var sy = (rr <= this._dirPad.height / 2) ? yy : (yy / rr * this._dirPad.height / 2);
        var dx = this._dirPad.x + this._dirPad.width / 2 - this._touchShadow.width / 2;
        var dy = this._dirPad.y + this._dirPad.height / 2 - this._touchShadow.height / 2;
        this._touchShadow.move(dx + sx, dy + sy);
    } else {
        var ox = this._dirPad.x + this._dirPad.width / 2 - this._touchShadow.width / 2;
        var oy = this._dirPad.y + this._dirPad.height / 2 - this._touchShadow.height / 2;
        this._touchShadow.move(ox, oy);
    }
};

Scene_Base.prototype.updateButton = function(index) {
    if (index > 0 && !$gameSystem.isJoystickShow()) return;
    var scene = SceneManager._scene;
    if (JHMW.Joystick.Respond) {
        this.activateButton(index);
        setTimeout(function(){
            if (SceneManager._scene == scene) {
                this.resetButton(index);
                this.respondButton(index);
            }
        }.bind(this), 50);
    } else this.respondButton(index);
};

Scene_Base.prototype.activateButton = function(index) {
    if (SceneManager._scene instanceof Scene_Map) {
        var btn = this._mapBtn[index];
        btn.x = JHMW.Joystick.mapBtnX[index] + 3;
        btn.y = JHMW.Joystick.mapBtnY[index] + 3;
    } else if (SceneManager._scene instanceof Scene_Battle) {
        var btn = this._btlBtn[index];
        btn.x = JHMW.Joystick.btlBtnX[index] + 3;
        btn.y = JHMW.Joystick.btlBtnY[index] + 3;
    } else if (SceneManager._scene instanceof Scene_MenuBase) {
        var btn = this._menuBtn[index];
        btn.x = JHMW.Joystick.menuBtnX[index] + 3;
        btn.y = JHMW.Joystick.menuBtnY[index] + 3;
    }
    btn.opacity = 150;
};

Scene_Base.prototype.resetButton = function(index) {
    if (SceneManager._scene instanceof Scene_Map) {
        var btn = this._mapBtn[index];
        btn.x = JHMW.Joystick.mapBtnX[index];
        btn.y = JHMW.Joystick.mapBtnY[index];
    } else if (SceneManager._scene instanceof Scene_Battle) {
        var btn = this._btlBtn[index];
        btn.x = JHMW.Joystick.btlBtnX[index];
        btn.y = JHMW.Joystick.btlBtnY[index];
    } else if (SceneManager._scene instanceof Scene_MenuBase) {
        var btn = this._menuBtn[index];
        btn.x = JHMW.Joystick.menuBtnX[index];
        btn.y = JHMW.Joystick.menuBtnY[index];
    }
    btn.opacity = 255;
};

Scene_Base.prototype.respondDirPad = function() {
    if (!$gameSystem.isJoystickShow()) return;
    if (Utils.isMobileDevice()) {
        var xx = JHMW.Joystick.TouchX - this._dirPad.x - this._dirPad.width / 2;
        var yy = JHMW.Joystick.TouchY - this._dirPad.y - this._dirPad.height / 2;
    } else {
        var xx = TouchInput.x - this._dirPad.x - this._dirPad.width / 2;
        var yy = TouchInput.y - this._dirPad.y - this._dirPad.height / 2;
    }
    if (TouchInput.isPressed() && Math.sqrt(Math.pow(xx, 2) + Math.pow(yy, 2)) <= this._dirPad.width / 2) {
        if (!Utils.isMobileDevice()) JHMW.Joystick.Input = true;
        if (!TouchInput.isButton()) this.actionDirPad(xx, yy);
    } else if (!TouchInput.isButton() && (JHMW.Joystick.Touch || JHMW.Joystick.DirTouch))
        this.actionDirPad(xx, yy);
    else TouchInput.clearPressed();
};

Scene_Base.prototype.actionDirPad = function(x, y) {
    if (Utils.isMobileDevice()) JHMW.Joystick.DirTouch = true;
    if (JHMW.Joystick.dir8Move && x > 0 && x / -y > Math.tan(0.3927) && -y / x > Math.tan(0.3927)) {
        Input._currentState['up'] = true;
        Input._currentState['down'] = false;
        Input._currentState['left'] = false;
        Input._currentState['right'] = true;
    } else if (JHMW.Joystick.dir8Move && x < 0 && x / y > Math.tan(0.3927) && y / x > Math.tan(0.3927)) {
        Input._currentState['up'] = true;
        Input._currentState['down'] = false;
        Input._currentState['left'] = true;
        Input._currentState['right'] = false;
    } else if (JHMW.Joystick.dir8Move && x < 0 && x / -y > Math.tan(0.3927) && -y / x > Math.tan(0.3927)) {
        Input._currentState['up'] = false;
        Input._currentState['down'] = true;
        Input._currentState['left'] = true;
        Input._currentState['right'] = false;
    } else if (JHMW.Joystick.dir8Move && x > 0 && x / y > Math.tan(0.3927) && y / x > Math.tan(0.3927)) {
        Input._currentState['up'] = false;
        Input._currentState['down'] = true;
        Input._currentState['left'] = false;
        Input._currentState['right'] = true;
    } else if (x > 0 && Math.abs(x) >= Math.abs(y)) {
        Input._currentState['up'] = false;
        Input._currentState['down'] = false;
        Input._currentState['left'] = false;
        Input._currentState['right'] = true;
    } else if (x < 0 && Math.abs(x) >= Math.abs(y)) {
        Input._currentState['up'] = false;
        Input._currentState['down'] = false;
        Input._currentState['left'] = true;
        Input._currentState['right'] = false;
    } else if (y > 0 && Math.abs(x) < Math.abs(y)) {
        Input._currentState['up'] = false;
        Input._currentState['down'] = true;
        Input._currentState['left'] = false;
        Input._currentState['right'] = false;
    } else if (y < 0 && Math.abs(x) < Math.abs(y)) {
        Input._currentState['up'] = true;
        Input._currentState['down'] = false;
        Input._currentState['left'] = false;
        Input._currentState['right'] = false;
    }
};

Scene_Base.prototype.respondButton = function(index) {
    if (SceneManager._scene instanceof Scene_Map) {
        if (JHMW.Joystick.mapBtnType[index] == 0) $gameTemp.reserveCommonEvent(JHMW.Joystick.mapBtnEvent[index]);
        else if (JHMW.Joystick.mapBtnType[index] == 1) {
            Input._currentState[JHMW.Joystick.mapBtnKey[index]] = true;
            setTimeout(function(){Input._currentState[JHMW.Joystick.mapBtnKey[index]] = false;}, 100);
        } else eval(JHMW.Joystick.mapBtnScript[index]);
    } else if (SceneManager._scene instanceof Scene_Battle) {
        if (JHMW.Joystick.btlBtnType[index] == 0) $gameTemp.reserveCommonEvent(JHMW.Joystick.btlBtnEvent[index]);
        else if (JHMW.Joystick.btlBtnType[index] == 1) {
            Input._currentState[JHMW.Joystick.btlBtnKey[index]] = true;
            setTimeout(function(){Input._currentState[JHMW.Joystick.btlBtnKey[index]] = false;}, 100);
        } else eval(JHMW.Joystick.btlBtnScript[index]);
    } else if (SceneManager._scene instanceof Scene_MenuBase) {
        if (JHMW.Joystick.menuBtnType[index] == 0) $gameTemp.reserveCommonEvent(JHMW.Joystick.menuBtnEvent[index]);
        else if (JHMW.Joystick.menuBtnType[index] == 1) {
            Input._currentState[JHMW.Joystick.menuBtnKey[index]] = true;
            setTimeout(function(){Input._currentState[JHMW.Joystick.menuBtnKey[index]] = false;}, 100);
        } else eval(JHMW.Joystick.menuBtnScript[index]);
    }
};

Scene_Base.prototype.updateOpacity = function() {
    if ($gameSystem.isJoystickShow()) {
        if (this._dirPad) this._dirPad.opacity = 255;
        if (this._touchShadow) this._touchShadow.opacity = 255;
        for (var i = 1; i < 20; i++) {
            if (this._mapBtn && this._mapBtn[i]) this._mapBtn[i].opacity = 255;
            if (this._btlBtn && this._btlBtn[i]) this._btlBtn[i].opacity = 255;
            if (this._menuBtn && this._menuBtn[i]) this._menuBtn[i].opacity = 255;
        }
    } else {
        if (this._dirPad) this._dirPad.opacity = 0;
        if (this._touchShadow) this._touchShadow.opacity = 0;
        for (var i = 1; i < 20; i++) {
            if (this._mapBtn && this._mapBtn[i]) this._mapBtn[i].opacity = 0;
            if (this._btlBtn && this._btlBtn[i]) this._btlBtn[i].opacity = 0;
            if (this._menuBtn && this._menuBtn[i]) this._menuBtn[i].opacity = 0;
        }
    }
    this.JoystickShow = $gameSystem.isJoystickShow();
};

JHMW.Joystick.Scene_Map_create = Scene_Map.prototype.createAllWindows;
Scene_Map.prototype.createAllWindows = function() {
    JHMW.Joystick.Scene_Map_create.call(this);
    this.createMapButton();
    if (Utils.isMobileDevice() || JHMW.Joystick.PCJoystick) {
        this.createDirPad();
        this.createTouchShadow();
    }
    this.JoystickShow = $gameSystem.isJoystickShow();
};

JHMW.Joystick.Scene_Map_update = Scene_Map.prototype.update;
Scene_Map.prototype.update = function() {
    JHMW.Joystick.Scene_Map_update.call(this);
    if (!JHMW.Joystick.Message && (TouchInput.isPressed() || JHMW.Joystick.Touch || JHMW.Joystick.DirTouch)) {
        var x = TouchInput.x;
        var y = TouchInput.y;
        for (var i = 0; i < 20; i++) {
            if (JHMW.Joystick.mapBtnActive[i] && (Utils.isMobileDevice() || JHMW.Joystick.mapBtnPCActive[i])) {
                var xx = x - JHMW.Joystick.mapBtnX[i] - this._mapBtn[i].width / 2;
                var yy = y - JHMW.Joystick.mapBtnY[i] - this._mapBtn[i].height / 2;
                if ((JHMW.Joystick.mapBtnMode[i] || TouchInput.isTriggered()) && Math.sqrt(Math.pow(xx, 2) + Math.pow(yy, 2)) <= this._mapBtn[i].width / 2)
                    this.updateButton(i);
            }
        }
        if (JHMW.Joystick.Shadow && this._touchShadow) this.updateShadow();
        if (Utils.isMobileDevice() || JHMW.Joystick.PCJoystick) this.respondDirPad();
    } else {
        if (JHMW.Joystick.Input && $gameSystem.isJoystickShow()) TouchInput.clearPressed();
        if (Utils.isMobileDevice() && !JHMW.Joystick.Touch && $gameSystem.isJoystickShow()) TouchInput.clearPressed();
        if (JHMW.Joystick.Shadow && this._touchShadow) this.updateShadow();
    }
    if (this.JoystickShow != $gameSystem.isJoystickShow()) this.updateOpacity();
};

JHMW.Joystick.Scene_Battle_create = Scene_Battle.prototype.createAllWindows;
Scene_Battle.prototype.createAllWindows = function() {
    JHMW.Joystick.Scene_Battle_create.call(this);
    this.createBattleButton();
    if ((Utils.isMobileDevice() || JHMW.Joystick.PCJoystick) && JHMW.Joystick.btlJoystick) {
        this.createDirPad();
        this.createTouchShadow();
    }
    this.JoystickShow = $gameSystem.isJoystickShow();
};

JHMW.Joystick.Scene_Battle_update = Scene_Battle.prototype.update;
Scene_Battle.prototype.update = function() {
    JHMW.Joystick.Scene_Battle_update.call(this);
    if (!JHMW.Joystick.Message && (TouchInput.isPressed() || JHMW.Joystick.Touch || JHMW.Joystick.DirTouch)) {
        var x = TouchInput.x;
        var y = TouchInput.y;
        for (var i = 0; i < 15; i++) {
            if (JHMW.Joystick.btlBtnActive[i] && (Utils.isMobileDevice() || JHMW.Joystick.btlBtnPCActive[i])) {
                var xx = x - JHMW.Joystick.btlBtnX[i] - this._btlBtn[i].width / 2;
                var yy = y - JHMW.Joystick.btlBtnY[i] - this._btlBtn[i].height / 2;
                if ((JHMW.Joystick.btlBtnMode[i] || TouchInput.isTriggered()) && Math.sqrt(Math.pow(xx, 2) + Math.pow(yy, 2)) <= this._btlBtn[i].width / 2)
                    this.updateButton(i);
            }
        }
        if (JHMW.Joystick.Shadow && this._touchShadow) this.updateShadow();
        if (JHMW.Joystick.btlJoystick && (Utils.isMobileDevice() || JHMW.Joystick.PCJoystick)) this.respondDirPad();
    } else {
        if (JHMW.Joystick.Input && $gameSystem.isJoystickShow()) TouchInput.clearPressed();
        if (Utils.isMobileDevice() && !JHMW.Joystick.Touch && $gameSystem.isJoystickShow()) TouchInput.clearPressed();
        if (JHMW.Joystick.Shadow && this._touchShadow) this.updateShadow();
    }
    if (this.JoystickShow != $gameSystem.isJoystickShow()) this.updateOpacity();
};

JHMW.Joystick.Scene_MenuBase_create = Scene_MenuBase.prototype.create;
Scene_MenuBase.prototype.create = function() {
    JHMW.Joystick.Scene_MenuBase_create.call(this);
    this.createMenuButton();
    if ((Utils.isMobileDevice() || JHMW.Joystick.PCJoystick) && JHMW.Joystick.menuJoystick) {
        this.createDirPad();
        this.createTouchShadow();
    }
    this.JoystickShow = $gameSystem.isJoystickShow();
};

JHMW.Joystick.Scene_MenuBase_update = Scene_MenuBase.prototype.update;
Scene_MenuBase.prototype.update = function() {
    JHMW.Joystick.Scene_MenuBase_update.call(this);
    if (TouchInput.isPressed() || JHMW.Joystick.Touch || JHMW.Joystick.DirTouch) {
        var x = TouchInput.x;
        var y = TouchInput.y;
        for (var i = 0; i < 5; i++) {
            if (JHMW.Joystick.menuBtnActive[i] && (Utils.isMobileDevice() || JHMW.Joystick.menuBtnPCActive[i])) {
                var xx = x - JHMW.Joystick.menuBtnX[i] - this._menuBtn[i].width / 2;
                var yy = y - JHMW.Joystick.menuBtnY[i] - this._menuBtn[i].height / 2;
                if ((JHMW.Joystick.menuBtnMode[i] || TouchInput.isTriggered()) && Math.sqrt(Math.pow(xx, 2) + Math.pow(yy, 2)) <= this._menuBtn[i].width / 2)
                    this.updateButton(i);
            }
        }
        if (JHMW.Joystick.Shadow && this._touchShadow) this.updateShadow();
        if (JHMW.Joystick.menuJoystick && (Utils.isMobileDevice() || JHMW.Joystick.PCJoystick)) this.respondDirPad();
    } else {
        if (JHMW.Joystick.Input && $gameSystem.isJoystickShow()) TouchInput.clearPressed();
        if (Utils.isMobileDevice() && !JHMW.Joystick.Touch && $gameSystem.isJoystickShow()) TouchInput.clearPressed();
        if (JHMW.Joystick.Shadow && this._touchShadow) this.updateShadow();
    }
    if (this.JoystickShow != $gameSystem.isJoystickShow()) this.updateOpacity();
};

JHMW.Joystick.Window_Selectable_processTouch = Window_Selectable.prototype.processTouch;
Window_Selectable.prototype.processTouch = function () {
    if (JHMW.Joystick.Scenes.contains(SceneManager._scene.constructor.name) && (Utils.isMobileDevice() || JHMW.Joystick.PCJoystick) && $gameSystem.isJoystickShow())
        return;
    JHMW.Joystick.Window_Selectable_processTouch.call(this);
};

JHMW.Joystick.Window_Message_terminateMessage = Window_Message.prototype.terminateMessage;
Window_Message.prototype.terminateMessage = function() {
    JHMW.Joystick.Message = true;
    JHMW.Joystick.Window_Message_terminateMessage.call(this);
    setTimeout("JHMW.Joystick.Message = false;", 200);
};