/*:
 * @plugindesc v1.05 LiuYue_StrengEquip 强化装备
 * @author 流逝的岁月
 *
 * @help
 * ============================================================================
 * 介绍
 * ============================================================================ *
 *
 * 
 *
 * 提供一个 装备强化系统
 * 
 *
 *
 *---------------------------------------------------------
 *
 *使用条例：本插件为定制插件,未经同意,禁止转载
 *插件的所有权归 上善若水 流逝的岁月 所有
 * 
 *---------------------------------------------------------
 *
 * 
 * 
 * 注意,所有百分比数值均以100作为计数单位
 * 比如暴击+35    那么实际效果就是暴击率+35%  也即是0.35
 *
 *
 * 关于公式,既为可写入一段js代码,以下是可用的变量简化
 * variables[ID] 或 v[ID]          代表全局变量     
 * switchs[ID] 或 s[ID]            代表全局开关
 * eq                              代表目前这个装备,也就是武器或者护甲
 * level                           代表目前这个装备的等级          
 *
 *
 *
 *
 * 
 *
 *以下是一些插件用到的脚本信息
 *---------------------Plugin Command--------------------
 * 
 * Zzy.SEF.OpenStrengScene()                            //这将打开强化界面       
 * Zzy.SEF.SetLevel(type,id,level)                      //设置一件装备的等级 请填写参数 type:('weapon'/'armor')代表是武器还是护甲  id:数据库的ID值  level:想要改成的等级 
 * Zzy.SEF.GetLevel(type,id)                            //获取一个装备的等级
 * Zzy.SEF.IsCanStrengEquip()                           //在强化界面时,检测物品是否满足强化需求,不满足返回false   满足返回true
 * Zzy.SEF.StrengEquip()                                //对物品进行强化,主要该脚本通常使用在Zzy.SEF.IsCanStrengEquip()满足的前提之下
 * Zzy.SEF.IsMaxLevel()                                 //判断这个装备是否达到了最高等级  
 *                                                      //达到最高等级返回true     没有达到最高等级返回false       输入有误返回或其他原因返回undefined 
 *
 *
 *
 *
  *以下是一些插件指令的信息
 *---------------------Data Case--------------------
 *
 * ZzySEF OpenStrengScene                               //这将打开强化界面  
 *
 * ZzySEF IsCanStreng x(true/false)                     //这将设置装备是否具有强化效果能力
 * ZzySEF MaxLevel x                                    //这将设置装备强化的最大等级,x可以是一个公式
 * ZzySEF Prefix x                                      //这将设置装备强化的前缀名称,x可以是一个公式
 * ZzySEF Suffix x                                      //这将设置装备强化的后缀名称,x可以是一个公式
 * ZzySEF SuccessRate x                                 //这会设置装备强化的成功率,x可以是一个公式
 * 
 * ZzySEF SetLevel x1(weapon/armor) x2 x3               //这会设置装备的等级  x1填写装备类型 x2填写装备ID值 x3填写要改变成为的等级
 *
 * ZzySEF SEFIsShowSuccessText x                        //这会设置装备强化成功后是否会显示文本,,x可以是一个公式,true显示,false不显示
 * ZzySEF SEFIsShowFailText x                           //这会设置装备强化失败后是否会显示文本,,x可以是一个公式,true显示,false不显示
 *
 *
 *
 *----------------------------------------------------------
 *
 *
 *以下是一些插件用到的备注信息
 *
 *---------------------Data Case--------------------
 *
 * 请在 数据库 - 武器/护甲 - 备注 中添加效果 
 * <ZzySEF IsCanStreng: x(true/false)>                   //这将设置装备是否具有强化效果能力,此优先级高于参数设置
 * <ZzySEF MaxLevel: x>                                  //这将设置装备强化的最大等级,x可以是一个公式,此优先级高于参数设置
 * <ZzySEF Prefix: x>                                    //这将设置装备强化的前缀名称,x可以是一个公式,此优先级高于参数设置
 * <ZzySEF Suffix: x>                                    //这将设置装备强化的后缀名称,x可以是一个公式,此优先级高于参数设置
 * <ZzySEF IsShowSuccessText: x>                         //这将设置装备强化后显示提示文本的限制,x可以是一个公式,此优先级高于参数设置
 * <ZzySEF IsShowFailText: x>                            //这将设置装备强化后显示提示文本的限制,x可以是一个公式,此优先级高于参数设置
 *
 * 例: <ZzySEF IsShowSuccessText: level>3?true:false>    --强化成功时这件装备等级是否大于3,如果大于则显示文本, 否则不显示
 *     <ZzySEF IsShowFailText: if(s[10]){true}else{false}>   --10号开关如果打开,强化失败会显示文本
 *
 *
 *
 *
 * <ZzySEF Level x1 to x2>                               //这将对装备在一个等级范围内进行特殊的定义,x1和x2代表一个等级的区间
 *
 * <ZzySEF Level End>                                    //结束对这个区间的编辑内容
 *
 * ---以下是在Level区间中,可以填写的内容效果---注意仅仅填写在<ZzySEF Level x1 to x2>区间才会生效
 * 
 * SuccessRate: x                                        //强化成功率,x可以是一个公式
 * ConsumeItem: x1 x2                                    //强化需要消耗的道具  x1需要填写道具ID     x2需要填写道具数量,x2可以是一个公式
 * ConsumeWeapon: x1 x2                                  //强化需要消耗的武器  x1需要填写武器ID     x2需要填写武器数量,x2可以是一个公式
 * ConsumeArmor: x1 x2                                   //强化需要消耗的护甲  x1需要填写护甲ID     x2需要填写护甲数量,x2可以是一个公式
 * ConsumeGold: x                                        //强化需要消耗的金币数量,x可以是一个公式
 * HP: x                           --生命--              //x可以是一个公式
 * HPPer: x                        --生命--              //x可以是一个公式
 * MP: x                           --魔力--              //x可以是一个公式
 * MPPer: x                        --魔力--              //x可以是一个公式
 * ATK: x                          --攻击--              //x可以是一个公式
 * ATKPER: x                       --攻击--              //x可以是一个公式
 * DEF: x                          --防御--              //x可以是一个公式
 * DEFPer: x                       --防御--              //x可以是一个公式
 * MAT: x                          --魔攻--              //x可以是一个公式
 * MATPer: x                       --魔攻--              //x可以是一个公式
 * MDF: x                          --魔抗--              //x可以是一个公式
 * MDFPer: x                       --魔抗--              //x可以是一个公式
 * AGI: x                          --速度--              //x可以是一个公式
 * AGIPer: x                       --速度--              //x可以是一个公式
 * LUK: x                          --幸运--               //x可以是一个公式
 * LUKPer: x                       --幸运--              //x可以是一个公式
 * HIT: x                          --命中--              //x可以是一个公式
 * EVA: x                          --闪避--              //x可以是一个公式
 * CRI: x                          --暴击--              //x可以是一个公式
 * CEV: x                        --暴击回避--              //x可以是一个公式
 * MEV: x                        --魔法回避--              //x可以是一个公式
 * MRF: x                        --魔法反射--              //x可以是一个公式
 * CNT: x                          --反击--              //x可以是一个公式
 * HRG: x                       --HP自动恢复--              //x可以是一个公式
 * MRG: x                       --MP自动恢复--              //x可以是一个公式
 * TRG: x                       --TP自动恢复--              //x可以是一个公式
 * TGR: x                      --受到攻击几率--              //x可以是一个公式
 * GRD: x                        --防御效果--              //x可以是一个公式
 * REC: x                        --恢复效果--              //x可以是一个公式
 * PHA: x                        --药理知识--              //x可以是一个公式
 * MCR: x                        --MP消耗率--              //x可以是一个公式
 * TCR: x                        --TP消耗率--              //x可以是一个公式
 * PDR: x                        --物理伤害--               //x可以是一个公式
 * MDR: x                        --魔法伤害--              //x可以是一个公式
 * FDR: x                        --地板伤害--               //x可以是一个公式
 * EXP: x                         --经验值--              //x可以是一个公式
 *
 *
 *
 * 请在 数据库 - 物品 - 备注 中添加效果 
 *
 * <ZzySEF Spell>                                              //这将视目标为强化符,可以作为强化符出现在窗口中
 * <ZzySEF NoConsume>                                          //这将使强化符使用后不会消失
 *
 * <ZzySEF ExtraLevel: x1 x2>                                  //这将使装备强化成功时,对应附加等级的增减   x1代表增加的额外等级  x2代表概率范围0~100   这条命令可以存在多个
 *                                                                         x1与x2均可以是一个公式带入
 * 例:如在数据库中有以下定义
 * <ZzySEF ExtraLevel: 1 50>
 * <ZzySEF ExtraLevel: 2 20>
 * <ZzySEF ExtraLevel: -1 50>
 * <ZzySEF ExtraLevel: -2 100>
 * 那么添加这个强化符会具备以下效果       强化后50%概率额外提升1级    20%概率额外强化2级    50%概率额外下降1级      100%概率额外下降2级
 *                     按照前后顺序，满足概率条件后,则不会继续随机强化概率
 *
 *
 * <ZzySEF EQProtect>                                          //这将使得装备强化失败后不会破碎
 * <ZzySEF SuccessRate: x>                                    //这将增加或减少额外的成功概率,x范围(-100~100)
 *
 * 例:<ZzySEF SuccessRate: 20>                                //增加20%额外概率   这可以是一个公式
 *
 *
 *
 *
 *
 *
 *
 *----------------------------------------------------------
 *
 *
 *
 *
 * 我叫坂本：v1.05 修复云端存档导致的无法初始化插件问题,优化显示文本
 * 我叫坂本：v1.04 旧存档兼容,添加强化成功显示,优化强化流程
 * 我叫坂本：v1.03 修复bug
 * 我叫坂本：v1.02 强化,退出UI界面按钮
 * 我叫坂本：v1.01 对特殊性道具强化符,进行添加
 * 我叫坂本：v1.00 完成插件功能
 *
 *----------------------------------------------------------
 *
 *
 *
 * @param ---设置---
 * @default
 *
 *
 * @param IsCanStreng
 * @text 装备拥有强化能力
 * @parent ---设置---
 * @type boolean
 * @on YES
 * @off NO
 * @desc 装备是否可以强化,默认值为true
 * YES - true     NO - false
 * @default true
 *
 *
 * @param Prefix
 * @text 装备强化的前缀名称
 * @parent ---设置---
 * @type Text
 * @desc 这是装备进行强化后会在名称前添加的前缀,%1是自动变量,代表对应的强化等级,默认值空
 * @default 
 *
 * @param Suffix
 * @text 装备强化的后缀名称
 * @parent ---设置---
 * @type Text
 * @desc 这是装备进行强化后会在名称后添加的后缀,%1是自动变量,代表对应的强化等级,默认值空
 * @default +%1
 *
 * @param IsCanEquipment
 * @text 穿着中的装备可强化
 * @parent ---设置---
 * @type boolean
 * @on YES
 * @off NO
 * @desc 这是穿着中的装备是否会出现在强化列表中
 * YES - true     NO - false
 * @default true
 *
 * @param StrengButtonID
 * @text 强化按钮公共事件ID
 * @parent ---设置---
 * @type Number
 * @desc 强化按钮调用的公共事件ID
 * @default 1
 *
 *
 *
 * @param ---强化窗口---
 * @default
 *
 * @param StrengWindowX
 * @text 强化窗口X位置
 * @parent ---强化窗口---
 * @type Text
 * @desc 出现的强化窗口X的位置
 * @default 0
 *
 * @param StrengWindowY
 * @text 强化窗口Y位置
 * @parent ---强化窗口---
 * @type Text
 * @desc 出现的强化窗口Y的位置
 * @default 0
 *
 * @param StrengWindowW
 * @text 强化窗口宽度
 * @parent ---强化窗口---
 * @type Text
 * @desc 出现的强化窗口宽度
 * @default Graphics.boxWidth
 *
 * @param StrengWindowH
 * @text 强化窗口高度
 * @parent ---强化窗口---
 * @type Text
 * @desc 出现的强化窗口高度
 * @default Graphics.boxHeight/2
 *
 *
 * @param StrengOpacity
 * @text 窗口透明度
 * @parent ---强化窗口---
 * @type Number
 * @desc 强化窗口的透明度,默认值255
 * @default 255
 *
 * @param StrengPadding
 * @text 窗口间距
 * @parent ---强化窗口---
 * @type Number
 * @desc 绘制背景板与窗口的距离,默认值18
 * @default 18
 *
 * @param StrengFillColor
 * @text 底板填充
 * @parent ---强化窗口---
 * @type Text
 * @desc 强化窗口的背景底板填充色块,默认值#000033,深蓝色
 * @default #000033
 *
 * @param PackEQRows
 * @text 道具排列列数
 * @parent ---强化窗口---
 * @type Number
 * @desc 支持排列的列数数值
 * @default 1
 *
 * @param PackFillColor
 * @text 底板填充
 * @parent ---强化窗口---
 * @type Text
 * @desc 背包窗口的背景底板填充色块,默认值#000033,深蓝色
 * @default #000033
 *
 * @param PackFillDis
 * @text 底板填充间距
 * @parent ---强化窗口---
 * @type Number
 * @desc 背包窗口的背景底板填充色块间距,默认值#000033,深蓝色
 * @default 3
 *
 *
 * @param ---装备放置格---
 * @default
 *
 * @param EquipPlaceX
 * @text 装备放置格X
 * @parent ---装备放置格---
 * @type Text
 * @desc 装备放置格X的位置
 * @default Graphics.boxWidth/2
 *
 * @param EquipPlaceY
 * @text 装备放置格Y
 * @parent ---装备放置格---
 * @type Text
 * @desc 装备放置格Y的位置
 * @default 200
 *
 * @param EquipPlaceSize
 * @text 装备放置格尺寸
 * @parent ---装备放置格---
 * @type Number
 * @desc 装备放置格X的位置
 * @default 32
 *
 * @param EquipPlaceBColor
 * @text 装备放置格尺内部颜色
 * @parent ---装备放置格---
 * @type Text
 * @desc 放置装备格内部的颜色
 * @default #333399
 *
 * @param EquipPlaceLWidth
 * @text 装备放置格边框宽度
 * @parent ---装备放置格---
 * @type Number
 * @desc 装备放置格边框的宽度
 * @default 2
 *
 * @param EquipPlaceLColor
 * @text 装备放置格尺边框颜色
 * @parent ---装备放置格---
 * @type Text
 * @desc 放置装备格外部边框的颜色
 * @default #6666cc
 *
 *
 * @param ---装备放置格名称---
 * @default
 *
 * @param EquipPlaceNameX
 * @text 装备放置格名称X
 * @parent ---装备放置格名称---
 * @type Text
 * @desc 装备放置格名称X的位置,这可以是一个公式
 * @default Graphics.boxWidth/2
 *
 * @param EquipPlaceNameY
 * @text 装备放置格名称Y
 * @parent ---装备放置格名称---
 * @type Text
 * @desc 装备放置格名称Y的位置,这可以是一个公式
 * @default 120
 *
 * @param EquipPlaceNameSize
 * @text 装备放置格名称尺寸
 * @parent ---装备放置格名称---
 * @type Number
 * @desc 显示的文本尺寸大小,默认值28
 * @default 28
 *
 *
 *
 * @param ---强化放置格1---
 * @default
 *
 * @param StrengPlace1X
 * @text 装备放置格1X
 * @parent ---强化放置格1---
 * @type Text
 * @desc 强化放置格1X的位置
 * @default Graphics.boxWidth/4
 *
 * @param StrengPlace1Y
 * @text 强化放置格1Y
 * @parent ---强化放置格1---
 * @type Text
 * @desc 强化放置格1Y的位置
 * @default 300
 *
 * @param StrengPlace1Size
 * @text 强化放置格1尺寸
 * @parent ---强化放置格1---
 * @type Number
 * @desc 强化放置格1X的位置
 * @default 32
 *
 * @param StrengPlace1BColor
 * @text 强化放置格1尺内部颜色
 * @parent ---强化放置格1---
 * @type Text
 * @desc 放置装备格内部的颜色
 * @default #333399
 *
 * @param StrengPlace1LWidth
 * @text 强化放置格1边框宽度
 * @parent ---强化放置格1---
 * @type Number
 * @desc 强化放置格1边框的宽度
 * @default 2
 *
 * @param StrengPlace1LColor
 * @text 强化放置格1尺边框颜色
 * @parent ---强化放置格1---
 * @type Text
 * @desc 放置装备格外部边框的颜色
 * @default #6666cc
 *
 * @param ---强化放置格1名称---
 * @default
 *
 * @param StrengPlace1NameX
 * @text 强化放置格1名称X
 * @parent ---强化放置格1名称---
 * @type Text
 * @desc 强化放置格1名称X的位置,这可以是一个公式
 * @default Graphics.boxWidth/4
 *
 * @param StrengPlace1NameY
 * @text 强化放置格1名称Y
 * @parent ---强化放置格1名称---
 * @type Text
 * @desc 强化放置格1名称Y的位置,这可以是一个公式
 * @default 380
 *
 * @param StrengPlace1NameSize
 * @text 强化放置格1名称尺寸
 * @parent ---强化放置格1名称---
 * @type Number
 * @desc 显示的文本尺寸大小,默认值28
 * @default 28
 
 *
 *
 *
 *
 *
 * @param ---强化放置格2---
 * @default
 *
 * @param StrengPlace2X
 * @text 装备放置格2X
 * @parent ---强化放置格2---
 * @type Text
 * @desc 强化放置格2X的位置
 * @default Graphics.boxWidth/2
 *
 * @param StrengPlace2Y
 * @text 强化放置格2Y
 * @parent ---强化放置格2---
 * @type Text
 * @desc 强化放置格2Y的位置
 * @default 300
 *
 * @param StrengPlace2Size
 * @text 强化放置格2尺寸
 * @parent ---强化放置格2---
 * @type Number
 * @desc 强化放置格2X的位置
 * @default 32
 *
 * @param StrengPlace2BColor
 * @text 强化放置格2尺内部颜色
 * @parent ---强化放置格2---
 * @type Text
 * @desc 放置装备格内部的颜色
 * @default #333399
 *
 * @param StrengPlace2LWidth
 * @text 强化放置格2边框宽度
 * @parent ---强化放置格2---
 * @type Number
 * @desc 强化放置格2边框的宽度
 * @default 2
 *
 * @param StrengPlace2LColor
 * @text 强化放置格2尺边框颜色
 * @parent ---强化放置格2---
 * @type Text
 * @desc 放置装备格外部边框的颜色
 * @default #6666cc
 *
 *
 * @param ---强化放置格2名称---
 * @default
 *
 * @param StrengPlace2NameX
 * @text 强化放置格2名称X
 * @parent ---强化放置格2名称---
 * @type Text
 * @desc 强化放置格2名称X的位置,这可以是一个公式
 * @default Graphics.boxWidth/2
 *
 * @param StrengPlace2NameY
 * @text 强化放置格2名称Y
 * @parent ---强化放置格2名称---
 * @type Text
 * @desc 强化放置格2名称Y的位置,这可以是一个公式
 * @default 380
 *
 * @param StrengPlace2NameSize
 * @text 强化放置格2名称尺寸
 * @parent ---强化放置格2名称---
 * @type Number
 * @desc 显示的文本尺寸大小,默认值28
 * @default 28
 *
 *
 *
 *
 * @param ---强化放置格3---
 * @default
 *
 * @param StrengPlace3X
 * @text 装备放置格3X
 * @parent ---强化放置格3---
 * @type Text
 * @desc 强化放置格3X的位置
 * @default Graphics.boxWidth*3/4
 *
 * @param StrengPlace3Y
 * @text 强化放置格3Y
 * @parent ---强化放置格3---
 * @type Text
 * @desc 强化放置格3Y的位置
 * @default 300
 *
 * @param StrengPlace3Size
 * @text 强化放置格3尺寸
 * @parent ---强化放置格3---
 * @type Number
 * @desc 强化放置格3X的位置
 * @default 32
 *
 * @param StrengPlace3BColor
 * @text 强化放置格3尺内部颜色
 * @parent ---强化放置格3---
 * @type Text
 * @desc 放置装备格内部的颜色
 * @default #333399
 *
 * @param StrengPlace3LWidth
 * @text 强化放置格3边框宽度
 * @parent ---强化放置格3---
 * @type Number
 * @desc 强化放置格3边框的宽度
 * @default 2
 *
 * @param StrengPlace3LColor
 * @text 强化放置格3尺边框颜色
 * @parent ---强化放置格3---
 * @type Text
 * @desc 放置装备格外部边框的颜色
 * @default #6666cc
 *
 * @param ---强化放置格3名称---
 * @default
 *
 * @param StrengPlace3NameX
 * @text 强化放置格3名称X
 * @parent ---强化放置格3名称---
 * @type Text
 * @desc 强化放置格3名称X的位置,这可以是一个公式
 * @default Graphics.boxWidth*3/4
 *
 * @param StrengPlace3NameY
 * @text 强化放置格3名称Y
 * @parent ---强化放置格3名称---
 * @type Text
 * @desc 强化放置格3名称Y的位置,这可以是一个公式
 * @default 380
 *
 * @param StrengPlace3NameSize
 * @text 强化放置格3名称尺寸
 * @parent ---强化放置格3名称---
 * @type Number
 * @desc 显示的文本尺寸大小,默认值28
 * @default 28
 *
 *
 * @param ---强化需求金币---
 * @default
 *
 *
 * @param StrengGoldX
 * @text 强化需求金币X
 * @parent ---强化需求金币---
 * @type Text
 * @desc 强化需求金币X的位置,这可以是一个公式
 * @default Graphics.boxWidth/2
 *
 * @param StrengGoldY
 * @text 强化需求金币Y
 * @parent ---强化需求金币---
 * @type Text
 * @desc 强化需求金币Y的位置,这可以是一个公式
 * @default 450
 *
 * @param StrengGoldSize
 * @text 强化需求金币尺寸
 * @parent ---强化需求金币---
 * @type Number
 * @desc 显示的文本尺寸大小,默认值28
 * @default 28
 *
 * @param StrengGoldName
 * @text 强化需求金币名称
 * @parent ---强化需求金币---
 * @type Text
 * @desc 这是强化需求金币信息的显示内容,%1代表队伍中拥有的金币数,%2代表升级需求的金币数
 * @default 升级需要金币数量: %1/%2
 *
 *
 * @param ---强化需求成功率---
 * @default
 *
 * @param StrengRateX
 * @text 强化需求成功率X
 * @parent ---强化需求成功率---
 * @type Text
 * @desc 强化需求成功率X的位置,这可以是一个公式
 * @default Graphics.boxWidth/2
 *
 * @param StrengRateY
 * @text 强化需求成功率Y
 * @parent ---强化需求成功率---
 * @type Text
 * @desc 强化需求成功率Y的位置,这可以是一个公式
 * @default 520
 *
 * @param StrengRateSize
 * @text 强化需求成功率尺寸
 * @parent ---强化需求成功率---
 * @type Number
 * @desc 显示的文本尺寸大小,默认值28
 * @default 28
 *
 * @param StrengRateName
 * @text 强化需求成功率名称
 * @parent ---强化需求成功率---
 * @type Text
 * @desc 这是强化需求成功率信息的显示内容,%1代表本次强化成功的概率
 * @default 强化成功率: %1 %
 *
 *
 * @param ---强化到最大等级---
 * @default
 *
 * @param MaxLevelX
 * @text 强化到最大等级X
 * @parent ---强化到最大等级---
 * @type Text
 * @desc 强化到最大等级X的位置,这可以是一个公式
 * @default Graphics.boxWidth/2
 *
 * @param MaxLevelY
 * @text 强化到最大等级Y
 * @parent ---强化到最大等级---
 * @type Text
 * @desc 强化到最大等级Y的位置,这可以是一个公式
 * @default 520
 *
 * @param MaxLevelSize
 * @text 强化到最大等级尺寸
 * @parent ---强化到最大等级---
 * @type Number
 * @desc 显示的文本尺寸大小,默认值28
 * @default 28
 *
 * @param MaxLevelName
 * @text 强化到最大等级名称
 * @parent ---强化到最大等级---
 * @type Text
 * @desc 这是武器强化到最大等级后提示的文本内容
 * @default 已满级
 *
 * @param ---强化显示文本---
 * @default
 *
 * @param StrengSuccessText
 * @text 显示成功文本
 * @parent ---强化显示文本---
 * @type Text
 * @desc 强化成功后显示的文本内容,其中%1会被替换为武器原本名,%2会被替换为目前的强化等级
 * @default %1持续的发出强烈光芒，竟然强化到%2了
 *
 *
 * @param StrengFailText
 * @text 显示失败文本
 * @parent ---强化显示文本---
 * @type Text
 * @desc 强化失败后显示的文本内容,其中%1会被替换为武器原本名,%2会被替换为目前的强化等级
 * @default %1持续的发出强烈光芒，竟然消失了
 *
 *
 * @param IsShowSuccessText
 * @text 限制成功文本
 * @parent ---强化显示文本---
 * @type Text
 * @desc 限制文本的显示,这可以是一个公式,结果为非0或是true,代表会显示,结果为0或是false,代表不会显示,默认值if(level>5){true;}else{false;}
 * @default if(level>5){true;}else{false;}
 *
 * @param IsShowFailText
 * @text 限制失败文本
 * @parent ---强化显示文本---
 * @type Text
 * @desc 限制文本的显示,这可以是一个公式,结果为非0或是true,代表会显示,结果为0或是false,代表不会显示,默认值if(level>10){true;}else{false;}
 * @default if(level>10){true;}else{false;}
 *
 *
 * @param ShowTSize
 * @text 显示文本尺寸
 * @parent ---强化显示文本---
 * @type Number
 * @desc 文本的尺寸
 * @default 24
 *
 * @param ShowTColor
 * @text 显示文本颜色
 * @parent ---强化显示文本---
 * @type Text
 * @desc 文本的颜色
 * @default #ffffff
 *
 * @param ShowBSize
 * @text 显示边框尺寸
 * @parent ---强化显示文本---
 * @type Number
 * @desc 文本边框的尺寸
 * @default 2
 *
 * @param ShowBColor
 * @text 显示边框颜色
 * @parent ---强化显示文本---
 * @type Text
 * @desc 文本边框的颜色
 * @default rgba(0,0,0,0.5)
 *
 *
 * @param STStartX
 * @text 显示文本开始位置X
 * @parent ---强化显示文本---
 * @type Text
 * @desc 文本开始位置的X这可以是一个正负整数,默认值0
 * @default 0
 *
 * @param STStartY
 * @text 显示文本开始位置Y
 * @parent ---强化显示文本---
 * @type Text
 * @desc 文本开始位置的Y这可以是一个正负整数,默认值130
 * @default 130
 *
 * @param STEndX
 * @text 显示文本结束位置X
 * @parent ---强化显示文本---
 * @type Text
 * @desc 文本结束位置的X这可以是一个正负整数,默认值0
 * @default 0
 *
 * @param STEndY
 * @text 显示文本结束位置Y
 * @parent ---强化显示文本---
 * @type Text
 * @desc 文本结束位置的Y这可以是一个正负整数,默认值80
 * @default 80
 *
 * @param STWEndFrame
 * @text 显示文本到达所需帧数
 * @parent ---强化显示文本---
 * @type Number
 * @desc 文本从开始位置到结束位置所需要的帧数,默认值60
 * @default 60
 *
 * @param STWBeFrame
 * @text 显示文本存在的帧数
 * @parent ---强化显示文本---
 * @type Number
 * @desc 文本存在这些帧数,超过这些帧数则消失,默认值120
 * @default 120
 *
 *
 *
 *
 * @param ---背包窗口---
 * @default
 *
 * @param PackWindowX
 * @text 背包窗口X位置
 * @parent ---背包窗口---
 * @type Text
 * @desc 出现的背包窗口X的位置
 * @default 0
 *
 * @param PackWindowY
 * @text 背包窗口Y位置
 * @parent ---背包窗口---
 * @type Text
 * @desc 出现的背包窗口Y的位置
 * @default Graphics.boxHeight/2
 *
 * @param PackWindowW
 * @text 背包窗口宽度
 * @parent ---背包窗口---
 * @type Text
 * @desc 出现的背包窗口宽度
 * @default Graphics.boxWidth
 *
 * @param PackWindowH
 * @text 背包窗口高度
 * @parent ---背包窗口---
 * @type Text
 * @desc 出现的背包窗口高度
 * @default Graphics.boxHeight/2
 *
 *
 * @param PackRows
 * @text 背包窗口X位置
 * @parent ---背包窗口---
 * @type Text
 * @desc 出现的背包窗口X的位置
 * @default 0
 *
 *
 *
 *
 *
 * @param ---数据---
 * @default
 *
 * @param MaxLevel
 * @text 装备强化最大等级
 * @parent ---数据---
 * @type Text
 * @desc 这是装备能强化的最大的等级,这可以是一个公式,默认值18
 * @default 18
 *
 * @param SuccessRate
 * @text 强化成功率
 * @parent ---数据---
 * @type Text
 * @desc 这是装备强化时的成功概率,范围0~100,这可以是一个正小数,这可以是一个公式
 * @default level < 6 ? 100 : 100 * (1.2 - level/maxlevel)
 *
 * @param ConsumeItem
 * @text 升级消耗道具
 * @parent ---数据---
 * @type item
 * @desc 这是强化会消耗的道具,需填写道具的ID值,为0则代表不会消耗道具,默认值为0
 * @default 0
 *
 * @param ConsumeItemCount
 * @text 升级消耗道具数量
 * @parent ---数据---
 * @type Text
 * @desc 这是强化会消耗的道具的数量,填写0则不消耗,需要正整数,这可以是一个公式
 * @default level*2
 *
 * @param ConsumeWeapon
 * @text 升级消耗武器
 * @parent ---数据---
 * @type weapon
 * @desc 这是强化会消耗的武器,需填写武器的ID值,为0则代表不会消耗武器,默认值为0
 * @default 0
 *
 * @param ConsumeWeaponCount
 * @text 升级消耗武器数量
 * @parent ---数据---
 * @type Text
 * @desc 这是强化会消耗的武器的数量,填写0则不消耗,需要正整数,这可以是一个公式
 * @default 0
 *
 * @param ConsumeArmor
 * @text 升级消耗护甲
 * @parent ---数据---
 * @type Armor
 * @desc 这是强化会消耗的护甲,需填写护甲的ID值,为0则代表不会消耗护甲,默认值为0
 * @default 0
 *
 * @param ConsumeArmorCount
 * @text 升级消耗护甲数量
 * @parent ---数据---
 * @type Text
 * @desc 这是强化会消耗的护甲的数量,填写0则不消耗,需要结果为正整数,这可以是一个公式
 * @default 0
 *
 * @param ConsumeGold
 * @text 升级消耗金币数量
 * @parent ---数据---
 * @type Text
 * @desc 这是强化会消耗的金币的数量,填写0则不消耗,需要结果为正整数,这可以是一个公式
 * @default level*1000
 *
 *
 *
 * @param ---强化成功---
 * @default
 *
 * @param SuccessSound
 * @text 强化成功音效
 * @parent ---强化成功---
 * @type file
 * @dir audio/se
 * @desc 强化成功产生的声音,请填写audio/se文件夹中的文件名,不包含m4a.ogg的后缀名
 * @default Bell2
 *
 * @param SuccessVolume
 * @text 强化成功音量
 * @parent ---强化成功---
 * @type number
 * @min 0
 * @desc 强化成功产生的音量,默认值100
 * @default 100
 *
 * @param SuccessPitch
 * @text 强化成功音调
 * @parent ---强化成功---
 * @type number
 * @min 0
 * @desc 强化成功产生的音调,默认值100
 * @default 100
 *
 * @param SuccessPan
 * @text 强化成功声道
 * @parent ---强化成功---
 * @type number
 * @desc 强化成功产生的声道,默认值0
 * @default 0
 *
 * @param SuConsumeItem
 * @text 是否成功消耗强化材料
 * @parent ---强化成功---
 * @type boolean
 * @on YES
 * @off NO
 * @desc 强化成功是否消耗升级材料
 * YES - true     NO - false
 * @default true
 *
 * @param SuConsumeGold
 * @text 是否成功消耗强化金币
 * @parent ---强化成功---
 * @type boolean
 * @on YES
 * @off NO
 * @desc 强化成功是否消耗强化金币
 * YES - true     NO - false
 * @default true
 *
 *
 *
 *
 * @param ---强化失败---
 * @default
 *
 * @param FailSound
 * @text 强化失败音效
 * @parent ---强化失败---
 * @type file
 * @dir audio/se
 * @desc 强化失败产生的声音,请填写audio/se文件夹中的文件名,不包含m4a.ogg的后缀名
 * @default Blind
 *
 * @param FailVolume
 * @text 强化失败音量
 * @parent ---强化失败---
 * @type number
 * @min 0
 * @desc 强化失败产生的音量,默认值100
 * @default 100
 *
 * @param FailPitch
 * @text 强化失败音调
 * @parent ---强化失败---
 * @type number
 * @min 0
 * @desc 强化失败产生的音调,默认值100
 * @default 100
 *
 * @param FailPan
 * @text 强化失败声道
 * @parent ---强化失败---
 * @type number
 * @desc 强化失败产生的声道,默认值0
 * @default 0
 *
 * @param FaConsumeItem
 * @text 是否失败消耗强化材料
 * @parent ---强化失败---
 * @type boolean
 * @on YES
 * @off NO
 * @desc 强化失败是否消耗升级材料
 * YES - true     NO - false
 * @default true
 *
 * @param FaConsumeGold
 * @text 是否失败消耗强化金币
 * @parent ---强化失败---
 * @type boolean
 * @on YES
 * @off NO
 * @desc 强化失败是否消耗强化金币
 * YES - true     NO - false
 * @default true
 *
 * @param FaConsumeEquip
 * @text 是否失败消耗原武器
 * @parent ---强化失败---
 * @type boolean
 * @on YES
 * @off NO
 * @desc 强化失败后强化装备是否会消失
 * YES - true     NO - false
 * @default false
 *
 *
 * @param IsFailDemotion
 * @text 是否失败武器降级
 * @parent ---强化失败---
 * @type boolean
 * @on YES
 * @off NO
 * @desc 强化失败是否会导致武器降级
 * YES - true     NO - false
 * @default true
 *
 * @param FailDemotionCount
 * @text 失败下降数值
 * @parent ---强化失败---
 * @type Text
 * @desc 失败后会下降的等级数值,这可以是一个公式
 * @default 1
 *
 *
 * @param ---强化---
 * @default
 *
 * @param UpHP
 * @text 升级生命
 * @parent ---强化---
 * @type Text
 * @desc 升级提供的数值,这可以是一个公式
 * @default 0
 *
 * @param UpHPPer
 * @text 升级生命百分比
 * @parent ---强化---
 * @type Text
 * @desc 升级提供的数值给予原属性的百分比,这可以是一个公式
 * @default 10*level
 *
 * @param UpMP
 * @text 升级魔力
 * @parent ---强化---
 * @type Text
 * @desc 升级提供的数值,这可以是一个公式
 * @default 0
 *
 * @param UpMPPer
 * @text 升级魔力百分比
 * @parent ---强化---
 * @type Text
 * @desc 升级提供的数值给予原属性的百分比,这可以是一个公式
 * @default 10*level
 *
 * @param UpATK
 * @text 升级攻击
 * @parent ---强化---
 * @type Text
 * @desc 升级提供的数值,这可以是一个公式
 * @default 0
 *
 * @param UpATKPer
 * @text 升级攻击百分比
 * @parent ---强化---
 * @type Text
 * @desc 升级提供的数值给予原属性的百分比,这可以是一个公式
 * @default 10*level
 *
 * @param UpDEF
 * @text 升级防御
 * @parent ---强化---
 * @type Text
 * @desc 升级提供的数值,这可以是一个公式
 * @default 0
 *
 * @param UpDEFPer
 * @text 升级防御百分比
 * @parent ---强化---
 * @type Text
 * @desc 升级提供的数值给予原属性的百分比,这可以是一个公式
 * @default 10*level
 *
 * @param UpMAT
 * @text 升级魔攻
 * @parent ---强化---
 * @type Text
 * @desc 升级提供的数值,这可以是一个公式
 * @default 0
 *
 * @param UpMATPer
 * @text 升级魔攻百分比
 * @parent ---强化---
 * @type Text
 * @desc 升级提供的数值给予原属性的百分比,这可以是一个公式
 * @default 10*level
 *
 * @param UpMDF
 * @text 升级魔抗
 * @parent ---强化---
 * @type Text
 * @desc 升级提供的数值,这可以是一个公式
 * @default 0
 *
 * @param UpMDFPer
 * @text 升级魔抗百分比
 * @parent ---强化---
 * @type Text
 * @desc 升级提供的数值给予原属性的百分比,这可以是一个公式
 * @default 10*level
 *
 * @param UpAGI
 * @text 升级速度
 * @parent ---强化---
 * @type Text
 * @desc 升级提供的数值,这可以是一个公式
 * @default 0
 *
 * @param UpAGIPer
 * @text 升级速度百分比
 * @parent ---强化---
 * @type Text
 * @desc 升级提供的数值给予原属性的百分比,这可以是一个公式
 * @default 10*level
 *
 * @param UpLUK
 * @text 升级幸运
 * @parent ---强化---
 * @type Text
 * @desc 升级提供的数值,这可以是一个公式
 * @default 0
 *
 * @param UpLUKPer
 * @text 升级幸运百分比
 * @parent ---强化---
 * @type Text
 * @desc 升级提供的数值给予原属性的百分比,这可以是一个公式
 * @default 10*level
 *
 * @param UpHIT
 * @text 升级命中
 * @parent ---强化---
 * @type Text
 * @desc 升级提供的数值,这可以是一个公式
 * @default 0
 *
 * @param UpEVA
 * @text 升级闪避
 * @parent ---强化---
 * @type Text
 * @desc 升级提供的数值,这可以是一个公式
 * @default 0
 *
 *
 * @param UpCRI
 * @text 升级暴击
 * @parent ---强化---
 * @type Text
 * @desc 升级提供的数值,这可以是一个公式
 * @default 0
 *
 *
 * @param UpCEV
 * @text 升级暴击回避
 * @parent ---强化---
 * @type Text
 * @desc 升级提供的数值,这可以是一个公式
 * @default 0
 *
 *
 * @param UpMEV
 * @text 升级魔法回避
 * @parent ---强化---
 * @type Text
 * @desc 升级提供的数值,这可以是一个公式
 * @default 0
 *
 *
 * @param UpMRF
 * @text 升级魔法反射
 * @parent ---强化---
 * @type Text
 * @desc 升级提供的数值,这可以是一个公式
 * @default 0
 *
 *
 * @param UpCNT
 * @text 升级反击
 * @parent ---强化---
 * @type Text
 * @desc 升级提供的数值,这可以是一个公式
 * @default 0
 *
 *
 * @param UpHRG
 * @text 升级HP自动恢复
 * @parent ---强化---
 * @type Text
 * @desc 升级提供的数值,这可以是一个公式
 * @default 0
 *
 * @param UpMRG
 * @text 升级MP自动恢复
 * @parent ---强化---
 * @type Text
 * @desc 升级提供的数值,这可以是一个公式
 * @default 0
 *
 * @param UpTRG
 * @text 升级TP自动恢复
 * @parent ---强化---
 * @type Text
 * @desc 升级提供的数值,这可以是一个公式
 * @default 0
 *
 * @param UpTRG
 * @text 升级受到攻击几率
 * @parent ---强化---
 * @type Text
 * @desc 升级提供的数值,这可以是一个公式
 * @default 0
 *
 * @param UpGRD
 * @text 升级防御效果
 * @parent ---强化---
 * @type Text
 * @desc 升级提供的数值,这可以是一个公式
 * @default 0
 *
 * @param UpREC
 * @text 升级恢复效果
 * @parent ---强化---
 * @type Text
 * @desc 升级提供的数值,这可以是一个公式
 * @default 0
 *
 * @param UpPHA
 * @text 升级药理知识
 * @parent ---强化---
 * @type Text
 * @desc 升级提供的数值,这可以是一个公式
 * @default 0
 *
 * @param UpMCR
 * @text 升级MP消耗率
 * @parent ---强化---
 * @type Text
 * @desc 升级提供的数值,这可以是一个公式
 * @default 0
 *
 * @param UpTCR
 * @text 升级TP消耗率
 * @parent ---强化---
 * @type Text
 * @desc 升级提供的数值,这可以是一个公式
 * @default 0
 *
 * @param UpPDR
 * @text 升级物理伤害
 * @parent ---强化---
 * @type Text
 * @desc 升级提供的数值,这可以是一个公式
 * @default 0
 *
 * @param UpMDR
 * @text 升级魔法伤害
 * @parent ---强化---
 * @type Text
 * @desc 升级提供的数值,这可以是一个公式
 * @default 0
 *
 * @param UpFDR
 * @text 升级地板伤害
 * @parent ---强化---
 * @type Text
 * @desc 升级提供的数值,这可以是一个公式
 * @default 0
 *
 * @param UpEXP
 * @text 升级经验值
 * @parent ---强化---
 * @type Text
 * @desc 升级提供的数值,这可以是一个公式
 * @default 0
 *
 *
 * @param ---虚拟按钮---
 * @default
 *
 * @param StrengButtonPic
 * @text 强化按钮
 * @parent ---虚拟按钮---
 * @dir img/system
 * @type file
 * @desc 显示强化按钮的图片,填写图片路径,图片放在system文件夹中
 * @default qd
 *
 * @param StrengButtonX
 * @text 强化按钮X位置
 * @parent ---虚拟按钮---
 * @type Text
 * @desc 图片显示的位置,可以输入一段代码或数值来确认位置
 * @default Graphics.boxWidth/3
 *
 * @param StrengButtonY
 * @text 强化按钮Y位置
 * @parent ---虚拟按钮---
 * @type Text
 * @desc 图片显示的位置,可以输入一段代码或数值来确认位置
 * @default Graphics.boxHeight*3/4
 *
 * @param CancelButtonPic
 * @text 取消按钮
 * @parent ---虚拟按钮---
 * @dir img/system
 * @type file
 * @desc 显示取消按钮的图片,填写图片路径,图片放在system文件夹中
 * @default qx
 *
 * @param CancelButtonX
 * @text 取消按钮X位置
 * @parent ---虚拟按钮---
 * @type Text
 * @desc 图片显示的位置,可以输入一段代码或数值来确认位置
 * @default Graphics.boxWidth*2/3
 *
 * @param CancelButtonY
 * @text 取消按钮Y位置
 * @parent ---虚拟按钮---
 * @type Text
 * @desc 图片显示的位置,可以输入一段代码或数值来确认位置
 * @default Graphics.boxHeight*3/4
 
 *
 *
 *
 *
 *
 */





var LiuYue = LiuYue || {};
LiuYue.LiuYue_StrengEquip = true;//插件启动
 
var Zzy = Zzy || {};
Zzy.SEF = Zzy.SEF || {};
Zzy.SEF.version = 1.05;
Zzy.Parameters = PluginManager.parameters('LiuYue_StrengEquip');
Zzy.Param = Zzy.Param || {};

Zzy.Param.SEFIsCanStreng = eval(String((Zzy.Parameters['IsCanStreng'])));//装备拥有强化能力
Zzy.Param.SEFPrefix = String(Zzy.Parameters['Prefix']);//装备强化最大等级
Zzy.Param.SEFSuffix = String(Zzy.Parameters['Suffix']);//装备强化最大等级

Zzy.Param.SEFIsCanEquipment = String(Zzy.Parameters['IsCanEquipment']);//穿着中的装备是否可强化


Zzy.Param.SEFStrengButtonID = parseInt(Zzy.Parameters['StrengButtonID']);//强化按钮公共事件ID




Zzy.Param.SEFStrengWindowX = String(Zzy.Parameters['StrengWindowX']);//强化窗口X位置
Zzy.Param.SEFStrengWindowY = String(Zzy.Parameters['StrengWindowY']);//强化窗口Y位置 
Zzy.Param.SEFStrengWindowW = String(Zzy.Parameters['StrengWindowW']);//强化窗口宽度 
Zzy.Param.SEFStrengWindowH = String(Zzy.Parameters['StrengWindowH']);//强化窗口高度 

Zzy.Param.SEFStrengOpacity = parseInt(Zzy.Parameters['StrengOpacity']);//窗口透明度
Zzy.Param.SEFStrengPadding = parseInt(Zzy.Parameters['StrengPadding']);//窗口间距
Zzy.Param.SEFStrengFillColor = String(Zzy.Parameters['StrengFillColor']);//强化窗口高度 

Zzy.Param.SEFEquipPlaceX = String(Zzy.Parameters['EquipPlaceX']);//装备放置格X
Zzy.Param.SEFEquipPlaceY = String(Zzy.Parameters['EquipPlaceY']);//装备放置格Y
Zzy.Param.SEFEquipPlaceSize = parseInt(Zzy.Parameters['EquipPlaceSize']);//装备放置格尺寸
Zzy.Param.SEFEquipPlaceBColor = String(Zzy.Parameters['EquipPlaceBColor']);//装备放置格尺内部颜色
Zzy.Param.SEFEquipPlaceLWidth = parseInt(Zzy.Parameters['EquipPlaceLWidth']);//装备放置格边框宽度
Zzy.Param.SEFEquipPlaceLColor = String(Zzy.Parameters['EquipPlaceLColor']);//装备放置格尺边框颜色

Zzy.Param.SEFEquipPlaceNameX = String(Zzy.Parameters['EquipPlaceNameX']);//装备放置格名称X
Zzy.Param.SEFEquipPlaceNameY = String(Zzy.Parameters['EquipPlaceNameY']);//装备放置格名称Y
Zzy.Param.SEFEquipPlaceNameSize = parseInt(Zzy.Parameters['EquipPlaceNameSize']);//装备放置格名称尺寸


Zzy.Param.SEFStrengPlace1X = String(Zzy.Parameters['StrengPlace1X']);//强化放置格1X
Zzy.Param.SEFStrengPlace1Y = String(Zzy.Parameters['StrengPlace1Y']);//强化放置格1Y
Zzy.Param.SEFStrengPlace1Size = parseInt(Zzy.Parameters['StrengPlace1Size']);//强化放置格1尺寸
Zzy.Param.SEFStrengPlace1BColor = String(Zzy.Parameters['StrengPlace1BColor']);//强化放置格1尺内部颜色
Zzy.Param.SEFStrengPlace1LWidth = parseInt(Zzy.Parameters['StrengPlace1LWidth']);//强化放置格1边框宽度
Zzy.Param.SEFStrengPlace1LColor = String(Zzy.Parameters['StrengPlace1LColor']);//强化放置格1尺边框颜色

Zzy.Param.SEFStrengPlace1NameX = String(Zzy.Parameters['StrengPlace1NameX']);//强化放置格1名称X
Zzy.Param.SEFStrengPlace1NameY = String(Zzy.Parameters['StrengPlace1NameY']);//强化放置格1名称Y
Zzy.Param.SEFStrengPlace1NameSize = parseInt(Zzy.Parameters['StrengPlace1NameSize']);//强化放置格1名称尺寸



Zzy.Param.SEFStrengPlace2X = String(Zzy.Parameters['StrengPlace2X']);//强化放置格2X
Zzy.Param.SEFStrengPlace2Y = String(Zzy.Parameters['StrengPlace2Y']);//强化放置格2Y
Zzy.Param.SEFStrengPlace2Size = parseInt(Zzy.Parameters['StrengPlace2Size']);//强化放置格2尺寸
Zzy.Param.SEFStrengPlace2BColor = String(Zzy.Parameters['StrengPlace2BColor']);//强化放置格2尺内部颜色
Zzy.Param.SEFStrengPlace2LWidth = parseInt(Zzy.Parameters['StrengPlace2LWidth']);//强化放置格2边框宽度
Zzy.Param.SEFStrengPlace2LColor = String(Zzy.Parameters['StrengPlace2LColor']);//强化放置格2尺边框颜色
 
Zzy.Param.SEFStrengPlace2NameX = String(Zzy.Parameters['StrengPlace2NameX']);//强化放置格2名称X
Zzy.Param.SEFStrengPlace2NameY = String(Zzy.Parameters['StrengPlace2NameY']);//强化放置格2名称Y
Zzy.Param.SEFStrengPlace2NameSize = parseInt(Zzy.Parameters['StrengPlace2NameSize']);//强化放置格2名称尺寸



Zzy.Param.SEFStrengPlace3X = String(Zzy.Parameters['StrengPlace3X']);//强化放置格3X
Zzy.Param.SEFStrengPlace3Y = String(Zzy.Parameters['StrengPlace3Y']);//强化放置格3Y
Zzy.Param.SEFStrengPlace3Size = parseInt(Zzy.Parameters['StrengPlace3Size']);//强化放置格3尺寸
Zzy.Param.SEFStrengPlace3BColor = String(Zzy.Parameters['StrengPlace3BColor']);//强化放置格3尺内部颜色
Zzy.Param.SEFStrengPlace3LWidth = parseInt(Zzy.Parameters['StrengPlace3LWidth']);//强化放置格3边框宽度
Zzy.Param.SEFStrengPlace3LColor = String(Zzy.Parameters['StrengPlace3LColor']);//强化放置格3尺边框颜色

Zzy.Param.SEFStrengPlace3NameX = String(Zzy.Parameters['StrengPlace3NameX']);//强化放置格3名称X
Zzy.Param.SEFStrengPlace3NameY = String(Zzy.Parameters['StrengPlace3NameY']);//强化放置格3名称Y
Zzy.Param.SEFStrengPlace3NameSize = parseInt(Zzy.Parameters['StrengPlace3NameSize']);//强化放置格3名称尺寸

Zzy.Param.SEFStrengGoldX = String(Zzy.Parameters['StrengGoldX']);//强化需求金币X
Zzy.Param.SEFStrengGoldY = String(Zzy.Parameters['StrengGoldY']);//强化需求金币Y
Zzy.Param.SEFStrengGoldSize = parseInt(Zzy.Parameters['StrengGoldSize']);//强化需求金币尺寸
Zzy.Param.SEFStrengGoldName = String(Zzy.Parameters['StrengGoldName']);//强化需求金币名称

Zzy.Param.SEFStrengRateX = String(Zzy.Parameters['StrengRateX']);//强化需求成功率X
Zzy.Param.SEFStrengRateY = String(Zzy.Parameters['StrengRateY']);//强化需求成功率Y
Zzy.Param.SEFStrengRateSize = parseInt(Zzy.Parameters['StrengRateSize']);//强化需求成功率尺寸
Zzy.Param.SEFStrengRateName = String(Zzy.Parameters['StrengRateName']);//强化需求成功率名称

Zzy.Param.SEFMaxLevelX = String(Zzy.Parameters['MaxLevelX']);//强化到最大等级X
Zzy.Param.SEFMaxLevelY = String(Zzy.Parameters['MaxLevelY']);//强化到最大等级Y
Zzy.Param.SEFMaxLevelSize = parseInt(Zzy.Parameters['MaxLevelSize']);//强化到最大等级尺寸
Zzy.Param.SEFMaxLevelName = String(Zzy.Parameters['MaxLevelName']);//强化到最大等级名称


Zzy.SEF.IsShowToBoolean = function(str)
{
	if(str === '')return true;
	return str;
}


Zzy.Param.SEFStrengSuccessText = String(Zzy.Parameters['StrengSuccessText']);//显示成功文本
Zzy.Param.SEFStrengFailText = String(Zzy.Parameters['StrengFailText']);//显示失败文本
Zzy.Param.SEFIsShowSuccessText = Zzy.SEF.IsShowToBoolean(String(Zzy.Parameters['IsShowSuccessText']));//限制成功文本
Zzy.Param.SEFIsShowFailText = Zzy.SEF.IsShowToBoolean(String(Zzy.Parameters['IsShowFailText']));//限制失败文本


//设置文本信息
Zzy.Param.SEFShowTSize = parseInt(Zzy.Parameters['ShowTSize']);
Zzy.Param.SEFShowTColor = String(Zzy.Parameters['ShowTColor']);
Zzy.Param.SEFShowBSize = parseInt(Zzy.Parameters['ShowBSize']);
Zzy.Param.SEFShowBColor = String(Zzy.Parameters['ShowBColor']);

Zzy.Param.SEFSTStartX = Number(Zzy.Parameters['STStartX']);
Zzy.Param.SEFSTStartY = Number(Zzy.Parameters['STStartY']); 
Zzy.Param.SEFSTEndX = Number(Zzy.Parameters['STEndX']);
Zzy.Param.SEFSTEndY = Number(Zzy.Parameters['STEndY']);
Zzy.Param.SEFSTWEndFrame = Number(Zzy.Parameters['STWEndFrame']);
Zzy.Param.SEFSTWBeFrame = Number(Zzy.Parameters['STWBeFrame']);


Zzy.Param.SEFConsumeItem = parseInt(Zzy.Parameters['ConsumeItem']);//升级消耗道具ID
Zzy.Param.SEFConsumeItemCount = String(Zzy.Parameters['ConsumeItemCount']);//升级消耗道具数量
Zzy.Param.SEFConsumeWeapon = parseInt(Zzy.Parameters['ConsumeWeapon']);//升级消耗武器ID
Zzy.Param.SEFConsumeWeaponCount = String(Zzy.Parameters['ConsumeWeaponCount']);//升级消耗武器数量
Zzy.Param.SEFConsumeArmor = parseInt(Zzy.Parameters['ConsumeArmor']);//升级消耗护甲ID
Zzy.Param.SEFConsumeArmorCount = String(Zzy.Parameters['ConsumeArmorCount']);//升级消耗护甲数量
Zzy.Param.SEFConsumeGold = String(Zzy.Parameters['ConsumeGold']);//升级消耗金币数量

Zzy.Param.SEFPackWindowX = String(Zzy.Parameters['PackWindowX']);//背包窗口X位置
Zzy.Param.SEFPackWindowY = String(Zzy.Parameters['PackWindowY']);//背包窗口Y位置 
Zzy.Param.SEFPackWindowW = String(Zzy.Parameters['PackWindowW']);//背包窗口宽度 
Zzy.Param.SEFPackWindowH = String(Zzy.Parameters['PackWindowH']);//背包窗口高度 

Zzy.Param.SEFPackEQRows = parseInt(Zzy.Parameters['PackEQRows']);//道具排列列数
Zzy.Param.SEFPackFillColor = String(Zzy.Parameters['PackFillColor']);//底板填充
Zzy.Param.SEFPackFillDis = parseInt(Zzy.Parameters['PackFillDis']);//底板填充间距


Zzy.Param.SEFMaxLevel = String(Zzy.Parameters['MaxLevel']);//装备强化最大等级
Zzy.Param.SEFSuccessRate = String(Zzy.Parameters['SuccessRate']);//装备强化成功概率



Zzy.Param.SEFUpHP = String(Zzy.Parameters['UpHP']);//升级生命
Zzy.Param.SEFUpHPPer = String(Zzy.Parameters['UpHPPer']);//升级生命百分比
Zzy.Param.SEFUpMP = String(Zzy.Parameters['UpHP']);//升级魔力
Zzy.Param.SEFUpMPPer = String(Zzy.Parameters['UpHPPer']);//升级魔力百分比
Zzy.Param.SEFUpATK = String(Zzy.Parameters['UpATK']);//升级攻击
Zzy.Param.SEFUpATKPer = String(Zzy.Parameters['UpATKPer']);//升级攻击百分比
Zzy.Param.SEFUpDEF = String(Zzy.Parameters['UpDEF']);//升级防御
Zzy.Param.SEFUpDEFPer = String(Zzy.Parameters['UpDEFPer']);//升级防御百分比
Zzy.Param.SEFUpMAT = String(Zzy.Parameters['UpMAT']);//升级魔攻
Zzy.Param.SEFUpMATPer = String(Zzy.Parameters['UpMATPer']);//升级魔攻百分比
Zzy.Param.SEFUpMDF = String(Zzy.Parameters['UpMDF']);//升级魔抗
Zzy.Param.SEFUpMDFPer = String(Zzy.Parameters['UpMDFPer']);//升级魔抗百分比
Zzy.Param.SEFUpAGI = String(Zzy.Parameters['UpAGI']);//升级速度
Zzy.Param.SEFUpAGIPer = String(Zzy.Parameters['UpAGIPer']);//升级速度百分比
Zzy.Param.SEFUpLUK = String(Zzy.Parameters['UpLUK']);//升级幸运
Zzy.Param.SEFUpLUKPer = String(Zzy.Parameters['UpLUKPer']);//升级幸运百分比

Zzy.Param.SEFUpHIT = String(Zzy.Parameters['UpHIT']);//升级命中
Zzy.Param.SEFUpEVA = String(Zzy.Parameters['UpEVA']);//升级闪避
Zzy.Param.SEFUpCRI = String(Zzy.Parameters['UpCRI']);//升级暴击
Zzy.Param.SEFUpCEV = String(Zzy.Parameters['UpCEV']);//升级暴击回避
Zzy.Param.SEFUpMEV = String(Zzy.Parameters['UpMEV']);//升级魔法回避
Zzy.Param.SEFUpMRF = String(Zzy.Parameters['UpMRF']);//升级魔法反射
Zzy.Param.SEFUpCNT = String(Zzy.Parameters['UpCNT']);//升级反击
Zzy.Param.SEFUpHRG = String(Zzy.Parameters['UpHRG']);//升级HP自动恢复
Zzy.Param.SEFUpMRG = String(Zzy.Parameters['UpMRG']);//升级MP自动恢复
Zzy.Param.SEFUpTRG = String(Zzy.Parameters['UpTRG']);//升级TP自动恢复

Zzy.Param.SEFUpTRG = String(Zzy.Parameters['UpTRG']);//升级受到攻击几率
Zzy.Param.SEFUpGRD = String(Zzy.Parameters['UpGRD']);//升级防御效果
Zzy.Param.SEFUpREC = String(Zzy.Parameters['UpREC']);//升级恢复效果
Zzy.Param.SEFUpPHA = String(Zzy.Parameters['UpPHA']);//升级药理知识
Zzy.Param.SEFUpMCR = String(Zzy.Parameters['UpMCR']);//升级MP消耗率
Zzy.Param.SEFUpTCR = String(Zzy.Parameters['UpTCR']);//升级TP消耗率
Zzy.Param.SEFUpPDR = String(Zzy.Parameters['UpPDR']);//升级物理伤害
Zzy.Param.SEFUpMDR = String(Zzy.Parameters['UpMDR']);//升级魔法伤害
Zzy.Param.SEFUpFDR = String(Zzy.Parameters['UpFDR']);//升级地板伤害
Zzy.Param.SEFUpEXP = String(Zzy.Parameters['UpEXP']);//升级经验值


Zzy.Param.SEFParam = [
Zzy.Param.SEFUpHP,Zzy.Param.SEFUpMP,Zzy.Param.SEFUpATK,Zzy.Param.SEFUpDEF,Zzy.Param.SEFUpMAT,Zzy.Param.SEFUpMDF,Zzy.Param.SEFUpAGI,Zzy.Param.SEFUpLUK
];

Zzy.Param.SEFParamPer = [
Zzy.Param.SEFUpHPPer,Zzy.Param.SEFUpMPPer,Zzy.Param.SEFUpATKPer,Zzy.Param.SEFUpDEFPer,Zzy.Param.SEFUpMATPer,Zzy.Param.SEFUpMDFPer,Zzy.Param.SEFUpAGIPer,Zzy.Param.SEFUpLUKPer
];

Zzy.Param.SEFExParam = [
Zzy.Param.SEFUpHIT,Zzy.Param.SEFUpEVA,Zzy.Param.SEFUpCRI,Zzy.Param.SEFUpCEV,Zzy.Param.SEFUpMEV,Zzy.Param.SEFUpMRF,Zzy.Param.SEFUpCNT,Zzy.Param.SEFUpHRG,Zzy.Param.SEFUpMRG,Zzy.Param.SEFUpTRG
];

Zzy.Param.SEFSpParam = [
Zzy.Param.SEFUpTRG,Zzy.Param.SEFUpGRD,Zzy.Param.SEFUpREC,Zzy.Param.SEFUpPHA,Zzy.Param.SEFUpMCR,Zzy.Param.SEFUpTCR,Zzy.Param.SEFUpPDR,Zzy.Param.SEFUpMDR,Zzy.Param.SEFUpFDR,Zzy.Param.SEFUpEXP
];


//强化
Zzy.Param.SEFSuConsumeItem = eval(String(Zzy.Parameters['SuConsumeItem']));//是否成功消耗强化材料
Zzy.Param.SEFSuConsumeGold = eval(String(Zzy.Parameters['SuConsumeGold']));//是否成功消耗强化金币

Zzy.Param.SEFFaConsumeItem = eval(String(Zzy.Parameters['FaConsumeItem']));//是否失败消耗强化材料
Zzy.Param.SEFFaConsumeGold = eval(String(Zzy.Parameters['FaConsumeGold']));//是否失败消耗强化金币
Zzy.Param.SEFFaConsumeEquip = eval(String(Zzy.Parameters['FaConsumeEquip']));//是否失败消耗原武器

Zzy.Param.SEFIsFailDemotion = eval(String(Zzy.Parameters['IsFailDemotion']));//是否失败武器降级
Zzy.Param.SEFFailDemotionCount = String(Zzy.Parameters['FailDemotionCount']);//失败下降数值



Zzy.SEF.MakeSE = function(seName,seVolume,sePitch,sePan)
{
	if(!seName)return undefined;
	var se = {
		name:seName,
		volume:(seVolume ? seVolume : 100),
		pitch:(sePitch ? sePitch : 100),
		pan:(sePan ? sePan : 0)
	};
	return se;
}

 
Zzy.Param.SEFSuccessSound = String(Zzy.Parameters['SuccessSound']);//选择失效音效
Zzy.Param.SEFSuccessVolume = parseInt(Zzy.Parameters['SuccessVolume']);//选择失效音量
Zzy.Param.SEFSuccessPitch = parseInt(Zzy.Parameters['SuccessPitch']);//选择失效音调
Zzy.Param.SEFSuccessPan = parseInt(Zzy.Parameters['SuccessPan']);//选择失效声道
Zzy.Param.SEFSuccessSE = Zzy.SEF.MakeSE(Zzy.Param.SEFSuccessSound,Zzy.Param.SEFSuccessVolume,Zzy.Param.SEFSuccessPitch,Zzy.Param.SEFSuccessPan);

Zzy.Param.SEFFailSound = String(Zzy.Parameters['FailSound']);//选择失效音效
Zzy.Param.SEFFailVolume = parseInt(Zzy.Parameters['FailVolume']);//选择失效音量
Zzy.Param.SEFFailPitch = parseInt(Zzy.Parameters['FailPitch']);//选择失效音调
Zzy.Param.SEFFailPan = parseInt(Zzy.Parameters['FailPan']);//选择失效声道
Zzy.Param.SEFFailSE = Zzy.SEF.MakeSE(Zzy.Param.SEFFailSound,Zzy.Param.SEFFailVolume,Zzy.Param.SEFFailPitch,Zzy.Param.SEFFailPan);



Zzy.Param.SEFAllSE = [];
Zzy.Param.SEFAllSE = [undefined,
Zzy.Param.SEFSuccessSE,Zzy.Param.SEFFailSE
]



Zzy.Param.SEFStrengButtonPic = String(Zzy.Parameters['StrengButtonPic']);//强化按钮
Zzy.Param.SEFStrengButtonX = String(Zzy.Parameters['StrengButtonX']);//强化按钮X位置
Zzy.Param.SEFStrengButtonY = String(Zzy.Parameters['StrengButtonY']);//强化按钮Y位置

Zzy.Param.SEFCancelButtonPic = String(Zzy.Parameters['CancelButtonPic']);//取消按钮
Zzy.Param.SEFCancelButtonX = String(Zzy.Parameters['CancelButtonX']);//取消按钮X位置
Zzy.Param.SEFCancelButtonY = String(Zzy.Parameters['CancelButtonY']);//取消按钮Y位置






//声音ID
//0 - undefined
//1 - 成功音效
//2 - 失败音效
//3 - 
//4 - 
//5 - 
//6 - 


//=============================================================================
//Game_System
//=============================================================================

Zzy.SEF.Game_System_initialize = Game_System.prototype.initialize;
Game_System.prototype.initialize = function() 
{
    Zzy.SEF.Game_System_initialize.call(this);
	this.ZzySEFInitData();//初始化数据
	
};
	

Game_System.prototype.ZzySEFInitData = function()
{
	this._ZzySEFIsCanStreng = Zzy.Param.SEFIsCanStreng;//装备拥有强化能力
	this._ZzySEFMaxLevel = Zzy.Param.SEFMaxLevel;//装备强化最大等级
	this._ZzySEFPrefix = Zzy.Param.SEFPrefix;//装备强化的前缀名称
	this._ZzySEFSuffix = Zzy.Param.SEFSuffix;//装备强化的后缀名称
	this._ZzySEFSuccessRate = Zzy.Param.SEFSuccessRate;//成功率
	this._ZzySEFIsShowSuccessText = Zzy.Param.SEFIsShowSuccessText;//限制成功文本
	this._ZzySEFIsShowFailText = Zzy.Param.SEFIsShowFailText;//限制失败文本

	//等级记录
	this._ZzySEFWeaponLevel = [];
	this._ZzySEFArmorLevel = [];
}




Game_System.prototype.GetZzySEFSuccessRate = function()
{
	if(this._ZzySEFSuccessRate === undefined)
	{this._ZzySEFSuccessRate = Zzy.Param.SEFSuccessRate;}
	return this._ZzySEFSuccessRate;
}

Game_System.prototype.GetZzySEFIsShowSuccessText = function()
{
	if(this._ZzySEFIsShowSuccessText === undefined)
	{this._ZzySEFIsShowSuccessText = Zzy.Param.SEFIsShowSuccessText;}
	return this._ZzySEFIsShowSuccessText;
}

Game_System.prototype.GetZzySEFIsShowFailText = function()
{
	if(this._ZzySEFIsShowFailText === undefined)
	{this._ZzySEFIsShowFailText = Zzy.Param.SEFIsShowFailText;}
	return this._ZzySEFIsShowFailText;
}


Game_System.prototype.GetZzySEFWeaponLevel = function(id)//获取武器等级
{
	if(this._ZzySEFWeaponLevel === undefined)
	{this._ZzySEFWeaponLevel = [];}
	return this._ZzySEFWeaponLevel[id];
}

Game_System.prototype.GetZzySEFArmorLevel = function(id)//获取护甲等级
{
	if(this._ZzySEFArmorLevel === undefined)
	{this._ZzySEFArmorLevel = [];}
	return this._ZzySEFArmorLevel[id];
}

Game_System.prototype.ZzySEFGetLevel = function(type,id)
{
	switch(type)
	{
		case 'weapon':return this.GetZzySEFWeaponLevel(id);
		case 'armor':return this.GetZzySEFArmorLevel(id);
	}
	console.log('一个错误:来自LiuYue_StrengEquip(强化装备):输入的type参数不正确');
}


Game_System.prototype.ZzySEFLevelUp = function(eq,levelUp)//装备升级,降级
{
	levelUp = (levelUp === undefined) ? 1 : levelUp;//防止为0

	
	var id = eq.id;
	var maxLevelEval = this.GetZzySEFMaxLevel(eq);
	var maxLevel = Zzy.SEF.EvalTranslate(maxLevelEval)//eval转换
	switch(eq.zzySEF.typeId)
	{
		case 2:
			if(!this._ZzySEFWeaponLevel[id])
			{this._ZzySEFWeaponLevel[id]=0;}
		
			this._ZzySEFWeaponLevel[id] += levelUp;
			if(this._ZzySEFWeaponLevel[id] > maxLevel)
			{
				this._ZzySEFWeaponLevel[id] = maxLevel;
			}
			if(this._ZzySEFWeaponLevel[id] < 0)
			{
				this._ZzySEFWeaponLevel[id] = 0;
			}
			
			
		break;
		
		case 3:
			if(!this._ZzySEFArmorLevel[id])
			{this._ZzySEFArmorLevel[id]=0;}
		
			this._ZzySEFArmorLevel[id] += levelUp;
			if(this._ZzySEFArmorLevel[id] > maxLevel)
			{
				this._ZzySEFArmorLevel[id] = maxLevel;
			}
			if(this._ZzySEFArmorLevel[id] < 0 )
			{
				this._ZzySEFArmorLevel[id] = 0;
			}
		break;
	}
}

Game_System.prototype.GetZzySEFEQParam = function(eq,paramId)//获取基础参数
{
	var level = this.GetZzySEFEQLevel(eq);
	if(!eq.zzySEF.param[paramId]){eq.zzySEF.param[paramId] = [];}
	var valueEval = eq.zzySEF.param[paramId][level];
	return valueEval ? valueEval : Zzy.Param.SEFParam[paramId];
}

Game_System.prototype.GetZzySEFEQParamPer = function(eq,paramId)//获取基础参数Per
{
	var level = this.GetZzySEFEQLevel(eq);
	if(!eq.zzySEF.paramPer[paramId]){eq.zzySEF.paramPer[paramId] = [];}
	var valueEval = eq.zzySEF.paramPer[paramId][level];
	return valueEval ? valueEval : Zzy.Param.SEFParamPer[paramId];
}

Game_System.prototype.GetZzySEFEQPExParam = function(eq,exParamId)//获取额外参数
{
	var level = this.GetZzySEFEQLevel(eq);
	if(!eq.zzySEF.exParam[exParamId]){eq.zzySEF.exParam[exParamId] = [];}
	var valueEval = eq.zzySEF.exParam[exParamId][level];
	return valueEval ? valueEval : Zzy.Param.SEFExParam[exParamId];
}

Game_System.prototype.GetZzySEFEQPSpParam = function(eq,spParamId)//获取特殊参数
{
	var level = this.GetZzySEFEQLevel(eq);
	if(!eq.zzySEF.spParam[spParamId]){eq.zzySEF.spParam[spParamId] = [];}
	var valueEval = eq.zzySEF.spParam[spParamId][level];
	return valueEval ? valueEval : Zzy.Param.SEFSpParam[spParamId];
}

Game_System.prototype.ZzySEFSetLevel = function(type,id,level)//设置装备等级
{
	switch(type)
	{
		case 'weapon':
		case 1:
			this._ZzySEFWeaponLevel[id] = level;
		break;
		
		case 'armor':
		case 2:
			this._ZzySEFArmorLevel[id] = level;
		break;
	}
}

Game_System.prototype.ClearZzySEFEQLevel = function(eq)//清空等级
{
	switch(eq.zzySEF.typeId)
	{
		case 2:
		this._ZzySEFWeaponLevel[eq.id] = 0;
		break;
		case 3:
		this._ZzySEFArmorLevel[eq.id] = 0;
		break;
	}
}

Game_System.prototype.DownZzySEFEQLevel = function(eq,value)//下降一个装备等级
{

	switch(eq.zzySEF.typeId)
	{
		case 2:
		this._ZzySEFWeaponLevel[eq.id] -= value;
		this._ZzySEFWeaponLevel[eq.id] = this._ZzySEFWeaponLevel[eq.id] < 0 ? 0 : this._ZzySEFWeaponLevel[eq.id];
		break;
		case 3:
		this._ZzySEFArmorLevel[eq.id] -= value;
		this._ZzySEFArmorLevel[eq.id] = this._ZzySEFArmorLevel[eq.id] < 0 ? 0 : this._ZzySEFArmorLevel[eq.id];
		break;
	}
}

Game_System.prototype.UpZzySEFEQLevel = function(eq,value)//提升一个装备等级
{
	var maxLevelEval = this.GetZzySEFMaxLevel(eq);
	var maxLevel = Zzy.SEF.EvalTranslate(maxLevelEval)//eval转换	
	switch(eq.zzySEF.typeId)
	{
		case 2:
		this._ZzySEFWeaponLevel[eq.id] += value;
		this._ZzySEFWeaponLevel[eq.id] = this._ZzySEFWeaponLevel[eq.id] > maxLevel ? maxLevel : this._ZzySEFWeaponLevel[eq.id];
		break;
		case 3:
		this._ZzySEFArmorLevel[eq.id] += value;
		this._ZzySEFArmorLevel[eq.id] = this._ZzySEFArmorLevel[eq.id] > maxLevel ? maxLevel : this._ZzySEFArmorLevel[eq.id];
		break;
	}
}

Game_System.prototype.IsZzySEFMaxLevel = function(eq)//是否达到最高等级
{
	var id = eq.id;
	var maxLevelEval = this.GetZzySEFMaxLevel(eq);
	var maxLevel = Zzy.SEF.EvalTranslate(maxLevelEval);//eval转换
	var level = this.GetZzySEFEQLevel(eq);
	
	if(level >= maxLevel)
	{
		return true;
	}
	return false;
}

Game_System.prototype.GetZzySEFIsCanStreng = function(eq)
{
	return eq.zzySEF.isCanStreng !== undefined ? eq.zzySEF.isCanStreng : this.getZzySEFIsCanStreng();
}

Game_System.prototype.getZzySEFIsCanStreng = function()
{
	if(this._ZzySEFIsCanStreng === undefined)
	{this._ZzySEFIsCanStreng = Zzy.SEF.IsCanStreng;}
	return this._ZzySEFIsCanStreng;
}

Game_System.prototype.GetZzySEFMaxLevel = function(eq)
{
	return eq.zzySEF.maxLevel !== undefined ? eq.zzySEF.maxLevel : this.getZzySEFMaxLevel();
}

Game_System.prototype.getZzySEFMaxLevel = function()
{
	if(this._ZzySEFMaxLevel === undefined)
	{this._ZzySEFMaxLevel = Zzy.Param.SEFMaxLevel;}
	return this._ZzySEFMaxLevel;
}


Game_System.prototype.GetZzySEFPrefix = function(eq)
{
	return eq.zzySEF.prefix !== undefined ? eq.zzySEF.prefix : this.getZzySEFPrefix();
}
 
Game_System.prototype.getZzySEFPrefix = function()
{
	if(this._ZzySEFPrefix === undefined)
	{this._ZzySEFPrefix = Zzy.Param.SEFPrefix;}
	return this._ZzySEFPrefix;
}

Game_System.prototype.GetZzySEFSuffix = function(eq)
{
	return eq.zzySEF.suffix !== undefined ? eq.zzySEF.suffix : this.getZzySEFSuffix();
}


Game_System.prototype.getZzySEFSuffix = function()
{
	if(this._ZzySEFSuffix === undefined)
	{this._ZzySEFSuffix = Zzy.Param.SEFSuffix;}
	return this._ZzySEFSuffix;
}


Game_System.prototype.IsZzySEFSpell = function(item)
{
	return item.zzySEF.isSpell ? true : false;
}

Game_System.prototype.IsZzySEFNoConsume = function(item)
{
	return item.zzySEF.isNoConsume ? true : false;
}

Game_System.prototype.IsZzySEFEqProtect = function(item)
{
	return item.zzySEF.isEqProtect ? true : false;
}

Game_System.prototype.GetZzySEFExtraLevelArr = function(item)
{
	return item.zzySEF.extraLevel;
}

Game_System.prototype.GetZzySEFSuccessRate = function(item)//概率提升
{
	return item.zzySEF.successRate;
}

Game_System.prototype.GetZzySEFEQLevel = function(eq)
{
	var currentLevel = 0;
	switch(eq.zzySEF.typeId)
	{
		case 2:
		currentLevel = $gameSystem.GetZzySEFWeaponLevel(eq.id);
		break;
		case 3:
		currentLevel = $gameSystem.GetZzySEFArmorLevel(eq.id);
		break;
	}
	
	return currentLevel ? currentLevel : 0;
}

Game_System.prototype.GetZzySEFEQSuccessRate = function(eq,level)//返回装备强化成功率
{
	if(eq.zzySEF.levelParam[level])
	{
		var info = eq.zzySEF.levelParam[level];
		
		if(info.successRate)
		{return info.successRate;}
	}
	
	return this.GetZzySEFSuccessRate();
}

Game_System.prototype.getZzySEFIsShowSuccessText = function(eq)
{
	var evalFormat = eq.zzySEF.isShowSuccessText;
	evalFormat = evalFormat ? evalFormat : this.GetZzySEFIsShowSuccessText();
	
	return evalFormat;
}

Game_System.prototype.getZzySEFIsShowFailText = function(eq)
{
	var evalFormat = eq.zzySEF.isShowFailText;
	evalFormat = evalFormat ? evalFormat : this.GetZzySEFIsShowFailText();
	
	return evalFormat;	
}

Game_System.prototype.GetZzySEFEQItemList = function(eq,level)
{
	var list = [];
	if(eq.zzySEF.levelParam[level])
	{
		var info = eq.zzySEF.levelParam[level];
		
		if(info.UpItem)
		{
			
			for(var i=0;i<info.UpItem.length;i++)
			{
				switch(info.UpItem[i].typeId)
				{
					case 1:list.push($dataItems[info.UpItem[i].itemId]);break;
					case 2:list.push($dataWeapons[info.UpItem[i].itemId]);break;
					case 3:list.push($dataArmors[info.UpItem[i].itemId]);break;
				}
				
			}
		}
		
	}
	else//使用参数默认
	{
		if(Zzy.Param.SEFConsumeItem)
		{list.push($dataItems[Zzy.Param.SEFConsumeItem]);}
	
		if(Zzy.Param.SEFConsumeWeapon)
		{list.push($dataWeapons[Zzy.Param.SEFConsumeWeapon]);}
	
		if(Zzy.Param.SEFConsumeArmor)
		{list.push($dataArmors[Zzy.Param.SEFConsumeArmor]);}
	}
	return list;
}

Game_System.prototype.GetZzySEFEQItemListEx = function(eq,level,excludeArr)
{
	var list = [];
	if(eq.zzySEF.levelParam[level])
	{
		var info = eq.zzySEF.levelParam[level];
		if(info.UpItem)
		{
			for(var i=0;i<info.UpItem.length;i++)
			{
				var isPush = true;
				switch(info.UpItem[i].typeId)
				{
					case 1:
					 list.push($dataItems[info.UpItem[i].itemId]);//道具
					break;
					case 2:				
					 list.push($dataWeapons[info.UpItem[i].itemId]);
					break;
					case 3:					
					 list.push($dataArmors[info.UpItem[i].itemId]);
					break;
				}
				
			}
		}
		
	}
	else//使用参数默认
	{
		
		if(Zzy.Param.SEFConsumeItem)
		{
			list.push($dataItems[Zzy.Param.SEFConsumeItem]);
		}
	
		if(Zzy.Param.SEFConsumeWeapon)
		{		
			list.push($dataWeapons[Zzy.Param.SEFConsumeWeapon]);
		}
	
		if(Zzy.Param.SEFConsumeArmor)
		{		
			list.push($dataArmors[Zzy.Param.SEFConsumeArmor]);
		}
	}
	return list;	
	
}

Game_System.prototype.GetZzySEFEQNeedGold = function(eq,level)
{
	if(eq.zzySEF.levelParam[level])
	{
		var info = eq.zzySEF.levelParam[level];
		if(info.gold)
		{return info.gold;}
	}
	return Zzy.Param.SEFConsumeGold;
}

Game_System.prototype.GetZzySEFEQNeedITCount = function(eq,level,it)//获取需要道具数量
{
	var count = 0;
	if(eq.zzySEF.levelParam[level])
	{
		var info = eq.zzySEF.levelParam[level];
		if(info.UpItem)
		{
			for(var i=0;i<info.UpItem.length;i++)
			{
				if(info.UpItem[i].typeId === it.zzySEF.typeId &&
				info.UpItem[i].itemId === it.id)
				{
					return info.UpItem[i].count;
				}
			
			}				
		}
	}
	else
	{
		switch(it.zzySEF.typeId)
		{
			case 1:if(it.id === Zzy.Param.SEFConsumeItem){return Zzy.Param.SEFConsumeItemCount}break;
			case 2:if(it.id === Zzy.Param.SEFConsumeWeapon){return Zzy.Param.SEFConsumeWeaponCount}break;
			case 3:if(it.id === Zzy.Param.SEFConsumeArmor){return Zzy.Param.SEFConsumeArmorCount}break;
		}
		
	}

	
	return 0;
}


//=============================================================================
//Game_Interpreter
//=============================================================================

Zzy.SEF.Game_Interpreter_pluginCommand = Game_Interpreter.prototype.pluginCommand;
Game_Interpreter.prototype.pluginCommand = function(command, args)//插件命令
{
	Zzy.SEF.Game_Interpreter_pluginCommand.call(this,command,args);

	if(command === 'ZzySEF')
	{
		this.ZzySEFCommand(args);
	}
}

Game_Interpreter.prototype.ZzySEFCommand = function(args)
{
	var command = String(args[0]);
	
	switch(command)
	{   	
		case 'OpenStrengScene':
			Zzy.SEF.OpenStrengScene();
		break;
		
		case 'IsCanStreng':
			var enable = eval(String(args[1]));
			$gameSystem._ZzySEFIsCanStreng = enable;
		break;
		
		case 'MaxLevel':
			var maxLevel = String(args[1]);
			$gameSystem._ZzySEFMaxLevel = maxLevel;
		break;
		
		case 'Prefix':
			var prefix = String(args[1]);
			$gameSystem._ZzySEFPrefix = prefix;
		break;
		
		case 'Suffix':
			var suffix = String(args[1]);
			$gameSystem._ZzySEFSuffix = suffix;
		break;
		
		case 'IsShowSuccessText':
			var evalFormat = String(args[1]);
			$gameSystem._ZzySEFIsShowSuccessText = evalFormat;
		break;
		
		case 'IsShowFailText':
			var evalFormat = String(args[1]);
			$gameSystem._ZzySEFIsShowFailText = evalFormat;
		break;
		
		
		case 'SuccessRate':
			var rate = String(args[1]);
			$gameSystem._ZzySEFSuccessRate = rate;
		break;
		
		case 'SetLevel':
			var type = String(args[1]);
			var ID = parseInt(args[2]);
			var level = parseInt(args[3]);
			$gameSystem.ZzySEFSetLevel(type,ID,level);
		break;
	}
}

Game_Interpreter.prototype.SetupZzySEFCommand = function(commonId) //存储事件信息
{
    var commonEvent = $dataCommonEvents[commonId];
    if (commonEvent) 
	{
        var eventId = this.isOnCurrentMap() ? this._eventId : 0;
        //this.setupChild(commonEvent.list, eventId);
		this.setup(commonEvent.list, eventId);
    }
    return true;
};


//================================================================
//DataManager
//================================================================
Zzy.SEF.DataManager_isDatabaseLoaded = DataManager.isDatabaseLoaded;
DataManager.isDatabaseLoaded = function()
{
	if (!Zzy.SEF.DataManager_isDatabaseLoaded.call(this)) return false;
	
	//添加标签内容
	this.ZzySEFLoadNoteCase1($dataWeapons,2);//武器
	this.ZzySEFLoadNoteCase1($dataArmors,3);//护甲
	this.ZzySEFLoadNoteCase2($dataItems);//道具
	return true;
}

DataManager.ZzySEFLoadNoteCase2 = function(objArr)
{
  for (var i = 1; i < objArr.length; i++) 
  {
    var obj = objArr[i];
    var noteData = obj.note.split(/[\r\n]+/);
	
	obj.zzySEF = {};
	obj.zzySEF.typeId = 1;
	

	for(var j=0;j<noteData.length;j++)
	{
		var lineStr = noteData[j];

		if(lineStr.match(/<ZZYSEF SPELL>/i))
		{
			obj.zzySEF.isSpell = true;
		}
		else if(lineStr.match(/<ZZYSEF NOCONSUME>/i))//强化不消失
		{
			obj.zzySEF.isNoConsume = true;
		}
		else if(lineStr.match(/<ZZYSEF EXTRALEVEL:[ ](.*)[ ](.*)>/i))
		{
			var levelEval = String(RegExp.$1);
			var rateEval = String(RegExp.$2);
			var info = {};
			info.level = levelEval;
			info.rate = rateEval;
			if(!obj.zzySEF.extraLevel)
			{obj.zzySEF.extraLevel = [];}
			obj.zzySEF.extraLevel.push(info);
		}
		else if(lineStr.match(/<ZZYSEF EQPROTECT>/i))
		{
			obj.zzySEF.isEqProtect = true;
		}
		else if(lineStr.match(/<ZZYSEF SUCCESSRATE:[ ](.*)>/i))
		{
			var successRateEval = String(RegExp.$1);
			obj.zzySEF.successRate = successRateEval;
		}		
	}
  }
}

DataManager.ZzySEFLoadNoteCase1 = function(objArr,typeId)//加载标签
{
  for (var i = 1; i < objArr.length; i++) 
  {
    var obj = objArr[i];
    var noteData = obj.note.split(/[\r\n]+/);
	
	obj.zzySEF = {};
	obj.zzySEF['param'] = [];
	obj.zzySEF['paramPer'] = [];
	obj.zzySEF['exParam'] = [];
	obj.zzySEF['spParam'] = [];
	
	obj.zzySEF.typeId = typeId;//武器类型
	obj.zzySEF.levelParam = [];
	

	var selectMode = '';
	var sLevel = 0;
	var eLevel = 0;	

	for(var j=0;j<noteData.length;j++)
	{
		var lineStr = noteData[j];

		switch(selectMode)
		{
			case 'n':
			if(lineStr.match(/<ZZYSEF LEVEL END>/i))
			{
				selectMode = '';
			}
			else if(lineStr.match(/SUCCESSRATE:[ ](.*)/i))
			{
				var rate = String(RegExp.$1);
				Zzy.SEF.CopyValueToArr(obj.zzySEF.levelParam,'successRate',rate,sLevel,eLevel);
				
			}
			else if(lineStr.match(/CONSUMEITEM:[ ](.*)[ ](.*)/i))
			{
				var info = {};
				info.typeId = 1;
				info.itemId = parseInt(RegExp.$1);
				info.count = String(RegExp.$2);
				Zzy.SEF.CopyInfoToArr(obj.zzySEF.levelParam,'UpItem',info,sLevel,eLevel);
			}
			else if(lineStr.match(/CONSUMEWEAPON:[ ](.*)[ ](.*)/i))
			{
				var info = {};
				info.typeId = 2;
				info.itemId = parseInt(RegExp.$1);
				info.count = String(RegExp.$2);
				Zzy.SEF.CopyInfoToArr(obj.zzySEF.levelParam,'UpItem',info,sLevel,eLevel);
			}			
			else if(lineStr.match(/CONSUMEARMOR:[ ](.*)[ ](.*)/i))
			{
				var info = {};
				info.typeId = 3;
				info.itemId = parseInt(RegExp.$1);
				info.count = String(RegExp.$2);
				Zzy.SEF.CopyInfoToArr(obj.zzySEF.levelParam,'UpItem',info,sLevel,eLevel);
			}
			else if(lineStr.match(/CONSUMEGOLD:[ ](.*)/i))
			{
				var gold = String(RegExp.$1);
				Zzy.SEF.CopyValueToArr(obj.zzySEF.levelParam,'gold',gold,sLevel,eLevel);
			}
			else if(lineStr.match(/HP:[ ](.*)/i))
			{
				var value = String(RegExp.$1);
				Zzy.SEF.CopyParamToArr(obj.zzySEF['param'],0,value,sLevel,eLevel);
			}
			else if(lineStr.match(/HPPER:[ ](.*)/i))
			{
				var value = String(RegExp.$1);
				Zzy.SEF.CopyParamToArr(obj.zzySEF['paramPer'],0,value,sLevel,eLevel);
			}			
			else if(lineStr.match(/MP:[ ](.*)/i))
			{
				var value = String(RegExp.$1);
				Zzy.SEF.CopyParamToArr(obj.zzySEF['param'],1,value,sLevel,eLevel);
			}
			else if(lineStr.match(/MPPER:[ ](.*)/i))
			{
				var value = String(RegExp.$1);
				Zzy.SEF.CopyParamToArr(obj.zzySEF['paramPer'],1,value,sLevel,eLevel);
			}		
			else if(lineStr.match(/ATK:[ ](.*)/i))
			{
				var value = String(RegExp.$1);
				Zzy.SEF.CopyParamToArr(obj.zzySEF['param'],2,value,sLevel,eLevel);
			}
			else if(lineStr.match(/ATKPER:[ ](.*)/i))
			{
				var value = String(RegExp.$1);
				Zzy.SEF.CopyParamToArr(obj.zzySEF['paramPer'],2,value,sLevel,eLevel);
			}
			else if(lineStr.match(/DEF:[ ](.*)/i))
			{
				var value = String(RegExp.$1);
				Zzy.SEF.CopyParamToArr(obj.zzySEF['param'],3,value,sLevel,eLevel);
			}
			else if(lineStr.match(/DEFPER:[ ](.*)/i))
			{
				var value = String(RegExp.$1);
				Zzy.SEF.CopyParamToArr(obj.zzySEF['paramPer'],3,value,sLevel,eLevel);
			}
			else if(lineStr.match(/MAT:[ ](.*)/i))
			{
				var value = String(RegExp.$1);
				Zzy.SEF.CopyParamToArr(obj.zzySEF['param'],4,value,sLevel,eLevel);
			}
			else if(lineStr.match(/MATPER:[ ](.*)/i))
			{
				var value = String(RegExp.$1);
				Zzy.SEF.CopyParamToArr(obj.zzySEF['paramPer'],4,value,sLevel,eLevel);
			}
			else if(lineStr.match(/MDF:[ ](.*)/i))
			{
				var value = String(RegExp.$1);
				Zzy.SEF.CopyParamToArr(obj.zzySEF['param'],5,value,sLevel,eLevel);
			}
			else if(lineStr.match(/MDFPER:[ ](.*)/i))
			{
				var value = String(RegExp.$1);
				Zzy.SEF.CopyParamToArr(obj.zzySEF['paramPer'],5,value,sLevel,eLevel);
			}
			else if(lineStr.match(/AGI:[ ](.*)/i))
			{
				var value = String(RegExp.$1);
				Zzy.SEF.CopyParamToArr(obj.zzySEF['param'],6,value,sLevel,eLevel);
			}
			else if(lineStr.match(/AGIPER:[ ](.*)/i))
			{
				var value = String(RegExp.$1);
				Zzy.SEF.CopyParamToArr(obj.zzySEF['paramPer'],6,value,sLevel,eLevel);
			}
			else if(lineStr.match(/LUK:[ ](.*)/i))
			{
				var value = String(RegExp.$1);
				Zzy.SEF.CopyParamToArr(obj.zzySEF['param'],7,value,sLevel,eLevel);
			}
			else if(lineStr.match(/LUKPER:[ ](.*)/i))
			{
				var value = String(RegExp.$1);
				Zzy.SEF.CopyParamToArr(obj.zzySEF['paramPer'],7,value,sLevel,eLevel);
			}
			else if(lineStr.match(/HIT:[ ](.*)/i))
			{
				var value = String(RegExp.$1);
				Zzy.SEF.CopyParamToArr(obj.zzySEF['exParam'],0,value,sLevel,eLevel);
			}
			else if(lineStr.match(/EVA:[ ](.*)/i))
			{
				var value = String(RegExp.$1);
				Zzy.SEF.CopyParamToArr(obj.zzySEF['exParam'],1,value,sLevel,eLevel);
			}
			else if(lineStr.match(/CRI:[ ](.*)/i))
			{
				var value = String(RegExp.$1);
				Zzy.SEF.CopyParamToArr(obj.zzySEF['exParam'],2,value,sLevel,eLevel);
			}
			
			else if(lineStr.match(/CEV:[ ](.*)/i))
			{
				var value = String(RegExp.$1);
				Zzy.SEF.CopyParamToArr(obj.zzySEF['exParam'],3,value,sLevel,eLevel);
			}			
			else if(lineStr.match(/MEV:[ ](.*)/i))
			{
				var value = String(RegExp.$1);
				Zzy.SEF.CopyParamToArr(obj.zzySEF['exParam'],4,value,sLevel,eLevel);
			}			
			else if(lineStr.match(/MRF:[ ](.*)/i))
			{
				var value = String(RegExp.$1);
				Zzy.SEF.CopyParamToArr(obj.zzySEF['exParam'],5,value,sLevel,eLevel);
			}
			else if(lineStr.match(/CNT:[ ](.*)/i))
			{
				var value = String(RegExp.$1);
				Zzy.SEF.CopyParamToArr(obj.zzySEF['exParam'],6,value,sLevel,eLevel);
			}
			else if(lineStr.match(/HRG:[ ](.*)/i))
			{
				var value = String(RegExp.$1);
				Zzy.SEF.CopyParamToArr(obj.zzySEF['exParam'],7,value,sLevel,eLevel);
			}
			else if(lineStr.match(/MRG:[ ](.*)/i))
			{
				var value = String(RegExp.$1);
				Zzy.SEF.CopyParamToArr(obj.zzySEF['exParam'],8,value,sLevel,eLevel);
			}
			else if(lineStr.match(/TRG:[ ](.*)/i))
			{
				var value = String(RegExp.$1);
				Zzy.SEF.CopyParamToArr(obj.zzySEF['exParam'],9,value,sLevel,eLevel);
			}
			else if(lineStr.match(/TGR:[ ](.*)/i))
			{
				var value = String(RegExp.$1);
				Zzy.SEF.CopyParamToArr(obj.zzySEF['spParam'],0,value,sLevel,eLevel);
			}
			else if(lineStr.match(/GRD:[ ](.*)/i))
			{
				var value = String(RegExp.$1);
				Zzy.SEF.CopyParamToArr(obj.zzySEF['spParam'],1,value,sLevel,eLevel);
			}
			else if(lineStr.match(/REC:[ ](.*)/i))
			{
				var value = String(RegExp.$1);
				Zzy.SEF.CopyParamToArr(obj.zzySEF['spParam'],2,value,sLevel,eLevel);
			}
			else if(lineStr.match(/PHA:[ ](.*)/i))
			{
				var value = String(RegExp.$1);
				Zzy.SEF.CopyParamToArr(obj.zzySEF['spParam'],3,value,sLevel,eLevel);
			}
			else if(lineStr.match(/MCR:[ ](.*)/i))
			{
				var value = String(RegExp.$1);
				Zzy.SEF.CopyParamToArr(obj.zzySEF['spParam'],4,value,sLevel,eLevel);
			}
			else if(lineStr.match(/TCR:[ ](.*)/i))
			{
				var value = String(RegExp.$1);
				Zzy.SEF.CopyParamToArr(obj.zzySEF['spParam'],5,value,sLevel,eLevel);
			}
			else if(lineStr.match(/PDR:[ ](.*)/i))
			{
				var value = String(RegExp.$1);
				Zzy.SEF.CopyParamToArr(obj.zzySEF['spParam'],6,value,sLevel,eLevel);
			}
			else if(lineStr.match(/MDR:[ ](.*)/i))
			{
				var value = String(RegExp.$1);
				Zzy.SEF.CopyParamToArr(obj.zzySEF['spParam'],7,value,sLevel,eLevel);
			}
			else if(lineStr.match(/FDR:[ ](.*)/i))
			{
				var value = String(RegExp.$1);
				Zzy.SEF.CopyParamToArr(obj.zzySEF['spParam'],8,value,sLevel,eLevel);
			}
			else if(lineStr.match(/EXP:[ ](.*)/i))
			{
				var value = String(RegExp.$1);
				Zzy.SEF.CopyParamToArr(obj.zzySEF['spParam'],9,value,sLevel,eLevel);
			}
			break;

			
			default:
			if(lineStr.match(/<ZZYSEF ISCANSTRENG:[ ](.*)>/i))//是否可以强化
			{
				var enable = eval(String(RegExp.$1));
				obj.zzySEF.isCanStreng = enable;
			}
			else if(lineStr.match(/<ZZYSEF MAXLEVEL:[ ](.*)>/i))//最大等级
			{
				var maxLevel = String(RegExp.$1);
				obj.zzySEF.maxLevel = maxLevel;
			}
			else if(lineStr.match(/<ZZYSEF PREFIX:[ ](.*)>/i))//前缀
			{
				var prefix = String(RegExp.$1);
				obj.zzySEF.prefix = prefix;
			}
			else if(lineStr.match(/<ZZYSEF SUFFIX:[ ](.*)>/i))//后缀
			{
				var suffix = String(RegExp.$1);
				obj.zzySEF.suffix = suffix;
			}			
			else if(lineStr.match(/<ZZYSEF LEVEL[ ](.*)[ ]TO[ ](.*)>/i))//开启等级区间
			{
				selectMode = 'n';
				sLevel = parseInt(RegExp.$1);
				eLevel = parseInt(RegExp.$2);
			}
			else if(lineStr.match(/<ZZYSEF ISSHOWSUCCESSTEXT:[ ](.*)>/i))//限制文本
			{
				var evalFormat = String(RegExp.$1);
				obj.zzySEF.isShowSuccessText = evalFormat;
			}
			else if(lineStr.match(/<ZZYSEF ISSHOWFAILTEXT:[ ](.*)>/i))//限制文本
			{
				var evalFormat = String(RegExp.$1);
				obj.zzySEF.isShowFailText = evalFormat;
			}			

		}
	}
  }
}






//==========================================================================
//Sprite_ZzySEFButton
//==========================================================================


function Sprite_ZzySEFButton() 
{
    this.initialize.apply(this, arguments);
}

Sprite_ZzySEFButton.prototype = Object.create(Sprite.prototype);
Sprite_ZzySEFButton.prototype.constructor = Sprite_ZzySEFButton;

Sprite_ZzySEFButton.prototype.initialize = function(xStr,yStr,commonId) 
{
    Sprite.prototype.initialize.call(this);
	this.commonId = commonId;//按钮ID值
	this.isReady = false;
	this.anchor.x = 0.5;
	this.anchor.y = 0.5;
	
	this.isShake = false;
	this.isShakeIn = false;
	this.shakeX = 2;
	this.shakeY = 2;
	this.shakeFrame = 2;
	this.cShakeFrame = 0;
	
	this.srcX = 0;
	this.srcY = 0;
	
	this.setPosition(xStr,yStr);//设置位置
	this.RequestBitmap();
	
}

Sprite_ZzySEFButton.prototype.setPosition = function(xStr,yStr)
{
	this.x = eval(xStr);
	this.y = eval(yStr);
	this.srcX = this.x;
	this.srcY = this.y;
}

Sprite_ZzySEFButton.prototype.RequestBitmap = function()
{
	var tempBitmap = undefined;
	switch(this.commonId)
	{
		case 1:
			tempBitmap = ImageManager.loadSystem(Zzy.Param.SEFStrengButtonPic);
		break;
		case 2:
			tempBitmap = ImageManager.loadSystem(Zzy.Param.SEFCancelButtonPic);
		break;
	}

	this.bitmap = tempBitmap;
}

Sprite_ZzySEFButton.prototype.IsReady = function()
{
	if(this.isReady)return this.isReady;
	
	if(this.bitmap && this.bitmap.width && this.bitmap.height)
	{this.isReady = true;return true;}
	return false;
}

Sprite_ZzySEFButton.prototype.update = function()
{
	Sprite.prototype.update.call(this);
	if(!this.IsReady())return;

	//准备完成
	if(this.CheckClick())
	{
		this.OnClick();//处理点击
	}
	
	
	this.updateShakeAndBlack();//更新抖动
}

Sprite_ZzySEFButton.prototype.ExeCommonId = function()//执行命令
{
	switch(this.commonId)
	{
		case 1:
			if(Zzy.SEF.IsCanStrengEquip() && !Zzy.SEF.IsMaxLevel())
			{
				Zzy.SEF.StrengEquip();
			}
		break;
		
		case 2:
			Input._currentState['escape'] = true;
			setTimeout(function(){Input._currentState['escape'] = false;}, 100);
		break;
	}	
}

Sprite_ZzySEFButton.prototype.CheckClick = function()//检测点击
{
	if(TouchInput.isTriggered())
	{
		//检测是否在点击其中
		{
			var rect = {};
			rect.left = this.x - this.bitmap.width/2;
			rect.right = this.x + this.bitmap.width/2;
			rect.up = this.y - this.bitmap.height/2;
			rect.down = this.y + this.bitmap.height/2;
			
			if(TouchInput.x > rect.left && 
			TouchInput.x < rect.right &&
			TouchInput.y > rect.up &&
			TouchInput.y < rect.down)
			{
				return true;
			}
			
			
		}
	}
	return false;

	
}


Sprite_ZzySEFButton.prototype.OnClick = function()//处理点击
{
	//播放点击动画-抖动
	this.isShake = true;
	this.isShakeIn = true;
	this.cShakeFrame = 0;
	this.cFrame = 0;
	this.ExeCommonId();//执行命令
}


Sprite_ZzySEFButton.prototype.updateShakeAndBlack = function()//更新抖动
{
	if(!this.isShake)return;
	if(this.cShakeFrame < this.shakeFrame)
	{this.cShakeFrame++;}
	else
	{
		if(this.isShakeIn)
		{this.isShakeIn = false;}
		else
		{
			this.isShake = false;
			this.cFrame = 0;
			this.x = this.srcX;
			this.y = this.srcY;
			this.setBlendColor([0,0,0,0]);
			return;
		}
		
		this.cShakeFrame = 0;
	}
	
	var cFrame = this.cShakeFrame;
	
	if(!this.isShakeIn)
	{cFrame = this.shakeFrame-cFrame;}
	
	this.x = this.srcX + this.shakeX*cFrame;
	this.y = this.srcY + this.shakeY*cFrame;
	this.setBlendColor([0,0,0,cFrame*50]);
}







//================================================================
//Scene_ZzySEFStreng
//================================================================

function Scene_ZzySEFStreng() {
    this.initialize.apply(this, arguments);
}

Scene_ZzySEFStreng.prototype = Object.create(Scene_MenuBase.prototype);
Scene_ZzySEFStreng.prototype.constructor = Scene_ZzySEFStreng;

Scene_ZzySEFStreng.prototype.initialize = function() 
{
    Scene_MenuBase.prototype.initialize.call(this);
	//初始化
	this.InitData();
};

Scene_ZzySEFStreng.prototype.InitData = function()
{
	this.showTextSprArr = [];
}

Scene_ZzySEFStreng.prototype.start = function()
{
	Scene_MenuBase.prototype.start.call(this);
	
	this.CreateChildWindow();//创造对象
	
	
	this._strengWindow.activate();
	this._strengWindow.select(0);
	
	this._strengWindow.setHandler('cancel',this.OnStrengCancel.bind(this));
	this._strengWindow.setHandler('ok',this.OnStrengOk.bind(this));	
	
	this._packWindow.deactivate();
	this._packWindow.select(-1);
	
	this._packWindow.setHandler('ok',this.OnPackOk.bind(this));	
	this._packWindow.setHandler('cancel',this.OnPackCancel.bind(this));	
	
	
	this.CreateButtom();//按钮
}


Scene_ZzySEFStreng.prototype.CreateButtom = function()
{
	this._strengButton = new Sprite_ZzySEFButton(Zzy.Param.SEFStrengButtonX,Zzy.Param.SEFStrengButtonY,1);
	this._cancelButton = new Sprite_ZzySEFButton(Zzy.Param.SEFCancelButtonX,Zzy.Param.SEFCancelButtonY,2);
	
	this.addChild(this._strengButton);
	this.addChild(this._cancelButton);
}


Scene_ZzySEFStreng.prototype.OnStrengOk = function()
{
	//设置为活跃
	this._packWindow.activate();
	this._packWindow.select(0);
	
	
	this._strengWindow.deactivate();

}

Scene_ZzySEFStreng.prototype.OnStrengCancel = function()
{
	SceneManager.pop();

}


Scene_ZzySEFStreng.prototype.OnPackOk = function()
{

	this._strengWindow.activate();//继续活跃
	//将存储
	
	if(this._strengWindow.IsEquipIndex())
	{
		var eq = this._packWindow.GetListItem();
		if(eq)
		{
			this._strengWindow.SelectStrengEQ(eq);//设置存储道具
		}	
	}
	else
	{
		var item = this._packWindow.GetListItem();
		if(item)
		{
			this._strengWindow.SelectStrengItem(item,this._strengWindow.index());//设置存储道具
		}		
	}
	
	
	this._packWindow.deactivate();//关闭活跃
	this._packWindow.select(-1);	

	
}

Scene_ZzySEFStreng.prototype.OnPackCancel = function()
{
	this._packWindow.deactivate();	
	this._packWindow.select(-1);
	
	this._strengWindow.activate();		
}


Scene_ZzySEFStreng.prototype.CreateChildWindow = function()
{
	this._strengWindow = new Window_ZzySEFStreng();
	this._packWindow = new Window_ZzySEFPack();
	
	this._strengWindow.setPackWindow(this._packWindow);
	this._packWindow.setStrengWindow(this._strengWindow);
	
	this.addChild(this._strengWindow);
	this.addChild(this._packWindow);
}


Scene_ZzySEFStreng.prototype.ShowStrengResultText = function(text)
{
	var spr = this.RequestShowTextSprite();
	spr.ResetInfo(text);//初始
}

Scene_ZzySEFStreng.prototype.RequestShowTextSprite = function()//申请对象
{
	var len = this.showTextSprArr.length;
	for(var i=0;i<len;i++)
	{
		var spr1 = this.showTextSprArr[i];
		if(spr1 && spr1.visible === false)
		{
			spr1.visible = true;
			return spr1;
		}
	}
	
	var spr2 = new Sprite_ZzySEFShowText();
	this.addChild(spr2);
	this.showTextSprArr.push(spr2);
	
	return spr2;
}



//================================================================
//Sprite_ZzySEFShowText
//================================================================
function Sprite_ZzySEFShowText() 
{
    this.initialize.apply(this, arguments);
}

Sprite_ZzySEFShowText.prototype = Object.create(Window_Base.prototype);
Sprite_ZzySEFShowText.prototype.constructor = Sprite_ZzySEFShowText;

Sprite_ZzySEFShowText.prototype.initialize = function() 
{
    Window_Base.prototype.initialize.call(this,0,0,Graphics.boxWidth,Zzy.Param.SEFShowTSize*2+Zzy.Param.SEFShowBSize*2);
	this._text = '';//显示文本内容
	this._textW = 0;//字体宽度
	this.tSize = 0;
	this.tColor = '';
	this.bSize = 0;
	this.bColor = '';
	
	this.startX = 0;
	this.startY = 0;
	this.endX = 0;
	this.endY = 0;	
	this.moving = false;
	this.endFrame = 0;
	this.cEndFrame = 0;
	this.beFrame = 0;
	this.cBeFrame = 0;
	
	this.opacity = 0;
}

Sprite_ZzySEFShowText.prototype.ResetInfo = function(text)//设置
{
	this._text = text;
	this.tSize = Zzy.Param.SEFShowTSize;
	this.tColor = Zzy.Param.SEFShowTColor;
	this.bSize = Zzy.Param.SEFShowBSize;
	this.bColor = Zzy.Param.SEFShowBColor;	

	this.startX = Zzy.Param.SEFSTStartX;
	this.startY = Zzy.Param.SEFSTStartY;
	this.endX = Zzy.Param.SEFSTEndX;
	this.endY = Zzy.Param.SEFSTEndY;
	this.moving = true;
	this.endFrame = Zzy.Param.SEFSTWEndFrame;
	this.cEndFrame = 0;
	this.beFrame = Zzy.Param.SEFSTWBeFrame;
	this.cBeFrame = 0;

	this.AutoBitmap();//设置位图
	
	//初始化位置
	
	this.x = this.startX;
	this.y = this.startY;
	this.x += (this.width-this._textW)/2;
}



Sprite_ZzySEFShowText.prototype.AutoBitmap = function()
{
	this.contents.clear();//清理
	
	//获取高度
	var h = this.tSize + this.bSize * 2;
	var w = Graphics.boxWidth;
	var text = this._text;
	this._textW = this.drawTextEx(text,this.bSize,this.bSize);
}


Sprite_ZzySEFShowText.prototype.standardPadding = function() {
    return 0;
};

Sprite_ZzySEFShowText.prototype.textPadding = function() {
    return 0;
};

Sprite_ZzySEFShowText.prototype.standardFontSize = function() {
    return Zzy.Param.SEFShowTSize;
};


Zzy.SEF.Sprite_ZzySEFShowText_processEscapeCharacter = Sprite_ZzySEFShowText.prototype.processEscapeCharacter;
Sprite_ZzySEFShowText.prototype.processEscapeCharacter = function(code, textState) 
{
	Zzy.SEF.Sprite_ZzySEFShowText_processEscapeCharacter.call(this,code,textState);

	if(code === 'ZZY')
	{
		//初始化信息
		this.contents.fontSize = this.tSize;
		this.contents.textColor = this.tColor;
		this.contents.outlineWidth = this.bSize;
		this.contents.outlineColor = this.bColor;
	}
};




Sprite_ZzySEFShowText.prototype.resetFontSettings = function() 
{
    this.contents.fontFace = this.standardFontFace();
    this.contents.fontSize = this.standardFontSize();
    this.resetTextColor();
	this.contents.outlineWidth = 2;
	this.contents.outlineColor = 'rgba(0,0,0,0.5)';
};




Sprite_ZzySEFShowText.prototype.update = function()
{
	Window_Base.prototype.update.call(this);
	
	if(!this.visible)return;//不再更新
	
	this.updateBeing();//更新存在
	this.updateMoving();//更新移动
}

Sprite_ZzySEFShowText.prototype.updateBeing = function()
{
	if(this.cBeFrame < this.beFrame)
	{this.cBeFrame++;}
	else
	{this.visible = false;}
}



Sprite_ZzySEFShowText.prototype.updateMoving = function()
{
	if(!this.moving)return;
	
	if(this.cEndFrame < this.endFrame)
	{this.cEndFrame++;}
	else
	{this.moving = false;}
	
	var rate = this.cEndFrame / this.endFrame;//比率
	
	var oftx = this.endX - this.startX;
	var ofty = this.endY - this.startY;

	oftx *= rate;
	ofty *= rate;
	this.x = Math.round(oftx+this.startX);
	this.y = Math.round(ofty+this.startY);
	
	//增加字体宽度居中的额外宽度
	this.x += (this.width-this._textW)/2;
}


//================================================================
//Window_ZzySEFStreng
//================================================================

function Window_ZzySEFStreng() 
{
    this.initialize.apply(this, arguments);
}

Window_ZzySEFStreng.prototype = Object.create(Window_Selectable.prototype);
Window_ZzySEFStreng.prototype.constructor = Window_ZzySEFStreng;

Window_ZzySEFStreng.prototype.initialize = function() 
{
	var x = this.windowX();
	var y = this.windowY();
    var width = this.windowWidth();
    var height = this.windowHeight();
    Window_Selectable.prototype.initialize.call(this, x, y, width, height);
	
	this.opacity = Zzy.Param.SEFStrengOpacity;
	this.packWindow = undefined;
	
	this.selectEQ = undefined;//选择的装备
	this.selectITArr = [];//选择的强化材料
	
	this.InitData();//初始化数据信息
	this.Refresh();
};



Window_ZzySEFStreng.prototype.InitData = function()
{
	this.eqPlaceInfo = {};
	this.eqPlaceInfo.x = eval(Zzy.Param.SEFEquipPlaceX);
	this.eqPlaceInfo.y = eval(Zzy.Param.SEFEquipPlaceY);
	this.eqPlaceInfo.size = Zzy.Param.SEFEquipPlaceSize;
	this.eqPlaceInfo.bColor = Zzy.Param.SEFEquipPlaceBColor;
	this.eqPlaceInfo.lWidth = Zzy.Param.SEFEquipPlaceLWidth;
	this.eqPlaceInfo.lColor = Zzy.Param.SEFEquipPlaceLColor;
	this.eqPlaceInfo.rect = {
		left:this.eqPlaceInfo.x-this.eqPlaceInfo.size/2-this.eqPlaceInfo.lWidth,
		right:this.eqPlaceInfo.x+this.eqPlaceInfo.size/2+this.eqPlaceInfo.lWidth,
		up:this.eqPlaceInfo.y-this.eqPlaceInfo.size/2-this.eqPlaceInfo.lWidth,
		down:this.eqPlaceInfo.y+this.eqPlaceInfo.size/2+this.eqPlaceInfo.lWidth
	};
	
	this.eqTextInfo = {};
	this.eqTextInfo.x = eval(Zzy.Param.SEFEquipPlaceNameX);
	this.eqTextInfo.y = eval(Zzy.Param.SEFEquipPlaceNameY);
	this.eqTextInfo.size = Zzy.Param.SEFEquipPlaceNameSize;


	this.itPlace1Info = {};
	this.itPlace1Info.x = eval(Zzy.Param.SEFStrengPlace1X);
	this.itPlace1Info.y = eval(Zzy.Param.SEFStrengPlace1Y);
	this.itPlace1Info.size = Zzy.Param.SEFStrengPlace1Size;
	this.itPlace1Info.bColor = Zzy.Param.SEFStrengPlace1BColor;
	this.itPlace1Info.lWidth = Zzy.Param.SEFStrengPlace1LWidth;
	this.itPlace1Info.lColor = Zzy.Param.SEFStrengPlace1LColor;
	this.itPlace1Info.rect = {
		left:this.itPlace1Info.x-this.itPlace1Info.size/2-this.itPlace1Info.lWidth,
		right:this.itPlace1Info.x+this.itPlace1Info.size/2+this.itPlace1Info.lWidth,
		up:this.itPlace1Info.y-this.itPlace1Info.size/2-this.itPlace1Info.lWidth,
		down:this.itPlace1Info.y+this.itPlace1Info.size/2+this.itPlace1Info.lWidth
	};

	this.itText1Info = {};
	this.itText1Info.x = eval(Zzy.Param.SEFStrengPlace1NameX);
	this.itText1Info.y = eval(Zzy.Param.SEFStrengPlace1NameY);
	this.itText1Info.size = Zzy.Param.SEFStrengPlace1NameSize;


	this.itPlace2Info = {};
	this.itPlace2Info.x = eval(Zzy.Param.SEFStrengPlace2X);
	this.itPlace2Info.y = eval(Zzy.Param.SEFStrengPlace2Y);
	this.itPlace2Info.size = Zzy.Param.SEFStrengPlace2Size;
	this.itPlace2Info.bColor = Zzy.Param.SEFStrengPlace2BColor;
	this.itPlace2Info.lWidth = Zzy.Param.SEFStrengPlace2LWidth;
	this.itPlace2Info.lColor = Zzy.Param.SEFStrengPlace2LColor;
	this.itPlace2Info.rect = {
		left:this.itPlace2Info.x-this.itPlace2Info.size/2-this.itPlace2Info.lWidth,
		right:this.itPlace2Info.x+this.itPlace2Info.size/2+this.itPlace2Info.lWidth,
		up:this.itPlace2Info.y-this.itPlace2Info.size/2-this.itPlace2Info.lWidth,
		down:this.itPlace2Info.y+this.itPlace2Info.size/2+this.itPlace2Info.lWidth
	};

	this.itText2Info = {};
	this.itText2Info.x = eval(Zzy.Param.SEFStrengPlace2NameX);
	this.itText2Info.y = eval(Zzy.Param.SEFStrengPlace2NameY);
	this.itText2Info.size = Zzy.Param.SEFStrengPlace2NameSize;





	this.itPlace3Info = {};
	this.itPlace3Info.x = eval(Zzy.Param.SEFStrengPlace3X);
	this.itPlace3Info.y = eval(Zzy.Param.SEFStrengPlace3Y);
	this.itPlace3Info.size = Zzy.Param.SEFStrengPlace3Size;
	this.itPlace3Info.bColor = Zzy.Param.SEFStrengPlace3BColor;
	this.itPlace3Info.lWidth = Zzy.Param.SEFStrengPlace3LWidth;
	this.itPlace3Info.lColor = Zzy.Param.SEFStrengPlace3LColor;
	this.itPlace3Info.rect = {
		left:this.itPlace3Info.x-this.itPlace3Info.size/2-this.itPlace3Info.lWidth,
		right:this.itPlace3Info.x+this.itPlace3Info.size/2+this.itPlace3Info.lWidth,
		up:this.itPlace3Info.y-this.itPlace3Info.size/2-this.itPlace3Info.lWidth,
		down:this.itPlace3Info.y+this.itPlace3Info.size/2+this.itPlace3Info.lWidth
	};
	
	this.itText3Info = {};
	this.itText3Info.x = eval(Zzy.Param.SEFStrengPlace3NameX);
	this.itText3Info.y = eval(Zzy.Param.SEFStrengPlace3NameY);
	this.itText3Info.size = Zzy.Param.SEFStrengPlace3NameSize;	
	
	this.itPlaceInfoArr = [undefined,this.itPlace1Info,this.itPlace2Info,this.itPlace3Info];
	this.itTextInfoArr = [undefined,this.itText1Info,this.itText2Info,this.itText3Info];
	
	
	this.goldTextInfo = {};
	this.goldTextInfo.x = eval(Zzy.Param.SEFStrengGoldX);
	this.goldTextInfo.y = eval(Zzy.Param.SEFStrengGoldY);
	this.goldTextInfo.size = Zzy.Param.SEFStrengGoldSize;
	this.goldTextInfo.goldText = Zzy.Param.SEFStrengGoldName;

	this.rateTextInfo = {};
	this.rateTextInfo.x = eval(Zzy.Param.SEFStrengRateX);
	this.rateTextInfo.y = eval(Zzy.Param.SEFStrengRateY);
	this.rateTextInfo.size = Zzy.Param.SEFStrengRateSize;
	this.rateTextInfo.rateText = Zzy.Param.SEFStrengRateName;

	this.maxTextInfo = {};
	this.maxTextInfo.x = eval(Zzy.Param.SEFMaxLevelX);
	this.maxTextInfo.y = eval(Zzy.Param.SEFMaxLevelY);
	this.maxTextInfo.size = Zzy.Param.SEFMaxLevelSize;
	this.maxTextInfo.maxText = Zzy.Param.SEFMaxLevelName;



}



Window_ZzySEFStreng.prototype.maxCols = function() //宽度
{
    return 1;
};

Window_ZzySEFStreng.prototype.maxItems = function() //显示数量
{
    return 4;
};


Window_ZzySEFStreng.prototype.itemRect = function(index) //宽度坐标
{
	if(index === 0)//开头坐标
	{
		var info = this.eqPlaceInfo;
	}
	else
	{
		var info = this.itPlaceInfoArr[index];
	}
	
	var rect = new Rectangle();
	if(info)
	{
		rect.x = info.rect.left - this.standardPadding();
		rect.y = info.rect.up - this.standardPadding();
		rect.width = info.rect.right - info.rect.left;
		rect.height = info.rect.down - info.rect.up;
	}
		
    return rect;
};





Window_ZzySEFStreng.prototype.windowX = function()
{
	return eval(Zzy.Param.SEFStrengWindowX);
}

Window_ZzySEFStreng.prototype.windowY = function()
{
	return eval(Zzy.Param.SEFStrengWindowY);
}

Window_ZzySEFStreng.prototype.windowWidth = function()
{
	return eval(Zzy.Param.SEFStrengWindowW);
}

Window_ZzySEFStreng.prototype.windowHeight = function()
{
	return eval(Zzy.Param.SEFStrengWindowH);
}


Window_ZzySEFStreng.prototype.Refresh = function()//刷新
{
    this.contents.clear();
	
	
	this.DrawFillBkWindow();//绘制背景
	this.DrawEquipPlace();//绘制装备填充
	this.DrawItemPlace();//强化道具填充
	
	if(!this.DrawIsMaxLevel())//绘制已满级提示
	{
		this.DrawStrengGold();//强化金币
		this.DrawStrengRate();//绘制成功率		
	}

	
}


Window_ZzySEFStreng.prototype.DrawIsMaxLevel = function()
{
	if(this.selectEQ)
	{
		if($gameSystem.IsZzySEFMaxLevel(this.selectEQ))//已满级
		{
			var contents = this.contents;
			var info = this.maxTextInfo;
			var sx = info.x;
			var sy = info.y;
			var size = info.size;
			var text = info.maxText;	
			
			var srcSize = contents.fontSize;
			contents.fontSize = size;
			var nx = sx-this.width/2 - this.standardPadding();
			var ny = sy - this.standardPadding();

			this.drawText(text,nx ,ny ,this.width,'center');
			contents.fontSize = srcSize;
			return true;
		}
	}
	return false;
	
}



Window_ZzySEFStreng.prototype.DrawStrengRate = function()
{
	if(this.selectEQ)
	{
		var contents = this.contents;
		var info = this.rateTextInfo;
		var sx = info.x;
		var sy = info.y;
		var size = info.size;
		var text = info.rateText;		
		
		var srcSize = contents.fontSize;
		contents.fontSize = size;
		var nx = sx-this.width/2 - this.standardPadding();
		var ny = sy - this.standardPadding();	

		var level = $gameSystem.GetZzySEFEQLevel(this.selectEQ);
		var rateEval = $gameSystem.GetZzySEFEQSuccessRate(this.selectEQ,level);
		var rate = Zzy.SEF.EvalTranslateOfEquip(rateEval,this.selectEQ);
		rate = Number(rate.toFixed(2));
		{
			//获取强化符咒,增加额外概率
			var spellItem = this.GetForwardSpell();//获取spell	
			if(spellItem)
			{
				var successRateEval = $gameSystem.GetZzySEFSuccessRate(spellItem);
				if(successRateEval)
				{
					var successEx = Zzy.SEF.EvalTranslateOfEquip(successRateEval,this.selectEQ);
					rate += successEx;//增加概率
				}
			}
		}
		
		var finalStr = text.format(rate);
		this.drawText(finalStr,nx ,ny ,this.width,'center');
		contents.fontSize = srcSize;
	}
	
}

Window_ZzySEFStreng.prototype.DrawStrengGold = function()
{
	if(this.selectEQ)
	{
		var contents = this.contents;
		var info = this.goldTextInfo;
		var sx = info.x;
		var sy = info.y;
		var size = info.size;
		var text = info.goldText;
		
		var srcSize = contents.fontSize;
		contents.fontSize = size;
		var nx = sx-this.width/2 - this.standardPadding();
		var ny = sy - this.standardPadding();
		
		
	var level = $gameSystem.GetZzySEFEQLevel(this.selectEQ);
	var needGold = $gameSystem.GetZzySEFEQNeedGold(this.selectEQ,level);
	
	needGold = Zzy.SEF.EvalTranslateOfEquip(needGold,this.selectEQ);
	
	var finalStr = text.format($gameParty.gold(),needGold);
			
		this.drawText(finalStr,nx ,ny ,this.width,'center');
		contents.fontSize = srcSize;
	}

	
}

Window_ZzySEFStreng.prototype._createAllParts = function() 
{
	Window_Selectable.prototype._createAllParts.call(this);
	this.removeChild(this._windowCursorSprite);
	this.addChild(this._windowCursorSprite);
	
};


Window_ZzySEFStreng.prototype.DrawFillBkWindow = function()//填充背景
{	
	var contents = this.contents;


	contents.fillRect(0,0,this.width,this.height,Zzy.Param.SEFStrengFillColor);
	
}

Window_ZzySEFStreng.prototype.DrawItemPlace = function()
{
	var contents = this.contents;
	
	for(var i=1;i<this.itPlaceInfoArr.length;i++)
	{
		var item = this.selectITArr[i];
		
		var info = this.itPlaceInfoArr[i];
		var sx = info.rect.left - this.standardPadding();
		var sy = info.rect.up - this.standardPadding();		
		var sx2 = info.rect.left+info.lWidth - this.standardPadding();
		var sy2 = info.rect.up+info.lWidth - this.standardPadding();
		var lSize = info.size + info.lWidth*2;
		var bSize = info.size;	
		contents.fillRect(sx,sy,lSize,lSize,info.lColor);
		contents.fillRect(sx2,sy2,bSize,bSize,info.bColor);

		
		if(item)
		{
			var icId = item.iconIndex;
			this.drawIcon(icId,sx2,sy2,bSize);
			
			var text = this.GetNeedItemCountText(item);

			var srcSize = contents.fontSize;
			contents.fontSize = this.itTextInfoArr[i].size;
			var nx = this.itTextInfoArr[i].x-this.width/2 - this.standardPadding();
			var ny = this.itTextInfoArr[i].y - this.standardPadding();
			this.drawText(text,nx ,ny ,this.width,'center');
			contents.fontSize = srcSize;			
		}
	}
	
}

Window_ZzySEFStreng.prototype.GetNeedItemCountText = function(item)
{
	 var text = Zzy.SEF.GetItemName(item);
	 
	 var level = $gameSystem.GetZzySEFEQLevel(this.selectEQ);
	 
	 var countEval = 0;
	 if(item.zzySEF.typeId === 1)//道具,代表强化符
	 {
		 if($gameSystem.IsZzySEFNoConsume(item))
		 {countEval = 0;}
		 else
		 {countEval = 1;}
	 }
	 else
	 {countEval = $gameSystem.GetZzySEFEQNeedITCount(this.selectEQ,level,item);}
	

	 var count = Zzy.SEF.EvalTranslateOfEquip(countEval,this.selectEQ);
	
	 //获取背包道具总数
	 var packCount = $gameParty.numItems(item);
	 
	 var str = text+'(%1/%2)';
	 
	 var finalStr = str.format(packCount,count);

	 return finalStr;
}

Window_ZzySEFStreng.prototype.DrawEquipPlace = function()
{
	var info = this.eqPlaceInfo;
	var contents = this.contents;
	
	var sx = info.rect.left - this.standardPadding();
	var sy = info.rect.up - this.standardPadding();
	
	var sx2 = info.rect.left+info.lWidth - this.standardPadding();
	var sy2 = info.rect.up+info.lWidth - this.standardPadding();
	
	var lSize = info.size + info.lWidth*2;
	var bSize = info.size;
	
	
	contents.fillRect(sx,sy,lSize,lSize,info.lColor);
	contents.fillRect(sx2,sy2,bSize,bSize,info.bColor);
	

	//绘制道具图标
	
	if(this.selectEQ)
	{
		var icId = this.selectEQ.iconIndex;
		this.drawIcon(icId,sx2,sy2,bSize);

		//绘制文本:显示物品名称
		var name = Zzy.SEF.GetItemName(this.selectEQ);
		var srcSize = contents.fontSize;
		contents.fontSize = this.eqTextInfo.size;
		var nx = this.eqTextInfo.x-this.width/2 - this.standardPadding();
		var ny = this.eqTextInfo.y - this.standardPadding();
		this.drawText(name,nx ,ny ,this.width,'center');
		contents.fontSize = srcSize;
	}
}


Window_ZzySEFStreng.prototype.GetSelectEQ = function()
{
	return this.selectEQ;
}


Window_ZzySEFStreng.prototype.GetSelectITArr = function()
{
	return this.selectITArr;
}


Window_ZzySEFStreng.prototype.drawIcon = function(iconIndex, x, y,size)
{
    var bitmap = ImageManager.loadSystem('IconSet');
    var pw = Window_Base._iconWidth ;
    var ph = Window_Base._iconHeight ;
    var sx = iconIndex % 16 * pw;
    var sy = Math.floor(iconIndex / 16) * ph;
    this.contents.blt(bitmap, sx, sy, pw, ph, x, y,size,size);
};


Window_ZzySEFStreng.prototype.standardPadding = function() 
{
    return Zzy.Param.SEFStrengPadding;
};

Window_ZzySEFStreng.prototype.setPackWindow = function(pointer)
{
	this.packWindow = pointer;
}

Window_ZzySEFStreng.prototype.IsEquipIndex = function()//装备下标
{
	if(this._index === 0)return true;
	return false;
}

Window_ZzySEFStreng.prototype.update = function()//刷新
{
	Window_Selectable.prototype.update.call(this);

	this.updateIndex();
}

Window_ZzySEFStreng.prototype.updateIndex = function()
{
	if(this._checkIndex === this._index)return;
	
	//刷新下方数据信息
	this._checkIndex = this._index;
	
	this.packWindow.RefreshData();//刷新数据信息
}


Window_ZzySEFStreng.prototype.SelectStrengEQ = function(eq)
{
	if(this.selectEQ !== eq)
	{//清空上方内容
		this.selectITArr = [];
	}
	
	this.selectEQ = eq;
	this.Refresh();
}

Window_ZzySEFStreng.prototype.IsEquipMaxLevel = function()
{
	if(this.selectEQ)
	{
		if($gameSystem.IsZzySEFMaxLevel(this.selectEQ))
		{
			return true;
		}
	}
	return false;
	
}



Window_ZzySEFStreng.prototype.SelectStrengItem = function(item,index)
{
	//此处需要进行判断道具是否重复
	
	for(var i=1;i<this.selectITArr.length;i++)
	{
		if(this.selectITArr[i] && this.selectITArr[i].zzySEF.typeId === item.zzySEF.typeId)
		{
			if(this.selectITArr[i].id === item.id)
			{
				this.selectITArr[i] = undefined;
				break;
			}
		}
	}

	//此处需要进行判断,是否存在强化符,保持单一性质
	if($gameSystem.IsZzySEFSpell(item))
	{
		for(var i=1;i<this.selectITArr.length;i++)
		{
			if(this.selectITArr[i] && $gameSystem.IsZzySEFSpell(this.selectITArr[i]))
			{
				this.selectITArr[i] = undefined;
			}
		}
	}


	this.selectITArr[index] = item;
	this.Refresh();
}


Window_ZzySEFStreng.prototype.ClearSelect = function()//清空选择
{
	this.selectEQ = undefined;//选择的装备
	this.selectITArr = [];//选择的强化材料	
	this.Refresh();
}


Window_ZzySEFStreng.prototype.ClearSelectITArr = function()//清除道具槽选择
{
	this.selectITArr = [];//选择的强化材料	
	this.Refresh();	
}

Window_ZzySEFStreng.prototype.ClearSelectEQArr = function()//清除装备槽选择
{
	this.selectEQ = undefined;//选择的装备
	this.Refresh();
}





Window_ZzySEFStreng.prototype.GetForwardSpell = function()//获取最靠前的spell
{
	for(var i=1;i<this.selectITArr.length;i++)
	{
		if(this.selectITArr[i])
		{
			if($gameSystem.IsZzySEFSpell(this.selectITArr[i]))
			{
				return this.selectITArr[i];
			}
		}
	}
	return undefined;
}


//================================================================
//Window_ZzySEFPack
//================================================================

function Window_ZzySEFPack() 
{
    this.initialize.apply(this, arguments);
}

Window_ZzySEFPack.prototype = Object.create(Window_Selectable.prototype);
Window_ZzySEFPack.prototype.constructor = Window_ZzySEFPack;

Window_ZzySEFPack.prototype.initialize = function() 
{
	var x = this.windowX();
	var y = this.windowY();
    var width = this.windowWidth();
    var height = this.windowHeight();
    Window_Selectable.prototype.initialize.call(this, x, y, width, height);
	
	this.strengWindow = undefined;
	this._List = [];//列表
	
	
	this.drawMode = 0;
	
	this.refresh();
};

Window_ZzySEFPack.prototype._createAllParts = function() 
{
	Window_Selectable.prototype._createAllParts.call(this);
	this.removeChild(this._windowCursorSprite);
	this.addChild(this._windowCursorSprite);
	
};

Window_ZzySEFPack.prototype.maxCols = function() 
{
    return Zzy.Param.SEFPackEQRows;
};

Window_ZzySEFPack.prototype.maxItems = function() 
{
	if(!this._List)return 0;
    return this._List.length;
};


Window_ZzySEFPack.prototype.windowX = function()
{
	return eval(Zzy.Param.SEFPackWindowX);
}

Window_ZzySEFPack.prototype.windowY = function()
{
	return eval(Zzy.Param.SEFPackWindowY);
}

Window_ZzySEFPack.prototype.windowWidth = function()
{
	return eval(Zzy.Param.SEFPackWindowW);
}

Window_ZzySEFPack.prototype.windowHeight = function()
{
	return eval(Zzy.Param.SEFPackWindowH);
}

Window_ZzySEFPack.prototype.setStrengWindow = function(pointer)
{
	this.strengWindow = pointer;
}

Window_ZzySEFPack.prototype.RefreshData = function()//刷新数据
{
	if(this.strengWindow.IsEquipMaxLevel())//判断装备是否满级
	{
		this._List = [];
	}
	else if(this.strengWindow.IsEquipIndex())//处于装备下标
	{
		this.drawMode = 1;
		//获取满足条件的装备
		var eq = undefined;
		var tempList = [];
		
		if(Zzy.Param.SEFIsCanEquipment)//处于穿着下的装备
		{
			var actorIdArr = $gameParty._actors;
			for(var i=0;i<actorIdArr.length;i++)
			{
				var actor = $gameActors.actor(actorIdArr[i]);
				if(actor)
				{
					var eqArr = actor.equips();
					for(var j=0;j<eqArr.length;j++)
					{
						eq = eqArr[j];
						if(eq)
						{
							if($gameSystem.GetZzySEFIsCanStreng(eq) && !tempList.contains(eq))
							{tempList.push(eq);}
						}
					}
				}
			}
			
		}
		
		
		
		for(id in $gameParty._weapons)
		{
			eq = $dataWeapons[parseInt(id)];
			
			if($gameSystem.GetZzySEFIsCanStreng(eq) && !tempList.contains(eq))
			{tempList.push(eq);}
			
			
		}
		for(id in $gameParty._armors)
		{
			eq = $dataArmors[parseInt(id)];
			if($gameSystem.GetZzySEFIsCanStreng(eq) && !tempList.contains(eq))
			{tempList.push(eq);}
		}		
		
			
		this._List = tempList;
	}
	else//处于选择材料界面
	{
		this.drawMode = 2;
		var eq = this.strengWindow.GetSelectEQ();
		var tempList = [];
		if(eq)
		{
			var currentLevel = $gameSystem.GetZzySEFEQLevel(eq);//目前获取等级
			//tempList = $gameSystem.GetZzySEFEQItemList(eq,currentLevel);//获取升级需要的道具数组
			
			var excludeArr = this.strengWindow.GetSelectITArr();
			tempList = $gameSystem.GetZzySEFEQItemListEx(eq,currentLevel,excludeArr);//获取升级需要的道具数组
			
				
			//将强化符压入数据中
			for(id in $gameParty._items)
			{
				var item = $dataItems[id];
				if($gameSystem.IsZzySEFSpell(item))
				{
					tempList.push(item);
				}
			}				
		}
		


		//检测剔除
		this._List = tempList;
	}
	
	this.Refresh();
}

Window_ZzySEFPack.prototype.Refresh = function() 
{
    this.contents.clear();
    this.drawAllItems();
	
};

Window_ZzySEFPack.prototype.drawItem = function(index) //绘制内容
{
	var rect = this.itemRect(index);
	
	//绘制小黑板
	this.contents.fillRect(
	rect.x+Zzy.Param.SEFPackFillDis,
	rect.y+Zzy.Param.SEFPackFillDis,
	rect.width-Zzy.Param.SEFPackFillDis*2,
	rect.height-Zzy.Param.SEFPackFillDis*2,
	Zzy.Param.SEFPackFillColor
	);
	
	if(this.drawMode === 1)//绘制武器
	{
		var eq = this._List[index];	
        rect.width -= this.textPadding();
        this.drawItemName(eq, rect.x, rect.y, rect.width);
		
	}
	else if(this.drawMode === 2)//绘制材料
	{
		var item = this._List[index];
		
		var numberWidth = this.numberWidth();

        rect.width -= this.textPadding();
        this.drawItemName(item, rect.x, rect.y, rect.width-numberWidth);		
		this.drawItemNumber(item, rect.x, rect.y, rect.width);//绘制数字
	}
};

Window_ZzySEFPack.prototype.numberWidth = function() {
    return this.textWidth('000');
};

Window_ZzySEFPack.prototype.drawItemNumber = function(item, x, y, width) 
{
   this.drawText(':', x, y, width - this.textWidth('00'), 'right');
   this.drawText($gameParty.numItems(item), x, y, width, 'right');
};


Window_ZzySEFPack.prototype.drawItemName = function(item, x, y, width) //绘制内容
{
    width = width || 312;
	
    if (item) {
        var iconBoxWidth = Window_Base._iconWidth + 4;
        this.resetTextColor();
        this.drawIcon(item.iconIndex, x + 2, y + 2);
		
		var name = Zzy.SEF.GetItemName(item);
		
		
        this.drawText(name, x + iconBoxWidth, y, width - iconBoxWidth);
    }
};


Window_ZzySEFPack.prototype.GetListItem = function()
{
	if(this._List[this._index])
	{return this._List[this._index];}
	
	return undefined;
}


//================================================================
//Window_ZzySEFPack
//================================================================
Zzy.SEF.Window_Base_drawItemName = Window_Base.prototype.drawItemName;
Window_Base.prototype.drawItemName = function(item, x, y, width) 
{
	var srcName = undefined;
	if(item && item.zzySEF)
	{
		if(item.zzySEF.typeId === 2 || item.zzySEF.typeId === 3)
		{
			srcName = item.name;
			item.name = Zzy.SEF.GetItemName(item);
		
		}
	}
	
	Zzy.SEF.Window_Base_drawItemName.call(this,item,x,y,width);
	
	if(srcName)
	{item.name = srcName;}
};


//=============================================================================
//Game_Actor
//=============================================================================
//所有的基础数据信息

Zzy.SEF.Game_Actor_paramPlus = Game_Actor.prototype.paramPlus;
Game_Actor.prototype.paramPlus = function(paramId) 
{
	var returnValue = Zzy.SEF.Game_Actor_paramPlus.call(this,paramId);
	
	var eqArr = this.equips();
	
	for(var i=0;i<eqArr.length;i++)
	{
		var eq = eqArr[i];
		if(eq)
		{

			var baseValue = eq.params[paramId];
			
			var value1Eval = $gameSystem.GetZzySEFEQParam(eq,paramId);
			var value1 = Zzy.SEF.EvalTranslateOfEquip(value1Eval,eq);
			
			var value2Eval = $gameSystem.GetZzySEFEQParamPer(eq,paramId);
			var value2Per = Zzy.SEF.EvalTranslateOfEquip(value2Eval,eq);
			
			returnValue += value1;
			returnValue += (baseValue * value2Per * 0.01);

		}
	}

	return Math.floor(returnValue);
}


Zzy.SEF.Game_Actor_xparam = Game_Actor.prototype.xparam;
Game_Actor.prototype.xparam = function(xparamId) 
{
	var retrurnValue = Zzy.SEF.Game_Actor_xparam.call(this,xparamId);

	var eqArr = this.equips();
	for(var i=0;i<eqArr.length;i++)
	{
		var eq = eqArr[i];
		if(eq)
		{
			var valueEval = $gameSystem.GetZzySEFEQPExParam(eq,xparamId);
			var value = Zzy.SEF.EvalTranslateOfEquip(valueEval,eq);
			retrurnValue += value * 0.01;
		}
	}
    return retrurnValue;
};


Zzy.SEF.Game_Actor_sparam = Game_Actor.prototype.sparam;
Game_Actor.prototype.sparam = function(sparamId)//特殊参数
{
	var retrurnValue = Zzy.SEF.Game_Actor_sparam.call(this,sparamId);

	var eqArr = this.equips();
	for(var i=0;i<eqArr.length;i++)
	{
		var eq = eqArr[i];
		if(eq)
		{
			var valueEval = $gameSystem.GetZzySEFEQPSpParam(eq,sparamId);
			var value = Zzy.SEF.EvalTranslateOfEquip(valueEval,eq);	
			retrurnValue += value * 0.01;
		}
	}	
	return retrurnValue;
};


//-------------------------------------Zzy.SEF.Fun-----------------------------------------

Zzy.SEF.GetItemName = function(item)//获取名字
{
	var pText = $gameSystem.GetZzySEFPrefix(item);
	var sText = $gameSystem.GetZzySEFSuffix(item);
	
	var level = $gameSystem.GetZzySEFEQLevel(item);
	
	var text = item.name;
	
	
	if(pText && level)
	{
		pText = pText.format(level);
		text = pText+text;
	}
	if(sText && level)
	{
		sText = sText.format(level);
		text = text+sText;
	}
	
	
	return text;
}


Zzy.SEF.OpenStrengScene = function()//打开强化界面
{
	if(SceneManager._scene instanceof Scene_ZzySEFStreng)
	{return false;}
	
	SceneManager.push(Scene_ZzySEFStreng);
	return true;
	
}

Zzy.SEF.EvalTranslate = function(formula)//eval转换
{
	var variables = $gameVariables._data;//全局变量
	var v = $gameVariables._data;
	var switchs = $gameSwitches._data;//全局开关
	var s = $gameSwitches._data;

	return eval(formula);
}



Zzy.SEF.EvalTranslateOfEquip = function(formula,equip)//eval转换
{
	var variables = $gameVariables._data;//全局变量
	var v = $gameVariables._data;
	var switchs = $gameSwitches._data;//全局开关
	var s = $gameSwitches._data;
	var eq = equip;
	var level = $gameSystem.GetZzySEFEQLevel(eq);
	var maxlevel = $gameSystem.GetZzySEFMaxLevel(eq);
	maxlevel = Zzy.SEF.EvalTranslate(maxlevel);//eval转换
	
	if(formula === '100 level<6?100:100*(0.77-level/maxlevel)')
	{formula = '100';}
	return eval(formula);
}


Zzy.SEF.CopyValueToArr = function(objArr,param,value,sLevel,eLevel)
{
	for(var i=sLevel;i<=eLevel;i++)
	{	
		if(!objArr[i]){objArr[i] = {};}	
		objArr[i][param] = value;

	}
	return objArr;
}

Zzy.SEF.CopyInfoToArr = function(objArr,param,info,sLevel,eLevel)
{
	for(var i=sLevel;i<=eLevel;i++)
	{
		if(!objArr[i]){objArr[i] = {};}	
		if(!objArr[i][param]){objArr[i][param] = [];}
		objArr[i][param].push(info);
	}
}

Zzy.SEF.CopyParamToArr = function(objArr,paramId,value,sLevel,eLevel)
{
	for(var i=sLevel;i<=eLevel;i++)
	{
		if(!objArr[paramId]){objArr[paramId] = [];}
		objArr[paramId][i] = value;
	}
	
}

Zzy.SEF.IsCanStrengEquip = function()//判断是否满足强化需求
{
	if(SceneManager._scene instanceof Scene_ZzySEFStreng)
	{
		var pointer = SceneManager._scene;
		var eq = pointer._strengWindow.GetSelectEQ();
		if(eq)
		{
			var level = $gameSystem.GetZzySEFEQLevel(eq);
			//获取需求强化的列表
			var needList = $gameSystem.GetZzySEFEQItemList(eq,level);
			var needItemArr = pointer._strengWindow.GetSelectITArr();
			
			//对比两者之间是否满足情况
			
			for(var i=0;i<needList.length;i++)
			{
				if(needItemArr.contains(needList[i]))//存在道具,比较是否满足数量
				{
					var item = needList[i];
					var level = $gameSystem.GetZzySEFEQLevel(eq);
					
					countEval = $gameSystem.GetZzySEFEQNeedITCount(eq,level,item);
					var count = Zzy.SEF.EvalTranslateOfEquip(countEval,eq);
				 
					//获取背包道具总数
					var packCount = $gameParty.numItems(item);				
					if(packCount < count)
					{return false;}
				}
				else
				{return false;}
			}
			
			//金币比较
			var needGold = $gameSystem.GetZzySEFEQNeedGold(eq,level);
			needGold = Zzy.SEF.EvalTranslateOfEquip(needGold,eq);
			if($gameParty.gold() < needGold)
			{return false;}

			return true;//满足所有的条件
		}
		return false;
	}
	return false;
}

Zzy.SEF.StrengEquip = function()//进行强化装备
{
	//返回强化概率
	var pointer = SceneManager._scene;
	var eq = pointer._strengWindow.GetSelectEQ();
	var spellItem = pointer._strengWindow.GetForwardSpell();//获取spell	
	
	var level = $gameSystem.GetZzySEFEQLevel(eq);
	var rateEval = $gameSystem.GetZzySEFEQSuccessRate(eq,level);
	var rate = Zzy.SEF.EvalTranslateOfEquip(rateEval,eq);
	
	//取到概率
	var ruRate = Math.random()*100;
	if(spellItem)
	{
		var successRateEval = $gameSystem.GetZzySEFSuccessRate(spellItem);
		if(successRateEval)
		{
			var successEx = Zzy.SEF.EvalTranslateOfEquip(successRateEval,eq);
			rate += successEx;//增加概率
		}
	}
	
	//------------------------------强化成功/失败---------------------------------
	
	var strengResult = undefined;//强化结果
	if(ruRate < rate)//代表强化成功
	{
		Zzy.SEF.PlaySE(1);
		Zzy.SEF.CONSUMEGOLD(eq,level,true);//消费金币
		Zzy.SEF.CONSUMEITEM(eq,level,true);//消费道具
		
		strengResult = Zzy.SEF.StrengSuccessProcess(pointer,eq,spellItem);//强化成功处理
	}
	else//代表强化失败
	{
		Zzy.SEF.PlaySE(2);
		Zzy.SEF.CONSUMEGOLD(eq,level,false);//消费金币
		Zzy.SEF.CONSUMEITEM(eq,level,false);//消费道具
		
		strengResult = Zzy.SEF.StrengFailProcess(pointer,eq,spellItem);//强化失败处理
	}

	//强化符是否消耗
	if(spellItem)
	{
		if(!$gameSystem.IsZzySEFNoConsume(spellItem))//满足消耗条件
		{$gameParty.loseItem(spellItem,1);}
	}
	
	
	Zzy.SEF.ExeCommonEvent(Zzy.Param.SEFStrengButtonID);//调用公共事件

	Zzy.SEF.ClearSelectWindow(pointer,strengResult);//清理选择窗口
	
	Zzy.SEF.ExeStrengShowText(pointer,strengResult);//执行强化显示文本

}




Zzy.SEF.ExeStrengShowText = function(pointer,strengResult)//执行强化显示文本
{
	var isEvalFormat = undefined;
	var evalFormat = undefined;
	var showText = '';//显示文本
	
	
	if(strengResult.isSuccess)
	{
		isEvalFormat = $gameSystem.getZzySEFIsShowSuccessText(strengResult.eq);
		evalFormat = Zzy.Param.SEFStrengSuccessText;
	}
	else
	{
		isEvalFormat = $gameSystem.getZzySEFIsShowFailText(strengResult.eq);
		evalFormat = Zzy.Param.SEFStrengFailText;
	}
	
	var eq = strengResult.eq;
	var result = Zzy.SEF.EvalTranslateOfEquip(isEvalFormat,eq);
	if(result)
	{
		
		var name = eq.name;//获取名字
		var level = $gameSystem.GetZzySEFEQLevel(eq);	
		evalFormat = '\\Zzy' + evalFormat;
		name = name + '\\Zzy';
		showText = evalFormat.format(name,level);

	}

	if(showText)
	{
		Zzy.SEF.ShowStrengResultText(pointer,showText);
	}
}


Zzy.SEF.ShowStrengResultText = function(pointer,text)//显示结果文本
{
	pointer.ShowStrengResultText(text);
}



Zzy.SEF.ClearSelectWindow = function(pointer,strengResult)
{
	//清空强化槽中的内容
	pointer._strengWindow.ClearSelectITArr();
	
	if(strengResult.isEqFracture)//判断是否导致强化破碎
	{pointer._strengWindow.ClearSelectEQArr();}
	
	pointer._packWindow.RefreshData();	
}




Zzy.SEF.ExeCommonEvent = function(commonId) //执行公共事件
{
	//tempInter.SetupZzySEFCommand(commonId);//启动一般保留事件
	//tempInter.updateChild();	
	var tempInter = new Game_Interpreter();//临时启动器
	tempInter.SetupZzySEFCommand(commonId);//启动一般保留事件
	var commonLen = tempInter._list.length;//事件长度
	
	//tempInter.update();
	while(true)
	{
		tempInter.update();
		if(Zzy.SEF.IsRunTempInterOk(tempInter,commonLen)){break;}	
	}
	

};

Zzy.SEF.IsRunTempInterOk = function(tempInter,commonLen)
{
	if(tempInter._index >= commonLen)return true;
	return false;
}



Zzy.SEF.StrengSuccessProcess = function(pointer,eq,spellItem)//强化成功处理
{
	var info = {};//处理结果
	var levelUp = 1;
	
	if(spellItem)//强化符判定
	{
		var levelArr = $gameSystem.GetZzySEFExtraLevelArr(spellItem);
		if(levelArr)
		{
			for(var i=0;i<levelArr.length;i++)
			{
				var info = levelArr[i];
				
				var rate = Zzy.SEF.EvalTranslateOfEquip(info.rate,eq);
				
				//计算概率与等级变化
				var result = Math.random() * 100;
				if(result < rate)//处于范围中
				{
					var level = Zzy.SEF.EvalTranslateOfEquip(info.level,eq);
					levelUp += level;
					break;
				}
				
			}
		}
		
	}
	
	info.levelUp = levelUp;//提升等级
	info.isSuccess = true;//强化成功
	info.eq = eq;
	
	$gameSystem.ZzySEFLevelUp(eq,levelUp);
	
	return info;
}

Zzy.SEF.StrengFailProcess = function(pointer,eq,spellItem)//处理过程
{
	var info = {};//处理结果
	
	var downLevel = 0;
	
	var isProtect = false;
	if(Zzy.Param.SEFFaConsumeEquip)//是否失败消耗原武器
	{
		if(spellItem)
		{
			if($gameSystem.IsZzySEFEqProtect(spellItem))//存在强化保护
			{isProtect = true;}
		}
		
		if(!isProtect)
		{
			$gameSystem.ClearZzySEFEQLevel(eq);//清空等级
			$gameParty.loseItem(eq,1,true);	
			
			info.isEqFracture = true;//武器破碎
		}

	}
	else
	{
		if(Zzy.Param.SEFIsFailDemotion)//是否失败武器降级
		{
			var downLevelEval = Zzy.Param.SEFFailDemotionCount;
			downLevel = Zzy.SEF.EvalTranslateOfEquip(downLevelEval,eq);
			
			if(downLevel)
			{$gameSystem.DownZzySEFEQLevel(eq,downLevel);}

		}
	}
	
	info.isSuccess = false;//强化失败
	info.levelDown = downLevel;//下降等级
	info.eq = eq;
	
	return info;
}

Zzy.SEF.CONSUMEGOLD = function(eq,level,isSuccess)
{
	var result = isSuccess ? Zzy.Param.SEFSuConsumeGold : Zzy.Param.SEFFaConsumeGold;
	if(result)
	{
		var goldEval = $gameSystem.GetZzySEFEQNeedGold(eq,level);
		var gold = Zzy.SEF.EvalTranslateOfEquip(goldEval,eq);
		if(gold)
		{$gameParty.loseGold(gold);}
	}	
}

Zzy.SEF.CONSUMEITEM = function(eq,level,isSuccess)
{
	var result = isSuccess ? Zzy.Param.SEFSuConsumeItem : Zzy.Param.SEFFaConsumeItem;
	if(result)
	{
		var itArr = $gameSystem.GetZzySEFEQItemList(eq,level);
		for(var i=0;i<itArr.length;i++)
		{
			var item = itArr[i];
			var countEval = $gameSystem.GetZzySEFEQNeedITCount(eq,level,item);
			var count = Zzy.SEF.EvalTranslateOfEquip(countEval,eq);
			if(count)
			{$gameParty.loseItem(item,count);}
		}
	}	
}

Zzy.SEF.PlaySE = function(soundID)//播放声音
{
	var se = Zzy.Param.SEFAllSE[soundID];
	
	if(se && se.name)
	{
		AudioManager.playSe(se);
	}
	
}

Zzy.SEF.SetLevel = function(type,id,level)
{
	$gameSystem.ZzySEFSetLevel(type,id,level);
}

Zzy.SEF.GetLevel = function(type,id)
{
	return $gameSystem.ZzySEFGetLevel(type,id);
}


Zzy.SEF.IsMaxLevel = function()
{
	if(SceneManager._scene instanceof Scene_ZzySEFStreng)
	{
		var pointer = SceneManager._scene;
		var eq = pointer._strengWindow.GetSelectEQ();
		if(eq)
		{
			return $gameSystem.IsZzySEFMaxLevel(eq);
		}
	}
	return undefined;
}

