 //=============================================================================
// Mano_KisekaeTrait.js
// ----------------------------------------------------------------------------
// Copyright (c) 2017-2017 Sigureya
// This software is released under the MIT License.
// http://opensource.org/licenses/mit-license.php
// ----------------------------------------------------------------------------
// [Twitter]: https://twitter.com/Sigureya/
// [github]:https://github.com/Sigureya/RPGmakerMV
// ----------------------------------------------------------------------------
//=============================================================================
/**
 * 允许重新分配。
 * 根据游戏内容，没有使用限制。 
 * 
 * 禁止以下行为。
 * ・谎称是自己做的
 * ・将本插件本身作为素材进行销售
 * (不禁止与其他素材并用的捆绑材料)。
 * 在自述文件中记载以下内容。
 * しぐれん：[github]:https://github.com/Sigureya/RPGmakerMV
 * 
 */
/*:
 * 如有修改，请在此之后以「改変者（〇〇）」的形式填写。
 * @author しぐれん
 * @plugindesc 在防具中添加改变角色图像功能
 * 
 * @param kisekae1
 * @text 外观1
 * @type struct<Kisekae>
 * @default {"armor":"1","characterId":"1","character":"Actor1","sv_actor":"Actor1_1"}
 * @param kisekae2
 * @text 外观2
 * @type struct<Kisekae>
 * 
 * @param kisekae3
 * @text 外观3
 * @type struct<Kisekae>
 * 
 * @param kisekae4
 * @text 外观4
 * @type struct<Kisekae>
 * 
 * @param kisekae5
 * @text 外观5
 * @type struct<Kisekae>
 * 
 * @param kisekae6
 * @text 外观6
 * @type struct<Kisekae>
 * @param kisekae7
 * @text 外观7
 * @type struct<Kisekae>
 * @param kisekae8
 * @text 外观8
 * @type struct<Kisekae>
 * @param kisekae9
 * @text 外观9
 * @type struct<Kisekae>
 * @param kisekae10
 * @text 外观10
 * @type struct<Kisekae>
 * @param kisekae11
 * @text 外观11
 * @type struct<Kisekae>
 * @param kisekae12
 * @text 外观12
 * @type struct<Kisekae>
 * @param kisekae13
 * @text 外观13
 * @type struct<Kisekae>
 * @param kisekae14
 * @text 外观14
 * @type struct<Kisekae>
 * @param kisekae15
 * @text 外观15
 * @type struct<Kisekae>
 * @param kisekae16
 * @text 外观16
 * @type struct<Kisekae>
 * @param kisekae17
 * @text 外观17
 * @type struct<Kisekae>
 * @param kisekae18
 * @text 外观18
 * @type struct<Kisekae>
 * @param kisekae19
 * @text 外观19
 * @type struct<Kisekae>
 * @param kisekae20
 * @text 外观20
 * @type struct<Kisekae>
 * @param kisekae21
 * @text 外观21
 * @type struct<Kisekae>
 * @param kisekae22
 * @text 外观22
 * @type struct<Kisekae>
 * @param kisekae23
 * @text 外观23
 * @type struct<Kisekae>
 * 
 * 如果没有足够的设置，请将以上内容复制到备忘录并添加项目。 
 * 
 * @help
 * 制作改变外观的防具。
 * 当多个防具满足外观变更条件时，
 * 将使用用最上面装备的数据。
 * 
 * 数据由插件参数设置。
 * 初始数据设置为将外观1变更为霍尔德的图形。
 * 
 * 图像的变更在切换装备的瞬间进行，
 * 所以游戏开始时实质上无效。
 *
 * ◆这里提醒几个点：
 * 1、character文件夹的图片参考顺序是从0开始，也就是0~7，不是1~8。
 * 2、其次，场上的sv战斗图不能有重复，不然会失效。
 * 3、仅适用于防具中的装备。
 * 于2022.2.9日翻译
 * var 0.9.0(2017/09/20) 仮公開
*/

/*~struct~Kisekae:
 * @param armor
 * @text 装备
 * @desc 确定相应的装备
 * @type armor
 * 
 * @param characterIndex
 * @text 行走图参照
 * @desc 决定参照哪个行走图形
 * @type number
 * @min 0
 * @max 7
 * @default 0
 * 
 * @param character
 * @text 行走图选择
 * @type file
 * @dir img/characters
 * 
 * @param battler
 * @text 战斗图
 * @desc 设置sv的图像
 * @type file
 * @dir img/sv_actors
 */
(function(){

'use strict'
//開発用　入力保管を有効にするならこれを使う
// class KisekaeTrait{
//     constructor(){
//         this.character ='';
//         this.index=1;
//         this.battler='';
//     }
// }

/**
 * 
 * @param {String} characterName
 * @param {Number} index
 * @param {String} battlerName
 * 
 */
function createKisekaeDefine(characterName,index,battlerName){
    return {
        character:characterName,
        index:index,
        battler:battlerName
    };
}
function boot_kisekae_eachArmor(param){
    const equipId = Number( param.armor);
    const index = Number(param.characterIndex);

    const characterName = param.character;
    const battlerName =param.battler;
    $dataArmors[equipId].kisekaeTrait_MA =createKisekaeDefine(characterName,index,battlerName);
}

const Scene_Boot_start = Scene_Boot.prototype.start;
Scene_Boot.prototype.start =function(){
    Scene_Boot_start.call(this);
    const param =(  PluginManager.parameters('Mano_KisekaeTrait'));
    for(var key in param){
        var data = param[key];
        if(data){
            boot_kisekae_eachArmor(JSON.parse(data) );
        }
    }
};
/**
 * @param {Game_Actor} actor 
 * @return {RPG.Armor} 見つからなかったらnull
 */
function fetchKisekaeArmor(actor){
    const equips = actor.equips();
    for(var i =0; i< equips.length; i+=1){
        const e = equips[i];
        if(e && e.kisekaeTrait_MA){
            return e;
        }
    }
    return null;
}

/**
 * @param {RPG.Armor} armor
 * @return {KisekaeTrait}
 */
function fetchKisekaeTrait(armor){
    return armor.kisekaeTrait_MA;
}
/**
 * @return {boolean}
 * @param {RPG.Armor} armor 
 */
function hasKisekaeTrait(armor){
    return armor && !!fetchKisekaeTrait(armor);
}

/**
 * 
 * @param {KisekaeTrait} trait 
 */
function requestKisekaeImage(trait){
    if(trait.character){
        ImageManager.requestCharacter(trait.character);
    }
    if(trait.battler){
        ImageManager.requestSvActor(trait.battler);
    }

}

/**
 * @param {Game_Actor} actor
 * @param {RPG.Armor} [armor=null]
 */
function kisekaeRefresh(actor,armor){
    if(armor){
        const trait = fetchKisekaeTrait(armor);
        if(trait){
            requestKisekaeImage(trait);
            actor.setCharacterImage(trait.character,trait.index);
            actor.setBattlerImage(trait.battler);
            return;
        }
    }
    const dataActor =actor.actor();
    actor.setCharacterImage(dataActor.characterName,dataActor.characterIndex);
    actor.setBattlerImage(dataActor.battlerName);
}

function kisekaeRefreshAll(){
    $gameParty.members().forEach(function(actor){
        actor.applyKiesekae();
    });
}

const  Game_Actor_setup =Game_Actor.prototype.setup;
Game_Actor.prototype.setup =function(actorId){
    Game_Actor_setup.call(this,actorId);
    this.applyKiesekae();
};

const Game_Actor_changeEquip = Game_Actor.prototype.changeEquip;
Game_Actor.prototype.changeEquip =function(slotId, item){
    const lastItem = this._equips[slotId].object();
    Game_Actor_changeEquip.call(this,slotId,item);

    if(lastItem ===item){
        return;
    }
    if(hasKisekaeTrait(item) || hasKisekaeTrait(lastItem) ){
        kisekaeRefresh(this,item);
        $gamePlayer.refresh();        
    }
};

Game_Actor.prototype.applyKiesekae =function(){
    const e = fetchKisekaeArmor(this);
    kisekaeRefresh(this,e);
};

const Game_Interpreter_pluginCommand=Game_Interpreter.prototype.pluginCommand;
Game_Interpreter.prototype.pluginCommand =function(command, args){
    if(command ==='kisekae'){
        const actors = $gameParty.members();
        actors.forEach(function(actor){actor.applyKiesekae()});
        $gamePlayer.refresh();
    }
};

})();
