var Mx = Mx || {};

//=============================================================================
/*:/*:
 * @plugindesc 交易行
 * By 目眩
 *
 *
 * @param 名称
 * @desc 交易专用货币的名称。
 * @default 绿宝石
 *
 * @param 图标
 * @desc 交易专用货币的图标。
 * @default 1
 *
 * @param 镶嵌是否允许上架
 * @desc 有宝石镶嵌的装备是否允许上架？ 1：是  0：否
 * @default 0
 *
 * @param 竖屏
 * @desc 游戏分辨率是否竖屏？ 1：是  0：否
 * @default 0
 *
 *
 *
 * @help
 *
 * 〓〓〓〓〓 注意点 〓〓〓〓〓
 *
 *   仅支持 1280 * 720 及 720 * 1440 的分辨率。
 *   需要YEP_ItemCore，并且武器、护甲启用独立道具，
 *   道具不启用独立道具。
 *   至少需要发电6元才能上架商品。
 *   每人同时上架量3个，********，最多50个。
 *   商品价格设置只能在10 ~ 99999之间。
 *   每次上架需要消耗1个交易货币，下架不消耗。
 *   每笔交易将抽取10%作为手续费。
 *   因为懒，所以没有写上架多个道具和批量购买道具。
 *   需要上架复数道具的话可以先通过NPC将多个A道具兑换为B道具，
 *   玩家通过交易行购买B后再使用B道具兑换为多个A道具。
 *
 * 〓〓〓〓〓 注意点 〓〓〓〓〓
 *
 * 脚本：HWGOE.auctionHouse.redeemingEmeralds(500);
 *   将付费货币（点券）1比1兑换为交易货币，兑换量500。
 *
 * 脚本：HWGOE.auctionHouse.consumptionEmeralds(200);
 *   扣除200交易货币。
 *   用法广泛，例如可以使用交易货币兑换商城物品。
 *
 * 脚本：HWGOE.auctionHouse.emerald();
 *   获得当前交易货币的数量。
 *
 * 脚本：HWGOE.auctionHouse.emeraldUsage();
 *   获得当前已消耗的交易货币的数量。
 *
 * 脚本：SceneManager.push(Scene_AuctionHouse);
 *   用于打开交易行,可通过发电量限制进入交易行。
 *
 * 标签：<auction>
 *   道具/武器/防具内填写，表示该物品可以上架拍卖行。
 *
 * 标签：<auctionGuidePrice:500>
 *   道具/武器/防具内填写，表示该物品上架的底价。10~50000区间
 *
 * 脚本：Mx.reEQ_auction();
 *   执行一次此命令，可使玩家已获得的独立装备刷新<auction>的状态。
 *   简单来说，就是先获得A装备之后，再在A装备中填写该标签，也无法使
 *   之前获取的A装备变为可交易状态。
 *   执行该命令后，将刷新一次所有装备，将其状态变更为数据库中该装备
 *   的状态。
 *
 *
 *
 *
 *
 *
 *
 *
 *
 */
//=============================================================================

Mx.Parameters = PluginManager.parameters("Mx_AuctionHouse");

Mx.Ahdata_name = String(Mx.Parameters["名称"]);
Mx.Ahdata_icon = String(Mx.Parameters["图标"]);
Mx.Ahdata_Bsxq = JSON.parse(String(Mx.Parameters["镶嵌是否允许上架"]));
Mx.Ahdata_SP = JSON.parse(String(Mx.Parameters["竖屏"]));

var GT = GT || null;

async function Mx_refreshMy() {
  var data = await HWGOE.auctionHouse.myAuctionHouse();
  Mx.AuctionHouse_DataA = data;
}

async function Mx_shopBuyList() {
  var data = await HWGOE.auctionHouse.allProductList();
  Mx.AuctionHouse_DataB = data;
}

async function Mx_dataUPsj(item, jg) {
  var lx = 0;
  if (DataManager.isItem(item)) lx = 1;
  if (DataManager.isWeapon(item)) lx = 2;
  if (DataManager.isArmor(item)) lx = 3;

  if (window.LiuYue && window.LiuYue.LiuYue_StrengEquip && lx != 1) {
    item.LiuQH =
      lx == 2
        ? $gameSystem._ZzySEFWeaponLevel[item.id]
        : $gameSystem._ZzySEFArmorLevel[item.id];
  }
  let product = {
    data: item,
    lx: lx
  };

  $gameParty.loseItem(item, 1);
  if (lx > 1) DataManager.removeIndependentItem(item);

  let { saveCode, saveMessage } = await HWGOE.auctionHouse.cloudSaveGame();
  if (saveCode === 1) {
    let { code, message } = await HWGOE.auctionHouse.productLaunches(
      jg,
      product
    );
    if (code === 1) {
      // 成功
      return code;
    } else {
      Mx.SFdata_sj(product.data, product.lx);
      await HWGOE.auctionHouse.cloudSaveGame();
      return code;
    }
  } else {
    Mx.SFdata_sj(product.data, product.lx);
    await HWGOE.auctionHouse.cloudSaveGame();
    return code;
  }
}

async function Mx_Mysell() {
  var data = await HWGOE.auctionHouse.myProductList();
  Mx.AuctionHouse_DataD = data;
}

Mx.SFdata_sj = function (item, lx) {
  if (typeof item === "string") item = JsonEx.parse(item);

  if (lx == 1) {
    item.___lx_ = 1;
    $gameParty.gainItem(item, 1);
  }
  if (lx == 2) {
    var id = $dataWeapons.length;
    $dataWeapons[id] = item;
    $dataWeapons[id].id = id;
    $gameParty._weapons[id] = 1;
    if (
      window.LiuYue &&
      window.LiuYue.LiuYue_StrengEquip &&
      $dataWeapons[id].LiuQH
    ) {
      $gameSystem._ZzySEFWeaponLevel[id] = $dataWeapons[id].LiuQH;
    }
    var did = id - Yanfly.Param.ItemStartingId - 1;
    DataManager._independentWeapons[did] = $dataWeapons[id];
  }
  if (lx == 3) {
    var id = $dataArmors.length;
    $dataArmors[id] = item;
    $dataArmors[id].id = id;
    $gameParty._armors[id] = 1;
    if (
      window.LiuYue &&
      window.LiuYue.LiuYue_StrengEquip &&
      $dataArmors[id].LiuQH
    ) {
      $gameSystem._ZzySEFArmorLevel[id] = $dataArmors[id].LiuQH;
    }
    var did = id - Yanfly.Param.ItemStartingId - 1;
    DataManager._independentArmors[did] = $dataArmors[id];
  }
};

Mx.reEQ_auction = function () {
  for (var s = 1; s < $dataWeapons.length; s++) {
    if (!$dataWeapons[s]) continue;
    if (!$dataWeapons[s].baseItemId) continue;
    var item = $dataWeapons[s];
    item.meta.auction = $dataWeapons[item.baseItemId].meta.auction;
    item.meta.auctionGuidePrice =
      $dataWeapons[item.baseItemId].meta.auctionGuidePrice;
  }
  for (var s = 1; s < $dataArmors.length; s++) {
    if (!$dataArmors[s]) continue;
    if (!$dataArmors[s].baseItemId) continue;
    var item = $dataArmors[s];
    item.meta.auction = $dataArmors[item.baseItemId].meta.auction;
    item.meta.auctionGuidePrice =
      $dataArmors[item.baseItemId].meta.auctionGuidePrice;
  }
};

//=============================================================================
// 窗口
//=============================================================================
{
  function Window_Aha() {
    this.initialize.apply(this, arguments);
  }

  Window_Aha.prototype = Object.create(Window_Selectable.prototype);
  Window_Aha.prototype.constructor = Window_Aha;

  Window_Aha.prototype.initialize = function () {
    Window_Selectable.prototype.initialize.call(this, 0, 0, 1280, 720);
    this.opacity = 0;
    this.refresh();
    this._helpWindow = "???";
    this.callUpdateHelp();
    this.select(0);
  };

  Window_Aha.prototype.maxCols = function () {
    return 1;
  };

  Window_Aha.prototype.spacing = function () {
    return 3;
  };

  Window_Aha.prototype.itemHeight = function () {
    return 40;
  };

  Window_Aha.prototype.itemRect = function (index) {
    var rect = new Rectangle();

    rect.width = 500;
    rect.height = 40;
    rect.x = 5 + (Mx.Ahdata_SP ? 90 : 0);
    rect.y = 170 + Math.floor(index / this.maxCols()) * 40 - this._scrollY;

    return rect;
  };

  Window_Aha.prototype.maxItems = function () {
    return this._data ? this._data.length : 1;
  };

  Window_Aha.prototype.item = function () {
    return this._data[this.index()];
  };

  Window_Aha.prototype.isCurrentItemEnabled = function () {
    return this.isEnabled(this._data[this.index()]);
  };

  Window_Aha.prototype.isEnabled = function (item) {
    if (!this._index) return false;
    return true;
  };

  Window_Aha.prototype.refresh = function () {
    this.makeItemList();
    this.createContents();
    Mx_refreshMy().then(() => {
      this.drawBJ();
    });
    this.drawAllItems();
  };

  Window_Aha.prototype.makeItemList = function () {
    this._data = [
      "刷新我的信息",
      "上架商品",
      "查看商品列表",
      "查看我的商品",
      "领取购买物/结算收益",
      "查询购买记录",
      "查看已退回商品"
    ];
  };

  Window_Aha.prototype.drawItem = function (index) {
    var xx = this._data[index];
    var rect = this.itemRect(index);
    if (!xx) return;

    this.contents.paintOpacity = 150;
    this.contents.fillRect(rect.x + 1, rect.y + 1, 498, 38, "#000000");
    this.contents.paintOpacity = 255;
    this.drawTextEx("\\fs[24]\\fb", rect.x + 10, rect.y + 3);
    this.drawText(xx, rect.x, rect.y + 3, 500, "center");
  };

  Window_Aha.prototype.drawBJ = async function () {
    let { code, message, result } = await HWGOE.auctionHouse.myProductList();
    var da = Mx.AuctionHouse_DataA;
    if (!da || da.code != 1) {
      this.drawTextEx("\\fs[24]\\fb获取信息失败。", Mx.Ahdata_SP ? 90 : 0, 0);
      return;
    }
    var hb = "\\i[" + Mx.Ahdata_icon + "]" + Mx.Ahdata_name;
    var tez = [
      "\\fs[24]用户：\\c[30]" + HWGOE.player.name() + "\\c[0]",
      "\\fs[24]拥有" +
        hb +
        "：\\c[30]" +
        HWGOE.auctionHouse.emerald() +
        "\\c[0]",
      "\\fs[24]消耗" +
        hb +
        "：\\c[30]" +
        HWGOE.auctionHouse.emeraldUsage() +
        "\\c[0]",
      "\\fs[24]未领" + hb + "：\\c[30]" + da.result.receiveEmeralds + "\\c[0]",
      "\\fs[24]未领取商品\\c[30] " +
        da.result.awaitingCollection.length +
        " \\c[0]件",
      "\\fs[24]已完成购买\\c[30] " + da.result.finished.length + " \\c[0]次",
      "\\fs[24]已退回商品\\c[30] " + result.timeout.length + " \\c[0]件"
    ];
    for (var s = 0; s < 8; s++) {
      var x = 5 + (s % 2) * 250 + (Mx.Ahdata_SP ? 90 : 0);
      var y = 5 + Math.floor(s / 2) * 40;
      this.contents.paintOpacity = 150;
      this.contents.fillRect(x, y, 248, 38, "#000000");
      this.contents.paintOpacity = 255;
      if (tez[s]) this.drawTextEx("\\fb" + tez[s], x + 5, y + 3);
    }
  };

  Window_Aha.prototype.setStatusWindow = function (statusWindow) {
    this._helpWindow = statusWindow;
    this.callUpdateHelp();
  };

  Window_Aha.prototype.setHelpWindowItem = function (item) {
    if (this._helpWindow) {
      //this._helpWindow.setItem(item);
    }
  };

  Window_Aha.prototype.updateHelp = function () {
    if (this._index == 0) this.refresh();
  };
}
//=============================================================================
// 列表
//=============================================================================
{
  function Window_Ahb() {
    this.initialize.apply(this, arguments);
  }

  Window_Ahb.prototype = Object.create(Window_Selectable.prototype);
  Window_Ahb.prototype.constructor = Window_Ahb;

  Window_Ahb.prototype.initialize = function () {
    Window_Selectable.prototype.initialize.call(
      this,
      Mx.Ahdata_SP ? -20 : 520,
      0,
      780,
      730
    );
    this.opacity = 0;
    this._List = [];
    this._lx = 1;
    this.refresh();
    this._helpWindow = "???";
    this.callUpdateHelp();
    this.select(0);
    this.createButtons();
    this.setup();
  };

  Window_Ahb.prototype.maxCols = function () {
    return 2;
  };

  Window_Ahb.prototype.spacing = function () {
    return 3;
  };

  Window_Ahb.prototype.itemHeight = function () {
    return 115;
  };

  Window_Ahb.prototype.maxPageRows = function () {
    return 5;
  };

  Window_Ahb.prototype.itemRect = function (index) {
    var rect = new Rectangle();
    rect.width = Math.min(Graphics._boxWidth / 2, 360);
    rect.height = 80;
    rect.x = (index % this.maxCols()) * (rect.width + 8);
    rect.y = 100 + Math.floor(index / this.maxCols()) * 115 - this._scrollY;

    return rect;
  };

  Window_Ahb.prototype.maxItems = function () {
    return this._data ? this._data.length : 1;
  };

  Window_Ahb.prototype.item = function () {
    return this._data[this.index()];
  };

  Window_Ahb.prototype.isCurrentItemEnabled = function () {
    return this.isEnabled(this._data[this.index()]);
  };

  Window_Ahb.prototype.isEnabled = function (item) {
    if (!item) return false;
    if (this.jzdj) return false;
    if (!this.win) return false;
    if (this.win._czmod == 2) {
      if (HWGOE.player.id() == item._sellerId) return false;
    }
    if (!HWGOE.auctionHouse.emerald()) return false;
    return true;
  };

  Window_Ahb.prototype.refresh = function () {
    this.makeItemList();
    this.createContents();
    this.drawBJ();
    this.drawAllItems();
  };

  Window_Ahb.prototype.makeItemList = function () {
    this._data = [];
    for (var s = 0; s < this._List.length; s++) {
      var data = this._List[s];
      if (data._sellerId) {
        var item = JsonEx.parse(data.data);
        if (this._lx == 1 && data.lx == 1) this._data.push(data);
        if (this._lx == 2 && data.lx == 2) this._data.push(data);
        if (this._lx == 3 && data.lx == 3) this._data.push(data);
      } else {
        var item = data;
        if (this._lx == 1 && DataManager.isItem(item)) this._data.push(data);
        if (this._lx == 2 && DataManager.isWeapon(item)) this._data.push(data);
        if (this._lx == 3 && DataManager.isArmor(item)) this._data.push(data);
      }
    }
  };

  Window_Ahb.prototype.drawItem = function (index) {
    var data = this._data[index];
    var rect = this.itemRect(index);
    if (!data) return;
    if (data._sellerId) {
      var item = JsonEx.parse(data.data);
    } else {
      var item = data;
    }

    var hb = "\\i[" + Mx.Ahdata_icon + "]" + Mx.Ahdata_name;
    this.drawIcon_x2(item.iconIndex, rect.x + 8, rect.y + 8);
    if (this.win._czmod != 5 && HWGOE.player.id() == data._sellerId) {
      this.drawTextEx("\\fs[16]\\fb\\c[26]U", rect.x + 58, rect.y + 3);
    }
    if (DataManager.isItem(item)) {
      this.drawText(
        "x" + $gameParty.numItems(item),
        rect.x,
        rect.y + 16,
        rect.width - 4,
        "right"
      );
    }
    this.drawTextEx(
      "\\fs[22]\\fb\\c[" + item.textColor + "]" + item.name,
      rect.x + 85,
      rect.y + 5
    );
    if (data._sellerId)
      this.drawTextEx(
        "\\fs[22]\\fb" + hb + " \\c[30]" + data._price,
        rect.x + 85,
        rect.y + 37
      );
      this.drawTextEx("\\fs[22]\\fb卖家 \\c[30]" + data._seller, rect.x + 85, rect.y + 70);
  };

  Window_Ahb.prototype.drawBJ = function () {
    for (var s = 0; s < 10; s++) {
      let width = Math.min(Graphics._boxWidth / 2, 360);
      var x = (s % 2) * (width + 9);
      var y = 100 + Math.floor(s / this.maxCols()) * 115;
      this.contents.paintOpacity = 150;
      this.contents.fillRect(x + 1, y + 1, width, 108, "#000000");
      this.contents.paintOpacity = 255;
    }
  };

  Window_Ahb.prototype.setStatusWindow = function (statusWindow) {
    this._helpWindow = statusWindow;
    this.callUpdateHelp();
  };

  Window_Ahb.prototype.setHelpWindowItem = function (item) {
    if (this._helpWindow) {
      //this._helpWindow.setItem(item);
    }
  };

  Window_Ahb.prototype.updateHelp = function () {
    this.refresh();
  };
  // = = =
  Window_Ahb.prototype.setup = function () {
    this.placeButtons();
    this.updateButtonsVisiblity();
  };

  Window_Ahb.prototype.createButtons = function () {
    var bitmap = ImageManager.loadSystem("Ahan");
    var buttonWidth = 230;
    var buttonHeight = 72;
    this._buttons = [];
    for (var s = 0; s < 3; s++) {
      var button = new Sprite_Button();
      var x = buttonWidth * s;
      var w = buttonWidth;
      button.bitmap = bitmap;
      button.setColdFrame(x, 0, w, buttonHeight);
      button.setHotFrame(x, buttonHeight, w, buttonHeight);
      button.visible = true;
      this._buttons.push(button);
      this.addChild(button);
      this._buttons[s].setClickHandler(this.CZ.bind(this, s));
    }
  };

  Window_Ahb.prototype.CZ = function (s) {
    this._lx = s + 1;
    this.select(0);
    this.refresh();
  };

  Window_Ahb.prototype.showButtons = function (x) {
    this._buttons[x].visible = true;
  };

  Window_Ahb.prototype.hideButtons = function (x) {
    this._buttons[x].visible = false;
  };

  Window_Ahb.prototype.placeButtons = function () {
    for (var s = 0; s < 3; s++) {
      this._buttons[s].x = 25 + s * 240;
      this._buttons[s].y = 27;
    }
  };

  Window_Ahb.prototype.updateButtonsVisiblity = function () {};
}
//=============================================================================
// 确认提示框
//=============================================================================
{
  function Window_Ahc() {
    this.initialize.apply(this, arguments);
  }

  Window_Ahc.prototype = Object.create(Window_Selectable.prototype);
  Window_Ahc.prototype.constructor = Window_Ahc;

  Window_Ahc.prototype.initialize = function () {
    Window_Selectable.prototype.initialize.call(
      this,
      Mx.Ahdata_SP ? 192 : 472,
      285,
      336,
      150
    );
    this.opacity = 255;
    this._text = "";
    this.refresh();
    this.select(0);
  };

  Window_Ahc.prototype.maxCols = function () {
    return 2;
  };

  Window_Ahc.prototype.spacing = function () {
    return 3;
  };

  Window_Ahc.prototype.itemHeight = function () {
    return 70;
  };

  Window_Ahc.prototype.maxPageRows = function () {
    return 5;
  };

  Window_Ahc.prototype.itemRect = function (index) {
    var rect = new Rectangle();

    rect.width = 150;
    rect.height = 40;
    rect.x = (index % this.maxCols()) * 150;
    rect.y = 70 + Math.floor(index / this.maxCols()) * 120 - this._scrollY;

    return rect;
  };

  Window_Ahc.prototype.maxItems = function () {
    return this._data ? this._data.length : 1;
  };

  Window_Ahc.prototype.item = function () {
    return this._data[this.index()];
  };

  Window_Ahc.prototype.isCurrentItemEnabled = function () {
    return this.isEnabled(this._data[this.index()]);
  };

  Window_Ahc.prototype.isEnabled = function (item) {
    return true;
  };

  Window_Ahc.prototype.refresh = function () {
    this.makeItemList();
    this.createContents();
    this.drawBJ();
    this.drawAllItems();
  };

  Window_Ahc.prototype.makeItemList = function () {
    this._data = ["确 认", "取 消"];
  };

  Window_Ahc.prototype.drawItem = function (index) {
    var item = this._data[index];
    var rect = this.itemRect(index);
    if (!item) return;

    this.drawTextEx("\\fs[22]\\fb", rect.x, rect.y);
    this.drawText(item, rect.x, rect.y + 2, 150, "center");
  };

  Window_Ahc.prototype.drawBJ = function () {
    this.drawTextEx("\\fs[22]\\fb", 0, 0);
    this.drawText(this._text, 0, 0, 300, "center");
  };
}
//=============================================================================
// 输入号码盘
//=============================================================================
{
  function Window_Ahd() {
    this.initialize.apply(this, arguments);
  }

  Window_Ahd.prototype = Object.create(Window_Selectable.prototype);
  Window_Ahd.prototype.constructor = Window_Ahd;

  Window_Ahd.prototype.initialize = function () {
    Window_Selectable.prototype.initialize.call(
      this,
      Mx.Ahdata_SP ? 185 : 465,
      100,
      350,
      520
    );
    this.opacity = 255;
    this._n = "0";
    this.refresh();
    this.select(0);
  };

  Window_Ahd.prototype.maxCols = function () {
    return 3;
  };

  Window_Ahd.prototype.spacing = function () {
    return 3;
  };

  Window_Ahd.prototype.itemHeight = function () {
    return 102;
  };

  Window_Ahd.prototype.maxPageRows = function () {
    return 4;
  };

  Window_Ahd.prototype.itemRect = function (index) {
    var rect = new Rectangle();

    rect.width = 100;
    rect.height = 100;
    rect.x = (index % this.maxCols()) * 102;
    rect.y = 75 + Math.floor(index / this.maxCols()) * 102 - this._scrollY;

    return rect;
  };

  Window_Ahd.prototype.maxItems = function () {
    return this._data ? this._data.length : 1;
  };

  Window_Ahd.prototype.item = function () {
    return this._data[this.index()];
  };

  Window_Ahd.prototype.isCurrentItemEnabled = function () {
    return this.isEnabled(this._data[this.index()]);
  };

  Window_Ahd.prototype.isEnabled = function (item) {
    return true;
  };

  Window_Ahd.prototype.refresh = function () {
    if (Number(this._n) > 99999) this._n = "99999";
    this.makeItemList();
    this.createContents();
    this.drawBJ();
    this.drawAllItems();
  };

  Window_Ahd.prototype.makeItemList = function () {
    this._data = [
      "7",
      "8",
      "9",
      "4",
      "5",
      "6",
      "1",
      "2",
      "3",
      "0",
      "清除",
      "确认"
    ];
  };

  Window_Ahd.prototype.drawItem = function (index) {
    var n = this._data[index];
    var rect = this.itemRect(index);
    if (!n) return;

    this.drawTextEx("\\fs[28]\\fb", rect.x, rect.y);
    this.drawText(n, rect.x, rect.y + 30, 100, "center");
  };

  Window_Ahd.prototype.drawBJ = function () {
    this.drawTextEx("\\fs[28]\\fb价格：", 0, 0);
    this.drawText(Number(this._n), 0, 30, 300, "right");
  };
}
//=============================================================================
// 交易行
//=============================================================================
{
  function Scene_AuctionHouse() {
    this.initialize.apply(this, arguments);
  }

  Scene_AuctionHouse.prototype = Object.create(Scene_MenuBase.prototype);
  Scene_AuctionHouse.prototype.constructor = Scene_AuctionHouse;

  Scene_AuctionHouse.prototype.initialize = function () {
    Scene_MenuBase.prototype.initialize.call(this);
    this._czmod = 0;
  };

  Scene_AuctionHouse.prototype.create = async function () {
    Scene_MenuBase.prototype.create.call(this);
    this._backSprite1 = new Sprite(ImageManager.loadPicture("AuctionHouse_bj"));
    this.addChild(this._backSprite1);
    var win = this;
    Mx_refreshMy();
    win.createWindow();
  };

  Scene_AuctionHouse.prototype.createWindow = function () {
    this.Awin = new Window_Aha();
    this.addChild(this.Awin);
    this.Awin.setHandler("ok", this.Aok.bind(this));
    this.Awin.setHandler("cancel", this.popScene.bind(this));
    this.Awin.activate();

    this.Bwin = new Window_Ahb();
    this.addChild(this.Bwin);
    this.Bwin.win = this;
    this.Bwin.setHandler("ok", this.Bok.bind(this));
    this.Bwin.setHandler("cancel", this.Bqx.bind(this));
    this.Bwin.hide();

    if (GT && GT.OIWin) {
      this._objInfoWindowSet = GT.Param.OIWSceneItemSet;
      this._objInfoWindow = new Window_ObjectInfo(this._objInfoWindowSet);
      this.addChild(this._objInfoWindow);
      this.Bwin.setObjInfoWindow(this._objInfoWindow);
      Mx.ce = this._objInfoWindow;
    }

    this.Cwin = new Window_Ahc();
    this.addChild(this.Cwin);
    this.Cwin.setHandler("ok", this.Cok.bind(this));
    this.Cwin.setHandler("cancel", this.Cqx.bind(this));
    this.Cwin.hide();

    this.Dwin = new Window_Ahd();
    this.addChild(this.Dwin);
    this.Dwin.setHandler("ok", this.Dok.bind(this));
    this.Dwin.setHandler("cancel", this.Cqx.bind(this));
    this.Dwin.hide();
  };

  Scene_AuctionHouse.prototype.SxList = async function (id) {
    if (id == 2) {
      await Mx_shopBuyList();
      if (Mx.AuctionHouse_DataB && Mx.AuctionHouse_DataB.code == 1) {
        this.Bwin._List = Mx.AuctionHouse_DataB.result;
        this.Bwin.refresh();
      }
    }
    if (id == 3) {
      await Mx_Mysell();
      if (Mx.AuctionHouse_DataD && Mx.AuctionHouse_DataD.code == 1) {
        this.Bwin._List = Mx.AuctionHouse_DataD.result.unSold;
        this.Bwin.refresh();
      }
    }
  };

  Scene_AuctionHouse.prototype.Aok = async function () {
    var ind = this.Awin.index();
    if (ind == 1) {
      var list = [];
      for (var s = 0; s < $gameParty.items().length; s++) {
        if ($gameParty.items()[s] && $gameParty.items()[s].meta.auction) {
          list.push($gameParty.items()[s]);
        }
      }
      for (var s = 0; s < $gameParty.weapons().length; s++) {
        if ($gameParty.weapons()[s] && $gameParty.weapons()[s].meta.auction) {
          if ($gameParty.weapons()[s].augmentSlotItems && !Mx.Ahdata_Bsxq) {
            var y = false;
            for (
              var w = 0;
              w < $gameParty.weapons()[s].augmentSlotItems.length;
              w++
            ) {
              if ($gameParty.weapons()[s].augmentSlotItems[w] != "none")
                y = true;
            }
            if (y) continue;
          }
          list.push($gameParty.weapons()[s]);
        }
      }
      for (var s = 0; s < $gameParty.armors().length; s++) {
        if ($gameParty.armors()[s] && $gameParty.armors()[s].meta.auction) {
          if ($gameParty.armors()[s].augmentSlotItems && !Mx.Ahdata_Bsxq) {
            var y = false;
            for (
              var w = 0;
              w < $gameParty.armors()[s].augmentSlotItems.length;
              w++
            ) {
              if ($gameParty.armors()[s].augmentSlotItems[w] != "none")
                y = true;
            }
            if (y) continue;
          }
          list.push($gameParty.armors()[s]);
        }
      }
      this.Bwin._List = list;
      this._czmod = ind;
      this.Bwin.select(0);
      this.Bwin.refresh();
      this.Bwin.show();
      this.Bwin.activate();
      if (Mx.Ahdata_SP) this.Awin.hide();
    }
    if (ind == 2) {
      await Mx_shopBuyList();
      if (Mx.AuctionHouse_DataB && Mx.AuctionHouse_DataB.code == 1) {
        this.Bwin._List = Mx.AuctionHouse_DataB.result;
        this._czmod = ind;
        this.Bwin.select(0);
        this.Bwin.refresh();
        this.Bwin.show();
        this.Bwin.activate();
        if (Mx.Ahdata_SP) this.Awin.hide();
      } else {
        this.Awin.activate();
      }
    }
    if (ind == 3) {
      await Mx_Mysell();
      if (Mx.AuctionHouse_DataD && Mx.AuctionHouse_DataD.code == 1) {
        this.Bwin._List = Mx.AuctionHouse_DataD.result.unSold;
        this._czmod = ind;
        this.Bwin.select(0);
        this.Bwin.refresh();
        this.Bwin.show();
        this.Bwin.activate();
        if (Mx.Ahdata_SP) this.Awin.hide();
      } else {
        this.Awin.activate();
      }
    }
    if (ind == 4) {
      let { code, message, result } = await HWGOE.auctionHouse.myAuctionHouse();
      var jslist = [];
      for (var s = 0; s < result.awaitingCollection.length; s++) {
        jslist.push(result.awaitingCollection[s]._id);
      }
      let dddata = await HWGOE.auctionHouse.auctionHouseSettlement(jslist);
      if (dddata.code == 1) {
        var list = result.awaitingCollection;
        for (var s = 0; s < list.length; s++) {
          var data = list[s];
          var item = JsonEx.parse(data.data);
          Mx.SFdata_sj(item, data.lx);
        }
        this._czmod = 998;
        this.Cwin._text = "领取成功！";
        this.Cwin.refresh();
        this.Cwin.show();
        this.Cwin.activate();
      } else {
        this._czmod = 998;
        this.Cwin._text = "领取失败！";
        this.Cwin.refresh();
        this.Cwin.show();
        this.Cwin.activate();
        return;
      }

      this.Awin.refresh();
      await HWGOE.auctionHouse.cloudSaveGame();
    }
    if (ind == 5) {
      await Mx_refreshMy();
      if (Mx.AuctionHouse_DataA && Mx.AuctionHouse_DataA.code == 1) {
        this.Bwin._List = Mx.AuctionHouse_DataA.result.finished;
        this.Bwin.jzdj = true;
        this._czmod = ind;
        this.Bwin.select(0);
        this.Bwin.refresh();
        this.Bwin.show();
        this.Bwin.activate();
        if (Mx.Ahdata_SP) this.Awin.hide();
      } else {
        this.Awin.activate();
      }
    }
    if (ind == 6) {
      let { code, message, result } = await HWGOE.auctionHouse.myProductList();
      if (code == 1) {
        this.Bwin._List = result.timeout;
        this._czmod = ind;
        this.Bwin.select(0);
        this.Bwin.refresh();
        this.Bwin.show();
        this.Bwin.activate();
        if (Mx.Ahdata_SP) this.Awin.hide();
      } else {
        this.Awin.activate();
      }
    }
  };

  Scene_AuctionHouse.prototype.Bok = function () {
    if (this._czmod == 1) {
      this.Dwin._n = "0";
      this.Dwin.refresh();
      this.Dwin.show();
      this.Dwin.activate();
    }
    if (this._czmod == 2) {
      this.Cwin._text = "是否购买此商品？";
      this.Cwin.refresh();
      this.Cwin.show();
      this.Cwin.activate();
    }
    if (this._czmod == 3) {
      this.Cwin._text = "是否下架此商品？";
      this.Cwin.refresh();
      this.Cwin.show();
      this.Cwin.activate();
    }
    if (this._czmod == 6) {
      this.Cwin._text = "是否取回此商品？";
      this.Cwin.refresh();
      this.Cwin.show();
      this.Cwin.activate();
    }
  };

  Scene_AuctionHouse.prototype.Dok = function () {
    var ind = this.Dwin.index();
    if (ind < 10) {
      this.Dwin._n += this.Dwin.item();
      this.Dwin.refresh();
      this.Dwin.activate();
    } else {
      if (ind == 10) {
        this.Dwin._n = "0";
        this.Dwin.refresh();
        this.Dwin.activate();
      } else {
        var jg = Number(this.Dwin._n);
        var item = this.Bwin.item();
        var guidePrice = 0;
        if (item && item.meta) {
          let price = Number(item.meta.auctionGuidePrice);
          if (!isNaN(price)) {
            guidePrice = Math.max(10, price);
          }
        }
        if (jg < 10 || jg < guidePrice) {
          this.Dwin.hide();
          if (guidePrice) {
            this.Cwin._text = "价格不允许被设定为" + guidePrice + "以下。";
          } else {
            this.Cwin._text = "价格不允许被设定为10以下。";
          }
          this.Cwin.refresh();
          this.Cwin.show();
          this.Cwin.activate();
        } else {
          this._czmod = 11;
          this._jg = jg;
          this.Dwin.hide();
          this.Cwin._text = "以" + jg + "的价格上架该商品？";
          this.Cwin.refresh();
          this.Cwin.show();
          this.Cwin.activate();
        }
      }
    }
  };

  Scene_AuctionHouse.prototype.Cok = async function () {
    if (this._czmod == 2 && !this.Cwin._index) {
      // 购买
      var qx = true;
      var item = this.Bwin.item();
      var pid = item._id;
      let { code, message } = await HWGOE.auctionHouse.auctionProduct(pid);
      this.Awin.refresh();
      if (code == 1) {
        this._czmod = 999;
        this._czmod_bf = 2;
        var lsbg = true;
        this.Cwin._text = "商品购买成功！";
        this.Cwin.refresh();
        this.Cwin.show();
        this.Cwin.activate();
      } else {
        this._czmod = 999;
        this._czmod_bf = 2;
        var lsbg = true;
        this.Cwin._text = "商品购买失败！";
        this.Cwin.refresh();
        this.Cwin.show();
        this.Cwin.activate();
      }
      this.SxList(2);
      await HWGOE.auctionHouse.cloudSaveGame();
    }
    if (this._czmod == 3 && !this.Cwin._index) {
      // 下架
      var qx = true;
      var item = this.Bwin.item();
      var pid = item._id;
      let { code, message } = await HWGOE.auctionHouse.productDiscontinuation(
        pid
      );
      await Mx_refreshMy();
      if (code == 1) {
        Mx.SFdata_sj(item.data, item.lx);
        await HWGOE.auctionHouse.cloudSaveGame();
        this.Awin.refresh();
        this._czmod = 999;
        this._czmod_bf = 3;
        var lsbg = true;
        this.Cwin._text = "商品下架成功！";
        this.Cwin.refresh();
        this.Cwin.show();
        this.Cwin.activate();
      } else {
        this._czmod = 999;
        this._czmod_bf = 3;
        var lsbg = true;
        this.Cwin._text = "商品下架失败！";
        this.Cwin.refresh();
        this.Cwin.show();
        this.Cwin.activate();
      }
      this.SxList(3);
      await HWGOE.auctionHouse.cloudSaveGame();
    }
    if (this._czmod == 6 && !this.Cwin._index) {
      // 取回
      var qx = true;
      var item = this.Bwin.item();
      var pid = item._id;
      let { code, message } = await HWGOE.auctionHouse.productDiscontinuation(
        pid
      );
      await Mx_refreshMy();
      if (code == 1) {
        Mx.SFdata_sj(item.data, item.lx);
        await HWGOE.auctionHouse.cloudSaveGame();
        this.Awin.refresh();
        this._czmod = 999;
        this._czmod_bf = 3;
        var lsbg = true;
        this.Cwin._text = "商品取回成功！";
        this.Cwin.refresh();
        this.Cwin.show();
        this.Cwin.activate();
      } else {
        this._czmod = 999;
        this._czmod_bf = 3;
        var lsbg = true;
        this.Cwin._text = "商品取回失败！";
        this.Cwin.refresh();
        this.Cwin.show();
        this.Cwin.activate();
      }
      this.SxList(3);
      await HWGOE.auctionHouse.cloudSaveGame();
    }
    if (this._czmod == 11 && !this.Cwin._index) {
      //  上架
      var qx = true;
      var item = this.Bwin.item();
      var jg = this._jg;
      var data = await Mx_dataUPsj(item, jg);
      Mx.AuctionHouse_DataC = data;
      this.Aok();
      if (Mx.AuctionHouse_DataC == 1) {
        this._czmod = 999;
        this._czmod_bf = 1;
        var lsbg = true;
        this.Cwin._text = "商品上架成功！";
        this.Cwin.refresh();
        this.Cwin.show();
        this.Cwin.activate();
      } else {
        this._czmod = 999;
        this._czmod_bf = 1;
        var lsbg = true;
        this.Cwin._text = "商品上架失败！";
        if (Mx.AuctionHouse_DataC === 5) {
          this.Cwin._text += "商品信息过载。";
        }
        if (Mx.AuctionHouse_DataC === 9) {
          this.Cwin._text += "货柜已满。";
        }
        if (Mx.AuctionHouse_DataC === 10) {
          this.Cwin._text += "上架需要1" + Mx.Ahdata_name + "。";
        }
        this.Cwin.refresh();
        this.Cwin.show();
        this.Cwin.activate();
      }
    }
    if (this._czmod == 998) {
      // 领取后
      var qx = true;
      this.Cwin.hide();
      this.Awin.activate();
    }

    if (this._czmod == 999 && !lsbg) {
      this._czmod = this._czmod_bf;
    }
    if (!qx) this.Cqx();
  };

  Scene_AuctionHouse.prototype.Bqx = function () {
    this.Bwin.hide();
    this.Awin.show();
    this.Awin.activate();
    this.Bwin.jzdj = false;
  };

  Scene_AuctionHouse.prototype.Cqx = function () {
    if (this._czmod == 998) {
      this.Cwin.hide();
      this.Awin.activate();
      return;
    }
    if (this._czmod == 11) this._czmod = 1;
    this.Cwin.hide();
    this.Dwin.hide();
    this.Bwin.activate();
  };

  Scene_AuctionHouse.prototype.update = function () {
    Scene_MenuBase.prototype.update.call(this);
  };
}

if (GT && GT.OIWin) {
  Mx.Window_ObjectInfo_setItem = Window_ObjectInfo.prototype.setItem;
  Window_ObjectInfo.prototype.setItem = function (item, targetWindow) {
    if (item && item._sellerId) {
      var lx = item.lx;
      var it = JsonEx.parse(item.data);
      it.___lx_ = lx;
      item = it;
    }

    Mx.Window_ObjectInfo_setItem.call(this, item, targetWindow);
  };
}

DataManager.isItem = function (item) {
  var fjtj = item && item.___lx_ == 1;
  return item && ($dataItems.contains(item) || fjtj);
};

DataManager.isWeapon = function (item) {
  var fjtj = item && item.___lx_ == 2;
  return item && ($dataWeapons.contains(item) || fjtj);
};

DataManager.isArmor = function (item) {
  var fjtj = item && item.___lx_ == 3;
  return item && ($dataArmors.contains(item) || fjtj);
};

Window_Base.prototype.drawIcon_x2 = function (iconIndex, x, y) {
  var bitmap = ImageManager.loadSystem("IconSet");
  var pw = Window_Base._iconWidth;
  var ph = Window_Base._iconHeight;
  var sx = (iconIndex % 16) * pw;
  var sy = Math.floor(iconIndex / 16) * ph;
  this.contents._context.imageSmoothingEnabled = false;
  this.contents.blt(bitmap, sx, sy, pw, ph, x, y, 64, 64);
  this.contents._context.imageSmoothingEnabled = true;
};
