//=============================================================================
// Mx_OnlineShop.js
//=============================================================================

var Mx = {};
Mx.Hbicon = 361; // 货币图标

//=============================================================================
 /*:
 * @plugindesc [商城] 
 *
 * @help
 * =========== 命令
 * 打开商城：SceneManager.push(Scene_MxOnlineShop);
 * 
 * =========== 道具标签
 * <注意，没有写出售武器防具的场合>
 * <如有需要，请用道具的公共事件完成>
 * 
 * <OsType:材料>  设定道具在商城中的分类
 * <OsTypeP:50>  设定道具价格为50
 * <Osxg:1>  设定道具限购数量为1
 * 
 * <Osid:3>  售出id
 * <Ossl:7>  售出数量
 * <Osdj:9>  售出单价
 *  以上三条命令需要同时添加，
 *  比如在2号道具中同时填入<Osid:20>、<Ossl:10>、<Osdj:10>，
 *  那么2号道具会出现在商城中，购买价格为63（9 * 7），
 *  购买后获得7个3号道具。
 * 
 * <OsTy:true> 该商品全存档通用
 * <help1:text>  将text替换为道具说明，
 * help1可以扩增到最多help10
 * 
 * 货币图标打开此js文件第6行修改
 * 
 * 
 * 
 * 
 * 
 * 
 * 
 * 
 * 
 * 
 * 
 * 
 * 
 * 
 * 
 * 
 * 
 * 
 * 
 * 
 */
//=============================================================================

var Scene_Boot_loadSystemImages = Scene_Boot.loadSystemImages;
Scene_Boot.loadSystemImages = function() { // 预加载
    Scene_Boot_loadSystemImages.call(this);
	
    ImageManager.reservePicture('Oshop1');
    ImageManager.reservePicture('Oshop2');
    ImageManager.reservePicture('Oshop3');
    ImageManager.reservePicture('Oshop4');
    ImageManager.reserveSystem('WindowK');
};

Window_Base.prototype.drawIcon_x2 = function(iconIndex, x, y) {
    var bitmap = ImageManager.loadSystem('IconSet');
    var pw = Window_Base._iconWidth;
    var ph = Window_Base._iconHeight;
    var sx = iconIndex % 16 * pw;
    var sy = Math.floor(iconIndex / 16) * ph;
    this.contents._context.imageSmoothingEnabled = false;
    this.contents.blt(bitmap, sx, sy, pw, ph, x, y, 64, 64);
    this.contents._context.imageSmoothingEnabled = true;
};

//■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■
{ // 商城
//=============================================================================
// 分类
//=============================================================================
{
function Window_OnlineShopA() {
    this.initialize.apply(this, arguments);
}

Window_OnlineShopA.prototype = Object.create(Window_Selectable.prototype);
Window_OnlineShopA.prototype.constructor = Window_OnlineShopA;

Window_OnlineShopA.prototype.initialize = function() {
    Window_Selectable.prototype.initialize.call(this, 0, 110, 1000, 500);
	this.opacity = 0;
	this.windowskin = ImageManager.loadSystem('WindowK');
	this._an = ImageManager.loadPicture('Oshop4');
    this.refresh();
	this._helpWindow = '???';
	this.callUpdateHelp();
    this.select(0);
}

Window_OnlineShopA.prototype.maxCols = function() {
    return 1;
};

Window_OnlineShopA.prototype.spacing = function() {
    return 3;
};

Window_OnlineShopA.prototype.itemHeight = function() {
    return 67;
};

Window_OnlineShopA.prototype.itemRect = function(index) {
    var rect = new Rectangle();
	
	rect.width = 234;
	rect.height = 67;
	rect.x = (this._index == index ? 24 : 4);
	rect.y = 30 + Math.floor(index / this.maxCols()) * 75 - this._scrollY;

    return rect;
};

Window_OnlineShopA.prototype.maxItems = function() {
    return this._data ? this._data.length : 1;
};

Window_OnlineShopA.prototype.item = function() {
    return this._data[this.index()];
};

Window_OnlineShopA.prototype.isCurrentItemEnabled = function() {
    return this.isEnabled(this._data[this.index()]);
};

Window_OnlineShopA.prototype.isEnabled = function(item) {
    return true;
};

Window_OnlineShopA.prototype.refresh = function() {
    this.makeItemList();
    this.createContents();
    this.drawAllItems();
};

Window_OnlineShopA.prototype.makeItemList = function() {
    this._data = ['壹 页', '贰 页', '叁 页', '肆 页'];
};

Window_OnlineShopA.prototype.drawItem = function(index) {
    var cz = this._data[index];
    var rect = this.itemRect(index);
	if (!cz) return;
	
	this.contents.blt(this._an, 0, 0, 234, 67, rect.x, rect.y);
	//this.drawTextEx('\\fs[28]\\fb', rect.x + 34, rect.y + 15);
	this.drawText(cz, rect.x + 34, rect.y + 16, 160, 'center');
};

Window_OnlineShopA.prototype.setStatusWindow = function(statusWindow) {
    this._helpWindow = statusWindow;
    this.callUpdateHelp();
};

Window_OnlineShopA.prototype.setHelpWindowItem = function(item) {
    if (this._helpWindow) {
        //this._helpWindow.setItem(item);
    }
};

Window_OnlineShopA.prototype.updateHelp = function() {
	this.refresh();
	if (this.win && this.item()){
		this.win.Type = this.item().replace(' ', '');
		this.win.refresh();
	}
};
}
//=============================================================================
// 商品列表
//=============================================================================
{
function Window_OnlineShopB() {
    this.initialize.apply(this, arguments);
}

Window_OnlineShopB.prototype = Object.create(Window_Selectable.prototype);
Window_OnlineShopB.prototype.constructor = Window_OnlineShopB;

Window_OnlineShopB.prototype.initialize = function() {
    Window_Selectable.prototype.initialize.call(this, 0, 0, 1280, 720);
	this.opacity = 0;
	this.windowskin = ImageManager.loadSystem('WindowK');
    this.refresh();
	this._helpWindow = '???';
	this.callUpdateHelp();
    this.select(-1);
}

Window_OnlineShopB.prototype.maxCols = function() {
    return 1;
};

Window_OnlineShopB.prototype.spacing = function() {
    return 3;
};

Window_OnlineShopB.prototype.itemHeight = function() {
    return 125;
};

Window_OnlineShopB.prototype.maxPageRows = function() {
    return 5;
};

Window_OnlineShopB.prototype.itemRect = function(index) {
    var rect = new Rectangle();
	
	rect.width = 300;
	rect.height = 100;
	rect.x = 287 + index % this.maxCols() * 350;
	rect.y = 70 + Math.floor(index / this.maxCols()) * 125 - this._scrollY;

    return rect;
};

Window_OnlineShopB.prototype.maxItems = function() {
    return this._data ? this._data.length : 1;
};

Window_OnlineShopB.prototype.item = function() {
    return this._data[this.index()];
};

Window_OnlineShopB.prototype.isCurrentItemEnabled = function() {
    return this.isEnabled(this._data[this.index()]);
};

Window_OnlineShopB.prototype.isEnabled = function(item) {
	if (item.meta.Osxg) if (HWGOE.shop.buyNumber(0, item.id, {limit: Number(item.meta.Osxg)}) == 0) return false;
	return HWGOE.shop.ticket() >= Number(item.meta.OsTypeP);
    return true;
};

Window_OnlineShopB.prototype.refresh = function() {
	if (!this.Type) return;
    this.makeItemList();
    this.createContents();
	this.drawBJ();
    this.drawAllItems();
};

Window_OnlineShopB.prototype.makeItemList = function() {
    this._data = [];
	for (var s=1;s<$dataItems.length;s++){
		if (!$dataItems[s] || !$dataItems[s].meta.OsTypeP) continue;
		if ($dataItems[s].meta.OsType && $dataItems[s].meta.OsType == this.Type){
			this._data.push($dataItems[s]);
		}
	}
};

Window_OnlineShopB.prototype.drawItem = function(index) {
    var item = this._data[index];
    var rect = this.itemRect(index);
	if (!item) return;
	
	this.drawIcon_x2(item.iconIndex, rect.x + 18, rect.y + 18);
	this.drawTextEx('\\c[' + item.textColor + ']', rect.x + 88, rect.y + 17);
	this.drawText(item.name, rect.x + 88, rect.y + 14, 190, 'right');
	this.drawIcon(Mx.Hbicon, rect.x + 100, rect.y + 48);
	//this.drawTextEx('\\fs[22]\\fb', rect.x, rect.y);
	this.drawText(item.meta.OsTypeP, rect.x + 88, rect.y + 47, 158, 'right');
	if (item == this.item()){
		var bit = ImageManager.loadPicture('Oshop3');
		this.contents.blt(bit, 0, 0, 55, 55, rect.x + 270, rect.y + 75);
	}
};

Window_OnlineShopB.prototype.drawBJ = function() {
    var item = this._data[this._index];
	for (var s=0;s<10;s++){
		var rect = this.itemRect(s);
		var tx = ImageManager.loadPicture('Oshop2');
		this.contents.blt(tx, 0, 0, 300, 100, rect.x, rect.y);
		this.contents.paintOpacity = 75;
		this.contents.fillRect(rect.x + 90, rect.y + 77, 190, 1, '#ffffff');
		this.contents.paintOpacity = 255;
		//if (!this._data[s]) this.drawIcon_x2(12, rect.x + 18, rect.y + 18);
	}
	
	var x = 960;
	var y = 95;
	this.contents.paintOpacity = 175;
	this.contents.fillRect(x, y, 300, 480, '#000000');
	this.contents.fillRect(x, y + 490, 300, 40, '#000000');
	this.contents.paintOpacity = 255;
	
	this.drawIcon(Mx.Hbicon, x + 5, y + 495);
	//this.drawTextEx('\\fs[22]\\fb', x, y + 490);
	this.drawText(HWGOE.shop.ticket(), x, y + 491, 270, 'right');
	if (!item) return;
	
	//this.drawIcon_x2((item.textColor ? item.textColor - 14 : 12), x + 5, y + 5);
	this.drawIcon_x2(item.iconIndex, x + 5, y + 5);
	this.drawTextEx('\\}\\c[' + item.textColor + ']' + item.name + '\\c[0]', x + 75, y + 5);
	var cyl = (item.sl ? item.sl : $gameParty.numItems(item));
	if (item.meta.Osid) cyl = $gameParty.numItems($dataItems[Number(item.meta.Osid)]);
	if (!DataManager.isWeapon(item) && !DataManager.isArmor(item)){
  this.drawTextEx('\\}拥有：' + cyl, x + 75, y + 35);
	} else {
		this.drawTextEx('\\}等级：' + item.lv, x + 75, y + 35);
	}
	var helpz = [];
	for (var s=0;s<10;s++){
		var ind = s + 1;
		if (!item.meta['help' + ind]) continue;
		var te = item.meta['help' + ind];
		helpz.push(te);
	}
	if (item.meta.OsTy) helpz.push('【该道具全存档可用】');
	for (var s=0;s<helpz.length;s++){
		var xx = x + 15;
		var yy = y + 80 + s * 30;
		this.drawTextEx("\\}" + helpz[s], xx, yy);
	}
	if (item.meta.Osxg){
		var sygm = HWGOE.shop.buyNumber(0, item.id, {limit: Number(item.meta.Osxg)});
	this.drawTextEx('\\}还可以购买' + sygm + '次。', x + 10, y + 440);
	}
};

Window_OnlineShopB.prototype.setStatusWindow = function(statusWindow) {
    this._helpWindow = statusWindow;
    this.callUpdateHelp();
};

Window_OnlineShopB.prototype.setHelpWindowItem = function(item) {
    if (this._helpWindow) {
        //this._helpWindow.setItem(item);
    }
};

Window_OnlineShopB.prototype.updateHelp = function() {
	this.refresh();
};
}
//=============================================================================
// 购买确认
//=============================================================================
{
function Window_OnlineShopC() {
    this.initialize.apply(this, arguments);
}

Window_OnlineShopC.prototype = Object.create(Window_Selectable.prototype);
Window_OnlineShopC.prototype.constructor = Window_OnlineShopC;

Window_OnlineShopC.prototype.initialize = function() {
    Window_Selectable.prototype.initialize.call(this, 472, 285, 336, 150);
	this.opacity = 255;
    this.refresh();
	this._helpWindow = '???';
	this.callUpdateHelp();
    this.select(0);
}

Window_OnlineShopC.prototype.maxCols = function() {
    return 2;
};

Window_OnlineShopC.prototype.spacing = function() {
    return 3;
};

Window_OnlineShopC.prototype.itemHeight = function() {
    return 70;
};

Window_OnlineShopC.prototype.maxPageRows = function() {
    return 5;
};

Window_OnlineShopC.prototype.itemRect = function(index) {
    var rect = new Rectangle();
	
	rect.width = 150;
	rect.height = 40;
	rect.x = index % this.maxCols() * 150;
	rect.y = 70 + Math.floor(index / this.maxCols()) * 120 - this._scrollY;

    return rect;
};

Window_OnlineShopC.prototype.maxItems = function() {
    return this._data ? this._data.length : 1;
};

Window_OnlineShopC.prototype.item = function() {
    return this._data[this.index()];
};

Window_OnlineShopC.prototype.isCurrentItemEnabled = function() {
    return this.isEnabled(this._data[this.index()]);
};

Window_OnlineShopC.prototype.isEnabled = function(item) {
    return true;
};

Window_OnlineShopC.prototype.refresh = function() {
    this.makeItemList();
    this.createContents();
	this.drawBJ();
    this.drawAllItems();
};

Window_OnlineShopC.prototype.makeItemList = function() {
    this._data = ['确 认', '取 消'];
};

Window_OnlineShopC.prototype.drawItem = function(index) {
    var item = this._data[index];
    var rect = this.itemRect(index);
	if (!item) return;
	
	//this.drawTextEx('\\fs[22]\\fb', rect.x, rect.y);
	this.drawTextEx(item, rect.x, rect.y + 2, 150, 'center');
};

Window_OnlineShopC.prototype.drawBJ = function() {
	//this.drawTextEx('\\fs[22]\\fb', 0, 0);
	this.drawText('是否确认购买该道具？', 0, 0, 300, 'center');
};

Window_OnlineShopC.prototype.setStatusWindow = function(statusWindow) {
    this._helpWindow = statusWindow;
    this.callUpdateHelp();
};

Window_OnlineShopC.prototype.setHelpWindowItem = function(item) {
    if (this._helpWindow) {
        //this._helpWindow.setItem(item);
    }
};

Window_OnlineShopC.prototype.updateHelp = function() {
	this.refresh();
};
}
//=============================================================================
// 商城菜单
//=============================================================================
{
function Scene_MxOnlineShop() {
  this.initialize.apply(this, arguments);
}

Scene_MxOnlineShop.prototype = Object.create(Scene_MenuBase.prototype);
Scene_MxOnlineShop.prototype.constructor = Scene_MxOnlineShop;

Scene_MxOnlineShop.prototype.initialize = function() {
    Scene_MenuBase.prototype.initialize.call(this);
	Scene_Boot.loadSystemImages();
};

Scene_MxOnlineShop.prototype.create = function() {
    Scene_MenuBase.prototype.create.call(this);
    this.createWindow();
};

 // 添加发电函数
function fadian() {
    HWGOE.shop.electricGenerate();
};

Scene_MxOnlineShop.prototype.createWindow = function() {
    this._backSprite1 = new Sprite(ImageManager.loadPicture('Oshop1'));
    this.addChild(this._backSprite1);
	
    this.Awin = new Window_OnlineShopA();
    this.addChild(this.Awin);
    this.Awin.setHandler('ok', this.Aok.bind(this));
    this.Awin.setHandler('cancel', this.popScene.bind(this));
	this.Awin.activate();
	
    this.Bwin = new Window_OnlineShopB();
    this.addChild(this.Bwin);
	this.Awin.win = this.Bwin;
	this.Bwin.win = this.Awin;
    this.Bwin.setHandler('ok', this.Bok.bind(this));
    this.Bwin.setHandler('cancel', this.Bqx.bind(this));
    // ========================================================================
    this._fadianSprite = new Sprite_Button(); // 添加发电按钮
    this._fadianSprite.bitmap = ImageManager.loadPicture("icon_jia");// 载入发电图标,位于img/picture文件夹内
    this._fadianSprite.setClickHandler(fadian);//设置点击回调
    this._fadianSprite.move(150, 20);// 设置显示的坐标位置x,y
    this.addChild(this._fadianSprite);
    // ========================================================================
    this.Cwin = new Window_OnlineShopC();
    this.addChild(this.Cwin);
    this.Cwin.setHandler('ok', this.Cok.bind(this));
    this.Cwin.setHandler('cancel', this.Cqx.bind(this));
	this.Cwin.hide();
	
	Mx.SceneSX = this;
	setTimeout(function(){
		Mx.SceneSX.Awin.updateHelp();
		Mx.SceneSX.Bwin.refresh();
	},30)
};

Scene_MxOnlineShop.prototype.Aok = function() {
	this.Bwin.select(0);
	this.Bwin.refresh();
	this.Bwin.activate();
};

Scene_MxOnlineShop.prototype.Bok = function() {
	this.item = this.Bwin.item();
	this.Cwin.activate();
	this.Cwin.show();
};

Scene_MxOnlineShop.prototype.Bqx = function() {
	this.Bwin.select(-1);
	this.Bwin.refresh();
	this.Awin.activate();
};

Scene_MxOnlineShop.prototype.Cok = function() {
	var ind = this.Cwin._index;
	if (ind == 1) return this.Cqx();
	var id = this.item.id;
	var xg = this.item.meta.Osxg ? Number(this.item.meta.Osxg) : 0;
	var ty = this.item.meta.OsTy ? true : false;
	var jg = this.item.meta.OsTypeP;
	var op = {
		global: ty
	}
	if (xg) op.limit = xg;
	var sl = 1;
	if (this.item.meta.Osid) id = Number(this.item.meta.Osid);
	if (this.item.meta.Ossl) sl = Number(this.item.meta.Ossl);
	if (this.item.meta.Osdj) jg = Number(this.item.meta.Osdj);
	HWGOE.shop.buyGameItem(0, id, jg, sl, op);
	this.sx = true;
	this.sz1 = HWGOE.shop.ticket();
	this.Cqx();
};

Scene_MxOnlineShop.prototype.Cqx = function() {
	this.Bwin.refresh();
	this.Bwin.activate();
	this.Cwin.hide();
};

Scene_MxOnlineShop.prototype.update = function() {
	Scene_MenuBase.prototype.update.call(this);
	if (!this.sx) return;
	this.sz2 = HWGOE.shop.ticket();
	if (this.sz1 != this.sz2){
		this.sx = false;
		this.Bwin.refresh();
	}
};
}
}