//=============================================================================
// Crafting System, ver0.0.1
// Add-on to Ammunition System
//   by Unconnected42
// UNCO_X_Crafting.js
// Last Updated : 2015/11/15
//=============================================================================


//=============================================================================
//=============================================================================
// Only try to do anthing is Ammunition System is there !!!
if (Imported && Imported.UNCO_AmmunitionSystem === true) {
Unco.CS = Unco.CS || {};
//=============================================================================
//=============================================================================


//=============================================================================
 /*:
 * @plugindesc  允许使用技能制造物品或装备。
 * <Unco Craft>
 * @author Unconnected42
 *
 * @param Crafting Skill Types
 * @text 制造技能类型
 * @desc 列出制造技能类型id，用逗号分隔。
 * @default 0
 *
 * @param Default Products Text
 * @text 默认制造物文本
 * @desc 信息窗口中介绍技能制造物的文本。
 * @default 制造物(s)
 *
 * @param Default Stock Text
 * @text 默认库存文本
 * @desc 信息窗口中介绍技能制造物和部件的文本，相当于介绍性文本。
 * @default 库存
 *
 * @param Default Components Text
 * @text 默认部件文本
 * @desc 信息窗口中介绍技能组成部分(即费用)的文本。
 * @default 部件(s)
 *
 * @param Display Products And Components Names
 * @text 显示制造物和部件名称
 * @desc 如果设置为true，将显示制造物/部件的名称。否则，将只显示图标。
 * @default false
 * @type boolean
 *
 * @param Craft Text Font Size
 * @text 制造文本字体大小
 * @desc  绘制部件和制造物信息时的文本字体大小。
 * @default 24
 *
 * @param Craft Text Font Color Normal
 * @text 制造文本字体颜色-充足
 * @desc 绘制部件和制造物信息时的文本字体颜色。
 * @default 0
 *
 * @param Craft Text Font Color Crisis
 * @text 制造文本字体颜色-不足
 * @desc 弹药不足时，绘制部件和制造物信息时的字体颜色。
 * @default 18
 *
 *
 * @help
 * ============================================
 * 介绍
 * ============================================
 *
 * 这个插件提供了一个基于技能的制造系统。
 * 
 * ============================================
 * 已知的兼容性问题
 * ============================================
 *
 * 这个插件是弹药系统的扩展插件。
 * 如果没有安装弹药系统，将不会生效。
 *
 * 如果使用的是Bobstah's BattleCommandList插件,
 * 可能需要手动从角色的战斗命令列表中删除制造技能类型(见下文)。
 * 
 * ============================================
 * 使用方法
 * ============================================
 * 
 * 这个插件允许技能制造任何种类的物品。
 * 制造技能(即制造物品的技能)可以根据弹药系统的规则消耗物品，
 * 但有一些特定的调整。
 * 注意：制造技能最好不允许它在战斗中使用。
 *
 * 为了让制造技能正常工作，它们必须被赋予特殊的技能类型，
 * 这些技能类型将在插件参数'制造技能类型'中列出。
 * 
 * 示例:创建一个名为'Alchemy'(炼金术)的技能类型，编号为6，
 * 并将'6'作为参数'制作技能类型'的值。
 * 把技能类型'Alchemy'赋予一些想要制造物品的技能。
 * 稍后，如果创建了另一个名为'Cooking'(烹饪)(数字7)技能类型，
*  将'6,7'作为参数'制作技能类型'的值。
 * 
 * 当技能类型被列在制造技能类型中时，会有两种结果:
 * - 该技能类型将不会在战斗中出现。
 *   (只有不使用任何插件改变角色战斗命令列表时)
 * - 在主要技能菜单中，当选择一个制造技能类型时，
 *   正常的项目窗口将被替换。相反，将有两个窗口:
 *   左边的一个将显示对应于所选技能类型的技能列表(所有这些技能都应该是制造技能)，
 *   右边的一个将显示当前所选技能的制造物和部件列表。
 *   还将显示制造物/部件的当前数量。
 *
 * 以下是放入制作技能备注的标签，用于定义制造物:
 * <Make i Item: n>
 * <Make i Armor: n>
 * <Make i Weapon: n>
 * ... 其中'i'是所需物品/防具/武器的ID,'n'是需要的数量。
 *
 * 至于部件，使用与弹药系统中相同的标签。
 * 但是，在物品消耗方面略有不同。
 * 武器和防具类物品将被视为普通物品:
 * 也就是说，它们不需要装备，只有库存中的物品将被考虑以估计可用数量(而不是装备的那些)，
 * 并且所有列出的装备型弹药都将被消耗掉，而不仅仅是装备的弹药。
 *
 * 可以在制造信息窗口中自定义介绍制造物和部件的文本，
 * 并在技能的备注框中添加以下标签:
 * <Craft Product Text: xxx>
 * <Craft Component Text: xxx>
 * 
 */
//=============================================================================

//=============================================================================
// Parameter Variables
//=============================================================================

Unco.Parameters = $plugins.filter(function(p) {
        return p.description.contains('<Unco Craft>');
    })[0].parameters; //Copied from Ellye, who thanks Iavra
Unco.Param = Unco.Param || {};

Unco.Param.craftDefProdText = String(Unco.Parameters['Default Products Text']);
Unco.Param.craftDefCompText = String(Unco.Parameters['Default Components Text']);
Unco.Param.craftDefStocText = String(Unco.Parameters['Default Stock Text']);
Unco.Param.craftDispNames = String(Unco.Parameters['Display Products And Components Names']).toLowerCase();
Unco.Param.craftSkillTypes = String(Unco.Parameters['Crafting Skill Types']).split(',');
Unco.Param.craftFontSize = parseInt(String(Unco.Parameters['Craft Text Font Size']));
Unco.Param.craftFontColorNorm = parseInt(String(Unco.Parameters['Craft Text Font Color Normal']));
Unco.Param.craftFontColorCris = parseInt(String(Unco.Parameters['Craft Text Font Color Crisis']));

Unco.CS.isCraftSkillType = function(stid) { 
   stid = String(stid);   
   for(var i = 0; i < Unco.Param.craftSkillTypes.length; i++) {
      if (Unco.Param.craftSkillTypes[i] === stid) {
         return true;
      }
   }
   return false;
}


//=============================================================================
// DataManager
//=============================================================================

Unco.CS.DataManager_isDatabaseLoaded = DataManager.isDatabaseLoaded;
DataManager.isDatabaseLoaded = function() {
    if (!Unco.CS.DataManager_isDatabaseLoaded.call(this)) return false;
    this.processUncoCraftNotetags($dataSkills);
    return true;
};

DataManager.processUncoCraftNotetags = function(group) {
   for (var n = 1; n < group.length; n++) {
      var obj = group[n];
      var notedata = obj.note.split(/[\r\n]+/);

      obj.makeItem = [];
      obj.makeArmor = [];
      obj.makeWeapon = [];

      for (var i = 0; i < notedata.length; i++) {
         var line = notedata[i];
         if (line.match(/<(?:MAKE)[ ](\d+)[ ](?:ITEM):[ ](\d+)>/i)) {
            var index = parseInt(RegExp.$1);
            var value = parseInt(RegExp.$2);
            if ( (!isNaN(index)) && (!isNaN(value)) ) {
               obj.makeItem[index] = value;
               obj.isCraft = true;
            }
         }
         if (line.match(/<(?:MAKE)[ ](\d+)[ ](?:ARMOR):[ ](\d+)>/i)) {
            var index = parseInt(RegExp.$1);
            var value = parseInt(RegExp.$2);
            if ( (!isNaN(index)) && (!isNaN(value)) ) {
               obj.makeArmor[index] = value;
               obj.isCraft = true;
            }
         }
         if (line.match(/<(?:MAKE)[ ](\d+)[ ](?:WEAPON):[ ](\d+)>/i)) {
            var index = parseInt(RegExp.$1);
            var value = parseInt(RegExp.$2);
            if ( (!isNaN(index)) && (!isNaN(value)) ) {
               obj.makeWeapon[index] = value;
               obj.isCraft = true;
            }
         }
         if (line.match(/<(?:CRAFT)[ ](?:PRODUCT)[ ](?:TEXT):[ ](.*)>/i)) {
            obj.craftProdText = String(RegExp.$1);
         }
         if (line.match(/<(?:CRAFT)[ ](?:COMPONENT)[ ](?:TEXT):[ ](.*)>/i)) {
            obj.craftCompText = String(RegExp.$1);
         }
      }
   }
}



//=============================================================================
// Window_ActorCommand
//=============================================================================

if (!Imported.BOB_BattleCommandList) {
   Window_ActorCommand.prototype.addSkillCommands = function() {
      var skillTypes = this._actor.addedSkillTypes();
      skillTypes.sort(function(a, b) {
         return a - b;
      });
      skillTypes.forEach(function(stypeId) {
         if (Unco.CS.isCraftSkillType(stypeId) === false) {
            var name = $dataSystem.skillTypes[stypeId];
            this.addCommand(name, 'skill', true, stypeId);
         }
      }, this);
   };
}
//=============================================================================
// Game_BattlerBase
//=============================================================================

Game_BattlerBase.prototype.canPaySkillEquipAmmoCost = function(skill) {
   if (skill.stypeId && Unco.CS.isCraftSkillType(skill.stypeId)) {
      for (var ammoId in skill.equipAmmoCost) {
         ammoId = parseInt(ammoId);
         if (!isNaN(ammoId) && (ammoId > 0)) {
            var nbOwned = $gameParty.getItemAmount($dataArmors[ammoId]);
            if (skill.equipAmmoCost[ammoId] > nbOwned) {
               return false;
            }
         }
      }
      for (var ammoId in skill.weaponAmmoCost) {
         ammoId = parseInt(ammoId);
         if (!isNaN(ammoId) && (ammoId > 0)) {
            var nbOwned = $gameParty.getItemAmount($dataWeapons[ammoId]);
            if (skill.weaponAmmoCost[ammoId] > nbOwned) {
               return false;
            }
         }
      }
      return true;
   }
   if (!this.canPaySkillArmorAmmoCost(skill)) return false;
   if (!this.canPaySkillWeaponAmmoCost(skill)) return false;
   return true;
};

Unco.CS.Game_BattlerBase_paySkillEquipAmmoCost = Game_BattlerBase.prototype.paySkillEquipAmmoCost;
Game_BattlerBase.prototype.paySkillEquipAmmoCost = function(skill) {
   if (skill.stypeId && Unco.CS.isCraftSkillType(skill.stypeId)) {
      for (var ammoId in skill.equipAmmoCost) {
         ammoId = parseInt(ammoId);
         if (!isNaN(ammoId) && (ammoId > 0)) {
            $gameParty.gainItem($dataArmors[ammoId],-skill.equipAmmoCost[ammoId]);
         }
      }
      for (var ammoId in skill.weaponAmmoCost) {
         ammoId = parseInt(ammoId);
         if (!isNaN(ammoId) && (ammoId > 0)) {
            $gameParty.gainItem($dataWeapons[ammoId],-skill.weaponAmmoCost[ammoId]);
         }
      }
   } else {
      Unco.CS.Game_BattlerBase_paySkillEquipAmmoCost.call(this,skill);
   }
};

Unco.CS.Game_BattlerBase_paySkillAmmoCost = Game_BattlerBase.prototype.paySkillAmmoCost;
Game_BattlerBase.prototype.paySkillAmmoCost = function(skill) {
   Unco.CS.Game_BattlerBase_paySkillAmmoCost.call(this,skill);
   if (skill.id === this.attackSkillId()) {
      return;
   }
   for (var makeId in skill.makeItem) {
      makeId = parseInt(makeId);
      if (!isNaN(makeId) && (makeId > 0)) {
         var makeAmount = parseInt(skill.makeItem[makeId]);
         if (!isNaN(makeAmount) &&  (makeAmount > 0)) {
            $gameParty.gainItem($dataItems[makeId],makeAmount);
         }
      }
   }
   for (var makeId in skill.makeArmor) {
      makeId = parseInt(makeId);
      if (!isNaN(makeId) && (makeId > 0)) {
         var makeAmount = parseInt(skill.makeArmor[makeId]);
         if (!isNaN(makeAmount) &&  (makeAmount > 0)) {
            $gameParty.gainItem($dataArmors[makeId],makeAmount);
         }
      }
   }
   for (var makeId in skill.makeWeapon) {
      makeId = parseInt(makeId);
      if (!isNaN(makeId) && (makeId > 0)) {
         var makeAmount = parseInt(skill.makeWeapon[makeId]);
         if (!isNaN(makeAmount) &&  (makeAmount > 0)) {
            $gameParty.gainItem($dataWeapons[makeId],makeAmount);
         }
      }
   }
};

//-----------------------------------------------------------------------------
// Window_CraftList
//
// The window for selecting a skill on the skill screen, for craft skills.

function Window_CraftList() {
    this.initialize.apply(this, arguments);
}

Window_CraftList.prototype = Object.create(Window_SkillList.prototype);
Window_CraftList.prototype.constructor = Window_CraftList;

Window_CraftList.prototype.initialize = function(x, y, width, height) {
    Window_SkillList.prototype.initialize.call(this, x, y, width, height);
    this._infoWindow = null;
};

Window_CraftList.prototype.maxCols = function() {
    return 1;
};

Window_CraftList.prototype.drawAmmoCost = function(skill, wx, wy, dw) {
   if (Unco.CS.isCraftSkillType(skill.stypeId) === false) {
      dw = Window_SkillList.prototype.drawAmmoCost.call(this,skill, wx, wy, dw);
   }
   return dw;
};

Window_CraftList.prototype.setInfoWindow = function(infoWindow) {
    this._infoWindow = infoWindow
    if (this.active && this._infoWindow) {
        this._infoWindow.setItem(this.item());
    }
};

Window_CraftList.prototype.updateHelp = function() {
    this.setHelpWindowItem(this.item());
    if (this._infoWindow) {
        this._infoWindow.setItem(this.item());
    }
};

//=============================================================================
// Window_CraftInfo
//=============================================================================

function Window_CraftInfo() {
    this.initialize.apply(this, arguments);
}

Window_CraftInfo.prototype = Object.create(Window_Base.prototype);
Window_CraftInfo.prototype.constructor = Window_CraftInfo;

Window_CraftInfo.prototype.initialize = function(x, y, width, height) {
    Window_Base.prototype.initialize.call(this, x, y, width, height);
    this._item = null;
    this.deactivate();
    this.refresh();
};

Window_CraftInfo.prototype.setItem = function(item) {
    if (this._item === item) return;
    this._item = item;
    this.refresh();
};

Window_CraftInfo.prototype.refresh = function() {
    this.contents.clear();
    var dy = 0;
    if (!this._item) return dy;
    dy = this.drawProducts(dy);
    dy = this.drawComponents(dy);
    return dy;
};

Window_CraftInfo.prototype.drawProducts = function(dy) {
   var skill = this._item;
   var indent = 24;
   var stockIndent = indent*3;
   var dx = this.textPadding();
   var dw = this.contents.width - this.textPadding() * 2;
   this.resetFontSettings();
   var text = ( (typeof skill.craftProdText !== 'undefined') ? skill.craftProdText : Unco.Param.craftDefProdText);
   this.drawDarkRect(dx-indent, dy, dw+indent, this.lineHeight());
   this.drawText(text, dx, dy, dw, 'left');
   dy += this.lineHeight();
   dx += indent;
   this.contents.fontSize = Unco.Param.craftFontSize;
   this.changeTextColor(this.textColor(Unco.Param.craftFontColorNorm));
   for (var makeId in skill.makeItem) {
      makeId = parseInt(makeId);
      if (!isNaN(makeId) && (makeId > 0)) {
         var makeAmount = parseInt(skill.makeItem[makeId]);
         if (!isNaN(makeAmount) &&  (makeAmount > 0)) {
            this.drawIcon($dataItems[makeId].iconIndex, dx, dy);
            if (Unco.Param.craftDispNames === 'true') {
               this.drawText($dataItems[makeId].name, dx + Window_Base._iconWidth + 2, dy, dw, 'left');
               dy += this.lineHeight();
            }
            text = 'x' + String(makeAmount);
            this.drawText(text, dx + Window_Base._iconWidth + 2, dy, dw, 'left');
            text = '(' + $gameParty.getItemAmount($dataItems[makeId]) + ' ' + Unco.Param.craftDefStocText + ')';
            this.drawText(text, dx + Window_Base._iconWidth + stockIndent, dy, dw, 'left');
            dy += this.lineHeight();
         }
      }
   }
   for (var makeId in skill.makeArmor) {
      makeId = parseInt(makeId);
      if (!isNaN(makeId) && (makeId > 0)) {
         var makeAmount = parseInt(skill.makeArmor[makeId]);
         if (!isNaN(makeAmount) &&  (makeAmount > 0)) {
            this.drawIcon($dataArmors[makeId].iconIndex, dx, dy);
            if (Unco.Param.craftDispNames === 'true') {
               this.drawText($dataArmors[makeId].name, dx + Window_Base._iconWidth + 2, dy, dw, 'left');
               dy += this.lineHeight();
            }
            text = 'x' + String(makeAmount);
            this.drawText(text, dx + Window_Base._iconWidth + 2, dy, dw, 'left');
            text = '(' + $gameParty.getItemAmount($dataArmors[makeId]) + ' ' + Unco.Param.craftDefStocText + ')';
            this.drawText(text, dx + Window_Base._iconWidth + stockIndent, dy, dw, 'left');
            dy += this.lineHeight();
         }
      }
   }
   for (var makeId in skill.makeWeapon) {
      makeId = parseInt(makeId);
      if (!isNaN(makeId) && (makeId > 0)) {
         var makeAmount = parseInt(skill.makeWeapon[makeId]);
         if (!isNaN(makeAmount) &&  (makeAmount > 0)) {
            this.drawIcon($dataWeapons[makeId].iconIndex, dx, dy);
            if (Unco.Param.craftDispNames === 'true') {
               this.drawText($dataWeapons[makeId].name, dx + Window_Base._iconWidth + 2, dy, dw, 'left');
               dy += this.lineHeight();
            }
            text = 'x' + String(makeAmount);
            this.drawText(text, dx + Window_Base._iconWidth + 2, dy, dw, 'left');
            text = '(' + $gameParty.getItemAmount($dataWeapons[makeId]) + ' ' + Unco.Param.craftDefStocText + ')';
            this.drawText(text, dx + Window_Base._iconWidth + stockIndent, dy, dw, 'left');
            dy += this.lineHeight();
         }
      }
   }
   this.resetFontSettings();
   return dy;
};

Window_CraftInfo.prototype.drawComponents = function(dy) {  
   var skill = this._item;
   var indent = 24;
   var stockIndent = indent*3;
   var dx = this.textPadding();
   var dw = this.contents.width - this.textPadding() * 2;
   this.resetFontSettings();
   this.drawDarkRect(dx-indent, dy, dw+indent, this.lineHeight());
   var text = ( (typeof skill.craftCompText !== 'undefined') ? skill.craftCompText : Unco.Param.craftDefCompText);
   this.drawText(text, dx, dy, dw, 'left');
   dy += this.lineHeight(); 
   dx += indent;
   this.contents.fontSize = Unco.Param.craftFontSize;
   var craftLineHeight = Math.max(Unco.Param.craftFontSize,Window_Base._iconHeight)+1;   
	if (typeof skill.goldCost === 'number') {
      this.drawIcon(Unco.Param.goldAmmoIconId, dx, dy);
      if (Unco.Param.craftDispNames === 'true') {
         this.drawText(TextManager.currencyUnit, dx + Window_Base._iconWidth + 2, dy, dw, 'left');
         dy += craftLineHeight;
      }
      var text = 'x' + String(skill.goldCost);
      this.drawText(text, dx + Window_Base._iconWidth + 2, dy, dw, 'left');
      if (skill.goldCost > $gameParty.gold()) this.changeTextColor(this.textColor(Unco.Param.craftFontColorCris));
      text = '(' + $gameParty.gold() + ' ' + Unco.Param.craftDefStocText + ')';
      this.drawText(text, dx + Window_Base._iconWidth + stockIndent, dy, dw, 'left');
      dy += craftLineHeight;
      this.changeTextColor(this.textColor(Unco.Param.craftFontColorNorm));
      this.resetFontSettings();
	}
   for (var ammoId in skill.itemAmmoCost) {
      ammoId = parseInt(ammoId);
      if (!isNaN(ammoId) && (ammoId > 0)) {
         var ammoAmount = parseInt(skill.itemAmmoCost[ammoId]);
         if (!isNaN(ammoAmount) &&  (ammoAmount > 0)) {
            this.drawIcon($dataItems[ammoId].iconIndex, dx, dy);
            if (Unco.Param.craftDispNames === 'true') {
               this.drawText($dataItems[ammoId].name, dx + Window_Base._iconWidth + 2, dy, dw, 'left');
               dy += craftLineHeight;
            }
            this.changeTextColor(this.textColor(Unco.Param.craftFontColorNorm));
            text = 'x' + String(ammoAmount);
            this.drawText(text, dx + Window_Base._iconWidth + 2, dy, dw, 'left');
            if (ammoAmount > $gameParty.getItemAmount($dataItems[ammoId])) this.changeTextColor(this.textColor(Unco.Param.craftFontColorCris));
            text = '(' + $gameParty.getItemAmount($dataItems[ammoId]) + ' ' + Unco.Param.craftDefStocText + ')';
            this.drawText(text, dx + Window_Base._iconWidth + stockIndent, dy, dw, 'left');
            dy += craftLineHeight;
            this.changeTextColor(this.textColor(Unco.Param.craftFontColorNorm));
         }
      }
   }
   for (var ammoId in skill.equipAmmoCost) {
      ammoId = parseInt(ammoId);
      if (!isNaN(ammoId) && (ammoId > 0)) {
         ammoAmount = parseInt(skill.equipAmmoCost[ammoId]);
         if (!isNaN(ammoAmount) && (ammoAmount > 0)) {
            this.drawIcon($dataArmors[ammoId].iconIndex, dx, dy);
            if (Unco.Param.craftDispNames === 'true') {
               this.drawText($dataArmors[ammoId].name, dx + Window_Base._iconWidth + 2, dy, dw, 'left');
               dy += craftLineHeight;
            }
            this.changeTextColor(this.textColor(Unco.Param.craftFontColorNorm));
            text = 'x' + String(ammoAmount);
            this.drawText(text, dx + Window_Base._iconWidth + 2, dy, dw, 'left');
            text = '(' + $gameParty.getItemAmount($dataArmors[ammoId]) + ' ' + Unco.Param.craftDefStocText + ')';
            if (ammoAmount > $gameParty.getItemAmount($dataArmors[ammoId])) this.changeTextColor(this.textColor(Unco.Param.craftFontColorCris));
            this.drawText(text, dx + Window_Base._iconWidth + stockIndent, dy, dw, 'left');
            dy += craftLineHeight;
            this.changeTextColor(this.textColor(Unco.Param.craftFontColorNorm));
         }
      }
   }
   for (var ammoId in skill.weaponAmmoCost) {
      ammoId = parseInt(ammoId);
      if (!isNaN(ammoId) && (ammoId > 0)) {
         ammoAmount = parseInt(skill.weaponAmmoCost[ammoId]);
         if (!isNaN(ammoAmount) && (ammoAmount > 0)) {
            this.drawIcon($dataWeapons[ammoId].iconIndex, dx, dy);
            if (Unco.Param.craftDispNames === 'true') {
               this.drawText($dataWeapons[ammoId].name, dx + Window_Base._iconWidth + 2, dy, dw, 'left');
               dy += craftLineHeight;
            }
            this.changeTextColor(this.textColor(Unco.Param.craftFontColorNorm));
            text = 'x' + String(ammoAmount);
            this.drawText(text, dx + Window_Base._iconWidth + 2, dy, dw, 'left');
            text = '(' + $gameParty.getItemAmount($dataWeapons[ammoId]) + ' ' + Unco.Param.craftDefStocText + ')';
            if (ammoAmount > $gameParty.getItemAmount($dataWeapons[ammoId])) this.changeTextColor(this.textColor(Unco.Param.craftFontColorCris));
            this.drawText(text, dx + Window_Base._iconWidth + stockIndent, dy, dw, 'left');
            dy += craftLineHeight;
            this.changeTextColor(this.textColor(Unco.Param.craftFontColorNorm));
         }
      }
   }
   return dy;
   this.resetFontSettings();
};

Window_CraftInfo.prototype.drawDarkRect = function(dx, dy, dw, dh) {
    var color = this.gaugeBackColor();
    this.changePaintOpacity(false);
    this.contents.fillRect(dx + 1, dy + 1, dw - 2, dh - 2, color);
    this.changePaintOpacity(true);
};

//=============================================================================
// Window_SkillType
//=============================================================================
Unco.CS.Window_SkillType_initialize = Window_SkillType.prototype.initialize;
Window_SkillType.prototype.initialize = function(x, y) {
    Unco.CS.Window_SkillType_initialize.call(this, x, y);
    this._craftWindow = null;
    this._infoWindow = null;
};

Window_SkillType.prototype.setCraftWindows = function(craftWindow,infoWindow) {
    this._craftWindow = craftWindow;
    this._infoWindow  = infoWindow;
    this.update();
};

Unco.CS.Window_SkillType_update = Window_SkillType.prototype.update
Window_SkillType.prototype.update = function() {
    Unco.CS.Window_SkillType_update.call(this);
    if (this._craftWindow) {
        this._craftWindow.setStypeId(this.currentExt());
    }
};

Unco.CS.Window_SkillType_select = Window_SkillType.prototype.select;
Window_SkillType.prototype.select = function(index) {
    Unco.CS.Window_SkillType_select.call(this,index);
    if (this._skillWindow) {
        if (Unco.CS.isCraftSkillType(this.currentExt()) === true) {
           this._skillWindow.hide();
           this._craftWindow.show();
           this._infoWindow.show();
        } else {
           this._skillWindow.show();
           this._craftWindow.hide();
           this._infoWindow.hide();
        }
    }
    console.log('Select:');
    console.log(this._list);
};

//=============================================================================
// Scene_Skill
//=============================================================================

Unco.CS.Scene_Skill_createItemWindow = Scene_Skill.prototype.createItemWindow;
Scene_Skill.prototype.createItemWindow = function() {
    Unco.CS.Scene_Skill_createItemWindow.call(this);
    var wx = 0;
    var wy = this._statusWindow.y + this._statusWindow.height;
    var ww = Graphics.boxWidth/2;
    var wh = Graphics.boxHeight - wy;
    this._craftWindow = new Window_CraftList(wx, wy, ww, wh);
    this._infoWindow  = new Window_CraftInfo(ww, wy, Graphics.boxWidth-ww, wh);
    this._craftWindow.setHelpWindow(this._helpWindow);
    this._craftWindow.setInfoWindow(this._infoWindow);
    this._craftWindow.setHandler('ok',     this.onItemOk.bind(this));
    this._craftWindow.setHandler('cancel', this.onItemCancel.bind(this));
    this._skillTypeWindow.setCraftWindows(this._craftWindow,this._infoWindow);
    this.addWindow(this._craftWindow);
    this.addWindow(this._infoWindow);
    this._craftWindow.hide();
    this._infoWindow.hide();
};

Unco.CS.Scene_Skill_commandSkill = Scene_Skill.prototype.commandSkill;
Scene_Skill.prototype.commandSkill = function() {
    console.log('Command:');
    console.log(this._skillTypeWindow.currentExt());
    if (Unco.CS.isCraftSkillType(this._skillTypeWindow.currentExt())) {
       this._craftWindow.activate();
       this._craftWindow.selectLast();
    } else {
       Unco.CS.Scene_Skill_commandSkill.call(this);       
    }
};

Scene_Skill.prototype.item = Scene_Skill.prototype.item;
Scene_Skill.prototype.item = function() {
    if (this._craftWindow) {
       if (Unco.CS.isCraftSkillType(this._skillTypeWindow.currentExt()) === true) {
          return this._craftWindow.item();
       }       
    }
    return this._itemWindow.item();
};

Unco.CS.Scene_Skill_refreshActor = Scene_Skill.prototype.refreshActor;
Scene_Skill.prototype.refreshActor = function() {
    Unco.CS.Scene_Skill_refreshActor.call(this);
    var actor = this.actor();
    this._craftWindow.setActor(actor);
};

Unco.CS.Scene_Skill_onItemCancel = Scene_Skill.prototype.onItemCancel;
Scene_Skill.prototype.onItemCancel = function() {
    if (Unco.CS.isCraftSkillType(this._skillTypeWindow.currentExt()) === true) {
       this._craftWindow.deselect();
       this._infoWindow.contents.clear();
       this._skillTypeWindow.activate();
    } else {
       Unco.CS.Scene_Skill_onItemCancel.call(this);       
    }
};

Unco.CS.Scene_Skill_useItem = Scene_Skill.prototype.useItem;
Scene_Skill.prototype.useItem = function() {
    Unco.CS.Scene_Skill_useItem.call(this);
    this._infoWindow.refresh();
    this._craftWindow.refresh();
};

Unco.CS.Scene_Skill_activateItemWindow = Scene_Skill.prototype.activateItemWindow;
Scene_Skill.prototype.activateItemWindow = function() {
   if (Unco.CS.isCraftSkillType(this._skillTypeWindow.currentExt()) === true) {
      this._craftWindow.refresh();
      this._craftWindow.activate();
   } else {
      Unco.CS.Scene_Skill_activateItemWindow.call(this);
   }
};

//=============================================================================
// Window_Help
//=============================================================================
Unco.CS.Window_Help_getAmmoAmountText = Window_Help.prototype.getAmmoAmountText;
Window_Help.prototype.getAmmoAmountText = function(item) {
   if (typeof item !== 'undefined') {
      if ((typeof item.ammoText !== "undefined") && (item.ammoText !== "")) {
         return Unco.CS.Window_Help_getAmmoAmountText.call(this,item);
      }
      if (Unco.CS.isCraftSkillType(item.stypeId)) {
         return '';
      }
      return Unco.CS.Window_Help_getAmmoAmountText.call(this,item);
   }
   return '';
};

//=============================================================================
//=============================================================================
// Only try to do anything is Ammunition System is there !!!
}
//=============================================================================
//=============================================================================