 /*:
 * @plugindesc 阵型系统与换人系统。
 * @author RyoSonic
 *
 * @param Max States
 * @desc 需要受到干预的最多状态。
 * @default 13
 *
 * @param Max Elements
 * @desc 需要受到干预的最多抗性。
 * @default 13
 *
 * @param List Window X
 * @desc 阵型选择窗口X轴。
 * @default 80
 *
 * @param List Window Y
 * @desc 阵型选择窗口Y轴。
 * @default 180
 *
 * @param List Layout X
 * @desc 阵型选择装饰X轴。
 * @default -33
 *
 * @param List Layout Y
 * @desc 阵型选择装饰Y轴。
 * @default -56
 *
 * @param Help Window X
 * @desc 阵型帮助窗口X轴。
 * @default 580
 *
 * @param Help Window Y
 * @desc 阵型帮助窗口Y轴。
 * @default 60
 *
 * @param Command Window X
 * @desc 阵型帮助窗口X轴。
 * @default 120
 *
 * @param Command Window Y
 * @desc 阵型帮助窗口Y轴。
 * @default 100
 *
 * @param Help Layout X
 * @desc 阵型帮助窗口X轴。
 * @default -85
 *
 * @param Help Layout Y
 * @desc 阵型帮助窗口Y轴。
 * @default -50
 *
 * @param Help Width
 * @desc 阵型帮助窗口宽度。
 * @default 376
 *
 * @param Help Height
 * @desc 阵型帮助窗口高度。
 * @default 180
 *
 * @param Exp Layout X
 * @desc 经验值装饰位置X。
 * @default 700
 *
 * @param Exp Layout Y
 * @desc 经验值装饰位置Y。
 * @default 510
 *
 * @param Exp Meter X
 * @desc 经验值条码位置X。
 * @default 35
 *
 * @param Exp Meter Y
 * @desc 经验值条码位置Y。
 * @default 45
 *
 * @param Exp Name X
 * @desc 目前选择阵型名称X。
 * @default 150
 *
 * @param Exp Name Y
 * @desc 目前选择阵型名称Y。
 * @default 57
 *
 * @param Icon Split
 * @desc 命令图标间隔。
 * @default 140
 *
 * @param Xparam 1
 * @desc Xparam的名字。
 * @default 命中率
 *
 * @param Xparam 2
 * @desc Xparam的名字。
 * @default 回避率
 *
 * @param Xparam 3
 * @desc Xparam的名字。
 * @default 暴击率
 *
 * @param Xparam 4
 * @desc Xparam的名字。
 * @default 暴击回避率
 *
 * @param Xparam 5
 * @desc Xparam的名字。
 * @default 魔法回避率
 *
 * @param Xparam 6
 * @desc Xparam的名字。
 * @default 魔法反射率
 *
 * @param Xparam 7
 * @desc Xparam的名字。
 * @default 反击率
 *
 * @param Xparam 8
 * @desc Xparam的名字。
 * @default HP自动回复率
 *
 * @param Xparam 9
 * @desc Xparam的名字。
 * @default MP自动回复率
 *
 * @param Xparam 10
 * @desc Xparam的名字。
 * @default TP自动回避率
 *
 * @param Sparam 1
 * @desc Sparam的名字。
 * @default 受到攻击几率
 *
 * @param Sparam 2
 * @desc Sparam的名字。
 * @default 防御效果
 *
 * @param Sparam 3
 * @desc Sparam的名字。
 * @default 恢复效果
 *
 * @param Sparam 4
 * @desc Sparam的名字。
 * @default 药理学知识
 *
 * @param Sparam 5
 * @desc Sparam的名字。
 * @default MP消耗率
 *
 * @param Sparam 6
 * @desc Sparam的名字。
 * @default TP消耗率
 *
 * @param Sparam 7
 * @desc Sparam的名字。
 * @default 物理伤害
 *
 * @param Sparam 8
 * @desc Sparam的名字。
 * @default 魔法伤害
 *
 * @param Sparam 9
 * @desc Sparam的名字。
 * @default 地形伤害
 *
 * @param Sparam 10
 * @desc Sparam的名字。
 * @default 经验值
 * @help
 */

var Imported = Imported || {};
Imported.Ryo_BattleForm = true;

var Ryo = Ryo || {};  
Ryo.Battleform = Ryo.Battleform || {};

//=============================================================================
// 读取Formation.json数据
//=============================================================================
Ryo.Battleform.file = {};

Ryo.Battleform.file.getString = function(filePath) {
    var request = new XMLHttpRequest();
    request.open("GET", filePath);
    request.overrideMimeType('application/json');
    request.onload = function() {
	if (request.status < 400) {
	    Ryo.Battleform.createForm(request.responseText);
	}
    };
    request.send();
};

Ryo.Battleform.createForm = function(string) {
    var lines = string.split(/[\r\n]+/);
    var FormNum = 0;
    var record = false;
    var PosRecord = false;
    var BonusRecord = false;
    var HelpRecord = false;
    Ryo.Battleform.formInfo = {};
    Ryo.Battleform.formNum = 0;
    for (i = 0; i < lines.length; i++) {
	if (lines[i].match(/<\/(?:BATTLE FORMATION)>/i)) {
	    record = false;
	} else if (lines[i].match(/<(?:BATTLE FORMATION(.*):(.*))>/i)) {
            record = true;
            Ryo.Battleform.formNum += 1;
	    var Fid = lines[i].match(/<(?:BATTLE FORMATION (.*):(.*))>/i);
            FormNum = Number(Fid[1]);
	    Ryo.Battleform.formInfo[FormNum] = {};
	    var s = Fid[2].split('|');
	    Ryo.Battleform.formInfo[FormNum].name = s[0] || '???';
	    Ryo.Battleform.formInfo[FormNum].maxMembers = Number(s[1]) || 4;
	    Ryo.Battleform.formInfo[FormNum].maxLevel = Number(s[2]) || 4;		
	} else if (record) {
	    if (lines[i].match(/<(?:LEVEL EXP|level exp):[ ]*(\d+(?:\s*,\s*\d+)*)>/i)) {
                Ryo.Battleform.formInfo[FormNum].exp = JSON.parse('[' + RegExp.$1.match(/\d+/g) + ']');  
            } else if (lines[i].match(/<\/(?:POSITION)>/i)) {
                PosRecord = false;
            } else if (lines[i].match(/<(?:POSITION)>/i)) {
                PosRecord = true;
                Ryo.Battleform.formInfo[FormNum].position = [];
            } else if (PosRecord) {
                Ryo.Battleform.formInfo[FormNum].position.push(lines[i]);
            } else if (lines[i].match(/<\/(?:BONUS)>/i)) {
                BonusRecord = false
            } else if (lines[i].match(/<(?:BONUS)>/i)) {
                BonusRecord = true;
                Ryo.Battleform.formInfo[FormNum].bonus = [];
            } else if (BonusRecord) {
                Ryo.Battleform.formInfo[FormNum].bonus.push(lines[i]);
            } else if (lines[i].match(/<\/(?:HELP)>/i)) {
                HelpRecord = false;
            } else if (lines[i].match(/<(?:HELP)>/i)) {
                HelpRecord = true;
                Ryo.Battleform.formInfo[FormNum].description = [];
            } else if (HelpRecord) {
                Ryo.Battleform.formInfo[FormNum].description += lines[i] + '\n'
            }
	}
    };
};

Ryo.Battleform.fileName = function() {
    if (!Ryo.Battleform.formInfo) {
	var folder = 'data/Formation';
	Ryo.Battleform.file.getString(folder + ".json");
    };
}

Ryo.parameters = PluginManager.parameters('Ryo_BattleForm'); 
Ryo.Battleform.maxState = Number(Ryo.parameters['Max States'])
Ryo.Battleform.maxElement = Number(Ryo.parameters['Max Elements'])
Ryo.Battleform.listWindowX = Number(Ryo.parameters['List Window X'])
Ryo.Battleform.listWindowY = Number(Ryo.parameters['List Window Y'])
Ryo.Battleform.listLayoutX = Number(Ryo.parameters['List Layout X'])
Ryo.Battleform.listLayoutY = Number(Ryo.parameters['List Layout Y'])
Ryo.Battleform.helpWindowX = Number(Ryo.parameters['Help Window X'])
Ryo.Battleform.helpWindowY = Number(Ryo.parameters['Help Window Y'])
Ryo.Battleform.commandWindowX = Number(Ryo.parameters['Command Window X'])
Ryo.Battleform.commandWindowY = Number(Ryo.parameters['Command Window Y'])
Ryo.Battleform.helpLayoutX = Number(Ryo.parameters['Help Layout X'])
Ryo.Battleform.helpLayoutY = Number(Ryo.parameters['Help Layout Y'])
Ryo.Battleform.helpWidth = Number(Ryo.parameters['Help Width'])
Ryo.Battleform.helpHeight = Number(Ryo.parameters['Help Height'])
Ryo.Battleform.expLayoutX = Number(Ryo.parameters['Exp Layout X'])
Ryo.Battleform.expLayoutY = Number(Ryo.parameters['Exp Layout Y'])
Ryo.Battleform.expMeterX = Number(Ryo.parameters['Exp Meter X'])
Ryo.Battleform.expMeterY = Number(Ryo.parameters['Exp Meter Y'])
Ryo.Battleform.expNameX = Number(Ryo.parameters['Exp Name X'])
Ryo.Battleform.expNameY = Number(Ryo.parameters['Exp Name Y'])
Ryo.Battleform.iconSplit = Number(Ryo.parameters['Icon Split'])

Ryo.Battleform.xparamName = []; 
Ryo.Battleform.sparamName = [];   
for (var i = 0; i < 10; i++) {
    Ryo.Battleform.xparamName[i] = String(Ryo.parameters['Xparam ' + String(i + 1)]);
    Ryo.Battleform.sparamName[i] = String(Ryo.parameters['Sparam ' + String(i + 1)]);
};

//=============================================================================
// DataManager
//=============================================================================
Ryo.Battleform._DataManager_isDatabaseLoaded = DataManager.isDatabaseLoaded;
DataManager.isDatabaseLoaded = function() {
    if (!Ryo.Battleform._DataManager_isDatabaseLoaded.call(this)) return false;
    if (!Ryo.Battleform._finish) {
        Ryo.Battleform.fileName(); 
        Ryo.Battleform._finish = true;
    }
    return true;  
}

//=============================================================================
// ImageManager
//=============================================================================
ImageManager.loadForm = function(filename) {
    return this.loadBitmap('img/formation/', filename, 0, true);
};

//=============================================================================
// 插件命令
//=============================================================================
Ryo.Battleform.Game_Interpreter_pluginCommand = Game_Interpreter.prototype.pluginCommand;
Game_Interpreter.prototype.pluginCommand = function(command, args) {
    Ryo.Battleform.Game_Interpreter_pluginCommand.call(this, command, args);
    if (command === 'learn_formation') {
        $gameSystem._learnForm[Number(args[0])][0] = 1;
        return true;
    }
    if (command === 'set_formation') {
        $gameSystem._learnForm[Number(args[0])][2] = eval(args[1]);
        return true;
    }
    if (command === 'lock_actor') {
        var num = args[0].split(',');
        for (i = 0; i < num.length; i++) $gameSystem._lockedMember.push(Number(num[i]));
        return true;
    }
    if (command === 'use_formation') {
        $gameSystem._formationId = Number(args[0]);
        $gameParty.getFormation();
        return true;
    }
};

//=============================================================================
// 设定人物站位
//=============================================================================
Sprite_Actor.prototype.setActorHome = function(index) {
    var maxId = $gameParty.battleMembers().length - 1;
    var position = Ryo.Battleform.formInfo[$gameSystem._formationId].position[maxId].split('|')
    var pos = position[index].split(',')
    this.setHome(Number(pos[0]), Number(pos[1]));
};

//=============================================================================
// 设置队形升级
//=============================================================================
var _ryo_form_BattleManager_processVictory = BattleManager.processVictory;
BattleManager.processVictory = function() {
    _ryo_form_BattleManager_processVictory.call(this);
    if ($gameSystem._formationId > 0 && $gameSystem._learnForm[$gameSystem._formationId][0] < Ryo.Battleform.formInfo[$gameSystem._formationId].maxLevel) {
        $gameSystem._learnForm[$gameSystem._formationId][1] += 1;
        if ($gameSystem._learnForm[$gameSystem._formationId][1] >= Ryo.Battleform.formInfo[$gameSystem._formationId].exp[$gameSystem._learnForm[$gameSystem._formationId][0] - 1]) {
            $gameSystem._learnForm[$gameSystem._formationId][1] = 0;
            $gameSystem._learnForm[$gameSystem._formationId][0] += 1;
        }
    }
}

//=============================================================================
// 记录队形变化与经验值
//=============================================================================
var _ryo_form_game_system_initalize = Game_System.prototype.initialize;
Game_System.prototype.initialize = function() {
    _ryo_form_game_system_initalize.call(this);
    this._formationId = 0;
    this._learnForm = [];
    this._learnForm[0] = [1, 0, true];
    for (i = 1; i < Ryo.Battleform.formNum; i++) this._learnForm[i] = [0, 0, true];
    this._lockedMember = []; 
}

//=============================================================================
// 设置人物因队形收益
//=============================================================================
var _ryo_form_game_actor_initMembers = Game_Actor.prototype.initMembers
Game_Actor.prototype.initMembers = function() {
    _ryo_form_game_actor_initMembers.call(this);
    this.cleanFormBonus();
}

Game_Actor.prototype.cleanFormBonus = function() {
    this._paramForm = [1,1,1,1,1,1,1,1];
    this._xparamForm = [0,0,0,0,0,0,0,0,0,0];
    this._sparamForm = [1,1,1,1,1,1,1,1,1,1];
    this._eleRateForm = []
    for (i = 0; i < Ryo.Battleform.maxElement; i++) {
        this._eleRateForm[i] = 1;
    }
    this._stateRateForm = []
    for (i = 0; i < Ryo.Battleform.maxState; i++) {
        this._stateRateForm[i] = 1;
    }
}

Game_Actor.prototype.getParam = function() {
    this._paramForm = [1,1,1,1,1,1,1,1];
    if (this.index() >= Ryo.Battleform.formInfo[$gameSystem._formationId].bonus.length) return;
    var info = Ryo.Battleform.formInfo[$gameSystem._formationId].bonus[this.index()].split('|')
    if (info[0] === undefined || info[0] === '') return;
    var param = info[0].split(',')
    for (i = 0; i < param.length; i++) {
        var bonus = param[i].split(':')
        this._paramForm[Number(bonus[0])] = Number(bonus[$gameSystem._learnForm[$gameSystem._formationId][0]]);
    }
}

Game_Actor.prototype.param = function(paramId) {
    var value = this.paramBase(paramId) + this.paramPlus(paramId);
    value *= this.paramRate(paramId) * this.paramBuffRate(paramId);
    value *= this._paramForm[paramId];
    var maxValue = this.paramMax(paramId);
    var minValue = this.paramMin(paramId);
    return Math.round(value.clamp(minValue, maxValue));
};

Game_Actor.prototype.getXParam = function() {
    this._xparamForm = [0,0,0,0,0,0,0,0,0,0];
    if (this.index() >= Ryo.Battleform.formInfo[$gameSystem._formationId].bonus.length) return;
    var info = Ryo.Battleform.formInfo[$gameSystem._formationId].bonus[this.index()].split('|')
    if (info[1] === undefined || info[1] === '') return;
    var param = info[1].split(',')
    for (i = 0; i < param.length; i++) {
        var bonus = param[i].split(':')
        this._xparamForm[Number(bonus[0])] = Number(bonus[$gameSystem._learnForm[$gameSystem._formationId][0]]);
    }
}

var _ryo_form_Game_Actor_xparam = Game_Actor.prototype.xparam;
Game_Actor.prototype.xparam = function(xparamId) {
    return _ryo_form_Game_Actor_xparam.call(this, xparamId) + this._xparamForm[xparamId];
};

Game_Actor.prototype.getSParam = function() {
    this._sparamForm = [1,1,1,1,1,1,1,1,1,1];
    if (this.index() >= Ryo.Battleform.formInfo[$gameSystem._formationId].bonus.length) return;
    var info = Ryo.Battleform.formInfo[$gameSystem._formationId].bonus[this.index()].split('|')
    if (info[2] === undefined || info[2] === '') return;
    var param = info[2].split(',')
    for (i = 0; i < param.length; i++) {
        var bonus = param[i].split(':')
        this._sparamForm[Number(bonus[0])] = Number(bonus[$gameSystem._learnForm[$gameSystem._formationId][0]]);
    }
}

var _ryo_form_Game_Actor_sparam = Game_Actor.prototype.sparam;
Game_Actor.prototype.sparam = function(sparamId) {
    return _ryo_form_Game_Actor_sparam.call(this, sparamId) * this._sparamForm[sparamId];
};

Game_Actor.prototype.getEleRate = function() {
    for (i = 0; i < Ryo.Battleform.maxElement; i++) {
        this._eleRateForm[i] = 1;
    }
    if (this.index() >= Ryo.Battleform.formInfo[$gameSystem._formationId].bonus.length) return;
    var info = Ryo.Battleform.formInfo[$gameSystem._formationId].bonus[this.index()].split('|')
    if (info[3] === undefined || info[3] === '') return;
    var param = info[3].split(',')
    for (i = 0; i < param.length; i++) {
        var bonus = param[i].split(':')
        this._eleRateForm[Number(bonus[0]) - 1] = Number(bonus[$gameSystem._learnForm[$gameSystem._formationId][0]]);
    }
}

var _ryo_form_Game_Actor_elementRate = Game_Actor.prototype.elementRate;
Game_Actor.prototype.elementRate = function(elementId) {
    if (elementId > Ryo.Battleform.maxElement) {
        return _ryo_form_Game_Actor_elementRate.call(this, elementId);
    }
    return _ryo_form_Game_Actor_elementRate.call(this, elementId) * this._eleRateForm[elementId - 1];
};

Game_Actor.prototype.getStateRate = function() {
    for (i = 0; i < Ryo.Battleform.maxState; i++) {
        this._stateRateForm[i] = 1;
    }
    if (this.index() >= Ryo.Battleform.formInfo[$gameSystem._formationId].bonus.length) return;
    var info = Ryo.Battleform.formInfo[$gameSystem._formationId].bonus[this.index()].split('|')
    if (info[4] === undefined) return;
    var param = info[4].split(',')
    for (i = 0; i < param.length; i++) {
        var bonus = param[i].split(':')
        this._stateRateForm[Number(bonus[0]) - 1] = Number(bonus[$gameSystem._learnForm[$gameSystem._formationId][0]]);
    }
}

var _ryo_form_Game_Actor_stateRate = Game_Actor.prototype.stateRate;
Game_Actor.prototype.stateRate = function(stateId) {
    if (stateId > Ryo.Battleform.maxState) {
        return _ryo_form_Game_Actor_stateRate.call(this, stateId);
    }
    return _ryo_form_Game_Actor_stateRate.call(this, stateId) * this._stateRateForm[stateId - 1];
};

//=============================================================================
// 设置队伍增减时队形变化
//=============================================================================
Game_Actor.prototype.getFormation = function() {
    this.getParam();
    this.getXParam();
    this.getSParam();
    this.getStateRate();
    this.getEleRate();
}

Game_Party.prototype.getFormation = function() {
    this.members().forEach(function(battler) {
        battler.cleanFormBonus();
    }, this);
    this.battleMembers().forEach(function(battler) {
        battler.getFormation();
    }, this);
};

var _ryo_form_Game_Party_addActor = Game_Party.prototype.addActor;
Game_Party.prototype.addActor = function(actorId) {
    _ryo_form_Game_Party_addActor.call(this, actorId);
    this.getFormation();
};

var _ryo_form_Game_Party_removeActor = Game_Party.prototype.removeActor;
Game_Party.prototype.removeActor = function(actorId) {
    _ryo_form_Game_Party_removeActor.call(this, actorId);
    this.getFormation();
};

var _ryo_form_Game_Party_swapOrder = Game_Party.prototype.swapOrder;
Game_Party.prototype.swapOrder = function(index1, index2) {
    _ryo_form_Game_Party_swapOrder.call(this, index1, index2);
    this.getFormation();
};

//=============================================================================
// 设置换人界面。
//=============================================================================
Window_MenuStatus.prototype.windowWidth = function() {
    return 370;
};

Window_MenuStatus.prototype.windowHeight = function() {
    return 392;
};

Window_MenuStatus.prototype.numVisibleRows = function() {
    return 4;
};

Window_MenuStatus.prototype.processOk = function() {
    if (this.isCurrentItemEnabled()) {
        this.updateInputData();
        this.deactivate();
        this.callOkHandler();
    } else {
        this.playBuzzerSound();
    }
    $gameParty.setMenuActor($gameParty.members()[this.index()]);
};

Window_MenuStatus.prototype.drawItem = function(index) {
    this.contents.clear();
    this.drawItemBackground(index);
    this.removeChild(this._face);
    this._face = new Sprite()
    this.addChild(this._face);
    this._faceIcon = []
    for (i = 0; i < this.maxItems(); i++) {
        var actor = $gameParty.members()[i];
        this._faceIcon[i] = new Sprite(ImageManager.loadMenusFaces1('Actor_' + actor._actorId))
        this._faceIcon[i].scale.x = 0.8;
        this._faceIcon[i].scale.y = 0.8;
        this._faceIcon[i].x = this.standardPadding();
        this._faceIcon[i].y = i * 90 + this.standardPadding();
        this._face.addChild(this._faceIcon[i]);
        if (i < $gameParty.maxBattleMembers()) this._faceIcon[i].opacity = 255;
        else this._faceIcon[i].opacity = 128;
        this.changePaintOpacity(i < $gameParty.maxBattleMembers())
        this.drawActorName(actor, this._faceIcon[i].bitmap.width, i * 90, this.windowWidth())
        this.drawActorClass(actor, this._faceIcon[i].bitmap.width, i * 90 + 40, this.windowWidth())
        this.changePaintOpacity(true)
    }
};

//=============================================================================
// 阵型列表
//=============================================================================
function Window_FormList() {
    this.initialize.apply(this, arguments);
}

Window_FormList.prototype = Object.create(Window_Selectable.prototype);
Window_FormList.prototype.constructor = Window_FormList;

Window_FormList.prototype.initialize = function(x, y) {
    this._list = [];
    this._formIndex = [];
    var width = this.windowWidth();
    var height = this.windowHeight();
    Window_Selectable.prototype.initialize.call(this, x, y, width, height);
    this.refresh();
};

Window_FormList.prototype.processOk = function() {
    if (this.isCurrentItemEnabled()) {
        this.updateInputData();
        this.deactivate();
        this.callOkHandler();
    } else {
        this.playBuzzerSound();
    }
    $gameParty.setMenuActor($gameParty.members()[this.index()]);
};

Window_FormList.prototype.windowWidth = function() {
    return 370;
};

Window_FormList.prototype.windowHeight = function() {
    return 392;
};

Window_FormList.prototype.maxCols = function() {
    return 1;
};

Window_FormList.prototype.updateHelp = function() {
    this.setHelpWindowItem(this._list[this.index()]);
};

Window_FormList.prototype.maxItems = function() {
    return this._list.length;
};

Window_FormList.prototype.listIndex = function() {
    return this._list[this.index()];
};

Window_FormList.prototype.drawItem = function(index) {
    this.resetTextColor();
    this.changePaintOpacity(this.isEnabled(index));
    var name = this._list[index].name;
    var rect = this.itemRectForText(index);
    this.drawText(name, rect.x, rect.y, rect.width);
    this.changePaintOpacity(true);
}

Window_FormList.prototype.show = function() {
    this.refresh();
    Window_Selectable.prototype.show.call(this);
};

Window_FormList.prototype.refresh = function() {
    this._list = [];
    for (i = 0; i < $gameSystem._learnForm.length; i++) {
        if ($gameSystem._learnForm[i][0] > 0) {
            this._list.push(Ryo.Battleform.formInfo[i])
            this._formIndex.push(i)
        }
    }
    Window_Selectable.prototype.refresh.call(this);
};

Window_FormList.prototype.isCurrentItemEnabled = function() {
    return this.isEnabled(this.index())
};

Window_FormList.prototype.isEnabled = function(index) {
    if (this._list[index].maxMembers > $gameParty.battleMembers().length) return false
    return $gameSystem._learnForm[this._formIndex[index]][2]; 
};

//=============================================================================
// 命令设置
//=============================================================================
function Window_FormCommand() {
    this.initialize.apply(this, arguments);
}

Window_FormCommand.prototype = Object.create(Window_HorzCommand.prototype);
Window_FormCommand.prototype.constructor = Window_FormCommand;

Window_FormCommand.prototype.initialize = function() {
    Window_HorzCommand.prototype.initialize.call(this, 0, 0);
    this.createCommandIcon();
};

Window_FormCommand.prototype.windowWidth = function() {
    return 0;
};

Window_FormCommand.prototype.maxCols = function() {
    return 2;
};

Window_FormCommand.prototype.createCommandIcon = function () {
    this.removeChild(this._command)
    this._command = new Sprite();
    this.addChild(this._command);
    this._com = [];
    for (i = 0; i < 2; i++) {
        this._com[i] = new Sprite(ImageManager.loadForm('Com_' + i));
        this._com[i].x = i * Ryo.Battleform.iconSplit;
        this._command.addChild(this._com[i])
        if (i === this._index) this._com[i].setBlendColor([255,255,255,128]);
        else this._com[i].setBlendColor([255,255,255,0]);
    }
}

Window_FormCommand.prototype.makeCommandList = function() {
    this.addCommand('更换队员',    'member');
    this.addCommand('更换阵型',  'formation');
};

Window_FormCommand.prototype.cursorLeft = function() {
    Window_HorzCommand.prototype.cursorLeft.call(this);
    this.createCommandIcon();
}

Window_FormCommand.prototype.cursorRight = function() {
    Window_HorzCommand.prototype.cursorRight.call(this);
    this.createCommandIcon();
}

//=============================================================================
// 帮助设置
//=============================================================================
function Window_FormHelp() {
    this.initialize.apply(this, arguments);
}

Window_FormHelp.prototype = Object.create(Window_Base.prototype);
Window_FormHelp.prototype.constructor = Window_FormHelp;

Window_FormHelp.prototype.initialize = function() {
    var width = Graphics.boxWidth;
    var height = Graphics.boxHeight;
    Window_Base.prototype.initialize.call(this, 0, 0, width, height);
    this.contents.height = Graphics.boxHeight;
    this._text = '';
};

Window_FormHelp.prototype.standardFontSize = function() {
    return 20;
};

Window_FormHelp.prototype.setText = function(text) {
    if (this._text !== text) {
        this._text = text;
        this.refresh();
    }
};

Window_FormHelp.prototype.clear = function() {
    this.setText('');
};

Window_FormHelp.prototype.setItem = function(item) {
    this.setText(item ? item.description : '');
};

Window_FormHelp.prototype.refresh = function() {
    this.contents.clear();
    this.drawTextEx(this._text, this.textPadding(), 0);
};

//=============================================================================
// 菜单队形设置
//=============================================================================
Scene_Menu.prototype.commandFormation = function() {
    SceneManager.push(Scene_Party);
};

Window_MenuCommand.prototype.isFormationEnabled = function() {
    return $gameSystem.isFormationEnabled();
};

//=============================================================================
// ** Party界面设置
//=============================================================================
function Scene_Party() {
    this.initialize.apply(this, arguments);
}

Scene_Party.prototype = Object.create(Scene_MenuBase.prototype);
Scene_Party.prototype.constructor = Scene_Party;

Scene_Party.prototype.initialize = function() {
    Scene_MenuBase.prototype.initialize.call(this);
    this._flow = 0;
};

Scene_Party.prototype.createBackground = function() {
    Scene_MenuBase.prototype.createBackground.call(this);
    this._field = new Sprite();
    this.addChild(this._field);	
};

Scene_Party.prototype.create = function() {
    Scene_MenuBase.prototype.create.call(this);
    this.createLayout();
    this.createHelpLayout();
    this.createHelpWindow();
    this.createCommandWindow();
    this.createStatusWindow();
    this.createFormWindow();
    this.createFormLayout();
    this.createActorSprites();
    this.createExpLayout();
    this.createExpMeter();
    this.createExpName();
};

Scene_Party.prototype.createLayout = function() {
    this._layout = new Sprite(ImageManager.loadForm("Layout"));
    this._field.addChild(this._layout);
};

Scene_Party.prototype.createHelpWindow = function() {
    this._helpWindow = new Window_FormHelp();
    this._helpWindow.x = Ryo.Battleform.helpWindowX
    this._helpWindow.y = Ryo.Battleform.helpWindowY
    this._helpWindow.width = Ryo.Battleform.helpWidth;
    this._helpWindow.height = Ryo.Battleform.helpHeight;
    this.addWindow(this._helpWindow);
    this._helpWindow.hide();
    this._helpWindow.opacity = 0;
};

Scene_Party.prototype.createCommandWindow = function() {
    this._commandWindow = new Window_FormCommand(0, 0);
    this._commandWindow.x = Ryo.Battleform.commandWindowX;
    this._commandWindow.y = Ryo.Battleform.commandWindowY;
    this._commandWindow.setHandler('member',     this.onCommandMember.bind(this));
    this._commandWindow.setHandler('formation',     this.onCommandFormation.bind(this));
    this._commandWindow.setHandler('cancel', this.onCommandCancel.bind(this));
    this.addWindow(this._commandWindow);
};

Scene_Party.prototype.createStatusWindow = function() {
    this._statusWindow = new Window_MenuStatus(Ryo.Battleform.listWindowX, Ryo.Battleform.listWindowY);
    this._statusWindow.setHandler('ok',     this.onFormationOk.bind(this));
    this._statusWindow.setHandler('cancel', this.onFormationCancel.bind(this));
    this.addWindow(this._statusWindow);
    this._statusWindow.hide();
    this._statusWindow.opacity = 0;
};

Scene_Party.prototype.createFormWindow = function() {
    this._listWindow = new Window_FormList(Ryo.Battleform.listWindowX, Ryo.Battleform.listWindowY);
    this._listWindow.setHandler('ok',     this.onListOk.bind(this));
    this._listWindow.setHandler('cancel', this.onListCancel.bind(this));
    this._listWindow.setHelpWindow(this._helpWindow);
    this.addWindow(this._listWindow);
    this._listWindow.hide();
    this._listWindow.opacity = 0;
};

Scene_Party.prototype.createActorSprites = function() {
    this.removeChild(this._actorSprites)
    this._actorSprites = new Sprite();
    this.addChild(this._actorSprites)
    this._actorPos = [];
    this._actorBonus = []
    var paramus = 0
    for (b = 0; b < $gameParty.battleMembers().length; b++) {
        paramus += $gameParty.battleMembers()[b].sparam(0);
    }
    var maxId = $gameParty.battleMembers().length;
    var position = Ryo.Battleform.formInfo[$gameSystem._formationId].position[maxId - 1].split('|')
    for (var i = 0; i < maxId; i++) {
        var pos = position[i].split(',')
        var actor = $gameParty.battleMembers()[i];
        this._actorPos[i] = new Sprite_Actor(actor);
        var x = Number(pos[0]);
        var y = Number(pos[1]);
        this._actorPos[i].setHome(x,y);
        this._actorPos[i].update();
        this._actorSprites.addChild(this._actorPos[i]);
        this._actorBonus[i] = new Sprite(new Bitmap(Graphics.boxWidth, Graphics.boxHeight))
        var param = $gameParty.battleMembers()[i]._paramForm;
        var xparam = $gameParty.battleMembers()[i]._xparamForm;
        var sparam = $gameParty.battleMembers()[i]._sparamForm;
        var eleRate = $gameParty.battleMembers()[i]._eleRateForm;
        var stateRate = $gameParty.battleMembers()[i]._stateRateForm;
        var line = 1;
        this._actorBonus[i].bitmap.fontSize = 16;
        text = Ryo.Battleform.sparamName[0] + ': ' + Math.ceil(($gameParty.battleMembers()[i].sparam(0) / paramus) * 100) + '%'
        this._actorBonus[i].bitmap.drawText(text, x, y, 200, 20, 'left')
        for (a = 0; a < param.length; a++) {
            if (param[a] != 1) {
                intext = param[a] > 1 ? '+' : ''
                text = TextManager.param(a) + ': ' + intext + Math.ceil((param[a] - 1) * 100) + '%'
                this._actorBonus[i].bitmap.drawText(text, x, y + line * 20, 200, 20, 'left')
                line += 1;
            }
        }
        for (a = 0; a < xparam.length; a++) {
            if (xparam[a] != 0) {
                intext = xparam[a] > 0 ? '+' : ''
                text =  Ryo.Battleform.xparamName[a] + ': ' + intext + xparam[a] + '%';
                this._actorBonus[i].bitmap.drawText(text, x, y + line * 20, 200, 20, 'left')
                line += 1;
            }
        }
        for (a = 1; a < sparam.length; a++) {
            if (sparam[a] != 1) {
                intext = sparam[a] > 1 ? '+' : ''
                text =  Ryo.Battleform.sparamName[a] + ': ' + intext + Math.ceil((sparam[a] - 1) * 100) + '%'
                this._actorBonus[i].bitmap.drawText(text, x, y + line * 20, 200, 20, 'left')
                line += 1;
            }
        }
        for (a = 0; a < Ryo.Battleform.maxElement; a++) {
            if (eleRate[a] != 1) {
                intext = 1 - eleRate[a] > 0 ? '+' : ''
                text = $dataSystem.elements[a + 1] + '耐性: ' + intext + Math.ceil((1 - eleRate[a]) * 100) + '%'
                this._actorBonus[i].bitmap.drawText(text, x, y + line * 20, 200, 20, 'left')
                line += 1;
            }
        }
        for (a = 0; a < Ryo.Battleform.maxState; a++) {
            if (stateRate[a] != 1) {
                intext = 1 - stateRate[a] > 0 ? '+' : ''
                text = $dataStates[a + 1].name + '耐性: ' + intext + Math.ceil((1 - stateRate[a]) * 100) + '%'
                this._actorBonus[i].bitmap.drawText(text, x, y + line * 20, 200, 20, 'left')
                line += 1;
            }
        }
        this._actorSprites.addChild(this._actorBonus[i]);
    }
};

Scene_Party.prototype.createExpLayout = function() {
    this._exp = new Sprite(ImageManager.loadForm('ExpLayout'))
    this._exp.x = Ryo.Battleform.expLayoutX;
    this._exp.y = Ryo.Battleform.expLayoutY;
    this._field.addChild(this._exp)
}

Scene_Party.prototype.createExpMeter = function() {
    this._field.removeChild(this._expMeter);
    this._expMeter = new Sprite(ImageManager.loadForm('ExpMeter'))
    this._expMeter.x = Ryo.Battleform.expLayoutX + Ryo.Battleform.expMeterX;
    this._expMeter.y = Ryo.Battleform.expLayoutY + Ryo.Battleform.expMeterY;
    this._field.addChild(this._expMeter)
    this.refreshMeter();
}

Scene_Party.prototype.createExpName = function() {
    this._expName = new Sprite(new Bitmap(200, 40))
    this._expName.x = Ryo.Battleform.expLayoutX + Ryo.Battleform.expNameX;
    this._expName.y = Ryo.Battleform.expLayoutY + Ryo.Battleform.expNameY;
    this._field.addChild(this._expName)
    this.refreshMeter();
}

Scene_Party.prototype.createHelpLayout = function() {
    this._helpLayout = new Sprite(ImageManager.loadForm('HelpLayout'))
    this._helpLayout.x = Ryo.Battleform.helpWindowX + Ryo.Battleform.helpLayoutX;
    this._helpLayout.y = Ryo.Battleform.helpWindowY + Ryo.Battleform.helpLayoutY;
    this._field.addChild(this._helpLayout)
    this._helpLayout.opacity = 0;
}

Scene_Party.prototype.createFormLayout = function() {
    this._formLayout = new Sprite(ImageManager.loadForm('FormLayout'))
    this._formLayout.x = Ryo.Battleform.listWindowX + Ryo.Battleform.listLayoutX;
    this._formLayout.y = Ryo.Battleform.listWindowY + Ryo.Battleform.listLayoutY;
    this._field.addChild(this._formLayout)
    this._formLayout.opacity = 0;
}

Scene_Party.prototype.onCommandMember = function() {
    this._commandWindow.deactivate();
    this._statusWindow.activate();
    this._statusWindow.select(0);
    this._statusWindow.show();
    this._formLayout.opacity = 255;
};

Scene_Party.prototype.onCommandFormation = function() {
    this._commandWindow.deactivate();
    this._listWindow.activate();
    this._listWindow.select(this._listWindow._formIndex.indexOf($gameSystem._formationId));
    this._listWindow.show();
    this._helpWindow.show();
    this._helpLayout.opacity = 255;
    this._formLayout.opacity = 255;
};

Scene_Party.prototype.onCommandCancel = function() {
    $gameParty.getFormation();
    this.popScene();
};

Scene_Party.prototype.onFormationOk = function() {
    var index = this._statusWindow.index();
    var actor = $gameParty.members()[index];
    var pendingIndex = this._statusWindow.pendingIndex();
    if (pendingIndex >= 0) {
        if ($gameSystem._lockedMember.length > 0 && $gameSystem._lockedMember.contains($gameParty.members()[pendingIndex]._actorId) && index >= $gameParty.maxBattleMembers()) {
            SoundManager.playBuzzer();
            this._statusWindow.activate();
            this._statusWindow.setPendingIndex(pendingIndex);
            return;
        }
        SoundManager.playOk();
        $gameParty.swapOrder(index, pendingIndex);
        this._statusWindow.setPendingIndex(-1);
        this._statusWindow.redrawItem(index);
        this.createActorSprites();
    } else {
        this._statusWindow.setPendingIndex(index);
        SoundManager.playOk();
    }
    this._statusWindow.activate();
};

Scene_Party.prototype.onFormationCancel = function() {
    if (this._statusWindow.pendingIndex() >= 0) {
        this._statusWindow.setPendingIndex(-1);
        this._statusWindow.activate();
    } else {
        this._statusWindow.deactivate();
        this._statusWindow.select(-1);
        this._commandWindow.activate();
        this._statusWindow.hide();
        this._formLayout.opacity = 0;
    }
};

Scene_Party.prototype.onListOk = function() {
    $gameSystem._formationId = this._listWindow._formIndex[this._listWindow.index()];
    $gameParty.getFormation();
    SoundManager.playEquip();
    this._listWindow.activate();
    this.createActorSprites();
};

Scene_Party.prototype.onListCancel = function() {
    this._listWindow.deactivate();
    this._listWindow.select(-1);
    this._commandWindow.activate();
    this._helpWindow.hide();
    this._listWindow.hide();
    this._helpLayout.opacity = 0;
    this._formLayout.opacity = 0;
};

Scene_Party.prototype.refreshMeter = function() {
    if (this._expMeter) {
        if ($gameSystem._formationId > 0 && $gameSystem._learnForm[$gameSystem._formationId][0] < Ryo.Battleform.formInfo[$gameSystem._formationId].maxLevel) {
	    this.refresh_meter_flow(this._expMeter, $gameSystem._learnForm[$gameSystem._formationId][1], Ryo.Battleform.formInfo[$gameSystem._formationId].exp[$gameSystem._learnForm[$gameSystem._formationId][0] - 1],this._flow);
        } else {
            this.refresh_meter_flow(this._expMeter, 1, 1,this._flow);
        }
	this._flow += 1.5;
	if (this._flow > this._expMeter.bitmap.width / 3 * 2) {
            this._flow = 0
        };		   
    };
    if (this._expName) {
        this._expName.bitmap.clear();
        this._expName.bitmap.fontSize = 24;
        var text = Ryo.Battleform.formInfo[$gameSystem._formationId].name + ' ';
        if ($gameSystem._formationId > 0 && $gameSystem._learnForm[$gameSystem._formationId][0] < Ryo.Battleform.formInfo[$gameSystem._formationId].maxLevel) var intext = 'Lv ' +  $gameSystem._learnForm[$gameSystem._formationId][0];
        else var intext = '最高等级'
        this._expName.bitmap.drawText(text + intext, 0, 0, this._expName.bitmap.width, this._expName.bitmap.height, 'left')
    } 
}

Scene_Party.prototype.refresh_meter_flow = function(sprite,value,value_max,flow) {
    var cw = sprite.bitmap.width / 3;
    var ch = sprite.bitmap.height;
    var meter_rate = cw * value / value_max;
    sprite.setFrame(flow, 0, meter_rate, ch);
};

Scene_Party.prototype.update = function() {
    Scene_MenuBase.prototype.update.call(this);
    this.refreshMeter();
}
