﻿/*:
 * @plugindesc 魔法盾插件，允许给装备配置魔法盾效果
 * @author solve
 *
 * 注释：
 *  <MagicShieldRate:[0.5,0.2,2]>
 *      50%概率将伤害的20%折算成魔法伤害
 *      每点魔法折算2点伤害
 *  <MagicShieldFlat:[0.5,200,2]>
 *      50%概率将200伤害折算成魔法伤害
 *       每点魔法折算2点伤害
 *
 *  如果两个都有，会先折算百分比 在折算固定伤害
 *
 *
 */


(function (solve) {


        var solve_changeEquip = Game_Actor.prototype.changeEquip;
        Game_Actor.prototype.changeEquip = function (slotId, item) {
            solve_changeEquip.call(this, slotId, item);
            this._magicShieldRate = [0, 0, 0];
            this._magicShieldFlat = [0, 0, 0];

            this.equips().forEach(item => {
                if (item && item.meta['MagicShieldRate']) {
                    var magicShield = eval(item.meta['MagicShieldRate']);
                    if (magicShield instanceof Array && magicShield.length >= 3) {
                        for (let i = 0; i < 3; i++) {
                            this._magicShieldRate[i] = Math.max(this._magicShieldRate[i], magicShield[i])
                        }
                    }
                }
                if (item && item.meta['MagicShieldFlat']) {
                    var magicShieldFlat = eval(item.meta['MagicShieldFlat']);
                    if (magicShieldFlat instanceof Array && magicShieldFlat.length >= 3) {
                        for (let i = 0; i < 3; i++) {
                            this._magicShieldFlat[i] = Math.max(this._magicShieldFlat[i], magicShieldFlat[i])
                        }
                    }
                }
            }, this);
        };

        var solve_executeHpDamage = Game_Action.prototype.executeHpDamage;
        Game_Action.prototype.executeHpDamage = function (target, value) {
            //返回最后折算的伤害
            var checkMp = function (target, v, r) {
                return Math.min(target.mp * r, v);
            };

            var magicDamage = 0;
            if (target._magicShieldRate) {
                if (Math.random() < target._magicShieldRate[0]) {
                    var magicD = value * target._magicShieldRate[1];
                    magicD = checkMp(target,magicD,target._magicShieldRate[2]);

                    value = Math.max(0, value - magicD);
                    magicDamage += (magicD / target._magicShieldRate[2])
                }
            }
            if (value > 0 && target._magicShieldFlat) {
                if (Math.random() < target._magicShieldFlat[0]) {
                    var magicD1 = target._magicShieldFlat[1];
                    magicD1 = checkMp(target,magicD1,target._magicShieldFlat[2]);
                    if (value > magicD1) {
                        value -= magicD1;
                        magicDamage += (magicD1 / target._magicShieldRate[2]);
                    } else {
                        magicDamage += (value / target._magicShieldRate[2]);
                        value = 0;
                    }
                }
            }

            if (magicDamage > 0) {
                this.executeMpDamage(target, Math.round(magicDamage))
            }
            solve_executeHpDamage.call(this, target, value)
        };

    }
)({});