//=============================================================================
//  wn_onlineChat.js
//=============================================================================
var wnChat = wnChat || {};
wnChat.chats = [];

//配置信息
//1.开关聊天框的开关id 把34改为你自己使用的开关id 
//这个开关如果是off的话，也就是默认状态，这时候聊天框是打开的
wnChat.param1 = 24;
//2.聊天框位置，长宽
wnChat.x = 430;
wnChat.y = 100;
wnChat.width = 300;
wnChat.height = 300;


/*:
* @plugindesc 聊天插件 v1.0
* @author 半醉的蜗牛
* @version 1.0
* @date 2022.11.06
* 
* 
* @help 
* ============================================================================
*  脚本及插件功能介绍
* ============================================================================
* 插件主要功能：
* 1.实现聊天框功能
在登录的事件里面，加上一个脚本，写上以下的代码
HWGOE.override.game.notification = function(response) {
    let { msg, userId } = response; 
    wnChat.chats.push(msg)
};
* 
* 2.玩家自由聊天脚本
* wnWordSpeek()
*
* 3.已兼容江湖梦网的聊天框的插件指令
*
* ============================================================================
*  兼容性
* ============================================================================
* 无
* 
* ============================================================================
*  用户规约
* ============================================================================
* 
* 定制插件，未获取授权不可使用
* 
* ============================================================================
*  更新日志
* ============================================================================
* 
* [v1.0] 完成插件  2022.11.06
*
* ============================================================================
*  帮助结束
* ============================================================================ 
* 
*/
function Window_wnChat() {
    this.initialize.apply(this, arguments);
}

Window_wnChat.prototype = Object.create(Window_Base.prototype);
Window_wnChat.prototype.constructor = Window_wnChat;

Window_wnChat.prototype.initialize = function(x, y, wight, height) {
    // this._windowWidth = width;
    // this._windowHeight = height;
    Window_Base.prototype.initialize.call(this, x, y, wight, height);
    this.opacity = 0;
    //this.contentsOpacity = 0;
    this._showCount = 0;
	this._chats = null;
    this.refresh();
};

Window_wnChat.prototype.windowWidth = function() {
    return 1280;
};

Window_wnChat.prototype.windowHeight = function() {
    return this.fittingHeight(1);
};

Window_wnChat.prototype.update = function() {
		if (!this.updateWait()) {
			this.callNext();
		}
};
Window_wnChat.prototype.updateWait = function() {
    if (this._showCount > 0) {
        this._showCount -= 1;
        if (this._showCount < 0) {
            this._showCount = 0;
        }
        return true;
    }
    return false;
};

Window_wnChat.prototype.refresh = function() {
    this.contents.clear();
    this.contents.paintOpacity = 40;
    if($gameSwitches.value(wnChat.param1)) this.contents.fillRect(0, 0, wnChat.width, wnChat.height, '#000000');
    this.contents.paintOpacity = 255;
    var chats = wnChat.chats
    while(chats.length>10){
        chats.splice(0,1)
    }
    var count = 0;
    var hjj = 22;
    // console.log(chats);
    for(let i=0;i<chats.length;i++){
        if($gameSwitches.value(wnChat.param1)) this.drawTextEx("\\fs[18]"+chats[i], 0, hjj*count++);
    }
    if($gameSwitches.value(wnChat.param1)) this.drawTextEx("\\fs[20]在线人数:"+HWGOE.gameInfo.ACU(), 0, 10*hjj+15);

};

Window_wnChat.prototype.callNext = function() {
	this._showCount = 60;
	this.refresh();
};

var wn_mapChatWindow = Scene_Map.prototype.createAllWindows
Scene_Map.prototype.createAllWindows = function() {
    wn_mapChatWindow.call(this);
    this._wnMapChatWindow = new Window_wnChat(wnChat.x,wnChat.y,wnChat.width,wnChat.height);
    this.addChild(this._wnMapChatWindow);
};


var wn_Game_Interpreter_pluginCommand = Game_Interpreter.prototype.pluginCommand
Game_Interpreter.prototype.pluginCommand = function(command,args){
    wn_Game_Interpreter_pluginCommand.call(this,command,args);
    if(command === 'SendWord'){
        var text = "\\C[2]恭喜\\C[6]"+HWGOE.player.name()+args;
        HWGOE.game.notification(text);
    }
}

function wnWordSpeek(){
    var msg = prompt('请输入', '');
    wnPlayerChat(msg)
}

function wnPlayerChat(msg){
    if(msg==null||msg=="") return;
    var text = "\\C[6]"+HWGOE.player.name()+"\\C[0] : \\C[3]"+forbiddenStr(msg);
    HWGOE.game.notification(text);
}

function forbiddenStr(str){
    var forbiddenArray =['蜗','妈','爸','\c','\C','傻逼','煞笔','沙比','沙壁','sb','SB','爹','傻子','国','倭','v','企鹅','微信',
    '加我','私我','qq','q','Q','QQ','微','修改','系统消息','习近平','胡锦涛','李克强','温家宝','毛泽东','邓小平','孙中山','法轮功','海洛因',
    '鸦片','冰毒','摇头丸'];
    var destString = str.trim();
    var re = '';
   
    for(var i=0;i<forbiddenArray.length;i++){
        if(i==forbiddenArray.length-1)
            re+=forbiddenArray[i];
        else
            re+=forbiddenArray[i]+"|";
    }
    var pattern = new RegExp(re,"g");
    destString=destString.replace(pattern,"**");
    return destString;
}