//=============================================================================
//  wn_onlineSignIn.js
//=============================================================================
/*:
* @plugindesc 签到 v1.2.1
* @author 半醉的蜗牛
* @version 1.2.1
* @date 2022.09.09
* 
* @help 
* ============================================================================
*  脚本及插件功能介绍  
* ============================================================================
* 累计签到奖励请到45行自行配置  每天的奖励在50行配置
* 打开签到菜单：SceneManager.push(Scene_wnOnlineSignIn);
* 补签卡制作：将一个物品做成补签卡，记得消耗品选择否，如果不满足条件的话，使用补签卡
* 无效,再让此物品执行一个公共事件，公共事件里执行脚本
* wnOnlineSignInComplement(itemId);  itemId就是补签卡的物品id
* ============================================================================
*  兼容性
* ============================================================================
* 无
* 
* ============================================================================
*  用户规约
* ============================================================================
* 
*  MIT规约。
*  如果你使用了本插件，请在致谢中包含'半醉的蜗牛'，谢啦！
* 
* ============================================================================
*  更新日志
* ============================================================================
* 
* [v1.0] 完成插件  2022.08.30
* [v1.1] 增加每天给的奖励  2022.09.09
* [v1.2] 修复补签卡各种bug  2022.09.18 
* [v1.2.1] 继续修复补签卡各种bug......  2022.09.18 
*
* ============================================================================
*  帮助结束
* ============================================================================ 
* 
*/
//三个参数，分别代表 连续签到天数，奖励的物品id，物品个数
//连序签到天数写100代表当月满签的奖励
var jfmOnlineSignInSward = [[3,258,3],
                            [7,258,4],
                            [14,258,7],
                            [25,258,7],
                            [100,67,8]];
var jfmOnlineSignInEveryDaySward = [125,1];//每天给的物品 [物品id,数量]

var jfmOnlineYear = 0;
var jfmOnlineMonth = 0;
var jfmOnlineDay = 0;
{
    function Window_wnOnlineSignInList() {
        this.initialize.apply(this, arguments);
    }
    
    Window_wnOnlineSignInList.prototype = Object.create(Window_Selectable.prototype);
    Window_wnOnlineSignInList.prototype.constructor = Window_wnOnlineSignInList;
    
    Window_wnOnlineSignInList.prototype.initialize = function(x, y, width, height) {
        this._windowWidth = width;
        this._windowHeight = height;
        Window_Selectable.prototype.initialize.call(this, x, y, width, height);
        this.opacity = 255;
        this.refresh();
        this.select(0);
        this._helpWindow = '???';
        this.callUpdateHelp();
    };
    
    Window_wnOnlineSignInList.prototype.maxCols = function() {
        return 1;
    };
    
    Window_wnOnlineSignInList.prototype.itemHeight = function() {
        return 37;
    };
    
    //这个是用来自定义选项的位置和大小
    Window_wnOnlineSignInList.prototype.itemRect = function(index) {
        var rect = new Rectangle();
        
        rect.width = 100;
        rect.height = 37;

        rect.x = 260+index % this.maxCols() * 100 ;
        rect.y = 580 + Math.floor(index / this.maxCols()) * 37 - this._scrollY;
    
        return rect;
    };
    
    Window_wnOnlineSignInList.prototype.maxItems = function() {
        return this._data ? this._data.length : 1;
    };
    
    Window_wnOnlineSignInList.prototype.item = function() {
        return this._data[this.index()];
    };
    
    Window_wnOnlineSignInList.prototype.isCurrentItemEnabled = function() {
        return this.isEnabled(this._data[this.index()]);
    };
    
    Window_wnOnlineSignInList.prototype.isEnabled = function(item) {
        return true;
    };
    
    Window_wnOnlineSignInList.prototype.refresh = function() {
        this.makeItemList();
        this.createContents();
        this.drawBJ();
        this.drawAllItems();
    };
    
    Window_wnOnlineSignInList.prototype.makeItemList = function() {
        //$dataActors[$gameParty.members()[0]._actorId].meta.颜色
        //atypeId
        this._data = [0];
    };
    
    //画内容的
    Window_wnOnlineSignInList.prototype.drawBJ = function() {
        this.contents.paintOpacity = 80;
        this.contents.fillRect(0, 0, 900, 720, '#000000');
        this.contents.paintOpacity = 255;
        if (!this.item()&&this.item()!="0") return;
        this.drawTextEx("\\C[3]\\fs[40]签到领军饷",100, 20);
        this.drawTextEx("\\C[3]\\fs[40]累计签到奖励",400, 20);
        this.drawTextEx(jfmOnlineYear+"年"+jfmOnlineMonth+"月"+jfmOnlineDay+"日",50, 500);

        var year = jfmOnlineYear;
        var month = jfmOnlineMonth;
        var day = jfmOnlineDay;
        var month_Days = getMonthDay(year, month);//当月天数
        var lie = 0;
        var hang = 0;
        var liekuan = 42;//列宽
        var hanggao = 42;//行高
        var lieno = 7;//每行几个 #ff7f00
        for(let i=1;i<=month_Days;i++){
            var bj = "#c0d9d9";
            if(i==day)bj = "#236b8e";
            this.contents.fillRect(10+liekuan*((i-1)%lieno), 170+hanggao*Math.floor((i-1)/lieno), 40, 40, bj);
            if(i>day){
                this.drawTextEx("\\C[0]",0, 0);
            }else{
                if($gameParty.wnOnlineSineInArr.indexOf(i)!=-1){
                    this.drawTextEx("\\C[3]",0, 0);
                }else{
                    this.drawTextEx("\\C[10]",0, 0);
                }
            }
            var day1 = i;
            if(i<10){
                day1 = "0"+i;
            }
            this.drawText(day1,12+liekuan*((i-1)%lieno) , 172+hanggao*Math.floor((i-1)/lieno),"center");
        }

        var count = 0;
        for(let i=0;i<jfmOnlineSignInSward.length;i++){
            if(jfmOnlineSignInSward[i][0]!=100){
                var color = 0;
                if($gameParty.wnOnlineSineInArr.length-1>=jfmOnlineSignInSward[i][0]){
                    color = 3;
                }
                this.drawTextEx("\\fs[24]\\C["+color+"]"+jfmOnlineSignInSward[i][0]+"天奖励 : "
                +"\\fs[24]\\C[1]"+$dataItems[jfmOnlineSignInSward[i][1]].name+"\\i["+$dataItems[jfmOnlineSignInSward[i][1]].iconIndex
                +"]\\fs[24]\\C[0] x " +jfmOnlineSignInSward[i][2],320, 120+count*60);               
            }else{
                var color = 0;
                if($gameParty.wnOnlineSineInArr.length-1>=getMonthDay(jfmOnlineYear,jfmOnlineMonth)){
                    color = 3;
                }
                this.drawTextEx("\\fs[24]\\C["+color+"]"+getMonthDay(jfmOnlineYear,jfmOnlineMonth)+"天奖励 : "
                +"\\fs[24]\\C[2]"+$dataItems[jfmOnlineSignInSward[i][1]].name+"\\i["+$dataItems[jfmOnlineSignInSward[i][1]].iconIndex
                +"]\\fs[24]\\C[0] x " +jfmOnlineSignInSward[i][2],320, 120+count*60);  
            }
            count++;
        }
        
    };
    
    Window_wnOnlineSignInList.prototype.drawItem = function(index) {
        var dt = this._data[index];
        var rect = this.itemRect(index);
        this.drawTextEx("\\C[6]",rect.x, rect.y);
        this.drawText("签 到",rect.x , rect.y,100,"center");
    };

    //是否可以点击
    Window_wnOnlineSignInList.prototype.isEnabled = function(item) {
        return true;
    }

    //不动
    Window_wnOnlineSignInList.prototype.setStatusWindow = function(statusWindow) {
        this._helpWindow = statusWindow;
        this.callUpdateHelp();
    };
    Window_wnOnlineSignInList.prototype.setHelpWindowItem = function(item) {
        if (this._helpWindow) {
            //this._helpWindow.setItem(item);
        }
    };
    Window_wnOnlineSignInList.prototype.updateHelp = function() {
        this.refresh();
    };


}


{
    function Scene_wnOnlineSignIn() {
        this.initialize.apply(this, arguments);
    }
      
    Scene_wnOnlineSignIn.prototype = Object.create(Scene_MenuBase.prototype);
    Scene_wnOnlineSignIn.prototype.constructor = Scene_wnOnlineSignIn;
    
    Scene_wnOnlineSignIn.prototype.initialize = function() {
        Scene_MenuBase.prototype.initialize.call(this);
    };
    
    Scene_wnOnlineSignIn.prototype.create = function() {
        Scene_MenuBase.prototype.create.call(this);
        $gameParty.wnOnlineSineInArr = $gameParty.wnOnlineSineInArr||[];
        var date = new Date(HWGOE.server.timestamp());
        jfmOnlineYear = date.getFullYear(); 
        jfmOnlineMonth = date.getMonth() + 1; 
        jfmOnlineDay = date.getDate(); // 日

        // jfmOnlineMonth = $gameVariables.value(2);
        // jfmOnlineDay = $gameVariables.value(1);

        if($gameParty.wnOnlineSineInArr.length==0){
            $gameParty.wnOnlineSineInArr.push(""+jfmOnlineYear+jfmOnlineMonth);           
        }else{
            if($gameParty.wnOnlineSineInArr[0]!=(""+jfmOnlineYear+jfmOnlineMonth)){
                $gameParty.wnOnlineSineInArr = [];
                $gameParty.wnOnlineSineInArr.push(""+jfmOnlineYear+jfmOnlineMonth);
            }
        }
        this.createListWindow();
    };
    
    Scene_wnOnlineSignIn.prototype.createListWindow = function() {
        this._wnOnlineSignInWindow = new Window_wnOnlineSignInList(0, 0, 720, 660);
        this.addWindow(this._wnOnlineSignInWindow);
        this._wnOnlineSignInWindow.setHandler('ok', this.cs.bind(this));
        this._wnOnlineSignInWindow.setHandler('cancel', this.popScene.bind(this));
        this._wnOnlineSignInWindow.activate();
    };

    Scene_wnOnlineSignIn.prototype.cs = function() {
        if($gameParty.wnOnlineSineInArr.indexOf(jfmOnlineDay)==-1){
            $gameParty.wnOnlineSineInArr.push(jfmOnlineDay);
            
            $gameParty.gainItem($dataItems[jfmOnlineSignInEveryDaySward[0]],jfmOnlineSignInEveryDaySward[1]);
            for(let i=0;i<jfmOnlineSignInSward.length;i++){
                if(($gameParty.wnOnlineSineInArr.length-1)==jfmOnlineSignInSward[i][0]){
                    $gameParty.gainItem($dataItems[jfmOnlineSignInSward[i][1]],jfmOnlineSignInSward[i][2]);
                    break;
                }
                if(jfmOnlineSignInSward[i][0]==100&&($gameParty.wnOnlineSineInArr.length-1)==getMonthDay(jfmOnlineYear,jfmOnlineMonth)){
                    $gameParty.gainItem($dataItems[jfmOnlineSignInSward[i][1]],jfmOnlineSignInSward[i][2]);
                    break;
                }
            }
            HWGOE.save.cloudSaveGame();
        }
        this._wnOnlineSignInWindow.refresh();
        this._wnOnlineSignInWindow.activate();
    };

    

}

function getMonthDay(year, month) {
	let days = new Date(year, month, 0).getDate()
	return days
}

function wnOnlineSignInComplement(itemId){
    var date = new Date(HWGOE.server.timestamp());
    jfmOnlineYear = date.getFullYear(); 
    jfmOnlineMonth = date.getMonth() + 1; 
    jfmOnlineDay = date.getDate(); // 日
    $gameParty.wnOnlineSineInArr = $gameParty.wnOnlineSineInArr||[];
    if($gameParty.wnOnlineSineInArr.length==0){
        $gameParty.wnOnlineSineInArr.push(""+jfmOnlineYear+jfmOnlineMonth);           
    }else{
        if($gameParty.wnOnlineSineInArr[0]!=(""+jfmOnlineYear+jfmOnlineMonth)){
            $gameParty.wnOnlineSineInArr = [];
            $gameParty.wnOnlineSineInArr.push(""+jfmOnlineYear+jfmOnlineMonth);
        }
    }
    var length = $gameParty.wnOnlineSineInArr.length;
    if($gameParty.wnOnlineSineInArr.indexOf(jfmOnlineDay)!=-1){
        length-=1;
    }
    var isBq = false;
    if(length<jfmOnlineDay){
        for(let j=1;j<jfmOnlineDay;j++){
            if($gameParty.wnOnlineSineInArr.indexOf(j)==-1){
                $gameParty.gainItem($dataItems[itemId],-1);
                $gameParty.gainItem($dataItems[jfmOnlineSignInEveryDaySward[0]],jfmOnlineSignInEveryDaySward[1]);
                $gameParty.wnOnlineSineInArr.push(j);
                isBq = true;
                for(let i=0;i<jfmOnlineSignInSward.length;i++){
                    if(($gameParty.wnOnlineSineInArr.length-1)==jfmOnlineSignInSward[i][0]){
                        $gameParty.gainItem($dataItems[jfmOnlineSignInSward[i][1]],jfmOnlineSignInSward[i][2]);
                        break;
                    }
                    if(jfmOnlineSignInSward[i][0]==100&&($gameParty.wnOnlineSineInArr.length-1)==getMonthDay(jfmOnlineYear,jfmOnlineMonth)){
                        $gameParty.gainItem($dataItems[jfmOnlineSignInSward[i][1]],jfmOnlineSignInSward[i][2]);
                        break;
                    }
                }
                break;
            }
        }
    }
    if(!isBq){
        $gameMessage.add("当前无需补签!");
    }
} 