﻿//=============================================================================
//  wn_yjfj.js
//=============================================================================
/*:
* @plugindesc 一键分解以及加锁界面 v1.8
* @author 半醉的蜗牛
* @version 1.8
* @date 2022.05.01
* 
* @param ---过滤的颜色（不分解）---
* @default
* 
* @param wn_filter1
* @desc 一键分解默认不分解条件（YEP_ItemCore的颜色）
* @text 过滤颜色
* @default 
* 
* @param wn_filter2
* @desc 一键分解默认不分解条件（YEP_ItemCore的颜色）
* @text 过滤颜色
* @default 
* 
* @param wn_filter3
* @desc 一键分解默认不分解条件（YEP_ItemCore的颜色）
* @text 过滤颜色
* @default 
* 
* @param wn_filter4
* @desc 一键分解默认不分解条件（YEP_ItemCore的颜色）
* @text 过滤颜色
* @default 
* 
* @param ---过滤的文字（不分解）---
* @default
* 
* @param wn_filter5
* @desc 带有该文字的装备不会分解
* @text 过滤文字
* @default 
* 
* @param wn_filter6
* @desc 带有该文字的装备不会分解
* @text 过滤文字
* @default 
* 
* @param wn_filter7
* @desc 带有该文字的装备不会分解
* @text 过滤文字
* @default 
* 
* @param wn_filter8
* @desc 带有该文字的装备不会分解
* @text 过滤文字
* @default 
* 
* @param ---上锁界面图标设置---
* @default
* 
* @param wn_icon1
* @desc 会被分解的图标
* @text 会被分解的图标
* @default 168
* 
* @param wn_icon2
* @desc 不会被分解的图标
* @text 不会被分解的图标(0表示无图标)
* @default 164
* 
* @param ---yep镶嵌插件---
* @default
* 
* @param wn_yjfjYepXq
* @desc 是否分解镶嵌宝石的装备
* @text 是否分解镶嵌宝石的装备(0-分解，1-不分解)
* @default 0
*
* @param ---装备展示的列数---
* @default
* 
* @param wn_yjfjrow
* @desc 装备展示的列数
* @text 装备展示的列数
* @default 2
* 
* @param ---属性窗口---
* @default
* 
* @param wn_yjfjgt
* @desc 是否使用自带的属性展示(0-使用，1-不使用)
* @text 是否使用自带的属性展示(0-使用，1-不使用)
* @default 0
*
* @param ---颜色设置---
* @param wn_param1
* @desc 颜色插件使用
* @text 0-yep颜色，1-drill颜色
* @default 0
* @help 
* ============================================================================
*  脚本
* ============================================================================
* 插件功能：
* 1.可以批量分解装备，并且会将独立物品删除干净，不用担心内存问题
* 2.可以在上锁界面给装备上锁，上锁的装备不会被一键分解掉
* 
* 使用方式：
* 打开一键分解界面：SceneManager.push(Scene_wnYJFJ);
* 注意：需要写上yep的分解的标签才可以分解，否则不分解，菜单自带
  的分解仍然生效
* 如果使用了gt的小窗口，请将本插件放在gt插件之下
* 
* 注意：
  当前只支持两种yep分解标签 
<Disassemble Pool>
item
</Disassemble Pool>
  
<Disassemble Pool>
x2 item y
</Disassemble Pool>
*
* ============================================================================
*  兼容性
* ============================================================================
* 此插件必须放在YEP_ItemCore和YEP_X_ItemDisassemble这两个插件下
* 
* ============================================================================
*  用户规约
* ============================================================================
* 
*  MIT规约。
*  如果你使用了本插件，请在致谢中包含'半醉的蜗牛'，谢啦！
* 
* ============================================================================
*  更新日志
* ============================================================================
* 
* [v1.0] 完成插件。 2021.12.21
* [v1.1] 优化上锁界面，增加基础属性的展示。 2022.03.27
* [v1.2] 优化上锁界面，增加追加能力值，基础属性百分比，暴击伤害的展示。 2022.03.27
* [v1.3] 界面优化，将功能整合到一个界面中 2022.04.08
* [v1.4] 操作选择改变时，下面的装备列表也会随之改变 2022.04.09
* [v1.5] 兼容gt小窗口，并且自带的属性显示可以屏蔽了,进入装备选择后，总是默认选择第一个 2022.04.10
* [v1.6] 兼容drill颜色以及在装备选择的时候可以区分装备的人物 2022.04.17
* [v1.7] 插件设置增加是否分解镶嵌宝石的装备的选项 2022.05.01
* [v1.8] 装备分解增加确定窗口，并且兼容itemStorage仓库，仓库里的装备不会被分解 2022.05.06
* ============================================================================
*  帮助结束
* ============================================================================ 
* 
*/
var wnSelectType = 1;//操作的种类
var wnfjFHXX = "";//返回信息
//=============================================================================
// 一键分解 
//=============================================================================
var wn_yepfj_Parameters = PluginManager.parameters('wn_yjfj');
var wn_yepfj_param = [];
wn_yepfj_param.push(wn_yepfj_Parameters['wn_filter1']||"");//过滤的颜色
wn_yepfj_param.push(wn_yepfj_Parameters['wn_filter2']||"");
wn_yepfj_param.push(wn_yepfj_Parameters['wn_filter3']||"");
wn_yepfj_param.push(wn_yepfj_Parameters['wn_filter4']||"");
wn_yepfj_param.push(wn_yepfj_Parameters['wn_filter5']||"");//过滤的文字
wn_yepfj_param.push(wn_yepfj_Parameters['wn_filter6']||"");
wn_yepfj_param.push(wn_yepfj_Parameters['wn_filter7']||"");
wn_yepfj_param.push(wn_yepfj_Parameters['wn_filter8']||"");
wn_yepfj_param.push(wn_yepfj_Parameters['wn_icon1']||"168");
wn_yepfj_param.push(wn_yepfj_Parameters['wn_icon2']||"164");
wn_yepfj_param.push(wn_yepfj_Parameters['wn_yjfjrow']||"2");//10
wn_yepfj_param.push(wn_yepfj_Parameters['wn_yjfjgt']||"0");
wn_yepfj_param.push(wn_yepfj_Parameters['wn_param1']||"0");
wn_yepfj_param.push(wn_yepfj_Parameters['wn_yjfjYepXq']||"0");

var wn_yep_plfj = function(lx) { // 批量分解  1-武器，2-防具 
	if(lx == 1){
		lx = $dataWeapons;
	}else if(lx == 2){
		lx = $dataArmors;
	}
	var wn_count = 0;//分解装备的数量
	for (i=3001;i<lx.length;i++){
		var carrier = 0;
		var item = lx[i];
		if(!item){
			continue;
		}
		for (var a = 0; a < $gameParty.members().length; ++a) {
			var actor = $gameParty.members()[a];
			if (!actor) continue;
			if (actor.equips().contains(item)) carrier += 1;
		}
		
        for(var j=0;j<4;j++){
            if(wn_yepfj_param[j]!=""&&item.textColor==wn_yepfj_param[j]){
                carrier += 1;
            }
        }
        for(var j=4;j<8;j++){
            if(wn_yepfj_param[j]!=""&&item.name.indexOf(""+wn_yepfj_param[j])!=-1){
                carrier += 1;
            }
        }
        //排除镶嵌宝石的装备
		if(wn_yepfj_param[13]=="1"&&item.augmentSlotItems&&item.augmentSlotItems.length>0){
			for(var p=0;p<item.augmentSlotItems.length;p++){
				if(item.augmentSlotItems[p]!="none"){
					carrier++;
					break;
				}
			}
		}
		if(!$gameParty.hasItem(item)){
			carrier += 1;
		}
        //item.wnCanYJFJ=="1"       1不会被分解  
		if(item.wnCanYJFJ=="1"){
			carrier += 1;
		}

		var wn_fjdjId = 0;//取出分解的道具id
				
		if (item && carrier == 0 ){
			//var effectItem = $dataItems[20];
			//if (effectItem) {
			//	var results = ItemManager.disassemble(item, effectItem);
			//} else {
			//	var results = [];
			//}
			if (item.disassembleItems.ALL&&item.disassembleItems.ALL[0]&&item.disassembleItems.ALL[0].indexOf('item') != -1){
				var wn_chws = item.disassembleItems.ALL[0].indexOf('x');				
				if(wn_chws == -1){
					$gameParty.loseItem(item, 1);			
					if (DataManager.isIndependent(item)) DataManager.removeIndependentItem(item); 
					//$gameParty.consumeItem(effectItem);					
					wn_count++;
					wn_fjdjId = item.disassembleItems.ALL[0].substring(item.disassembleItems.ALL[0].indexOf('item')+5);
					$gameParty.gainItem($dataItems[wn_fjdjId], 1);					
				}else{
					$gameParty.loseItem(item, 1);			
					if (DataManager.isIndependent(item)) DataManager.removeIndependentItem(item); 
					//$gameParty.consumeItem(effectItem);
                    var wn_fjwpNum11 = item.disassembleItems.ALL[0].substring(1,item.disassembleItems.ALL[0].indexOf('item')-1);
					var wn_fjwpNum = parseInt(wn_fjwpNum11);
					wn_fjdjId = item.disassembleItems.ALL[0].substring(item.disassembleItems.ALL[0].indexOf('item')+5);
					$gameParty.gainItem($dataItems[wn_fjdjId], wn_fjwpNum);

                    wn_count++;
                }
				
				
			}
			
		}
	}
	return wn_count;
}


//=============================================================================
// 一键分解加锁窗口
//=============================================================================
{
    function Window_wnYJFJList() {
        this.initialize.apply(this, arguments);
    }
    
    Window_wnYJFJList.prototype = Object.create(Window_Selectable.prototype);
    Window_wnYJFJList.prototype.constructor = Window_wnYJFJList;
    
    Window_wnYJFJList.prototype.initialize = function(x, y, width, height) {
        this._windowWidth = width;
        this._windowHeight = height;
        Window_Selectable.prototype.initialize.call(this, x, y, width, height);
        this.opacity = 255;
        this.refresh();
        this.select(0);
        this._helpWindow = '???';
        this.callUpdateHelp();
    };
    
    Window_wnYJFJList.prototype.maxCols = function() {
        return Number(wn_yepfj_param[10]);
    };
    
    Window_wnYJFJList.prototype.itemHeight = function() {
        return 32;
    };
    
    Window_wnYJFJList.prototype.itemRect = function(index) {
        var rect = new Rectangle();
        var lie = Number(wn_yepfj_param[10]);
        var isUserPramShow = wn_yepfj_param[11]=='0'?800:1200;
        rect.width = isUserPramShow/lie;
        rect.height = 32;

        rect.x = index % this.maxCols() * isUserPramShow / lie ;
        rect.y = 0 + Math.floor(index / this.maxCols()) * 32 - this._scrollY;
    
        return rect;
    };
    
    Window_wnYJFJList.prototype.maxItems = function() {
        return this._data ? this._data.length : 1;
    };
    
    Window_wnYJFJList.prototype.item = function() {
        return this._data[this.index()];
    };
    
    Window_wnYJFJList.prototype.isCurrentItemEnabled = function() {
        return this.isEnabled(this._data[this.index()]);
    };
    
    Window_wnYJFJList.prototype.isEnabled = function(item) {
        return true;
    };
    
    Window_wnYJFJList.prototype.refresh = function() {
        this.makeItemList();
        this.createContents();
        if(wn_yepfj_param[11]=='0') this.drawBJ();      
        this.drawAllItems();
    };
    
    Window_wnYJFJList.prototype.drawBJ = function() {
        this.contents.paintOpacity = 80;
        this.contents.fillRect(830, 20, 400, 700, '#000000');
        this.contents.paintOpacity = 255;
        if (!this.item()) return;
        var equip = this.item();
        var zhongwen = $dataSystem.terms.params;
        var hangGao = 33;
        for(let i=0;i<8;i++){
            if(equip.params[i]==0) continue;
            this.drawTextEx(zhongwen[i], 850, hangGao);
            this.drawTextEx(" + "+equip.params[i], 1000, hangGao);
            hangGao+=33;
        }
        if(equip.traits.length>0){
            var zwm = ["命中率","回避率","暴击率","暴击回避","魔法回避","魔法反射","反击","HP回复","MP回复","TP回复"];
            for (let j = 0; j < equip.traits.length; j++) {
                if(equip.traits[j].code == 21 && equip.traits[j].value>0){
                    this.drawTextEx(zhongwen[equip.traits[j].dataId], 850, hangGao);
                    this.drawTextEx(" * "+Math.floor(equip.traits[j].value*100) + " %", 1000, hangGao);
                    hangGao+=33;   
                }
                if(equip.traits[j].code == 22 && equip.traits[j].value>0){
                    this.drawTextEx(zwm[equip.traits[j].dataId], 850, hangGao);
                    this.drawTextEx(" + "+Math.floor(equip.traits[j].value*100) + " %", 1000, hangGao);
                    hangGao+=33;                   
                }
            }
        }
        if(equip.critMultBonus>0){
            this.drawTextEx("暴击伤害", 850, hangGao);
            this.drawTextEx(" + "+Math.floor(equip.critMultBonus*100) + " %", 1000, hangGao);
            hangGao+=33;
        }
    };
    

    Window_wnYJFJList.prototype.makeItemList = function() {
        this._data = [];
        if(wnSelectType==1){//武器上锁
            var allZb = $dataWeapons;
            for (i=3001;i<allZb.length;i++){
                if(allZb[i]!=null){
                    var carrier = 0;
                    for(var j=0;j<4;j++){
                        if(wn_yepfj_param[j]!=""&&allZb[i].textColor==wn_yepfj_param[j]){
                            carrier += 1;
                        }
                    }
                    for(var j=4;j<8;j++){
                        if(wn_yepfj_param[j]!=""&&allZb[i].name.indexOf(""+wn_yepfj_param[j])!=-1){
                            carrier += 1;
                        }
                    }
                    // if(!$gameParty.hasItem(allZb[i])) carrier += 1;
                    if(carrier>0){
                        continue;
                    }
                    if(!$gameParty.hasItem(allZb[i])){
                        continue;
                    }
                    this._data.push(allZb[i]); 
                }                    
            }
        }else if(wnSelectType==2){//护甲上锁
            var allZb = $dataArmors;
            for (i=3001;i<allZb.length;i++){
                if(allZb[i]!=null){
                    var carrier = 0;
                    for(var j=0;j<4;j++){
                        if(wn_yepfj_param[j]!=""&&allZb[i].textColor==wn_yepfj_param[j]){
                            carrier += 1;
                        }
                    }
                    for(var j=4;j<8;j++){
                        if(wn_yepfj_param[j]!=""&&allZb[i].name.indexOf(""+wn_yepfj_param[j])!=-1){
                            carrier += 1;
                        }
                    }
                    // if(!$gameParty.hasItem(allZb[i])) carrier += 1;
                    if(carrier>0){
                        continue;
                    }
                    if(!$gameParty.hasItem(allZb[i])){
                        continue;
                    }
                    this._data.push(allZb[i]); 
                }                    
            }
        }else if(wnSelectType==3){//武器分解
            var allZb = $dataWeapons;
            for (i=3001;i<allZb.length;i++){
                if(allZb[i]!=null){
                    var carrier = 0;
                    for(var j=0;j<4;j++){
                        if(wn_yepfj_param[j]!=""&&allZb[i].textColor==wn_yepfj_param[j]){
                            carrier += 1;
                        }
                    }
                    for(var j=4;j<8;j++){
                        if(wn_yepfj_param[j]!=""&&allZb[i].name.indexOf(""+wn_yepfj_param[j])!=-1){
                            carrier += 1;
                        }
                    }
                    var isCan = allZb[i].wnCanYJFJ||0;
                    if(isCan==1){
                        carrier++;
                    }
                    var isEquip = false;
                    for (var a = 0; a < $gameParty.members().length; ++a) {
                        var actor = $gameParty.members()[a];
                        if (!actor) continue;
                        if (actor.equips().contains(allZb[i])) isEquip = true;
                    }
                    if(isEquip){
                        carrier++;
                    }
                    if(carrier>0){
                        continue;
                    }
                    if(!$gameParty.hasItem(allZb[i])){
                        continue;
                    }
                    this._data.push(allZb[i]); 
                }                    
            }
        }else if(wnSelectType==4){//护甲分解
            var allZb = $dataArmors;
            for (i=3001;i<allZb.length;i++){
                if(allZb[i]!=null){
                    var carrier = 0;
                    for(var j=0;j<4;j++){
                        if(wn_yepfj_param[j]!=""&&allZb[i].textColor==wn_yepfj_param[j]){
                            carrier += 1;
                        }
                    }
                    for(var j=4;j<8;j++){
                        if(wn_yepfj_param[j]!=""&&allZb[i].name.indexOf(""+wn_yepfj_param[j])!=-1){
                            carrier += 1;
                        }
                    }
                    var isEquip = false;
                    for (var a = 0; a < $gameParty.members().length; ++a) {
                        var actor = $gameParty.members()[a];
                        if (!actor) continue;
                        if (actor.equips().contains(allZb[i])) isEquip = true;
                    }
                    if(isEquip){
                        carrier++;
                    }
                    var isCan = allZb[i].wnCanYJFJ||0;
                    if(isCan==1){
                        carrier++;
                    }
                    if(carrier>0){
                        continue;
                    }
                    if(!$gameParty.hasItem(allZb[i])){
                        continue;
                    }
                    this._data.push(allZb[i]); 
                }                    
            }
        }
		
		
        // console.log(this._data);
    };   
    
    Window_wnYJFJList.prototype.drawItem = function(index) {
        var dt = this._data[index];
        var rect = this.itemRect(index);
        var drawText = "\\fs[24]" + dt.name;
        var isEquip = false;
        var wnname = "";
        for (var a = 0; a < $gameParty.members().length; ++a) {
			var actor = $gameParty.members()[a];
			if (!actor) continue;
			if (actor.equips().contains(dt)) {
                isEquip = true;
                wnname = actor._name;
            }
		}
        if(isEquip){
            drawText = drawText + "\\C[3]["+wnname+"]";
        }else{
            drawText = drawText;
        }
        var color = dt.textColor||0;
        if(wn_yepfj_param[12] == 1){
            color = Number(dt.meta.颜色)+100;
        }
        if(dt.wnCanYJFJ&&dt.wnCanYJFJ=="1"){
            drawText = "\\C["+color+"]" + drawText + "\\i["+wn_yepfj_param[9]+"]";
        }else{
            drawText = "\\C["+color+"]" + drawText + "\\i["+wn_yepfj_param[8]+"]";
        }
        this.drawTextEx(drawText, rect.x + 20, rect.y);
    };
    

    Window_wnYJFJList.prototype.setStatusWindow = function(statusWindow) {
        this._helpWindow = statusWindow;
        this.callUpdateHelp();
    };
    Window_wnYJFJList.prototype.setHelpWindowItem = function(item) {
        if (this._helpWindow) {
        }
    };
    Window_wnYJFJList.prototype.updateHelp = function() {
        this.refresh();
    };


}

//=============================================================================
// 一键分解操作选择窗口
//=============================================================================
{
    function Window_wnYJFJSelect() {
        this.initialize.apply(this, arguments);
    }
    
    Window_wnYJFJSelect.prototype = Object.create(Window_Selectable.prototype);
    Window_wnYJFJSelect.prototype.constructor = Window_wnYJFJSelect;
    
    Window_wnYJFJSelect.prototype.initialize = function(x, y, width, height) {
        this._windowWidth = width;
        this._windowHeight = height;
        Window_Selectable.prototype.initialize.call(this, x, y, width, height);
        this.opacity = 255;
        this.refresh();
        this.select(0);
        this._helpWindow = '???';
        this.callUpdateHelp();
    };
    
    Window_wnYJFJSelect.prototype.maxCols = function() {
        return 2;
    };
    
    Window_wnYJFJSelect.prototype.itemHeight = function() {
        return 40;
    };
    
    Window_wnYJFJSelect.prototype.itemRect = function(index) {
        var rect = new Rectangle();
        
        rect.width = 200;
        rect.height = 40;

        rect.x = index % this.maxCols() * 200 ;
        rect.y = 10 + Math.floor(index / this.maxCols()) * 40 - this._scrollY;
    
        return rect;
    };
    
    Window_wnYJFJSelect.prototype.maxItems = function() {
        return this._data ? this._data.length : 1;
    };
    
    Window_wnYJFJSelect.prototype.item = function() {
        return this._data[this.index()];
    };
    
    Window_wnYJFJSelect.prototype.isCurrentItemEnabled = function() {
        return this.isEnabled(this._data[this.index()]);
    };
    
    Window_wnYJFJSelect.prototype.isEnabled = function(item) {
        return true;
    };
    
    Window_wnYJFJSelect.prototype.refresh = function() {
        this.makeItemList();
        this.createContents();
        this.drawBJ();
        this.drawAllItems();
    };
    
    Window_wnYJFJSelect.prototype.drawBJ = function() {
        this.contents.paintOpacity = 80;
        this.contents.fillRect(420, 0, 850, 140, '#000000');
        this.contents.paintOpacity = 255;
        if (!this.item()&&this.item()!="0") return;
        if(this.item()==1){
            this.drawTextEx("分解前请上锁", 440, 20);
        }else if(this.item()==2){
            this.drawTextEx("分解前请上锁", 440, 20);
        }else if(this.item()==3){
            this.drawTextEx("\\fs[25]分解所有装备", 440, 20);
        }else if(this.item()==4){
            this.drawTextEx("\\fs[25]分解所有装备", 440, 20);
        }        
        // this.drawTextEx("\\C[1][☆]\\C[6]未装备 \\C[1][★]\\C[6]已装备(不会被分解)", 440, 53);     
        wnSelectType=this.item();
        this.refreshList();
    };
    

    Window_wnYJFJSelect.prototype.makeItemList = function() {
        this._data = [1,2,3,4];
		
    };   
    
    Window_wnYJFJSelect.prototype.drawItem = function(index) {
        var dt = this._data[index];
        var rect = this.itemRect(index);
        if(dt==1){
            this.drawTextEx("\\C[3]",rect.x, rect.y);
            this.drawText("武器上锁",rect.x , rect.y+1,200,"center");        
        }else if(dt==2){
            this.drawTextEx("\\C[3]",rect.x, rect.y);
            this.drawText("护甲上锁",rect.x , rect.y+1,200,"center");  
        }else if(dt==3){
            this.drawTextEx("\\C[10]",rect.x, rect.y);
            this.drawText("武器分解",rect.x , rect.y+1,200,"center");  
        }else if(dt==4){
            this.drawTextEx("\\C[10]",rect.x, rect.y);
            this.drawText("护甲分解",rect.x , rect.y+1,200,"center");  
        }
    };
    

    Window_wnYJFJSelect.prototype.setStatusWindow = function(statusWindow) {
        this._helpWindow = statusWindow;
        this.callUpdateHelp();
    };
    Window_wnYJFJSelect.prototype.setHelpWindowItem = function(item) {
        if (this._helpWindow) {
        }
    };
    Window_wnYJFJSelect.prototype.updateHelp = function() {
        this.refresh();
    };

    Window_wnYJFJSelect.prototype.refreshWindow = function(listWindow) {
        this._wnYJFJListWindow = listWindow;
        this.refreshList();
    };

    Window_wnYJFJSelect.prototype.refreshList = function() {
        if (this._wnYJFJListWindow) {
            this._wnYJFJListWindow.updateHelp();
            this._wnYJFJListWindow.select(0);
        }
    };
}

//=============================================================================
// 一键分解确定取消窗口
//=============================================================================
{
    function Window_wnyjfjQD() {
        this.initialize.apply(this, arguments);
    }
    
    Window_wnyjfjQD.prototype = Object.create(Window_Selectable.prototype);
    Window_wnyjfjQD.prototype.constructor = Window_wnyjfjQD;
    
    Window_wnyjfjQD.prototype.initialize = function(x, y, width, height) {
        this._windowWidth = width;
        this._windowHeight = height;
        Window_Selectable.prototype.initialize.call(this, x, y, width, height);
        this.opacity = 255;
        this.refresh();
        this.select(0);
        this._helpWindow = '???';
        this.callUpdateHelp();
    };
    
    Window_wnyjfjQD.prototype.maxCols = function() {
        return 2;
    };
    
    Window_wnyjfjQD.prototype.itemHeight = function() {
        return 38;
    };
    
    //这个是用来自定义选项的位置和大小
    Window_wnyjfjQD.prototype.itemRect = function(index) {
        var rect = new Rectangle();
        
        rect.width = 120;
        rect.height = 38;

        rect.x = index % this.maxCols() * 150 +100;
        rect.y = 40 + Math.floor(index / this.maxCols()) * 38 - this._scrollY;
    
        return rect;
    };
    
    Window_wnyjfjQD.prototype.maxItems = function() {
        return this._data ? this._data.length : 1;
    };
    
    Window_wnyjfjQD.prototype.item = function() {
        return this._data[this.index()];
    };
    
    Window_wnyjfjQD.prototype.isCurrentItemEnabled = function() {
        return this.isEnabled(this._data[this.index()]);
    };
    
    Window_wnyjfjQD.prototype.isEnabled = function(item) {
        return true;
    };
    
    Window_wnyjfjQD.prototype.refresh = function() {
        this.makeItemList();
        this.createContents();
        this.drawBJ();
        this.drawAllItems();
    };
    
    Window_wnyjfjQD.prototype.makeItemList = function() {
        // this._data = $gameParty.allMembers();
        //this._data = $gameParty.armors();//未装备的
        this._data = [1,2];

    };
    
    //画内容的
    Window_wnyjfjQD.prototype.drawBJ = function() {
        this.drawTextEx("       确认分解以下\\C[3]所有\\C[0]装备?", 5, 3);
    };
    
    Window_wnyjfjQD.prototype.drawItem = function(index) {
        // var dt = this._data[index];
        var rect = this.itemRect(index);
        if(index ==0){
            this.drawTextEx("\\C[1]确认", rect.x + 32, rect.y);
        }else{
            this.drawTextEx("\\C[10]取消", rect.x + 32, rect.y);
        }
    };
    

    //不动
    Window_wnyjfjQD.prototype.setStatusWindow = function(statusWindow) {
        this._helpWindow = statusWindow;
        this.callUpdateHelp();
    };
    Window_wnyjfjQD.prototype.setHelpWindowItem = function(item) {
        if (this._helpWindow) {
            //this._helpWindow.setItem(item);
        }
    };
    Window_wnyjfjQD.prototype.updateHelp = function() {
        this.refresh();
    };

    // Window_wnyjfjQD.prototype.wnXinXi = function(wnxx) {
    //     this.drawTextEx(wnxx, 300, 400);
    // };

}

//=============================================================================
// 确定弹框
//=============================================================================
{
    function Window_wnYjfjQd() {
        this.initialize.apply(this, arguments);
    }
    
    Window_wnYjfjQd.prototype = Object.create(Window_Selectable.prototype);
    Window_wnYjfjQd.prototype.constructor = Window_wnYjfjQd;
    
    Window_wnYjfjQd.prototype.initialize = function(x, y, width, height) {
        this._windowWidth = width;
        this._windowHeight = height;
        Window_Selectable.prototype.initialize.call(this, x, y, width, height);
        this.opacity = 255;
        this.refresh();
        this.select(0);
        this._helpWindow = '???';
        this.callUpdateHelp();
    };
    
    Window_wnYjfjQd.prototype.maxCols = function() {
        return 1;
    };
    
    Window_wnYjfjQd.prototype.itemHeight = function() {
        return 37;
    };
    
    //这个是用来自定义选项的位置和大小
    Window_wnYjfjQd.prototype.itemRect = function(index) {
        var rect = new Rectangle();
        
        rect.width = 120;
        rect.height = 37;

        rect.x = index % this.maxCols() * 150 +225;
        rect.y = 50 + Math.floor(index / this.maxCols()) * 37 - this._scrollY;
    
        return rect;
    };
    
    Window_wnYjfjQd.prototype.maxItems = function() {
        return this._data ? this._data.length : 1;
    };
    
    Window_wnYjfjQd.prototype.item = function() {
        return this._data[this.index()];
    };
    
    Window_wnYjfjQd.prototype.isCurrentItemEnabled = function() {
        return this.isEnabled(this._data[this.index()]);
    };
    
    Window_wnYjfjQd.prototype.isEnabled = function(item) {
        return true;
    };
    
    Window_wnYjfjQd.prototype.refresh = function() {
        this.makeItemList();
        this.createContents();
        this.drawBJ();
        this.drawAllItems();
    };
    
    Window_wnYjfjQd.prototype.makeItemList = function() {
        // this._data = $gameParty.allMembers();
        //this._data = $gameParty.armors();//未装备的
        this._data = [1];

    };
    
    //画内容的
    Window_wnYjfjQd.prototype.drawBJ = function() {
        this.drawTextEx(wnfjFHXX, 10, 3);
    };
    
    Window_wnYjfjQd.prototype.drawItem = function(index) {
        // var dt = this._data[index];
        var rect = this.itemRect(index);
        if(index ==0){
            this.drawTextEx("\\C[1]确认", rect.x + 35, rect.y);
        }
    };
    

    //不动
    Window_wnYjfjQd.prototype.setStatusWindow = function(statusWindow) {
        this._helpWindow = statusWindow;
        this.callUpdateHelp();
    };
    Window_wnYjfjQd.prototype.setHelpWindowItem = function(item) {
        if (this._helpWindow) {
            //this._helpWindow.setItem(item);
        }
    };
    Window_wnYjfjQd.prototype.updateHelp = function() {
        this.refresh();
    };


}

//=============================================================================
// 一键分解加锁菜单
//=============================================================================
{
    function Scene_wnYJFJ() {
      this.initialize.apply(this, arguments);
    }
    
    Scene_wnYJFJ.prototype = Object.create(Scene_MenuBase.prototype);
    Scene_wnYJFJ.prototype.constructor = Scene_wnYJFJ;
    
    Scene_wnYJFJ.prototype.initialize = function() {
        Scene_MenuBase.prototype.initialize.call(this);
    };
    
    Scene_wnYJFJ.prototype.create = function() {
        Scene_MenuBase.prototype.create.call(this);
        wnSelectType=1;
        this.createListWindow();
        this.createSelectWindow();    
        this._wnYJFJSelectWindow.activate();   
        this._wnYJFJSelectWindow.refreshWindow(this._wnYJFJListWindow);
    };

    Scene_wnYJFJ.prototype.createSelectWindow = function() {
        this._wnYJFJSelectWindow = new Window_wnYJFJSelect(0, 0, 1280, 140);
        this.addWindow(this._wnYJFJSelectWindow);
        this._wnYJFJSelectWindow.setHandler('ok', this.wnqd.bind(this));
        this._wnYJFJSelectWindow.setHandler('cancel', this.popScene.bind(this));   
    };

    Scene_wnYJFJ.prototype.createWnQdQxWindow = function() {
        this._WNyjfjQdWindow = new Window_wnyjfjQD(400, 200, 500, 120);
        this.addWindow(this._WNyjfjQdWindow);
        this._WNyjfjQdWindow.setHandler('ok', this.wnYjfjQd.bind(this));
        this._WNyjfjQdWindow.setHandler('cancel', this.wnYjfjQx.bind(this));
        this._WNyjfjQdWindow.activate();
    };

    Scene_wnYJFJ.prototype.createListWindow = function() {
        this._wnYJFJListWindow = new Window_wnYJFJList(0, 145, 1280, 570);
        this.addWindow(this._wnYJFJListWindow);
        this._wnYJFJListWindow.setHandler('ok', this.hjtqwn.bind(this));
        this._wnYJFJListWindow.setHandler('cancel', this.returnSelect.bind(this));
        // this._wnYJFJListWindow.activate();
    };
    
    Scene_wnYJFJ.prototype.returnSelect = function() {
        this._wnYJFJListWindow.deactivate();
        this._wnYJFJSelectWindow.activate();
    }

    Scene_wnYJFJ.prototype.wnqd = function() {
        var select = this._wnYJFJSelectWindow.item();
        if(select == 1){
            wnSelectType=1;
            this._wnYJFJListWindow.activate();
            this._wnYJFJSelectWindow.deactivate();  
        }else if(select == 2){
            wnSelectType=2;
            this._wnYJFJListWindow.activate();
            this._wnYJFJSelectWindow.deactivate();   
        }else if(select == 3){
            wnSelectType=1;
            this.createWnQdQxWindow(); 
        }else if(select == 4){
            wnSelectType=2;
            this.createWnQdQxWindow(); 
        }
    }
    //createWnQdQxWindow  _WNyjfjQdWindow wnYjfjQd
    Scene_wnYJFJ.prototype.wnYjfjQd = function() {
        var select = this._WNyjfjQdWindow.item();
        if(select=="1"){
            if(wnSelectType==1){
                var fjCount = wn_yep_plfj(1);
                wnfjFHXX = "一键分解武器完成！共分解武器：\\C[10]"+fjCount+"\\C[0]件！" ;
                this.createWnQdWindow(); 
            }else{
                var fjCount = wn_yep_plfj(2);
                wnfjFHXX = "一键分解武器完成！共分解护甲：\\C[10]"+fjCount+"\\C[0]件！" ;
                this.createWnQdWindow(); 
            }
            this._WNyjfjQdWindow.close();
        }else{
            this._WNyjfjQdWindow.close(); 
            this._wnYJFJSelectWindow.activate(); 
        }
    }

    Scene_wnYJFJ.prototype.wnYjfjQx = function() {
        this._WNyjfjQdWindow.close(); 
        this._wnYJFJSelectWindow.activate(); 
    }

    Scene_wnYJFJ.prototype.createWnQdWindow = function() {
        this._WNFJQDWindow = new Window_wnYjfjQd(340, 200, 600, 150);
        this.addWindow(this._WNFJQDWindow);
        this._WNFJQDWindow.setHandler('ok', this.hjqx.bind(this));
        this._WNFJQDWindow.setHandler('cancel', this.hjqx.bind(this));
        this._WNFJQDWindow.activate();
    };

    Scene_wnYJFJ.prototype.hjqx = function() {
        wnfjFHXX = "";
        this._WNFJQDWindow.close();
        this._wnYJFJSelectWindow.activate();
        this._wnYJFJListWindow.refresh();
    };

    Scene_wnYJFJ.prototype.hjtqwn = function() {
        var plfjItem = this._wnYJFJListWindow.item(); 
        if(plfjItem){
            if(plfjItem.wnCanYJFJ&&plfjItem.wnCanYJFJ=="1"){
                plfjItem.wnCanYJFJ="0";//未上锁
            }else{
                plfjItem.wnCanYJFJ="1";
            }  
        }
		this._wnYJFJListWindow.activate();       
    };

    if(GT != undefined&&GT!=null&&GT.OIWin!= undefined){
		Scene_Base.prototype.getObjInfoWindowSetWNYJFJ = function() {
			if (this.constructor === Scene_wnYJFJ){
                this._objInfoWindowSet = GT.Param.OIWSceneShopSet;
            }
        }
		Scene_Base.prototype.createObjInfoWindowWNYJFJ = function() {
			this._objInfoWindow = new Window_ObjectInfo(this._objInfoWindowSet);
			this.addChild(this._objInfoWindow);
			if (this._wnYJFJListWindow) 
				this._wnYJFJListWindow.setObjInfoWindow(this._objInfoWindow);

		};
		GT.OIWin.Scene_wnYJFJ_create = Scene_wnYJFJ.prototype.create;
        Scene_wnYJFJ.prototype.create = function() {
            GT.OIWin.Scene_wnYJFJ_create.call(this);
            if (eval(GT.Param.OIWSceneShopSet.ShowWindow)) {
                this.getObjInfoWindowSetWNYJFJ();
                this.createObjInfoWindowWNYJFJ();
            }
        };
	}; 

}



